<?php
/**
 * $Id: tools.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access');

jimport( 'joomla.application.component.controller');

class ResControllerTools extends JController
{
	function __construct($config = array())
	{
		if(!JRequest::getVar('view')) JRequest::setVar( 'view'  , 'tools');
		parent::__construct($config);
	}

	function show_params()
	{
		JRequest::setVar('layout', 'form');
		JRequest::setVar( 'view'  , 'tools');

		parent::display();
	}
	function apply()
	{
		JRequest::setVar('layout', 'form');
		JRequest::setVar( 'view'  , 'tools');
		
		$name = JRequest::getVar('name');
		$id = JRequest::getVar('id');
		
		$dispatcher =& JDispatcher::getInstance();	
		JPluginHelper::importPlugin( 'joomsuite_content', $name);
		$dispatcher->trigger( 'onToolExecute', array($name, $id));
		
		parent::display();
	}
}
?>