<?php
/**
 * $Id: type.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

class ResControllerType extends ResController1
{
	function __construct()
	{
		parent::__construct();
		//$this->registerTask( 'add', 'edit');
		$this->registerTask( 'apply', 'save');
		JRequest::setVar('view', 'type');
	}
	
	function display(){
	    JRequest::setVar('view', 'type');
	    JRequest::setVar('hidemenu', 0);
	    parent::display();
	}
	function edit()
	{
	    JRequest::setVar( 'view', 'type');
	    JRequest::setVar( 'layout', 'form');
	    $model = $this->getModel('type');
		$model->checkout();
	    parent::display();
	}
	function add()
	{
	    JRequest::setVar( 'view', 'type');
	    JRequest::setVar( 'layout', 'form');
	    
	    parent::display();
	}
	function close()
	{
	    JRequest::setVar( 'view', 'type');
	    
	    parent::display();
	}
	function cancel()
	{
	    JRequest::setVar( 'view', 'type');
	    
	    //$record = & $this->getTable('type','Res');
	    //$record->checkin(JRequest::getVar('id'));

		$this->setRedirect( 'index.php?option=com_resource&controller=type');
	}
	function copytype()
	{
		$db = & JFactory::getDBO();
		
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array');
		JArrayHelper::toInteger($cid);
		
		$ids = implode(", ", $cid);
		
		$sql = "SELECT * FROM #__js_res_types WHERE id IN({$ids})";
		$db->setQuery($sql);
		$result = $db->loadObjectList();
		
		foreach ($result AS $type)
		{
			$sql = "INSERT INTO #__js_res_types (`name`, `params`, `published`, `description`) 
			 SELECT CONCAT(`name`, ' - Copy'), `params`, `published`, `description` FROM #__js_res_types WHERE id = {$type->id}";
			$db->setQuery($sql);
			$db->query();
			$id = $db->insertid();

			$sql = "INSERT INTO #__js_res_fields (`type_id`, `type`, `params`, `published`, `ordering`, `title`, `show_intro`, 
			`show_detail`, `searchable`, `filter`, `access`) SELECT {$id}, `type`, `params`, `published`, `ordering`, `title`, `show_intro`, 
			`show_detail`, `searchable`, `filter`, `access` FROM  #__js_res_fields WHERE type_id = {$type->id}";
			$db->setQuery($sql);
			$db->query();
		}

		$link = 'index.php?option=com_resource&controller=type';
		$this->setRedirect($link, JText::_('Type(s) Copied'));
	}
	function save()
	{
		//JRequest::checkToken() or jexit( 'Invalid Token');

		$post	= JRequest::get('post');
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array');
		$post['id'] = (int) $cid[0];

		$model = $this->getModel('type');

		if ($model->store($post)) {
			$msg = JText::_('Type Saved');
		} else {
			$msg = JText::_('Error Saving Type');
		}

		// Check the table in so it can be edited.... we are done with it anyway
		$model->checkin();
		
		$link = 'index.php?option=com_resource&controller=type';
		if(JRequest::getVar('task') == 'apply') $link = "index.php?option=com_resource&controller=type&view=type&task=edit&cid[]=".($post['id'] ? $post['id'] :$model->id);
		
		$this->setRedirect($link, $msg);
	}
}
?>
