<?php
/**
 * $Id: helper.php 7763 2012-01-26 07:47:42Z kostya $
 * $LastChangedDate: 2012-01-26 13:47:42 +0600 (Thu, 26 Jan 2012) $
 * $LastChangedBy: kostya $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'helpers'.DS.'helper.php');
require_once (JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'helpers'.DS.'alerts.php');
require_once JPATH_ADMINISTRATOR . DS . 'includes' . DS . 'toolbar.php';
require_once JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_resource' . DS . 'library' . DS . 'helpers' . DS . 'subtmpls.php';

jimport('joomla.application.component.model');

JHTML::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'html');

class jcHtml
{
	function orderUpIcon($i, $condition = true, $task = 'orderup', $alt = 'Move Up', $enabled = true, $limitstart = 0)
	{

		$alt = JText::_($alt);
		$path = 'components/com_resource/images/';
		$html = '&nbsp;';
		if (($i > 0 || ($i + $limitstart > 0)) && $condition)
		{
			if ($enabled)
			{
				$html = '<a href="#reorder" onclick="return listItemTask(\'cb' . $i . '\',\'' . $task . '\')" title="' . $alt . '">';
				$html .= '   <img src="' . $path . '/uparrow.png" width="16" height="16" border="0" alt="' . $alt . '" />';
				$html .= '</a>';
			}
			else
			{
				$html = '<img src="' . $path . '/uparrow0.png" width="16" height="16" border="0" alt="' . $alt . '" />';
			}
		}
		else
		{
			$html = '<img src="components/com_resource/images/uparrow0.png" width="16" height="16" border="0" alt="' . $alt . '" />';
		}

		return $html;
	}
	function orderDownIcon($i, $n, $condition = true, $task = 'orderdown', $alt = 'Move Down', $enabled = true, $limitstart = 0)
	{
		$alt = JText::_($alt);
		$path = 'components/com_resource/images/';
		$html = '&nbsp;';
		if (($i < $n - 1 || $i + $limitstart < $n - 1) && $condition)
		{
			if ($enabled)
			{
				$html = '<a href="#reorder" onclick="return listItemTask(\'cb' . $i . '\',\'' . $task . '\')" title="' . $alt . '">';
				$html .= '  <img src="' . $path . '/downarrow.png" width="16" height="16" border="0" alt="' . $alt . '" />';
				$html .= '</a>';
			}
			else
			{
				$html = '<img src="' . $path . '/downarrow0.png" width="16" height="16" border="0" alt="' . $alt . '" />';
			}
		}
		else
		{
			$html = '<img src="components/com_resource/images/downarrow0.png" width="16" height="16" border="0" alt="' . $alt . '" />';
		}

		return $html;
	}
	function published(&$row, $i, $imgY = 'publish.png', $imgX = 'delete.png', $prefix = '')
	{
		$img = $row->published ? $imgY : $imgX;
		$task = $row->published ? 'unpublish' : 'publish';
		$alt = $row->published ? JText::_('Published') : JText::_('Unpublished');
		$action = $row->published ? JText::_('Unpublish Item') : JText::_('Publish item');

		$href = '
		<a href="javascript:void(0);" onclick="return listItemTask(\'cb' . $i . '\',\'' . $prefix . $task . '\')" title="' . $action . '">
		<img src="components/com_resource/images/' . $img . '" border="0" alt="' . $alt . '" /></a>';

		return $href;
	}
	function getDefenderSign2($user, $id)
	{
		$API = JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jdefender';
		if(@is_dir($API))
		{
			$atr['onclick'] = "document.getElementById('icondefend2{$user}{$id}').src = '".JURI::root()."administrator/components/com_resource/images/load.gif'; xajax_jsrBlockUser('$user', {$id});";
			$sql = "SELECT COUNT(*) FROM #__jdefender_block_list WHERE type = 'user' AND `value` = '$user'";
			$db =& JFactory::getDBO();
			$db->setQuery($sql);
			$res = $db->loadResult();
		}
		else
		{
			$atr['onclick'] = "alert('".Jtext::_('To Block this User install Defender')."')";
			$res = 0;
		}
		$atr['align'] = 'absmiddle';
		$atr['style'] = 'cursor:pointer';
		$atr['id'] = 'icondefend2'.$user.$id;
		$atr['border'] = 0;


		$user = JFactory::getUser($user);
		$user = $user->get('username');


		if($res)
		{
			$img = 'user_secure.png';
			$atr['title'] = Jtext::_('Unblock User');
		}
		else
		{
			$img = 'user_secure_b.png';
			$atr['title'] = Jtext::_('Block User');
		}

		return JHTML::image(JURI::root().'administrator/components/com_resource/images/'.$img, $atr['title'], $atr);
	}
	function getDefenderSign($ip, $id)
	{
		$API = JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jdefender';
		if(@is_dir($API))
		{
			$atr['onclick'] = "document.getElementById('icondefend{$id}').src = '".JURI::root()."administrator/components/com_resource/images/load.gif'; xajax_jsrBlockIP('$ip', {$id});";
			$sql = "SELECT COUNT(*) FROM #__jdefender_block_list WHERE type = 'ip' AND `value` = '$ip'";
			$db =& JFactory::getDBO();
			$db->setQuery($sql);
			$res = $db->loadResult();
		}
		else
		{
			$atr['onclick'] = "alert('".Jtext::_('To Block this IP install Defender')."')";
			$res = 0;
		}
		$atr['align'] = 'absmiddle';
		$atr['style'] = 'cursor:pointer';
		$atr['id'] = 'icondefend'.$id;
		$atr['border'] = 0;

		if($res)
		{
			$img = 'secure_b.png';
			$atr['title'] = Jtext::_('Unblock IP');
		}
		else
		{
			$img = 'secure.png';
			$atr['title'] = Jtext::_('Block IP');
		}

		return JHTML::image(JURI::root().'administrator/components/com_resource/images/'.$img, Jtext::_('Block IP'), $atr);
	}


}

class JSToolBar extends JToolBarHelper
{
	function helpW($url, $width, $height)
	{
		$text	= JText::_('Help');
		$doTask	= "popupWindow('$url', '".JText::_('Help', true)."', $width, $height, 1)";

		$html	= "<a href=\"#\" onclick=\"$doTask\" class=\"toolbar\">\n";
		$html .= "<span class=\"icon-32-help\" title=\"$text\">\n";
		$html .= "</span>\n";
		$html	.= "$text\n";
		$html	.= "</a>\n";

		$bar = & JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'help');
	}
	function mass()
	{
		$document = &JFactory::getDocument();
		$document->addScript( JURI::root().'components/com_resource/library/js/dropdown.js');

		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript:" .
		"document.adminForm.filter_order.value=''; document.adminForm.controller.value='';\" class=\"toolbar\"  id=\"mass_click\" rel=\"mass_menu\">";
		$html .= "<span class=\"icon-32-mass\" id=\"button_mass\" type=\"Standard\">";
		$html .= "</span>";
		$html .= JText::_('Mass');
		$html .= "</a>";
		$html .= '<div align="left" id="mass_menu" style="position:absolute; visibility: hidden; width: 130px; padding: 8px;">';
		$html .= '<div id="toolbar-box"><div class="t">
			<div class="t">
				<div class="t"></div>
			</div>
		</div>
		<div class="m">';
		$html .= '
			<a class="my_submenu" onclick="massSubmenu(\'change_category\');">'.JText::_('Change Category').'</a><br />
			<a class="my_submenu" onclick="massSubmenu(\'change_field\');">'.JText::_('Change Field Value').'</a><br />
			<a class="my_submenu" onclick="massSubmenu(\'change_core\');">'.JText::_('Change Core Fields').'</a><br />
		';
		$html .= '<div class="clr"></div>
		</div>
		<div class="b">
			<div class="b">
				<div class="b"></div>
			</div>
		</div></div>';
		$html .= '</div>';
		$html .= '<script type="text/javascript">';
		$html .= 'dropdowncontent.init("mass_click", "right-bottom", 200, "click")';
		$html .= '</script>';
		$bar = & JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'reset');
	}
	function emptyX()
	{
		$document = &JFactory::getDocument();
		$document->addScript( JURI::root().'components/com_resource/library/js/dropdown.js');

		$html = '<a href="javascript:void(0);" onclick="javascript: emptyCategory();" class="toolbar"  id="reset_click" rel="reset_menu">';
		$html .= "<span class=\"icon-32-reset\" id=\"button_reset\" type=\"Standard\">";
		$html .= "</span>";
		$html .= JText::_('Empty');
		$html .= "</a>";

		$bar = & JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'reset');
	}
	function reset()
	{
		$document = &JFactory::getDocument();
		$document->addScript( JURI::root().'components/com_resource/library/js/dropdown.js');

		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript:" .
		"document.adminForm.filter_order.value=''; document.adminForm.controller.value=''; " . 
		"submitbutton('');\" class=\"toolbar\"  id=\"reset_click\" rel=\"reset_menu\">";
		$html .= "<span class=\"icon-32-reset\" id=\"button_reset\" type=\"Standard\">";
		$html .= "</span>";
		$html .= JText::_('Reset');
		$html .= "</a>";
		$html .= '<div align="left" id="reset_menu" style="position:absolute; visibility: hidden; width: 130px; padding: 8px;">';
		$html .= '<div id="toolbar-box"><div class="t">
			<div class="t">
				<div class="t"></div>
			</div>
		</div>
		<div class="m">';
		$html .= '
			<a class="my_submenu" onclick="clickSubmenu(\'reset_hits\');">'.JText::_('Reset Hits').'</a><br />
			<a class="my_submenu" onclick="clickSubmenu(\'reset_com\');">'.JText::_('Reset Comments').'</a><br />
			<a class="my_submenu" onclick="clickSubmenu(\'reset_vote\');">'.JText::_('Reset Rating').'</a><br />
			<a class="my_submenu" onclick="clickSubmenu(\'reset_fav\');">'.JText::_('Reset Favorite').'</a><br />
			<a class="my_submenu" onclick="clickSubmenu(\'reset_ctime\');">'.JText::_('Reset Create Date').'</a><br />
			<a class="my_submenu" onclick="clickSubmenu(\'reset_mtime\');">'.JText::_('Reset Modified Date').'</a><br />
			<a class="my_submenu" onclick="clickSubmenu(\'reset_extime\');">'.JText::_('Reset Expire Date').'</a><br />
		';
		$html .= '<div class="clr"></div>
		</div>
		<div class="b">
			<div class="b">
				<div class="b"></div>
			</div>
		</div></div>';
		$html .= '</div>';
		$html .= '<script type="text/javascript">';
		$html .= 'dropdowncontent.init("reset_click", "right-bottom", 200, "click")';
		$html .= '</script>';
		$bar = & JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'reset');
	}
	function close($contr, $string = 'Close')
	{
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript:" . "document.adminForm.filter_order.value=''; document.adminForm.controller.value='$contr'; " . "submitbutton('');\" class=\"toolbar\">";
		$html .= "<span class=\"icon-32-cancel\" type=\"Standard\">";
		$html .= "</span>";
		$html .= JText::_($string);
		$html .= "</a>";
		$bar = & JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'close');
	}
/*	function edit($file)
	{
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript:" . "if(document.adminForm.boxchecked.value==0){alert('" . "Please make a selection from the list to Delete');}" . "else{ResEdit('$file')}\" class=\"toolbar\">";
		$html .= "<span class=\"icon-32-edit\" type=\"Standard\">";
		$html .= "</span>";
		$html .= JText::_('Edit');
		$html .= "</a>";

		$bar = & JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'edit');
	}
	function addnew($file, $add = 0)
	{
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: " . "pBar(); listAdminClose(); xajax_jcNew('$file', 0, '$add');\" class=\"toolbar\">";
		$html .= "<span class=\"icon-32-new\" type=\"Standard\">";
		$html .= "</span>";
		$html .= JText::_('New');
		$html .= "</a>";

		$bar = & JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'addnew');
	}*/
	function delete($table, $trash = 0)
	{
		$document = & JFactory::getDocument();

		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript:" .
		"if(document.adminForm.boxchecked.value==0){alert('" . 
		"Please make a selection from the list to Delete');}" . 
		"else{if(confirm('" . JText::_('Are you sure you whant to delete this items?') . 
		"')){ResDelete('$table', '$trash');}}\" class=\"toolbar\">";
		$html .= "<span class=\"icon-32-delete\" type=\"Standard\" id=\"bar_delete\">";
		$html .= "</span>";
		$html .= JText::_('Delete');
		$html .= "</a>";

		$bar = & JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'delete');
	}
	function fields()
	{
		$document = & JFactory::getDocument();

		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript:" . "if(document.adminForm.boxchecked.value==0){alert('" . "Please make a selection from the list to Access Fields');}" . "else{document.adminForm.controller.value='field'; document.adminForm.filter_order.value=''; submitbutton();}\" class=\"toolbar\">";
		$html .= "<span class=\"icon-32-field\" type=\"Standard\" id=\"bar_delete\">";
		$html .= "</span>";
		$html .= JText::_('Fields');
		$html .= "</a>";

		$bar = & JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'field');
	}

	function publish($table, $publish)
	{
		$document = & JFactory::getDocument();

		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript:" . "if(document.adminForm.boxchecked.value==0){alert('" . JText::_("Please make a selection from the list to (Un)publish"). "');}" . "else{ResPublish(" . ($publish ? 0 : 1) . ", '$table');}\" class=\"toolbar\">";
		$html .= "<span class=\"icon-32-" . (! $publish ? 'un' : null) . "publish\" type=\"Standard\" id=\"bar_publish$publish\">";
		$html .= "</span>";
		$html .= ! $publish ? JText::_('Unpublish') : JText::_('Publish');
		$html .= "</a>";

		$bar = & JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'publish');
	}
	function types()
	{
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: " . "document.adminForm.controller.value='type'; document.adminForm.filter_order.value=''; submitbutton();\" class=\"toolbar\">";
		$html .= "<span class=\"icon-32-types\" type=\"Standard\">";
		$html .= "</span>";
		$html .= JText::_('Types');
		$html .= "</a>";

		$bar = & JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'types');
	}
	function category()
	{
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: " . "document.adminForm.controller.value='category'; document.adminForm.filter_order.value=''; submitbutton();\" class=\"toolbar\">";
		$html .= "<span class=\"icon-32-category\" type=\"Standard\">";
		$html .= "</span>";
		$html .= JText::_('Categories');
		$html .= "</a>";

		$bar = & JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'category');
	}
	function records()
	{
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: " . "document.adminForm.controller.value='record'; document.adminForm.filter_order.value=''; submitbutton();\" class=\"toolbar\">";
		$html .= "<span class=\"icon-32-record\" type=\"Standard\">";
		$html .= "</span>";
		$html .= JText::_('Content');
		$html .= "</a>";

		$bar = & JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'record');
	}
	function install()
	{
		$text	= JText::_('Install');
		$doTask	= "slideinstall('ins')";

		$html	= "<a href=\"#\" onclick=\"$doTask\" class=\"toolbar\">\n";
		$html .= "<span class=\"icon-32-install\" title=\"$text\">\n";
		$html .= "</span>\n";
		$html	.= "$text\n";
		$html	.= "</a>\n";

		$bar = & JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'install');
	}
	function cr()
	{
		$text	= JText::_('Copy/Rename');
		$doTask	= "slideinstall('cr')";

		$html	= "<a href=\"#\" onclick=\"$doTask\" class=\"toolbar\">\n";
		$html .= "<span class=\"icon-32-cr\" title=\"$text\">\n";
		$html .= "</span>\n";
		$html	.= "$text\n";
		$html	.= "</a>\n";

		$bar = & JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'cr');
	}
}

class ResHelper
{

	var $_tparams = array();
	var $_sid = array();
	var $_asec = array();
	var $_sparams = array();
	var $_atype = array();

	function countUserCategoryRecords($section_id, $params)
	{
		static $result = array();
		if(array_key_exists($section_id, $result)) return $result[$section_id];
		
		$now = ResHelper::getDate();

		$where = '';
		if($params->get('show_past_records') == 0)
		{
			$where = " AND (r.extime = '0000-00-00 00:00:00' OR r.extime > '{$now}') ";
		}
		$user = & JFactory::getUser();
		$db = &JFactory::getDBO();
		$sql = "SELECT r.id as total FROM #__js_res_record AS r
		LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id
		LEFT JOIN #__js_res_category AS c ON c.id = rc.catid
		WHERE (c.id = {$section_id} OR c.section_id = {$section_id}) AND r.user_id = ".$user->get('id').
		$where . "  GROUP by r.id";
		$db->setQuery($sql);
		$result[$section_id] = count($db->loadResultArray());

		return $result[$section_id];
	}
	function getIds($id)
	{
		$list = ResHelper::getSectionParent($id);
		
		$out = array();
		
		foreach ($list as $item)
		{
			$out[] = $item->id;
		}
		return $out;
	}
	
	function getSectionIds($id)
	{
		static $result = array();

		if(array_key_exists($id, $result)) return $result[$id];

		$db = &JFactory::getDBO();
		$sql = "SELECT id FROM #__js_res_category WHERE section_id = $id";
		$db->setQuery($sql);
		$ids = $db->loadResultArray();
		$ids[] = $id;
		
		JArrayHelper::toInteger($ids);
		
		$result[$id] = implode(",", $ids);

		return $result[$id];
	}
	
	function getCategoryChildrenIds($id)
	{
		static $result = array();

		if(array_key_exists($id, $result)) return $result[$id];

		$ids = ResHelper::getIds($id);
		//$db = &JFactory::getDBO();
		//$sql = "SELECT id FROM #__js_res_category WHERE parent = $id";
		//$db->setQuery($sql);
		//$ids = $db->loadResultArray();
		if(is_array($ids))
		{
			foreach ($ids AS $cid)
			{
				$out[] = ResHelper::getCategoryChildrenIds($cid);
			}
			//$out = array_merge($out, $ids);
		}
		
		$out[] = $id;
		
		$result[$id] = implode(",", $out);

		return $result[$id];
	}
	function MyState($name, $value, $default = FALSE)
	{
		global $mainframe;

		echo $name;
		if(trim($value))
		{
			$mainframe->setUserState($name, $value);
		}
		$out = $mainframe->getUserState($name);
		echo $out;
		if(!$out) $out = $default;
		return $out;
	}
	function regActivity($par)
	{

		jimport('joomla.database.table');

		$row =& JTable::getInstance('Activity', 'Res');

		$row->bind( $par );
		$row->check();
		$row->store();
	}

	function getDate($offset = 0)
	{
		global $mainframe;
		static $now = array();
		
		$offset += (int)$mainframe->getCfg('config.offset') * 3600;
		settype($offset, 'integer');
		if(array_key_exists($offset, $now)) return $now[$offset];
		
		$db = & JFactory::getDBO();
		$sql = "SELECT NOW() + INTERVAL {$offset} SECOND";
		$db->setQuery($sql);
		$result = $db->loadResult();
		
		$now[$offset] = $result;
		return $result;
	}

	function getArticleSection($id)
	{
		if (!$id)
		{
			//JError::raiseNotice(205, JText::_('Article ID not given to get its section'));
			return false;
		}
		static $data = array();

		if (!@$data[$id])
		{
			$db = & JFactory::getDBO();
			$sql = "SELECT c.id, c.section_id FROM #__js_res_record AS r
			LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id
			LEFT JOIN #__js_res_category AS c ON c.id = rc.catid
			WHERE r.id = ".(int)$id;
			$db->setQuery($sql);

			$result = $db->loadObject();
			if ($result->section_id > 0)
			$data[$id] = $result->section_id;
			else
			$data[$id] = $result->id;
		}
		return $data[$id];
	}

	function getTypeParams($type_id)
	{
		if(!$type_id)
		{
			JError::raiseNotice(400, JText::_('Type not set for Reshelper::getTypeParams()'));
			return new JParameter('');
		}

		static $data = array();

		if (!@$data[$type_id])
		{
			$db = & JFactory::getDBO();
			$sql = "SELECT params FROM #__js_res_types WHERE id = ".(int)$type_id;
			$db->setQuery($sql);
			$params = $db->loadResult();
			if($params) $data[$type_id] = new JParameter($params);
		}
		return $data[$type_id];
	}
	function getArticle($id)
	{
		static $articles = array();
		
		if(array_key_exists($id, $articles)) return $articles[$id];
		
		$db = & JFactory::getDBO();
		$sql = "SELECT r.*, t.name as type_name
			FROM #__js_res_record AS r
			LEFT JOIN #__js_res_types AS t ON t.id = r.type_id
			WHERE r.id = ".(int)$id;
		$db->setQuery($sql);
		$articles[$id] = $db->loadObject();
			
		return $articles[$id];
	}
	function getArticleUser($id)
	{
		$article = ResHelper::getArticle($id);
		return $article->user_id;
	}
	function getArticleType($id)
	{
		$article = ResHelper::getArticle($id);
		return $article->type_id;
	}
	function initArticleParams($type_id, $params = '1=1')
	{
		static $data = array();
		
		if(!$type_id)
		{
			JError::raiseError(500, 'Type Not Set');
		}
		$key = md5($type_id.serialize($params));
		if(isset($data[$key]))
			return $data[$key];

		$type_params = ResHelper::getTypeParams($type_id);
		$item_params = new JParameter($params);

		$item_params->def('item_title', $type_params->get('item_title'));
		$item_params->def('item_categories', $type_params->get('item_categories'));
		$item_params->def('item_link', $type_params->get('item_link'));
		$item_params->def('item_intro', $type_params->get('item_intro'));
		$item_params->def('item_hits', $type_params->get('item_hits'));
		$item_params->def('item_author', $type_params->get('item_author'));
		$item_params->def('item_author_mode', $type_params->get('item_author_mode'));
		$item_params->def('item_avatar', $type_params->get('item_avatar'));
		$item_params->def('avatar_width', $type_params->get('avatar_width'));
		$item_params->def('avatar_height', $type_params->get('avatar_height'));

		$item_params->def('karma_add_record', $type_params->get('karma_add_record'));
		$item_params->def('karma_update_record', $type_params->get('karma_update_record'));
		$item_params->def('karma_add_comment', $type_params->get('karma_add_comment'));
		$item_params->def('karma_add_rate', $type_params->get('karma_add_rate'));
		$item_params->def('karma_add_view', $type_params->get('karma_add_view'));
		$item_params->def('karma_add_fav', $type_params->get('karma_add_fav'));
		$item_params->def('karma_added_comment', $type_params->get('karma_added_comment'));
		$item_params->def('karma_added_rate', $type_params->get('karma_added_rate'));
		$item_params->def('karma_added_view', $type_params->get('karma_added_view'));
		$item_params->def('karma_added_fav', $type_params->get('karma_added_fav'));
		$item_params->def('karma_add_rate_com', $type_params->get('karma_add_rate_com'));
		$item_params->def('karma_added_rate_com', $type_params->get('karma_added_rate_com'));
		$item_params->def('karma_deny_view', $type_params->get('karma_deny_view'));
		$item_params->def('karma_deny_submit', $type_params->get('karma_deny_submit'));
		$item_params->def('karma_deny_edit', $type_params->get('karma_deny_edit'));
		$item_params->def('karma_deny_submit_comment', $type_params->get('karma_deny_submit_comment'));
		//$item_params->def('', $type_params->get(''));

		$item_params->def('activity_update_record', $type_params->get('activity_update_record'));
		$item_params->def('activity_add_record', $type_params->get('activity_add_record'));
		$item_params->def('activity_add_comment', $type_params->get('activity_add_comment'));
		$item_params->def('activity_add_rate', $type_params->get('activity_add_rate'));
		$item_params->def('activity_add_view', $type_params->get('activity_add_view'));
		$item_params->def('activity_add_favorite', $type_params->get('activity_add_favorite'));
		$item_params->def('activity_icon_record_update', $type_params->get('activity_icon_record_update'));
		$item_params->def('activity_icon_record', $type_params->get('activity_icon_record'));
		$item_params->def('activity_icon_comment', $type_params->get('activity_icon_comment'));
		$item_params->def('activity_icon_rate', $type_params->get('activity_icon_rate'));
		$item_params->def('activity_icon_rate', $type_params->get('activity_icon_rate'));
		$item_params->def('activity_icon_view', $type_params->get('activity_icon_view'));
		$item_params->def('activity_icon_favorite', $type_params->get('activity_icon_favorite'));
		$item_params->def('activity_text_record_update', $type_params->get('activity_text_record_update'));
		$item_params->def('activity_text_record', $type_params->get('activity_text_record'));
		$item_params->def('activity_text_comment', $type_params->get('activity_text_comment'));
		$item_params->def('activity_text_rate', $type_params->get('activity_text_rate'));
		$item_params->def('activity_text_view', $type_params->get('activity_text_view'));
		$item_params->def('activity_text_favorite', $type_params->get('activity_text_favorite'));

		$item_params->def('item_author_link', $type_params->get('item_author_link'));
		$item_params->def('item_fav_link', $type_params->get('item_fav_link'));
		$item_params->def('item_comment_link', $type_params->get('item_comment_link'));
		$item_params->def('item_hit_link', $type_params->get('item_hit_link'));
		$item_params->def('item_vote_link', $type_params->get('item_vote_link'));


		$item_params->def('item_compare', $type_params->get('item_compare'));
		$item_params->def('item_itemid', $type_params->get('item_itemid'));
		$item_params->def('item_author_link_itemid', $type_params->get('item_author_link_itemid'));
		$item_params->def('item_show_all_label', $type_params->get('item_show_all_label'));
		$item_params->def('item_ctime', $type_params->get('item_ctime'));
		$item_params->def('item_extime', $type_params->get('item_extime'));
		$item_params->def('item_mtime', $type_params->get('item_mtime'));
		$item_params->def('item_time_format', $type_params->get('item_time_format'));
		$item_params->def('item_navigation', $type_params->get('item_navigation'));
		$item_params->def('item_readon', $type_params->get('item_readon'));
		$item_params->def('item_readon_label', $type_params->get('item_readon_label'));
		$item_params->def('item_icons', $type_params->get('item_icons'));
		$item_params->def('item_button', $type_params->get('item_button'));
		$item_params->def('item_pdf', $type_params->get('item_pdf'));
		$item_params->def('item_print', $type_params->get('item_print'));
		$item_params->def('item_send', $type_params->get('item_send'));
		$item_params->def('rating', $type_params->get('rating'));
		$item_params->def('rating_access', $type_params->get('rating_access'));

		$item_params->def('tmpl_article', $type_params->get('tmpl_article'));
		$item_params->def('tmpl_comment', $type_params->get('tmpl_comment'));
		$item_params->def('tmpl_rating', $type_params->get('tmpl_rating'));
		$item_params->def('tmpl_articleform', $type_params->get('tmpl_articleform'));

		$item_params->def('hidden_name', $type_params->get('hidden_name'));
		$item_params->def('title_name', $type_params->get('title_name'));
		$item_params->def('extime_name', $type_params->get('extime_name'));
		$item_params->def('ctime_name', $type_params->get('ctime_name'));
		$item_params->def('category_name', $type_params->get('category_name'));
		$item_params->def('submit_name', $type_params->get('submit_name'));
		$item_params->def('submit_apply', $type_params->get('submit_apply'));
		$item_params->def('submit_cancel', $type_params->get('submit_cancel'));

		$item_params->def('size_category_select', $type_params->get('size_category_select'));
		$item_params->def('submission', $type_params->get('submission'));
		$item_params->def('allow_category', $type_params->get('allow_category'));
		$item_params->def('first_category', $type_params->get('first_category'));
		$item_params->def('multi_category', $type_params->get('multi_category'));
		$item_params->def('public_alert', $type_params->get('public_alert'));

		$item_params->def('submit_captcha', $type_params->get('submit_captcha'));
		$item_params->def('meta_key', $type_params->get('meta_key'));
		$item_params->def('meta_descr', $type_params->get('meta_descr'));
		$item_params->def('expire_time', $type_params->get('expire_time'));
		$item_params->def('create_time', $type_params->get('create_time'));

		$item_params->def('allow_extend', $type_params->get('allow_extend'));
		$item_params->def('default_extend', $type_params->get('default_extend'));
		$item_params->def('default_expire', $type_params->get('default_expire'));
		$item_params->def('autopublish', $type_params->get('autopublish'));
		$item_params->def('edit_autopublish', $type_params->get('edit_autopublish'));
		$item_params->def('access', $type_params->get('access'));
		$item_params->def('redirect_url', $type_params->get('redirect_url'));
		$item_params->def('submission_redirect', $type_params->get('submission_redirect'));

		$item_params->def('alert_tags', $type_params->get('alert_tags'));
		$item_params->def('alert_archive', $type_params->get('alert_archive'));
		$item_params->def('alert_send_mode', $type_params->get('alert_send_mode'));
		$item_params->def('alert_fetured_finished', $type_params->get('alert_fetured_finished'));
		$item_params->def('alert_rating', $type_params->get('alert_rating'));
		$item_params->def('alert_favorite', $type_params->get('alert_favorite'));
		//$item_params->def('alert_rating_custom', $type_params->get('alert_rating_custom'));
		$item_params->def('alert_rating_delete', $type_params->get('alert_rating_delete'));
		$item_params->def('alert_expire', $type_params->get('alert_expire'));
		$item_params->def('alert_expire_day', $type_params->get('alert_expire_day'));
		$item_params->def('alert_extended', $type_params->get('alert_extended'));
		$item_params->def('alert_now_featured', $type_params->get('alert_now_featured'));
		$item_params->def('alert_publish', $type_params->get('alert_publish'));
		$item_params->def('alert_unpublish', $type_params->get('alert_unpublish'));
		$item_params->def('alert_delete', $type_params->get('alert_delete'));
		$item_params->def('alert_edit', $type_params->get('alert_edit'));
		$item_params->def('alert_new', $type_params->get('alert_new'));
		$item_params->def('alert_comment', $type_params->get('alert_comment'));
		$item_params->def('alert_comment_insert', $type_params->get('alert_comment_insert'));
		$item_params->def('alert_comment_rate', $type_params->get('alert_comment_rate'));
		$item_params->def('alert_comment_rate_delete', $type_params->get('alert_comment_rate_delete'));
		
		$item_params->def('alert_comment_custom', $type_params->get('alert_comment_custom'));
		$item_params->def('alert_comment_rating_custom', $type_params->get('alert_comment_rating_custom'));
		$item_params->def('alert_rating_custom', $type_params->get('alert_rating_custom'));
		$item_params->def('alert_record_custom', $type_params->get('alert_record_custom'));
		
		$item_params->def('alert_comment_admin', $type_params->get('alert_comment_admin'));
		$item_params->def('alert_comment_rating_admin', $type_params->get('alert_comment_rating_admin'));
		$item_params->def('alert_rating_admin', $type_params->get('alert_rating_admin'));
		$item_params->def('alert_record_admin', $type_params->get('alert_record_admin'));
		$item_params->def('alert_delete_admin', $type_params->get('alert_delete_admin'));
		
		//$item_params->def('alert_email', $type_params->get('alert_email'));
		//$item_params->def('user_alert', $type_params->get('user_alert'));
		//$item_params->def('rate_alert', $type_params->get('rate_alert'));
		//$item_params->def('rate_email_alert', $type_params->get('rate_email_alert'));
		//$item_params->def('comments_alert', $type_params->get('comments_alert'));
		//$item_params->def('email_alert', $type_params->get('email_alert'));
		//$item_params->def('author_alert', $type_params->get('author_alert'));
		//$item_params->def('comment_user_alert', $type_params->get('comment_user_alert'));
		//$item_params->def('comments_rate_alert', $type_params->get('comments_rate_alert'));
		
		$item_params->def('item_tag', $type_params->get('item_tag'));
		$item_params->def('item_tag_num', $type_params->get('item_tag_num'));
		$item_params->def('item_tag_access', $type_params->get('item_tag_access'));
		
		$item_params->def('favorite', $type_params->get('favorite'));
		$item_params->def('new_days', $type_params->get('new_days'));
		$item_params->def('expire_edit', $type_params->get('expire_edit'));
		$item_params->def('item_edit', $type_params->get('item_edit'));
		$item_params->def('item_delete', $type_params->get('item_delete'));
		$item_params->def('item_publish', $type_params->get('item_publish'));
		$item_params->def('comments', $type_params->get('comments'));
		$item_params->def('comment_id', $type_params->get('comment_id'));
		$item_params->def('comments_sort', $type_params->get('comments_sort'));
		
		$item_params->def('allow_archive', $type_params->get('allow_archive'));
		$item_params->def('allow_block_comment', $type_params->get('allow_block_comment'));
		$item_params->def('comments_pagination', $type_params->get('comments_pagination'));
		$item_params->def('comments_title', $type_params->get('comments_title'));
		$item_params->def('comments_editor', $type_params->get('comments_editor'));
		$item_params->def('comments_author', $type_params->get('comments_author'));
		$item_params->def('comments_avatar_width', $type_params->get('comments_avatar_width'));
		$item_params->def('comments_avatar_height', $type_params->get('comments_avatar_height'));
		$item_params->def('comments_delete', $type_params->get('comments_delete'));
		$item_params->def('comments_edit', $type_params->get('comments_edit'));
		$item_params->def('comments_rate', $type_params->get('comments_rate'));
		$item_params->def('comments_rate_access', $type_params->get('comments_rate_access'));
		$item_params->def('comments_rate_delete', $type_params->get('comments_rate_delete'));
		$item_params->def('comments_hide', $type_params->get('comments_hide'));
		$item_params->def('comments_alert_replay', $type_params->get('comments_alert_replay'));
		$item_params->def('comments_hide_access', $type_params->get('comments_hide_access'));
		$item_params->def('comments_hide_default', $type_params->get('comments_hide_default'));
		$item_params->def('comments_access_default', $type_params->get('comments_access_default'));
		$item_params->def('comment_attach', $type_params->get('comment_attach'));
		$item_params->def('comments_allowed_formats', $type_params->get('comments_allowed_formats'));
		$item_params->def('comments_attachment_max', $type_params->get('comments_attachment_max'));
		$item_params->def('comments_attachment_timestamp', $type_params->get('comments_attachment_timestamp'));
		$item_params->def('comments_attachment_overwrite', $type_params->get('comments_attachment_overwrite'));
		$item_params->def('comments_attachment_hit', $type_params->get('comments_attachment_hit'));
		$item_params->def('comments_attachment_size', $type_params->get('comments_attachment_size'));
		$item_params->def('comments_style', $type_params->get('comments_style'));
		$item_params->def('comments_rss', $type_params->get('comments_rss'));
		$item_params->def('comments_alert_replay', $type_params->get('comments_alert_replay'));
		$item_params->def('comemnts_fold', $type_params->get('comemnts_fold'));
		$item_params->def('comments_title_lbl', $type_params->get('comments_title_lbl'));
		$item_params->def('comments_add_title_lbl', $type_params->get('comments_add_title_lbl'));
		$item_params->def('comments_button_title_lbl', $type_params->get('comments_button_title_lbl'));

		$item_params->def('comments_author', $type_params->get('comments_author'));
		$item_params->def('comments_avatar', $type_params->get('comments_avatar'));
		$item_params->def('comments_avatar_link', $type_params->get('comments_avatar_link'));
		$item_params->def('comments_author_itemid', $type_params->get('comments_author_itemid'));
		$item_params->def('comments_approve', $type_params->get('comments_approve'));
		$item_params->def('comments_approve_author', $type_params->get('comments_approve_author'));
		$item_params->def('comments_access', $type_params->get('comments_access'));
		$item_params->def('comments_access_view', $type_params->get('comments_access_view'));
		$item_params->def('comment_time_format', $type_params->get('comment_time_format'));
		$item_params->def('comment_captcha', $type_params->get('comment_captcha'));
		$item_params->def('comments_lang_mode', $type_params->get('comments_lang_mode'));
		$item_params->def('comemnts_limit_box', $type_params->get('comemnts_limit_box'));

		if(is_array($type_params->get('item_category_limit')))
		{
			$item_params->def('item_category_limit', @implode(",", $type_params->get('item_category_limit', array())));
		}
		else
		{
			$item_params->def('item_category_limit', $type_params->get('item_category_limit'));
		}
		
		if(is_array($type_params->get('type_comment_subscription')))
		{
			$item_params->def('type_comment_subscription', @implode(",", $type_params->get('type_comment_subscription', array())));
		}
		else
		{
			$item_params->def('type_comment_subscription', $type_params->get('type_comment_subscription'));
		}
		
		if(is_array($type_params->get('type_submit_subscription')))
		{
			$item_params->def('type_submit_subscription', @implode(",", $type_params->get('type_submit_subscription', array())));
		}
		else
		{
			$item_params->def('type_submit_subscription', $type_params->get('type_submit_subscription'));
		}
		
		if(is_array($type_params->get('type_edit_subscription')))
		{
			$item_params->def('type_edit_subscription', @implode(",", $type_params->get('type_edit_subscription', array())));
		}
		else
		{
			$item_params->def('type_edit_subscription', $type_params->get('type_edit_subscription'));
		}
		
		if(is_array($type_params->get('type_feature_subscription')))
		{
			$item_params->def('type_feature_subscription', @implode(",", $type_params->get('type_feature_subscription', array())));
		}
		else
		{
			$item_params->def('type_feature_subscription', $type_params->get('type_feature_subscription'));
		}
		
		if(is_array($type_params->get('type_extend_subscription')))
		{
			$item_params->def('type_extend_subscription', @implode(",", $type_params->get('type_extend_subscription', array())));
		}
		else
		{
			$item_params->def('type_extend_subscription', $type_params->get('type_extend_subscription'));
		}
		
		if(is_array($type_params->get('type_display_subscription')))
		{
			$item_params->def('type_display_subscription', @implode(",", $type_params->get('type_display_subscription', array())));
		}
		else
		{
			$item_params->def('type_display_subscription', $type_params->get('type_display_subscription'));
		}

		$item_params->def('type_comment_subscription_msg', $type_params->get('type_comment_subscription_msg'));
		$item_params->def('type_submit_subscription_msg', $type_params->get('type_submit_subscription_msg'));
		$item_params->def('type_edit_subscription_msg', $type_params->get('type_edit_subscription_msg'));
		$item_params->def('type_feature_subscription_msg', $type_params->get('type_feature_subscription_msg'));
		$item_params->def('type_extend_subscription_msg', $type_params->get('type_extend_subscription_msg'));
		
		$item_params->def('type_display_subscription_count', $type_params->get('type_comment_subscription_count'));
		$item_params->def('type_comment_subscription_count', $type_params->get('type_comment_subscription_count'));
		$item_params->def('type_submit_subscription_count', $type_params->get('type_submit_subscription_count'));
		$item_params->def('type_edit_subscription_count', $type_params->get('type_edit_subscription_count'));
		$item_params->def('type_feature_subscription_count', $type_params->get('type_feature_subscription_count'));
		$item_params->def('type_extend_subscription_count', $type_params->get('type_extend_subscription_count'));
		$item_params->def('type_feature_subscription_time', $type_params->get('type_feature_subscription_time'));
		
		$item_params->def('subscription_iid', $type_params->get('subscription_iid'));
		$item_params->def('subscription_admin_skip', $type_params->get('subscription_admin_skip'));

		$data[$key] = $item_params;
		return $item_params;
	}
	function getSection($id)
	{
		//return $id;
		static $sections = array();
		
		if(array_key_exists((int)$id, $sections)) return $sections[$id];
		
		$db = & JFactory::getDBO();
		$sql = "SELECT * FROM #__js_res_category WHERE id = ".(int)$id;
		$db->setQuery($sql);
		$sections[$id] = $db->loadObject();
			
		return $sections[$id];
	}
	function getSectionParent($id, $params = null, $ids = '')
	{
		static $sections = array();
		
		if(!$params) $params = new JParameter('1=2');
		
		if(array_key_exists($id, $sections)) return $sections[$id];
//		$add = '';
		//$ids = $add = " AND c.id IN ({$ids})";
		
		$db = & JFactory::getDBO();
		$sql = "SELECT c.*, c.id AS value, c.name AS text FROM #__js_res_category AS c WHERE 1 AND c.published = 1 AND c.parent = ".(int)$id./*$add.*/' ORDER by '.$params->get('cat_ordering', 'c.ordering ASC');
		$db->setQuery($sql);
		$sections[$id] = $db->loadObjectList();
		
		return $sections[$id];
	}
	function getCategorySection($catid)
	{
		$section = ResHelper::getSection($catid);
		//return $section;
		if($section->section_id > 0)
		{
			return $section->section_id;
		}
		else
		{
			return $catid;
		}

	}
	function getSectionParams($section_id)
	{
		$section = ResHelper::getSection($section_id);
		return new JParameter($section->params);
	}

	function initListParams($catid)
	{
		static $data = array();

		if (!$catid)
		{
			//$ex = new JException('');
			//echo $ex->getTraceAsString().'<br><br>';
			JError::raiseWarning(500, JText::_('Error H262'));
			return;
		}
		if(@$data[$catid]) return @$data[$catid];
		
		$section_id = ResHelper::getCategorySection($catid);
		$sec_params = ResHelper::getSectionParams($section_id);
		$cat_params = ResHelper::getSectionParams($catid);
		
		$cat_params->def('search_length_limit', $sec_params->get('search_length_limit'));
		$cat_params->def('search_limit', $sec_params->get('search_limit'));
		$cat_params->def('orderby', $sec_params->get('orderby'));
		$cat_params->def('category_itemid', $sec_params->get('category_itemid'));

		$cat_params->def('featured_first', $sec_params->get('featured_first'));
		if(!$cat_params->get('tmpl_list'))
		{
			if(is_array($sec_params->get('tmpl_list')))
			{
				$templs = implode(",", $sec_params->get('tmpl_list'));
				$cat_params->set('tmpl_list', $templs);

			}
			else
			{
				$cat_params->def('tmpl_list', $sec_params->get('tmpl_list'));
			}
		}

		if(is_array($cat_params->get('tmpl_list')))
		{
			$cat_params->set('tmpl_list', implode(",", $cat_params->get('tmpl_list')));
		}
		//echo $cat_params->get('tmpl_list');

		$cat_params->def('tmpl_filters', $sec_params->get('tmpl_filters'));
		$cat_params->def('tmpl_category', $sec_params->get('tmpl_category'));
		$cat_params->def('tmpl_menu', $sec_params->get('tmpl_menu'));
		$cat_params->def('tmpl_compare', $sec_params->get('tmpl_compare'));

		$cat_params->def('rate_smart', $sec_params->get('rate_smart'));
		$cat_params->def('rate_smart_before', $sec_params->get('rate_smart_before'));
		$cat_params->def('rate_smart_minimum', $sec_params->get('rate_smart_minimum'));
		$cat_params->def('rate_bay_ns', $sec_params->get('rate_bay_ns'));
		
		$cat_params->def('moder_icons', $sec_params->get('moder_icons'));
		$cat_params->def('moder_archive_record', $sec_params->get('moder_archive_record'));
		$cat_params->def('moder_uncomment_record', $sec_params->get('moder_uncomment_record'));
		$cat_params->def('moder_extend_record', $sec_params->get('moder_extend_record'));
		$cat_params->def('moder_delete_record', $sec_params->get('moder_delete_record'));
		$cat_params->def('moder_publish_record', $sec_params->get('moder_publish_record'));
		$cat_params->def('moder_edit_record', $sec_params->get('moder_edit_record'));
		$cat_params->def('moder_delete_comment', $sec_params->get('moder_delete_comment'));
		$cat_params->def('moder_publish_comment', $sec_params->get('moder_publish_comment'));
		$cat_params->def('moder_delete_vote', $sec_params->get('moder_delete_vote'));
		$cat_params->def('moder_delete_comment_vote', $sec_params->get('moder_delete_comment_vote'));
		
		$cat_params->def('access_section', $sec_params->get('access_section'));
		$cat_params->def('access_msg', $sec_params->get('access_msg'));
		$cat_params->def('orderby_rss', $sec_params->get('orderby_rss'));
		$cat_params->def('feed_limit', $sec_params->get('feed_limit'));
		$cat_params->def('feed_link', $sec_params->get('feed_link'));
		$cat_params->def('feed_link2', $sec_params->get('feed_link2'));
		$cat_params->def('feed_link_type', $sec_params->get('feed_link_type'));
		$cat_params->def('pagination', $sec_params->get('pagination'));
		$cat_params->def('show_restrict', $sec_params->get('show_restrict'));
		$cat_params->def('category_mode', $sec_params->get('category_mode'));
		$cat_params->def('records_mode', $sec_params->get('records_mode'));
		$cat_params->def('show_future_records', $sec_params->get('show_future_records'));
		$cat_params->def('show_past_records', $sec_params->get('show_past_records'));
		$cat_params->def('lang_mode', $sec_params->get('lang_mode'));
		$cat_params->def('record_submit_limit', $sec_params->get('record_submit_limit'));

		$cat_params->def('submit_subscr', $sec_params->get('submit_subscr'));
		$cat_params->def('submit_iid', $sec_params->get('submit_iid'));
		$cat_params->def('list_clients', $sec_params->get('list_clients'));
		
		$cat_params->def('cache_enable', $sec_params->get('cache_enable'));
		$cat_params->def('cache_days', $sec_params->get('cache_days'));

		$cat_params->def('menu_title_my', $sec_params->get('menu_title_my'));
		$cat_params->def('menu_title', $sec_params->get('menu_title'));
		$cat_params->def('menu_show_icons', $sec_params->get('menu_show_icons'));
		$cat_params->def('menu_show_nums', $sec_params->get('menu_show_nums'));
		$cat_params->def('menu_personalize_group', $sec_params->get('menu_personalize_group'));

		$cat_params->def('menu_icon_all', $sec_params->get('menu_icon_all'));
		$cat_params->def('menu_icon_add', $sec_params->get('menu_icon_add'));
		$cat_params->def('menu_icon_category', $sec_params->get('menu_icon_category'));
		$cat_params->def('menu_icon_my', $sec_params->get('menu_icon_my'));
		$cat_params->def('menu_icon_created', $sec_params->get('menu_icon_created'));
		$cat_params->def('menu_icon_favorited', $sec_params->get('menu_icon_favorited'));
		$cat_params->def('menu_icon_visited', $sec_params->get('menu_icon_visited'));
		$cat_params->def('menu_icon_rated', $sec_params->get('menu_icon_rated'));
		$cat_params->def('menu_icon_commented', $sec_params->get('menu_icon_commented'));
		$cat_params->def('menu_icon_delete', $sec_params->get('menu_icon_delete'));
		$cat_params->def('menu_icon_hidden', $sec_params->get('menu_icon_hidden'));
		$cat_params->def('menu_icon_unpublished', $sec_params->get('menu_icon_unpublished'));
		$cat_params->def('menu_icon_expired', $sec_params->get('menu_icon_expired'));

		$cat_params->def('menu_label_all', $sec_params->get('menu_label_all'));
		$cat_params->def('menu_label_add', $sec_params->get('menu_label_add'));
		$cat_params->def('menu_label_add_reg', $sec_params->get('menu_label_add_reg'));
		$cat_params->def('menu_label_category', $sec_params->get('menu_label_category'));
		$cat_params->def('menu_label_category_add', $sec_params->get('menu_label_category_add'));
		$cat_params->def('menu_label_category_reg', $sec_params->get('menu_label_category_reg'));
		$cat_params->def('menu_label_my', $sec_params->get('menu_label_my'));
		$cat_params->def('menu_label_favorited', $sec_params->get('menu_label_favorited'));
		$cat_params->def('menu_label_created', $sec_params->get('menu_label_created'));
		$cat_params->def('menu_label_visited', $sec_params->get('menu_label_visited'));
		$cat_params->def('menu_label_rated', $sec_params->get('menu_label_rated'));
		$cat_params->def('menu_label_commented', $sec_params->get('menu_label_commented'));
		$cat_params->def('menu_label_delete', $sec_params->get('menu_label_delete'));
		$cat_params->def('menu_label_hidden', $sec_params->get('menu_label_hidden'));
		$cat_params->def('menu_label_unpublished', $sec_params->get('menu_label_unpublished'));
		$cat_params->def('menu_label_expired', $sec_params->get('menu_label_expired'));

		$cat_params->def('menu_show_favorited', $sec_params->get('menu_show_favorited'));
		$cat_params->def('menu_show_rated', $sec_params->get('menu_show_rated'));
		$cat_params->def('menu_show_commented', $sec_params->get('menu_show_commented'));
		$cat_params->def('menu_show_visited', $sec_params->get('menu_show_visited'));
		$cat_params->def('menu_show_hidden', $sec_params->get('menu_show_hidden'));
		$cat_params->def('menu_show_unpublished', $sec_params->get('menu_show_unpublished'));
		$cat_params->def('menu_show_expired', $sec_params->get('menu_show_expired'));



		$cat_params->def('show_menu', $sec_params->get('show_menu'));
		$cat_params->def('template_switcher', $sec_params->get('template_switcher'));
		$cat_params->def('alpha_index', $sec_params->get('alpha_index'));
		$cat_params->def('title_index', $sec_params->get('title_index'));
		$cat_params->def('filter_order', $sec_params->get('filter_order'));
		$cat_params->def('filters', $sec_params->get('filters'));
		$cat_params->def('filters_mode', $sec_params->get('filters_mode'));
		$cat_params->def('filters_fields', $sec_params->get('filters_fields'));
		$cat_params->def('filters_ext', $sec_params->get('filters_ext'));
		$cat_params->def('filters_search', $sec_params->get('filters_search'));
		$cat_params->def('filters_category', $sec_params->get('filters_category'));
		$cat_params->def('filters_limit', $sec_params->get('filters_limit'));
		$cat_params->def('filters_type', $sec_params->get('filters_type'));
		$cat_params->def('filters_worn', $sec_params->get('filters_worn'));
		$cat_params->def('filters_tags', $sec_params->get('filters_tags'));
		$cat_params->def('filters_feed', $sec_params->get('filters_feed'));
		$cat_params->def('ext_filters', $sec_params->get('ext_filters'));
		$cat_params->def('description', $sec_params->get('description'));
		$cat_params->def('descr_image', $sec_params->get('descr_image'));
		$cat_params->def('cat_index', $sec_params->get('cat_index'));
		//$cat_params->def('cat_descr', $sec_params->get('cat_descr'));
		//$cat_params->def('cat_img', $sec_params->get('cat_img'));
		//$cat_params->def('cat_cols', $sec_params->get('cat_cols'));
		$cat_params->def('cat_empty', $sec_params->get('cat_empty'));
		//$cat_params->def('cat_nums', $sec_params->get('cat_nums'));
		$cat_params->def('cat_type', $sec_params->get('cat_type'));
		$cat_params->def('cat_ordering', $sec_params->get('cat_ordering'));
		$cat_params->def('subcat', $sec_params->get('subcat'));
		$cat_params->def('subcat_level', $sec_params->get('subcat_level'));
		$cat_params->def('subcat_limit', $sec_params->get('subcat_limit'));
		$cat_params->def('subcat_empty', $sec_params->get('subcat_empty'));
		//$cat_params->def('subcat_nums', $sec_params->get('subcat_nums'));
		$cat_params->def('order_ctime', $sec_params->get('order_ctime'));
		$cat_params->def('order_mtime', $sec_params->get('order_mtime'));
		$cat_params->def('order_title', $sec_params->get('order_title'));
		$cat_params->def('order_hits', $sec_params->get('order_hits'));
		$cat_params->def('order_autor', $sec_params->get('order_autor'));
		$cat_params->def('order_rate', $sec_params->get('order_rate'));
		$cat_params->def('order_comment', $sec_params->get('order_comment'));
		$cat_params->def('order_favorite', $sec_params->get('order_favorite'));
		$cat_params->def('order_fields', $sec_params->get('order_fields'));

		$cat_params->def('pcat_index', $sec_params->get('pcat_index'));
		$cat_params->def('pcat_descr', $sec_params->get('pcat_descr'));
		$cat_params->def('pcat_cols', $sec_params->get('pcat_cols'));
		$cat_params->def('pcat_empty', $sec_params->get('pcat_empty'));
		$cat_params->def('pcat_nums', $sec_params->get('pcat_nums'));
		$cat_params->def('pcat_submit', $sec_params->get('pcat_submit'));
		$cat_params->def('pcat_mean', $sec_params->get('pcat_mean'));
		$cat_params->def('pcat_mean2', $sec_params->get('pcat_mean2'));
		$cat_params->def('pcat_require', $sec_params->get('pcat_require'));
		$cat_params->def('pcat_limit', $sec_params->get('pcat_limit'));
		$cat_params->def('pcat_icon', $sec_params->get('pcat_icon'));
		$cat_params->def('pcat_icon_w', $sec_params->get('pcat_icon_w'));
		$cat_params->def('pcat_icon_h', $sec_params->get('pcat_icon_h'));
		$cat_params->def('pcat_meta', $sec_params->get('pcat_meta'));

		if(is_array($sec_params->get('type')))
		{
			$templs = implode(",", $sec_params->get('type'));
			$cat_params->set('type', $templs);

		}
		else
		{
			$cat_params->def('type', $sec_params->get('type'));
		}

		if(is_array($sec_params->get('comm_request_field')))
		{
			$templs = implode(",", $sec_params->get('comm_request_field'));
			$cat_params->set('comm_request_field', $templs);

		}
		else
		{
			$cat_params->def('comm_request_field', $sec_params->get('comm_request_field'));
		}

		if(is_array($sec_params->get('comm_confirm_field')))
		{
			$templs = implode(",", $sec_params->get('comm_confirm_field'));
			$cat_params->set('comm_confirm_field', $templs);

		}
		else
		{
			$cat_params->def('comm_confirm_field', $sec_params->get('comm_confirm_field'));
		}

		if(is_array($sec_params->get('comm_payout_gateways')))
		{
			$templs = implode(",", $sec_params->get('comm_payout_gateways'));
			$cat_params->set('comm_payout_gateways', $templs);

		}
		else
		{
			$cat_params->def('comm_payout_gateways', $sec_params->get('comm_payout_gateways'));
		}

		if(is_array($sec_params->get('comm_pay_gateways')))
		{
			$templs = implode(",", $sec_params->get('comm_pay_gateways'));
			$cat_params->set('comm_pay_gateways', $templs);

		}
		else
		{
			$cat_params->def('comm_pay_gateways', $sec_params->get('comm_pay_gateways'));
		}

		$cat_params->def('comm_enabled', $sec_params->get('comm_enabled'));
		$cat_params->def('comm_multi_seller', $sec_params->get('comm_multi_seller'));
		$cat_params->def('comm_ship_add', $sec_params->get('comm_ship_add'));
		$cat_params->def('comm_core_currency', $sec_params->get('comm_core_currency'));
		$cat_params->def('comm_layout_price', $sec_params->get('comm_layout_price'));
		$cat_params->def('comm_date_format', $sec_params->get('comm_date_format'));
		$cat_params->def('comm_use_shadowbox', $sec_params->get('comm_use_shadowbox'));
		$cat_params->def('comm_cart', $sec_params->get('comm_cart'));
		$cat_params->def('comm_inquire_type', $sec_params->get('comm_inquire_type'));
		$cat_params->def('comm_inquire_sellers', $sec_params->get('comm_inquire_sellers'));
		$cat_params->def('comm_cart_mode', $sec_params->get('comm_cart_mode'));
		$cat_params->def('comm_multi_vendor', $sec_params->get('comm_multi_vendor'));
		$cat_params->def('comm_payment_method', $sec_params->get('comm_payment_method'));
		$cat_params->def('comm_percentage', $sec_params->get('comm_percentage'));
		$cat_params->def('comm_transaction', $sec_params->get('comm_transaction'));
		//$cat_params->def('comm_pay_gateways', $sec_params->get('comm_pay_gateways'));
		//$cat_params->def('comm_payout_gateways', $sec_params->get('comm_payout_gateways'));
		$cat_params->def('comm_allow_negative', $sec_params->get('comm_allow_negative'));
		$cat_params->def('comm_negative_limit', $sec_params->get('comm_negative_limit'));
		$cat_params->def('comm_positive_limit', $sec_params->get('comm_positive_limit'));
		$cat_params->def('comm_payoutbill', $sec_params->get('comm_payoutbill'));
		//$cat_params->def('comm_request_field', $sec_params->get('comm_request_field'));
		//$cat_params->def('comm_confirm_field', $sec_params->get('comm_confirm_field'));
		$cat_params->def('comm_lay_icons_dir', $sec_params->get('comm_lay_icons_dir'));

		$data[$catid] =  $cat_params;
		return $data[$catid];
	}

	function getFieldParams($id)
	{
		if(!$id) return;

		static $data = array();

		if (!@$data[$id])
		{
			$db = & JFactory::getDBO();
			$sql = "SELECT params FROM #__js_res_fields WHERE id = ".(int)$id;
			$db->setQuery($sql);
			$params = $db->loadResult();
			$data[$id] = new JParameter($params);
		}
		return $data[$id];
	}
	function getFieldType($id)
	{
		if(!$id) return;
		static $data = array();

		if (!@$data[$id])
		{
			$db = & JFactory::getDBO();
			$sql = "SELECT type FROM #__js_res_fields WHERE id = ".(int)$id;
			$db->setQuery($sql);
			$data[$id] = $db->loadResult();
		}
		return $data[$id];
	}
	function AccessProcessingX(&$row, $table)
	{
		if (!$row->access)
		{
			$color_access = 'style="color: green;"';
		}
		else if ($row->access == 1)
		{
			$color_access = 'style="color: red;"';
		}
		else
		{
			$color_access = 'style="color: black;"';
		}

		$href = "
		<span id=\"adiv_$row->id\">
		<a href=\"javascript:void(0);\"  id=\"access_$row->id\"
		$color_access onclick=\"document.getElementById('adiv_$row->id').innerHTML = '<img src=components/com_resource/images/load.gif>';xajax_jcAccess('$row->id', '$table',
		'$row->access')\">" . JText::_($row->groupname) . "</a></span>";

		return $href;
	}

	function PublishedProcessingX(&$row, $table, $i)
	{

		$img = $row->published ? $imgY = 'tick.png' : $imgX = 'publish_x.png';
		if($row->published == -1) $img = 'disabled.png';
		//$task   = $row->published ? 'unpublish' : 'publish';
		$alt = $row->published ? JText::_('Published') : JText::_('Unpublished');
		$action = $row->published ? JText::_('Unpublish Item') : JText::_('Publish item');

		//$href = '<a href="javascript:void(0);" onclick="return listItemTask(\'cb'. $i .'\',\''. $task .'\')" title="'. $action .'"><img src="images/'. $img .'" border="0" alt="'. $alt .'" /></a>';
		$href = "<span id=\"pdiv_$row->id\"><a href=\"javascript:void(0);\"  id=\"publish_$row->id\" onclick=\"document.getElementById('pdiv_$row->id').innerHTML = '<img src=components/com_resource/images/load.gif>';xajax_jcPublish('$row->id', '$table', '$row->published')\"><img src=\"images/$img\" border=\"0\" align=\"absmiddle\" alt=\"$alt\"/></a><span>";

		return $href;
	}
	function FeaturedProcessingX(&$row, $table, $i)
	{

		$img = $row->featured ? $imgY = 'tick.png' : $imgX = 'publish_x.png';
		if($row->featured == -1) $img = 'disabled.png';
		//$task   = $row->published ? 'unpublish' : 'publish';
		$alt = $row->featured ? JText::_('Featured') : JText::_('Normal');
		$action = $row->featured ? JText::_('UnFeature') : JText::_('Make Featured');

		//$href = '<a href="javascript:void(0);" onclick="return listItemTask(\'cb'. $i .'\',\''. $task .'\')" title="'. $action .'"><img src="images/'. $img .'" border="0" alt="'. $alt .'" /></a>';
		$href = "<span id=\"fdiv_$row->id\"><a href=\"javascript:void(0);\"  id=\"feature_$row->id\" onclick=\"document.getElementById('fdiv_$row->id').innerHTML = '<img src=components/com_resource/images/load.gif>';xajax_jcFeature('$row->id', '$table', '$row->featured')\"><img src=\"images/$img\" border=\"0\" align=\"absmiddle\" alt=\"$alt\"/></a><span>";

		return $href;
	}
	/*function ElementName($var, $row, $i, $file, $add = 0)
	{
		$name = sprintf('<a href="javascript:void(0);" onclick="ResEditItem(\'cb%d\', \'%s\', \'%s\');"><span id="row_%s_%d">%s</span></a>', $i, $file, ($add ? $add : 0), $var, $row->id, $row->{$var});
		return $name;
	}*/

	function cleanFilterValue($value, $base64_value, $field, $params, $record)
	{
		$output = ResHelper::translateValue($value);
		
		$category_id = $params->get('category_id', JRequest::getInt('category_id'));

		if(@$field->filter == 1 && $params->get('filter_linkage') && $category_id)
		{
			$options = array();
			if(!JRequest::getInt('client_id') && $record->client_id)
			{
				$options['client_id'] = $record->client_id;
				$options['client'] = $record->client;
			}
			$link = MEUrl::link_list($category_id, $options);			
			$link .= '&filter'.$field->fid.'[]='.urlencode($base64_value);
			
			$link = MERoute::_($link);
		}

		if(@$link)
		{
			JHTML::_('behavior.tooltip');
			$tip = JText::_('Filter By').' '.$field->title.'::'.htmlspecialchars(JText::sprintf($params->get('filter_tip', 'Show all records of %s'), strip_tags($output)));
			if($params->get('filter_linkage') == 1)
			{
				$output = JHTML::link($link, $output, array('class' => 'hasTip', 'title' => $tip));
			}
			if($params->get('filter_linkage') == 2)
			{
				$output .= ' '.JHTML::link($link, JHTML::image(JURI::root().'components/com_resource/images/filter/'.$params->get('filter_icon', 'default.png'), '', array('border' => '0', 'align' => 'absmiddle')), array('class' => 'hasTip', 'title' => $tip));
			}
		}

		return $output;
	}
	function translateValue($val)
	{
		$val = stripslashes($val);
		$text = strip_tags($val);
		
		// Avoid JText class not found error.
		$new_text = explode('::', $text);
		$new_text = array_map(array('JText', '_'), $new_text);
		$new_text = implode('::', $new_text);
		
		$out = str_replace($text, $new_text, $val);
		return $out;
	}
	function jsFormatSize($size)
	{
			
		$kb = 1024;
		$mgb = $kb * 1024;
		$gb  = $mgb * 1024;
		$trb = $gb * 1024;
			
		if($size > $trb)
		{
			return number_format($size / $trb, 2, ',', ' ')." Tb";
		}
		elseif($size > $gb)
		{
			return number_format($size / $gb, 1, ',', ' ')." Gb";
		}
		elseif($size > $mgb)
		{
			return number_format($size / $mgb, 0, ',', ' ')." Mb";
		}
		elseif($size > $kb)
		{
			return number_format($size / $kb, 0, ',', ' ')." Kb";
		}
		else
		{
			return $size." B";
		}
	}
	
	function getAjaxTreeCategoryList($parent = 0, $def = array(), $multiple = false, $disabled = array(), $name = 'categories[]'){
		//Ñ‡ÐµÑ€ÐµÐ· doc Ð½Ðµ ÐºÐ°Ð½Ð°ÐµÑ‚ ÐµÑ�Ð»Ð¸ Ð¿Ð¾Ð»Ðµ Ñ‡ÐµÑ€ÐµÐ· ajax Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ Ð½Ð°Ñ�Ñ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ñ� Ñ�Ñ‚Ð¸Ð¼ Ñ�Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð¼
		//$doc = &JFactory::getDocument();
		/*$doc->addStyleDeclaration(*/$html = '<style type="text/css">
				
			.Container {
			    padding: 0;
			    margin: 0;
			}
			
			.Container li {
			    list-style-type: none;
			}
			
			/* indent for all tree children excepts root */
			.Node {
			    background-image : url('.JURI::root().'components/com_resource/images/tree/i.gif);
			    background-position : top left;
			    background-repeat : repeat-y;
			    margin-left : 18px;
			    line-height : 17px;
			}
			
			.IsRoot {
			    margin-left: 0;
			}
			
			/* left vertical line (grid) for all nodes */
			.IsLast {
			    background-image: url('.JURI::root().'components/com_resource/images/tree/i_half.gif);
			    background-repeat : no-repeat;
			}
			
			.ExpandOpen .Expand {
			    background-image: url('.JURI::root().'components/com_resource/images/tree/expand_minus.gif);
			}
			
			/* closed is higher priority than open */
			.ExpandClosed .Expand {
			    background-image: url('.JURI::root().'components/com_resource/images/tree/expand_plus.gif);
			}
			
			/* highest priority */
			.ExpandLeaf .Expand {
			    background-image: url('.JURI::root().'components/com_resource/images/tree/expand_leaf.gif);
			}
			
			.Content {
			    min-height: 18px;
			    margin-left:18px;
			}
			
			* html .Content {
			    height: 18px;
			}
			
			.Expand {
			    width: 18px;
			    height: 18px;
			    float: left;
			}
			
			
			.ExpandOpen .Container {
			        display: block;
			}
			
			.ExpandClosed .Container {
			        display: none;
			}
			
			.ExpandOpen .Expand, .ExpandClosed .Expand {
			        cursor: pointer;
			}
			.ExpandLeaf .Expand {
			        cursor: auto;
			}
			
			.ExpandLoading   {
			    width: 18px;
			    height: 18px;
			    float: left;
			    background-image: url('.JURI::root().'components/com_resource/images/tree/expand_loading.gif);
			}
			
			.maindiv {
				height : auto;
				width : 300px;
				overflow : auto;
			}</style>
			'/*)*/;
		
		$js_disable = 'var disable = new Array();';
		if(!empty($disabled)){
			foreach ($disabled as $d) {
				$js_disable .= 'disable.push('.$d.');';
			}
		}
		
		if($multiple && $name != 'categories[]'){
			$name .='[]';
		}
		
		/*$doc->addScriptDeclaration(*/$html .= '<script type="text/javascript">'.$js_disable.'
			var my_loaded = new Array();
			function my_load(el){
				if(my_loaded.indexOf(el.id) == -1){
					var expand = el.getElementsByTagName("DIV")[0];
					expand.className = "ExpandLoading";
					xajax_jsGetCategoryList(el.id,'.(int)$multiple.',disable,"'.$name.'");
					my_loaded.push(el.id);
				}else{
					el.toggleClass("ExpandOpen");
					el.toggleClass("ExpandClosed");
				}
			}</script>
		'/*)*/;
		
		$db = JFactory::getDBO();
		
		$node ='';
		$tree_array = array();
		$sections_array = array();
		
		if($parent == 0){
			$sql = "select c.id FROM #__js_res_category as c
				WHERE c.parent = 0 AND c.published = 1 GROUP BY c.id ORDER BY c.name";
			$db->setQuery($sql);
			$sec = $db->loadResultArray();
		}else{
			$sec = array($parent);
		}
			
		if(!empty($def)){
			
			foreach ($def as $value) {
				$cat_path = ResHelper::getCategoryParentIds($value);
				$cat_path = explode(',', $cat_path);
				$s = array_shift($cat_path);
				$sections_array[] = $s;
				if(count($cat_path)>0){
					$tree_array[$s] = 1;
					foreach ($cat_path as $key => $value) {
						$tree_array[$value] = 1;
					}
					$tree_array[$value] = 0;
				}
			}
		}
		if(!empty($sec))
				$sections_array = $sec;
		$i = 0;
		$count = count($sections_array);
		$isLast = false;
		foreach ($sections_array as $key => $value) {
			$i++;
			if($i == $count)
				$isLast = true;
			$node .= ResHelper::_getDecoratedItem($value, true, $tree_array, $def, $isLast, $multiple, $disabled, $name);
		}
		return $html .= '<div class="maindiv">
				<ul class="Container" id="tree">
				  '.$node.'
				</ul></div>
			';
	}
	
	function _getDecoratedItem($category_id, $first = false, $tree_array = array(), $def = array(), $isLast = false, $multiple = false, $disabled = array(), $name = 'categories'){
		
		if(empty($category_id)) return;
		
		$db = &JFactory::getDBO();
		
		if($first){
			$sql = "select c.id AS value, c.name as text, count(c1.id)  as leaf 
				FROM #__js_res_category as c
				LEFT JOIN #__js_res_category as c1 on c1.parent = c.id
				WHERE c.id = $category_id GROUP BY c.id";
			$db->setQuery($sql);
			$res = $db->loadObjectList();
			$a = true;
		}else{
			$sql = "select c.id AS value, c.name as text, count(c1.id)  as leaf 
				FROM #__js_res_category as c
				LEFT JOIN #__js_res_category as c1 on c1.parent = c.id
				WHERE c.parent = $category_id GROUP BY c.id";
			$db->setQuery($sql);
			$res = $db->loadObjectList();
			$a = false;
		}
		
		$node = array();
		$amount = count($res);
		$i = 0;
		if( !$node ) $node = '';
		foreach ($res as $key => $r) {
			$i++;
			$node .= '<li id="catid_'.$r->value.'" class="Node '.( $first ?' IsRoot ': '' ).((($i == $amount && !$first)|| ($isLast && $first))? 'IsLast' : '').(!$r->leaf ? ' ExpandLeaf ' : ( (!isset($tree_array[$r->value]) || !$tree_array[$r->value]) ? ' ExpandClosed ' : ' ExpandOpen ') ).' ">
						    <div id="catid_'.$r->value.'_control" class="Expand" '.(!$r->leaf ? '' : 'onclick="my_load($(\'catid_'.$r->value.'\'));"').'></div>
						    <div class="Content">'.
							(empty($disabled) || in_array($r->value, $disabled) ? '<input id="input'.$r->value.'" type="'.($multiple ? 'checkbox' : 'radio').'" name="'.$name.'" value="'.$r->value.'" '.(in_array($r->value,$def) ? ' checked="checked" >': '>') : '').
							(empty($disabled) || in_array($r->value, $disabled) ? '<label for="input'.$r->value.'" ':'<span ').(!$r->leaf ? '' : 'ondblclick="my_load($(\'catid_'.$r->value.'\'));"').'>'.$r->text.
							(empty($disabled) || in_array($r->value, $disabled) ? '</label> ' : '</span>').
							'</div>
							<ul id="catid_'.$r->value.'_container" class="Container">';
			if( isset($tree_array[$r->value]) && $tree_array[$r->value]/*count($cat)>1 && isset($cat[0]) && ($cat[0] == $r->value || $a )*/){
				$node .= '<script>my_loaded.push("catid_'.$r->value.'");</script>';
				$node .= ResHelper::_getDecoratedItem($r->value, false, $tree_array, $def, $isLast, $multiple, $disabled, $name);
			}
						    
			$node .= '</ul></li>';
		}
		return $node;
	}
	
	function getCategoryParentIds($id, $result = false)
	{
		$db = & JFactory::getDBO();
		$sql = "SELECT  c.parent  FROM #__js_res_category AS c WHERE c.published = 1 AND c.id = ".(int)$id;
		$db->setQuery($sql);
		$res = $db->loadResult();
		$out = array();
		if($res != 0 && !empty($res))
		{
			$out[] = ResHelper::getCategoryParentIds($res);
		}
			$out[] = $id;
		
		$result[$id] = implode(",", $out);

		return $result[$id];
	}
	
}

jimport('joomla.cache.cache');

class MECache extends JCache
{
	function cleanCache($days, $section_id)
	{
		$db = & JFactory::getDBO();
		$sql = "DELETE FROM #__js_res_cache WHERE section = {$section_id} AND ctime < NOW() - INTERVAL {$days} DAY";
		$db->setQuery($sql);
		$db->query();
	}	
	/**
	 * Get content of the cache.
	 *
	 * @param string $type type name like record, field, category
	 * @param integer $id1 Id of the record or field or category depends on type
	 * @param integer $id2 additional ID
	 * @param integer $id3 additional ID
	 * @return object
	 */
	function get($type, $id1, $section)
	{
		if(!$type || !$id1) return false;

		$db = & JFactory::getDBO();
		$sql = "SELECT `content` FROM #__js_res_cache WHERE `type` = '{$type}' AND ref1 = {$id1} ";
		if($section) $sql .= "AND section = {$section} ";
		$db->setQuery($sql);
		$res = $db->loadResult();

		if(!$res) return false;

		return unserialize($res);
	}
	/**
	 * Enter description here...
	 *
	 * @param mixed $content
	 * @param string $type
	 * @param int $id1
	 * @param int $id2
	 * @param int $id3
	 * @return int
	 */
	function set($content, $id, $key, $type, $section)
	{
		if(!$content || !$id || !$key || !$type || !$section) return false;

		MECache::delete($id, $key);

		$db = & JFactory::getDBO();
		$content = $db->getEscaped(serialize($content));

		$sql = "INSERT INTO #__js_res_cache VALUES (NULL, {$id}, '{$key}', NOW(), '{$content}', '{$type}', '{$section}') ";
		$db->setQuery($sql);
		$db->query();

		return $db->insertid();
	}
	function delete($id, $type)
	{
		if(!$type || !$id) return false;

		$db = & JFactory::getDBO();
		$sql = "DELETE FROM #__js_res_cache WHERE `ref_id` = {$id} AND `type` = '{$type}' ";
		$db->setQuery($sql);
		$db->query();
		return $db->getAffectedRows();
	}
	function delete_section($type, $section_id)
	{
		if(!$type || !$section_id) return false;

		$db = & JFactory::getDBO();
		$sql = "DELETE FROM #__js_res_cache WHERE `section` = '{$section_id}' AND `type` = '{$type}' ";
		$db->setQuery($sql);
		$db->query();
		return $db->getAffectedRows();
	}
	function getKey($type)
	{
		$user = & JFactory::getUser();
		jimport('joomla.language.helper');
		$lang =& JFactory::getLanguage();
		return md5($type.JRequest::getInt('Itemid', 0).$user->get('gid', 0).$lang->getTag());
	}
}

class MEAccess
{
	function isAdmin()
	{
		$admins = array(23,24,25);
		$user = & JFactory::getUser();
		if(in_array($user->get('gid'), $admins)) return TRUE;
		return FALSE;
	}
	function isPublisher()
	{
		$user = & JFactory::getUser();
		if($user->get('gid') == 21) return TRUE;
		return FALSE;
	}
	function isEditor()
	{
		$user = & JFactory::getUser();
		if($user->get('gid') == 20) return TRUE;
		return FALSE;
	}
	
	function isAuthor($user_id, $have_access = true)
	{
		if($have_access == false) return false;
		if(!$user_id) return FALSE;
		$user = & JFactory::getUser();
		if($user->get('id') == $user_id) return true;
		return false;
	}
	function isModerator($user_id, $name = null, $params = null)
	{
		if(!$user_id) return FALSE;
		static $users = array();
		
		if(array_key_exists($user_id.$name, $users))
		{
			//echo $user_id.$name;
			return  $users[$user_id.$name];
		}
		
		if($name)
		{
			//echo $name.'-'.$params->get($name).'<br />';
			$ids = explode(',', $params->get($name));
			if(in_array($user_id, $ids)) return $users[$user_id.$name] = true;
		}
		else
		{
			$params = ResHelper::initListParams(JRequest::getInt('category_id', ResHelper::getArticleSection(JRequest::getInt('article'))));
			
			if(!is_object($params)){
				$params = new JParameter('');
			}
			
			$ids = explode(',', $params->get('moder_delete_record'));
			$add = explode(',', $params->get('moder_publish_record'));
			$ids = array_merge($ids, $add);
			$add = explode(',', $params->get('moder_edit_record'));
			$ids = array_merge($ids, $add);
			$add = explode(',', $params->get('moder_delete_comment'));
			$ids = array_merge($ids, $add);
			$add = explode(',', $params->get('moder_publish_comment'));
			$ids = array_merge($ids, $add);
			$add = explode(',', $params->get('moder_delete_vote'));
			$ids = array_merge($ids, $add);
			$add = explode(',', $params->get('moder_delete_comment_vote'));
			$ids = array_merge($ids, $add);
			$add = explode(',', $params->get('moder_extend_record'));
			$ids = array_merge($ids, $add);
			$add = explode(',', $params->get('moder_edit_fields'));
			$ids = array_merge($ids, $add);
			
			if(in_array($user_id, $ids)) return $users[$user_id.$name] = true;
		}
		
		return $users[$user_id.$name] = FALSE;
	}
	function isHome($params)
	{
		if(JRequest::getVar('option', '', 'get') != 'com_resource') return false;
		if($params->get('client') == 'module') return false;
		return true;
	}
	function login($return = '', $msg = '')
	{
		global $mainframe;
		if(!$return)
		{
			$uri = &JFactory::getURI();
			$return = $uri->toString();
		}
		$url = 'index.php?option=com_user&view=login&Itemid=' . JRequest::getInt('Itemid');
		$url .= '&return=' . base64_encode($return);
		$mainframe->redirect(MERoute::_($url, FALSE), $msg);
	}
}

class MEUrl
{
	function link_list($category, $params = array())
	{
		static $links = array();
		$key = md5($category.'-'.print_r($params, TRUE));
		
		if(@$links[$key]) return $links[$key];
		
		$link = 'index.php?option=com_resource&view=list&category_id='.$category;
		$link = MEUrl::linkAdditions($link, $params);
		$link .= '&Itemid='.MEUrl::itemid(@$params['itemid'], $category);

		return $links[$key] = $link;
	}

	function link_record($record, $category = 0, $params = array())
	{
		static $links = array();
		
		if(is_object($record))
		{
			if(!$record->id) return;
			if(key_exists($record->id.'-'.$category, $links)) return $links[$record->id.'-'.$category];
		}
		else
		{
			if(!$record) return;
			
			if(key_exists($record.'-'.$category, $links)) return $links[$record.'-'.$category];
			
			jimport('joomla.application.component.model');
			JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models');
			$article_model = &JModel::getInstance('Article','ResModel');
			$record = $article_model->getRecord($record);
		}
		$id = $record->id;
		
		$cat_id = $category;
		if(!$cat_id) $cat_id = ResHelper::getArticleSection($id);

		$cparams = ResHelper::initListParams($cat_id);
		
		if($record->ucatid && $cparams->get('category_mode') > 1)
		{
			$params['ucid'] = $record->ucatid;
		}
		if($record->client_id)
		{
			$params['client_id'] = $record->client_id;
			$params['client'] = $record->client;
		}
		if($cparams->get('category_mode') > 1 && $record->user_id)
		{
			$params['user_id'] = $record->user_id;
		}

		$link = 'index.php?option=com_resource&controller=article&article='.$id;
		if($category > 0) $link .= '&category_id='.$category;
		$link = MEUrl::linkAdditions($link, $params);
		$link .= '&Itemid='.MEUrl::itemid(@$params['itemid'], $category, $record);
		return $links[$id.'-'.$category] = $link;
	}
	function linkAdditions($link, $params = 0)
	{
		//if(JRequest::getInt('user_id')) echo JRequest::getInt('user_id');
		static $request = array();
		if(empty($request)){
			$request['ucid'] = JRequest::getInt('ucid');
			$request['user_id'] = JRequest::getInt('user_id');
			$request['client_id'] = JRequest::getInt('client_id');
			$request['view_what'] = JRequest::getVar('view_what');
			$request['client'] = JRequest::getVar('client', 'resource');
		}
		
		settype($params, 'array');

		if(@$params['ucid'])
		{
			$link .= "&ucid=".$params['ucid'];
		}
		else
		{
			if($request['ucid'] && !(@$params['ucid'] === 0)) $link .= "&ucid=".$request['ucid'];
		}
		if(@$params['user_id'])
		{
			$link .= '&user_id='.$params['user_id'];
		}
		else
		{
			if($request['user_id'] && !$request['client_id'] && !(@$params['user_id'] === 0)) $link .= '&user_id='.$request['user_id'];
		}
		if(@$params['view_what'])
		{
			$link .= '&view_what='.$params['view_what'];
		}
		else
		{
			if($request['view_what'] && !$request['client_id'] && !(@$params['view_what'] === 0)) $link .= '&view_what='.$request['view_what'];
		}
		if(@$params['client_id'])
		{
			$link .= '&client_id='.$params['client_id'];
		}
		else
		{
			if($request['client_id'] && !(@$params['client_id'] === 0)) $link .= '&client_id='.$request['client_id'];
		}
		if(@$params['client'])
		{
			$link .= '&client='.urlencode(stripslashes($params['client']));
		}
		else
		{
			if($request['client'] != 'resource' && !(@$params['client'] === 0)) $link .= '&client='.urlencode(stripslashes($request['client']));
		}

		return $link;

	}
	function itemid($itemid = null, $category = null, $article = null)
	{
		If($itemid) return $itemid;
//		echo '<pre>';
//		var_dump($article);exit;
		static $date = array();
		static $date2 = array();

		if($article)
		{
			if(array_key_exists($article->id, $date2))
			{
				if($date2[$article->id]) return $date2[$article->id];
			}

			if(!array_key_exists($article->id, $date2))
			{
				$db = JFactory::getDBO();
				$sql = "SELECT id FROM #__menu WHERE `link` = 'index.php?option=com_resource&view=article&article=".$article->id."'";
				$db->setQuery($sql);
				$date2[$article->id] = $db->loadResult();
				if($date2[$article->id]) return $date2[$article->id];
			}
			if(isset($article->type_id)){
				$params = ResHelper::initArticleParams($article->type_id);
			}else{
				$params = ResHelper::initArticleParams(ResHelper::getArticleType($article->id));
			}
			if($params->get('item_itemid'))
			{
				$date2[$article->id] = $params->get('item_itemid');
				return $date2[$article->id];
			}

			if(!$category) $category = ResHelper::getArticleSection($article->id);
		}

		if($category)
		{
			if(array_key_exists($category, $date))
			{
				if($date[$category]) return $date[$category];
			}

			if(!array_key_exists($category, $date))
			{
				//echo 's';
				$db = JFactory::getDBO();
				$sql = "SELECT id FROM #__menu WHERE `link` = 'index.php?option=com_resource&view=list&category_id=".$category."'";
				$db->setQuery($sql);
				$res = $db->loadResult();
				//echo $res;
				$date[$category] = $res;
				if($res)
				{
					return $date[$category];
				}
			}
			
			$params = ResHelper::initListParams($category);
			
			//echo $category;
			
			if($params->get('category_itemid'))
			{
				$date[$category] = $params->get('category_itemid');
				return $date[$category];
			}
		}

		if(JRequest::getInt('Itemid')) return JRequest::getInt('Itemid');
	}
}
class MERoute extends JRoute
{
	function _($url, $xhtml = true, $ssl = null)
	{
		return parent::_($url, $xhtml, $ssl);

		$db 	= & JFactory::getDBO();
		$_url 	= $db->getEscaped(stripslashes($url));

		$sql = "SELECT sef_url FROM #__js_res_sef WHERE `option` = 'com_resource' AND original_url = '{$_url}'";
		$db->setQuery($sql);
		$sef = $db->loadResult();

		if(!$sef)
		{
			$sef = parent::_($url, $xhtml, $ssl);
			$_sef = $db->getEscaped(stripslashes($sef));
			if($_sef != $_url)
			{
				$sql = "INSERT INTO #__js_res_sef VALUES (NULL, '{$_sef}', '{$_url}',  NOW(), 'com_resource')";
				$db->setQuery($sql);
				$db->query();
			}
		}
		return $sef;
	}
}

function jsGeshiHighlite(&$matches)
{
	$params = & $GLOBALS['_MAMBOT_GESHI_PARAMS'];

	jimport('geshi.geshi');
	jimport('domit.xml_saxy_shared');

	$args = explode("|", $matches[1]);
	$text = $matches[2];

	$lang = JArrayHelper::getValue($args, 0, 'php');
	$lines = JArrayHelper::getValue($args, 1, 'false');

	$html_entities_match = array("|\<br \/\>|", "#<#", "#>#", "|&#39;|", '#&quot;#', '#&nbsp;#');
	$html_entities_replace = array("\n", '&lt;', '&gt;', "'", '"', ' ');

	$text = preg_replace($html_entities_match, $html_entities_replace, $text);

	$text = str_replace('&lt;', '<', $text);
	$text = str_replace('&gt;', '>', $text);

	/*
	 // Replace 2 spaces with "&nbsp; " so non-tabbed code indents without making huge long lines.
	 $text = str_replace("  ", "&nbsp; ", $text);
	 // now Replace 2 spaces with " &nbsp;" to catch odd #s of spaces.
	 $text = str_replace("  ", " &nbsp;", $text);
	 */
	// Replace tabs with "&nbsp; &nbsp;" so tabbed code indents sorta right without making huge long lines.
	//$text = str_replace("\t", "&nbsp; &nbsp;", $text);
	$text = str_replace("\t", '  ', $text);

	$geshi = new GeSHi($text, $lang);
	if ($lines == 'true')
	{
		$geshi->enable_line_numbers(GESHI_NORMAL_LINE_NUMBERS);
	}
	$text = $geshi->parse_code();

	return $text;
}

/*function jsCheckUserSubscriptions($user_id, $group, $field, $plans)
{
	if (count($plans) == 1 && $plans[0] == - 1)
	return true;
	static $user_subscriptions = array();

	$db = & JFactory::getDBO();

	//if($params)

	if (! isset($_user_subscriptions[$group][$field][$user_id]) || ! $_user_subscriptions[$group][$field][$user_id])
	{

		$query = "    SELECT u.subscription_id"
		 ."\n      FROM #__jcs_user_subscr AS u"
		 ."\n LEFT JOIN #__jcs_plans AS s ON s.id = u.subscription_id"
		 ."\n     WHERE     u.user_id = {$user_id}
		 AND u.extime > NOW()
		 AND u.ctime < NOW()
		 AND u.published = 1
		 AND s.id IN (".implode( ',', $plans).")"
		 ;
		$query = "    SELECT id " . "\n      FROM #__jcs_plans AS s " . "\n     WHERE s.id IN (" . implode(',', $plans) . ") AND s.published = 1";
		$db->setQuery($query);
		$plans = $db->loadResultArray();

		if (! count($plans))
		return true;

		$query = "    SELECT *, IF(u.access_limit > 0, IF(u.access_count >= u.access_limit, 0, 1), 1) AS cl " . "\n      FROM #__jcs_plans AS s " . "\n LEFT JOIN #__jcs_user_subscr AS u ON s.id = u.subscription_id" . "\n     WHERE s.id IN (" . implode(',', $plans) . ")
		AND u.user_id = {$user_id}
		AND u.extime > NOW()
		AND u.ctime < NOW()
		AND u.published = 1
		GROUP BY s.id
		HAVING cl > 0
		ORDER BY u.ctime LIMIT 1";
		;
		$db->setQuery($query);

		$user_subscriptions[$group][$field][$user_id] = $db->loadObject();
	}
	if ($user_subscriptions[$group][$field][$user_id])
	{
		$sql = "UPDATE #__jcs_user_subscr SET access_count = access_count + 1 WHERE id = " . $user_subscriptions[$group][$field][$user_id]->id;
		$db->setQuery($sql);
		$db->query();
	}
	return (bool)$user_subscriptions[$group][$field][$user_id];
}*/
/*
function jsRecalculationCategoryItemsNum($_sections)
{
	global $mainframe;

	$db = JFactory::getDBO();

	$sql = "UPDATE #__js_res_category AS c SET c.`items_num` = ( SELECT COUNT(*) FROM #__js_res_record_category AS rc WHERE c.id = catid ) WHERE c.section_id IN (" . implode(",", $_sections) . ") OR c.id IN (" . implode(",", $_sections) . ")";
	$db->setQuery($sql);
	$db->query();

	$sql = "SELECT id, parent FROM #__js_res_category WHERE section_id IN (" . implode(",", $_sections) . ") OR id IN (" . implode(",", $_sections) . ")";
	$db->setQuery($sql);
	$categories = $db->loadObjectList();

	$go_once_more = true;
	$current_level = 1;
	$current_parents[0] = array(0);
	$cats_by_levels = array();

	while($go_once_more)
	{
		$go_once_more = false;
		foreach($categories as $cat)
		{
			if (in_array($cat->parent, $current_parents[$current_level - 1]))
			{
				$cats_by_levels[$current_level][] = $cat->id;
				$current_parents[$current_level][] = $cat->id;
				$go_once_more = true;
			}
		}

		$current_level ++;
		$current_parents[$current_level - 1][] = array();
	}

	$r_cats_by_levels = array_reverse($cats_by_levels);

	foreach($r_cats_by_levels as $cats)
	{
		foreach($cats as $cat)
		{

			$sql = "SELECT SUM(items_num) FROM #__js_res_category WHERE parent = " . (int)$cat;
			$db->setQuery($sql);
			if ($db->getErrorNum())
			{
				JError::raiseNotice(500, $db->stderr());
				return false;
			}
			$item_num = $db->loadResult();

			if ($item_num)
			{
				$sql = "   UPDATE #__js_res_category SET items_num = items_num + " . $item_num . " WHERE id = " . $cat;
				$db->setQuery($sql);
				if ($db->getErrorNum())
				{
					JError::raiseNotice(500, $db->stderr());
					return false;
				}
				$db->query();
			}
		}
	}

	return true;
}
*/
// TODO count limit function for subscritpions
function jscCountLimit($plans, $mode, $user_id = 0)
{
	// if we should not count
	if($mode == 0) return;

	if(!$user_id)
	{
		$user = & JFactory::getUser();
		$user_id = $user->get('id');
	}
	$db = JFactory::getDBO();

	if (is_array($plans))
	{
		$plans = implode(',', $plans);
	}
	if (! $plans)
	return;

	$query = "SELECT id FROM #__jcs_plans AS s  WHERE s.id IN (" . $plans . ") AND s.published = 1";
	$db->setQuery($query);
	$plans = $db->loadResultArray();

	if (!count($plans)) return;

	$plans = implode(',', $plans);

	if($mode == 2)
	{
		$query = "SELECT u.id, IF(u.access_limit > 0, IF(u.access_count >= u.access_limit, 0, 1), 1) AS cl
					FROM #__jcs_plans AS s 
					LEFT JOIN #__jcs_user_subscr AS u ON s.id = u.subscription_id
				   WHERE s.id IN (" .$plans. ")
	                 AND u.user_id = {$user_id}
	                 AND u.extime > NOW()
	                 AND u.ctime < NOW()
	                 AND u.published = 1
	               GROUP BY u.id
	              HAVING cl > 0
	               ORDER BY u.extime DESC LIMIT 1";
		//echo $query; Exit;
		$db->setQuery($query);
			
		if ($res = $db->loadObject())
		{
			$sql = "UPDATE #__jcs_user_subscr SET access_count = access_count + 1 WHERE id = {$res->id}";
			$db->setQuery($sql);
			$db->query();
		}
	}
	else if($mode == 1)
	{
		$url = & JFactory::getURI();

		$sql  = 'SELECT subscription_id AS sid FROM #__jcs_history WHERE user_id = '.$user_id;
		$sql .= ' AND subscription_id IN ('.$plans.') ';
		$sql .= ' AND url = \''.$db->getEscaped($url->toString()).'\'';
		$db->setQuery($sql);
		$res = $db->loadResult();
		//echo $res; exit;
		if (!$res)
		{
			$query = "SELECT u.id, s.id as sid, IF(u.access_limit > 0, IF(u.access_count >= u.access_limit, 0, 1), 1) AS cl
					FROM #__jcs_plans AS s 
					LEFT JOIN #__jcs_user_subscr AS u ON s.id = u.subscription_id
				   WHERE s.id IN (" . $plans . ")
	                 AND u.user_id = {$user_id}
	                 AND u.extime > NOW()
	                 AND u.ctime < NOW()
	                 AND u.published = 1
	               /* GROUP BY u.id */
	              HAVING cl > 0
	               ORDER BY u.extime DESC LIMIT 1";
			$db->setQuery($query);
			$planId = $db->loadObject();
			//print_r($res);exit;

			if ($planId) {
				$sql = "UPDATE #__jcs_user_subscr SET access_count = access_count + 1 WHERE id = {$planId->id}";
				$db->setQuery($sql);
				$db->query();

				$sql = "INSERT INTO #__jcs_history VALUES(NULL, {$user_id}, '".$db->getEscaped($url->toString())."', NOW(), {$planId->sid})";
				$db->setQuery($sql);
				$db->query();
			}

		}
	}
}
// TODO count limit check. 3 modes.
/**
 *
 * @global Object $mainframe
 * @param mixed $plans comma separated plan ids
 * @param string $msg
 * @param int $itemid
 * @param url $redirect
 * @param int $mode
 * @return boolean true or false. true if no subscription found.
 */
function jscCheckSubscription($plans, $msg, $itemid, $redirect = true, $mode = 0, $user_id = 0)
{
	global $mainframe;
	
	if(!$user_id)
	{
		$user = & JFactory::getUser();
		$user_id = $user->get('id');
	}
	
	$db = JFactory::getDBO();
	$url = & JFactory::getURI();
	if (is_array($plans))
	{
		$plans = implode(',', $plans);
	}

	if($plans == -1) $plans = FALSE;

	if(!$plans) return false;

	if(!$user_id)
	{
		if ($redirect)
		{
			JError::raiseWarning(403, $msg);
			JError::raiseWarning(403, Jtext::_('You are not loged-in'));
			$mainframe->redirect('index.php?option=com_jcs&layout=form&Itemid=' . $itemid . '&id=' . $plans);
		}
		return TRUE;
	}
	$query = "SELECT id FROM #__jcs_plans AS s WHERE s.id IN (" . $plans . ") AND s.published = 1";
	$db->setQuery($query);
	$plans = $db->loadResultArray();

	if (count($plans))
	{
		$query = "
		SELECT u.*, IF(u.access_limit > 0 AND {$mode} > 0, IF(u.access_count >= u.access_limit, IF({$mode} = 1 AND h.url = '".$db->getEscaped($url->toString())."', 1, 0), 1), 1) AS cl
		          FROM #__jcs_plans AS s 
		     LEFT JOIN #__jcs_user_subscr AS u ON s.id = u.subscription_id 
		     LEFT JOIN #__jcs_history AS h ON (h.subscription_id = s.id AND h.user_id = u.user_id)
		        WHERE s.id IN (" . implode(',', $plans) . ")
                   AND u.user_id = {$user_id}
                   AND u.extime > NOW()
                   AND u.ctime < NOW()
                   AND u.published = 1
                 /*GROUP BY u.id*/
	            HAVING cl > 0";
		$db->setQuery($query);

		if (!$db->loadObjectList())
		{
			if ($redirect)
			{
				JError::raiseWarning(403, $msg);
				$mainframe->redirect('index.php?option=com_jcs&layout=form&Itemid=' . $itemid . '&id=' . implode(',', $plans));
			}
			return TRUE;
		}
	}
	return FALSE;
}
function aliasConverter($str)
{
	$lines = explode("\n", RES_ALIAS_CONV);
	$from = array(" ");
	$to = array("-");
	foreach ($lines AS $k => $v)
	{
		$r = explode("=",$v);
		if(!trim($r[0])) continue;
		$from[$k+1] = $r[0];
		$to[$k+1] = $r[1];
	}

	$str = preg_replace("/[\+\=\;\:\`\~\?\>\<\!\@\#\$\%\^\&\*\'\"\/\\\]+/i", '', $str);

	$str = JString::str_ireplace($from, $to, $str);
	$str = JString::str_ireplace('---', '', $str);
	$str = JString::str_ireplace('--', '', $str);
	return $str;
}
function getCountryByIP($ip)
{
	static $results = array();
	$db = JFactory::getDBO();

	if(!key_exists($ip, $results))
	{
		$sql = "SELECT code, short_code, country FROM  #__js_ip_2_country
		WHERE ip_from <= inet_aton('$ip') AND ip_to >= inet_aton('$ip')";
		$db->setQuery($sql);
		$results[$ip] = $db->loadObject();
	}
	$info = $results[$ip];
	if($info) echo "<img style=\"cursor:pointer\" onclick=\"document.getElementById('search').value='country:".strtolower($info->code)."'; document.adminForm.submit();\" width=\"16\" height=\"16\" src=\"components/com_resource/images/flags/".strtolower($info->short_code).".gif\" align=\"absmiddle\" title=\"{$info->country} (".Jtext::_('Click to filter').")\" /> ";
}
function wordSensor(&$text)
{
	if(RES_SENSOR)
	{
		$words = explode("\n", RES_SENSOR_WORDS);
		$text = JString::str_ireplace($words, RES_SENSOR_REPLACE, $text);
	}
}
function str_limit($str, $limit)
{
	if ($str && strlen($str) > $limit)
	return substr($str, 0, $limit - 3) . '...';
	else
	return $str;
}

?>
