<?php
/**
 * $Id: config.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('dead');

jimport('joomla.application.component.model');

class ResModelConfig extends JModel
{
    
    function __construct()
    {
        parent::__construct();
    }
    function get($val)
    {
        $db =& JFactory::getDBO();
        
        if(!$val)
        {
            JError::riseError(0112, JText::_('Rewuired parameter empty'));
        }
        $val = explode('.', $val);
        $section = $val[0];
        $value   = $val[1];
        $sql = "SELECT `selected` FROM  #__js_res_config  WHERE `section` = '{$section}' AND name = '{$value}'";
        $db->setQuery( $sql );
        $rows = $db->loadResult();
        return $rows;
    }
    
    function set($val, $val2, $option='', $ad=NULL)
    {
        $db =& JFactory::getDBO();
        
        if(!$option) $option = JRequest::getVar('option', 'com_jcommerce');
        if(!$option || !$val) return false;
        $val = explode('.', $val);
        $section = $val[0];
        $value   = $val[1];
        
        $sql = "SELECT id FROM `#__js_res_config` WHERE `section` = '{$section}' AND `name` = '{$value}'";
        $db->setQuery( $sql );
        
        if($db->loadResult() > 0)
        {
            $sql = "UPDATE `#__js_res_config` SET `selected` = '{$val2}' WHERE `section` = '{$section}' AND `name` = '{$value}'";
        }
        else
        {
            $sql = "
                INSERT INTO `#__js_res_config` 
                    ( `id` , `component` , `section` , `lable` , `name` , 
                    `type` , `description` , `values` , `selected` , `hidden` )
                VALUES ( NULL , '{$option}', '{$section}', '{$ad[lable]}', 
                         '{$value}', '{$ad[type]}', '{$ad[descr]}', 
                         '{$val2}', '{$val2}', '{$ad[hidden]}');";
        }
        
        $db->setQuery( $sql );
        if(!$db->query())
        {
            return FALSE;
        }
        else
        {
            return TRUE;
        }
    }
    
    function getData()
    {
        
        if (empty($this->_data))
      	{
      		$query = "SELECT * FROM #__js_res_config WHERE hidden = 'N'  ORDER BY `section`, `fieldset`, `type`, `lable` ASC";
      		$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
      		//echo $query;
      	}

        return $this->_data;
    }

    
    
	    function _getDirs($dir, $params, $dis = '', $level = 0)
		{
            global $mainframe;
            $skip = explode(", ", $params->get('skip'));
            if($params->get('level', 0) > 0)
            {
                if($params->get('level') <= $level){
                    return false;
                }
            }
            if($level == 0 && $params->get('show_root')) $dis = $dir;
            //$home = JPATH_BASE;
            if(!is_readable($dir)) return;
            $point = opendir($dir);
            //echo getcwd()."<br>";
            if(!$point) return JText::_('Cannot Open Directory');
            $dirs = false;
            while (($file = readdir($point)) !== false) { 
                //echo "ddddd";
                if($file == '.' || $file == '..' || !is_dir($dir.DS.$file) || in_array($file, $skip)) continue;
                $save = str_replace(DS.DS, DS, $dir.DS.$file);
                $display = str_replace(DS.DS, DS, $dis.DS.$file);
                $dirs[] = JHTML::_('select.option', $save, $display);
                $add = ResModelConfig::_getDirs($save, $params, $display, $level + 1);
                if(is_array($add)) $dirs = array_merge($dirs, $add);
            }
            closedir($point); 
            return $dirs;
        
		}
}
?>   
