<?php
/**
 * $Id: resource.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access');

jimport('joomla.html.pane');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.archive');
jimport('joomla.filter.filteroutput');
jimport('joomla.mail.helper');
jimport('joomla.application.component.controller');
jimport('joomla.application.component.model');
jimport('joomla.utilities.date');
jimport('joomla.language.helper');
jimport('joomla.database.table');

if(!JFile::exists(JPATH_ROOT.DS.'media'.DS.'mightyextensions'.DS.'xajax'.DS.'xajaxAIO.inc.php' ))
{
	JError::raiseWarning(500, JText::_('In order Rresources 1.5 and above to work, you need to install latest media pack.'));
	if(JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jslm'.DS.'jslm.php'))
	{
		$mainframe->redirect('index.php?option=com_jslm&cmt=com_resource');
	}
	else
	{
		JError::raiseWarning(403, JText::_('Please install Mighty Assistant.').' <a target="_blank" href="http://www.mightyextensions.com/download-mighty-assistant">'.JText::_('Download').'</a>');
		$mainframe->redirect('index.php');
	}
	return;
}

JHTML::_('behavior.tooltip');

require_once (JPATH_COMPONENT.DS.'controller.php');
require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');
require_once (JPATH_COMPONENT_ADMINISTRATOR.DS.'controllers'.DS.'config.php');
require_once (JPATH_COMPONENT_SITE.DS.'library'.DS.'php'.DS.'jsfilemanager.php');
ResControllerConfig::initialyze();

$document = &JFactory::getDocument();
$document->addScript(JURI::root().'components/com_resource/library/js/resource.js');
$document->addStyleSheet( JURI::root().'administrator/components/com_resource/library/style.css');

if($controller = JRequest::getWord('controller', 'application')) {
	$path = JPATH_COMPONENT.DS.'controllers'.DS.$controller.'.php';
	if (file_exists($path)) {
		require_once $path;
	} else {
		$controller = '';
	}
}

if((!defined('RES_GENERAL_UPLOAD') || !is_dir(@RES_GENERAL_UPLOAD) || !is_readable(@RES_GENERAL_UPLOAD)) && $controller != 'config')
{
	JError::raiseNotice(100, 'File Secure Directory either not set or not writtable. We recommend create "uploads" directory in your Joomla root and set this directory as File Secure Directory.');
	$mainframe->redirect('index.php?option=com_resource&controller=config');
}
JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables');

ucfirst($controller) ? $classname = 'ResController'.ucfirst($controller) : $classname = 'ResController1';
$controller	= new $classname( );

require_once (JPATH_COMPONENT.DS.'resource.xajax.php');

$controller->execute( JRequest::getCmd('task'));
$controller->redirect();
?>
<div style="clear:both"></div>
<p>
	<center class="small">
		&copy; 2007 - 2011 <a href="http://www.mightyextensions.com">MightyExtensions</a>, 
		<a href="mailto:support@joomsuite.com?subject=JoomSuite Resources Joomla Component">support@mightyextensions.com</a>  
	</center>
</p>
<style type="text/css">
 #adesk-button{
 position: fixed;
 right: 0;
 top: 50%;
 background: url(https://s3.amazonaws.com/adws/widgets/imgs/fs-r-joomla.png) no-repeat;
 height: 250px;
 width: 27px
}
</style>
    <a href="javascript:adesk_stak.init.call();" id="adesk-button"></a>

          <div id="adesk-widget" style="display:none;">

            <div id="wd-overlay">

              <div class="info-box"><a class="close" href="javascript:javascript:adesk_stak.closePop();"></a></div>

            </div>

            <div id="wd-expose"></div>

          </div>
          
     <script type="text/javascript">

      adesk_option = {

        prod: 'mighty-resources-cck-joomla-component',

                    user: 'mightyextensions',

                    lang:'en'

      }

    </script>

    <script type="text/javascript" src="https://s3.amazonaws.com/adws/widgets/feed/widget.js"></script>