<?php
/**
 * $Id: resource.xajax.php 8087 2012-04-24 05:24:42Z kostya $
 * $LastChangedDate: 2012-04-24 11:24:42 +0600 (Tue, 24 Apr 2012) $
 * $LastChangedBy: kostya $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access');
//require_once( JPATH_COMPONENT_ADMINISTRATOR.DS.'library'.DS.'xajax'.DS.'xajax_core'.DS.'xajax.inc.php');
require_once( JPATH_ROOT.DS.'media'.DS.'mightyextensions'.DS.'xajax'.DS.'xajaxAIO.inc.php'  );
function jsrEmptyX($rows)
{
	$objResponse = new JS_SAFE_xajaxResponse();
	$db =& JFactory::getDBO();
	if(!$rows)
	{
		$objResponse->alert(Jtext::_('Please, select records'));
		return $objResponse;
	}
	$_rows = implode(",", $rows);

	$sql = "DELETE FROM #__js_res_record_category WHERE  catid IN($_rows)";
	$db->setQuery($sql);
	$db->query();

	foreach ($rows as $row) {
		$objResponse->assign('rnum_'.$row, 'innerHTML', 0);
	}

	$objResponse->assign('button_reset', "style.backgroundImage", 'url(components/com_resource/images/reset.png)');
	return $objResponse;

}
function jsrBlockIP($ip, $id)
{
	$objResponse = new JS_SAFE_xajaxResponse();
	$db =& JFactory::getDBO();

	$sql = "SELECT COUNT(*) FROM #__jdefender_block_list WHERE type = 'ip' AND `value` = '$ip'";
	$db->setQuery($sql);
	$res = $db->loadResult();

	if($res)
	{
		$sql = "DELETE FROM #__jdefender_block_list WHERE type = 'ip' AND `value` = '{$ip}'";
		$db->setQuery($sql);
		$db->query();
		$img = 'secure.png';
		$title = Jtext::_('Block IP');
	}
	else
	{
		$sql = "INSERT INTO #__jdefender_block_list (type, value) VALUES('ip', '{$ip}')";
		$db->setQuery($sql);
		$db->query();
		$img = 'secure_b.png';
		$title = Jtext::_('Unblock IP');
	}

	$objResponse->assign('icondefend'.$id, "src", JURI::root().'administrator/components/com_resource/images/'.$img);
	$objResponse->assign('icondefend'.$id, "title", $title);

	return $objResponse;
}
function jsrBlockUser($user, $id)
{
	$objResponse = new JS_SAFE_xajaxResponse();
	$db =& JFactory::getDBO();
	$o_user = & JFactory::getUser($user);

	$user = $o_user->get('username');

	$sql = "SELECT COUNT(*) FROM #__jdefender_block_list WHERE type = 'user' AND `value` = '{$user}'";
	$db->setQuery($sql);
	$res = $db->loadResult();

	if($res)
	{
		$sql = "DELETE FROM #__jdefender_block_list WHERE type = 'user' AND `value` = '{$user}'";
		$db->setQuery($sql);
		$db->query();
		$img = 'user_secure_b.png';
		$title = Jtext::_('Block User');
	}
	else
	{
		$sql = "INSERT INTO #__jdefender_block_list (type, value) VALUES('user', '{$user}')";
		$db->setQuery($sql);
		$db->query();
		$img = 'user_secure.png';
		$title = Jtext::_('Unblock User');
	}

	$objResponse->assign('icondefend2'.$o_user->get('id').$id, "src", JURI::root().'administrator/components/com_resource/images/'.$img);
	$objResponse->assign('icondefend2'.$o_user->get('id').$id, "title", $title);

	return $objResponse;
}
function jcResetHits( $id )
{
	$objResponse = new JS_SAFE_xajaxResponse();

	$db =& JFactory::getDBO();

	$sql = "DELETE FROM #__js_res_hits WHERE record_id = $id";
	$db->setQuery($sql);
	$db->query();

	$sql = "UPDATE #__js_res_record SET hits = '0'  WHERE id = $id";
	$db->setQuery($sql);
	$db->query();

	$objResponse->assign('hit_'.$id, "innerHTML", '0');
	return $objResponse;
}
function jsrResetX( $ids, $what )
{
	$objResponse = new JS_SAFE_xajaxResponse();
	$db =& JFactory::getDBO();
	$objResponse->assign('button_reset', "style.backgroundImage", 'url(components/com_resource/images/reset.png)');
	if(!$ids)
	{
		$objResponse->alert(Jtext::_('Please, select records'));
		return $objResponse;
	}
	foreach ($ids as $key => $value)
	{
		if(is_array($ids[$key]))
		{
			unset($ids[$key]);
		}
	}
	$ids = implode(",", $ids);
	
	$now = ResHelper::getDate();

	switch ($what)
	{
		case 'reset_hits':
			$sql = "DELETE FROM #__js_res_hits WHERE record_id IN ($ids)";
			$db->setQuery($sql);
			$db->query();

			$sql = "UPDATE #__js_res_record SET hits = '0'  WHERE id IN ($ids)";
			$db->setQuery($sql);
			$db->query();

			//$objResponse->assign('hit_'.$id, "innerHTML", '0');
			break;
		case 'reset_com':
			$sql = "DELETE FROM #__js_res_comments WHERE record_id IN ($ids)";
			$db->setQuery($sql);
			$db->query();
			break;
		case 'reset_vote':
			$sql = "DELETE FROM #__js_res_vote WHERE record_id IN ($ids)";
			$db->setQuery($sql);
			$db->query();
			break;
		case 'reset_fav':
			$sql = "DELETE FROM #__js_res_favorite WHERE record_id IN ($ids)";
			$db->setQuery($sql);
			$db->query();
			break;
		case 'reset_ctime':
			$sql = "UPDATE #__js_res_record SET ctime = '{$now}' WHERE id IN ($ids)";
			$db->setQuery($sql);
			$db->query();
			break;
		case 'reset_mtime':
			$sql = "UPDATE #__js_res_record SET mtime = '{$now}' WHERE id IN ($ids)";
			$db->setQuery($sql);
			$db->query();
			break;
		case 'reset_extime':
			$sql = "UPDATE #__js_res_record SET extime = '0000-00-00 00:00:00' WHERE id IN ($ids)";
			$db->setQuery($sql);
			$db->query();
			break;
	}
	$objResponse->alert(Jtext::_('Reset Successfully'));
	return $objResponse;
}
function jcFilterTypeParams( $type )
{
	$objResponse = new JS_SAFE_xajaxResponse();
	if( $type ) {
		$params = new JParameter( '', JPATH_PLUGINS.DS.'joomsuite_content'.DS."filter_".$type.'.xml');
		$objResponse->assign( 'type_params', "innerHTML", $params->render() );
	} else {
		$objResponse->assign( 'type_params', "innerHTML", JText::_( "No params in this type" ) );
	}

	return $objResponse;
}
function jcTypeParams($type)
{
	$objResponse = new JS_SAFE_xajaxResponse();

	$lang = JFactory::getLanguage();
	$lang->load('plg_joomsuite_content_fields_'.$type);

	$params = new JParameter('', JPATH_ROOT.DS.'plugins'.DS.'joomsuite_content_fields'.DS.$type.'.xml');
	$fparams = new JParameter('', JPATH_COMPONENT_ADMINISTRATOR.DS.'xml'.DS.'fields.xml');

	$dispatcher    =& JDispatcher::getInstance();
	JPluginHelper::importPlugin('joomsuite_content_fields', $type);
//	$dispatcher->trigger( 'onJip', array (&$jip, $type) );
//	if($jip) $objResponse->assign('jip_params', "innerHTML", '<fieldset><legend>'.JText::_('Just In Place').'</legend>'.$fparams->render('params', 'jip').'</fieldset>');
//	else $objResponse->assign('jip_params', "innerHTML", '');

	$dispatcher->trigger( 'onFilter', array (&$filter, $type) );
	if($filter) $objResponse->assign('filter_params', "innerHTML", '<fieldset><legend>'.JText::_('Filter').'</legend>'.$fparams->render('params', 'Filter').'</fieldset>');
	else $objResponse->assign('filter_params', "innerHTML", '');
	
	$objResponse->assign('type_params', "innerHTML", $params->render());

	$objResponse->script("jcRunScripts('type_params');");
	//$objResponse->script("listAdmin();");
	return $objResponse;
}
/*function jcLoadList($contr, $add = 0)
{

	$objResponse = new JS_SAFE_xajaxResponse();

	ob_start();
	$str = sprintf('jc%sController::show_list(%d);',
	ucfirst($contr), $add ? $add : NULL);
	eval($str);
	$form = ob_get_clean();

	//$objResponse->alert($form);
	//return $objResponse;

	$objResponse->assign('jcAdminList', "innerHTML", $form);
	$objResponse->script("listAdmin();");
	return $objResponse;

}

function jcSaveFormClose($post, $contr)
{
	$objResponse = new JS_SAFE_xajaxResponse();
	if(!$contr) $contr = 'Record';
	$objResponse->script("pBarOut();");

	$db  =& JFactory::getDBO();
	$row =& JTable::getInstance($contr, 'Res');
	//$objResponse->alert($contr);
	//return $objResponse;

	$row->bind( $post );
	$row->checkin();

	$objResponse->script("listAdmin();");
	$objResponse->script("subClose();");
	return $objResponse;
}

function jcSaveForm($vals, $contr, $add = 0)
{
	$objResponse = new JS_SAFE_xajaxResponse();

	//$objResponse->alert($contr);
	//return $objResponse;
	$objResponse->script("pBarOut();");
	//$objResponse->script("subClose();");
	//return $objResponse;

	$db  =& JFactory::getDBO();
	$row =& JTable::getInstance($contr, 'Res');

	if (!$row->bind( $vals ))
	{
		$objResponse->alert($row->getError());
		return $objResponse;
	}
	if (!$row->check())
	{
		$objResponse->alert($row->getError());
		return $objResponse;
	}

	if (!$row->store())
	{
		$objResponse->alert($row->getError());
		return $objResponse;
	}
	$row->checkin();

	//if($vals['mark'])
	//{
	//jcCurrencyController::updateMark($vals['mark'], $vals['id']);
	//}
	JRequest::setVar('type_id', @$vals['type_id']);
	ob_start();
	$classname	= 'ResController'.ucfirst($contr);
	$controller	= new $classname( );
	$controller->execute('show_list');

	//$str = sprintf('ResController%s::show_list(%d);',
	//ucfirst($contr), $add ? $add : NULL);
	//eval($str);
	$form = ob_get_clean();


	//$objResponse->alert($str);
	$objResponse->assign('jcAdminList', "innerHTML", $form);
	$objResponse->script("listAdmin();");
	$objResponse->script("subClose();");
	return $objResponse;
}

function jcNew($contr, $id = null, $add = 0)
{
	$objResponse = new JS_SAFE_xajaxResponse();

	ob_start();
	//$classname	= 'ResController'.ucfirst($contr);
	//$controller	= new $classname( );
	//$controller->execute('edit');
	$str = sprintf('ResController%s::edit(\'%d\',\'%d\');',
	ucfirst($contr), $id, $add);
	eval($str);
	$form = ob_get_clean();

	$objResponse->assign('jcSubForm', "innerHTML", $form);
	$objResponse->script("subForm();");
	//$objResponse->alert($form);
	//return $objResponse;
	$objResponse->script("pBarOut();");
	//$objResponse->script("return true;");
	//$objResponse->alert($form);

	return $objResponse;
}*/


function jcFeature($id, $table, $publish)
{
	$db =& JFactory::getDBO();
	$publish ? $img  = 'publish_x.png' : $img  = 'tick.png';
	$alt = !$publish ? JText::_('Featured' ) : JText::_('UnFeatured');
	$set = ($publish ? 0 : 1);

	$sql = "UPDATE #__$table SET featured = '$set' WHERE id = '$id'";
	$db->setQuery($sql);
	$db->query();


	$href = "<a href=\"javascript:void(0);\"  ".
        "id=\"feature_$id\" onclick=\"document.getElementById('fdiv_$id').innerHTML = '<img src=components/com_resource/images/load.gif>';xajax_jcFeature('$id', '$table', '$set')\">".
        "<img src=\"images/$img\" border=\"0\" title=\"$alt\"/></a>";

	$objResponse = new JS_SAFE_xajaxResponse();
	//$objResponse->script("pBarOut();");

	//$objResponse->alert($publish.$set);
	$objResponse->assign("fdiv_$id", "innerHTML", $href);

	return $objResponse;

}
function jcPublish($id, $table, $publish)
{
	$db =& JFactory::getDBO();
	$publish ? $img  = 'publish_x.png' : $img  = 'tick.png';
	$alt = !$publish ? JText::_('Published' ) : JText::_('Unpublished');
	$set = ($publish ? 0 : 1);
	if($publish == '-1')
	{
		$set = 1;
		$img  = 'tick.png';
		$alt = JText::_('Published');
	}

	$sql = "UPDATE #__$table SET published = '$set' WHERE id = '$id'";
	$db->setQuery($sql);
	$db->query();


	$href = "<a href=\"javascript:void(0);\"  ".
        "id=\"publish_$id\" onclick=\"document.getElementById('pdiv_$id').innerHTML = '<img src=components/com_resource/images/load.gif>';xajax_jcPublish('$id', '$table', '$set')\">".
        "<img src=\"images/$img\" border=\"0\" title=\"$alt\"/></a>";

	$objResponse = new JS_SAFE_xajaxResponse();
	//$objResponse->script("pBarOut();");

	//$objResponse->alert($publish.$set);
	$objResponse->assign("pdiv_$id", "innerHTML", $href);

	return $objResponse;

}
function jcPublishList($ids, $table, $publish)
{
	$objResponse = new JS_SAFE_xajaxResponse();
	//$objResponse->assign('bar_publish1', 'style.backgroundImage', 'url(components/com_jcommerce/images/toolbar/icon-32-publish.png)');
	//$objResponse->assign('bar_publish0', 'style.backgroundImage', 'url(components/com_jcommerce/images/toolbar/icon-32-unpublish.png)');
//	$objResponse->script("pBarOut();");

	$alt = !$publish ? JText::_('Publish' ) : JText::_('Unpublish');
	foreach ($ids as $key => $value)
	{
		if(is_array($ids[$key]))
		{
			unset($ids[$key]);
		}
	}
	if(!$ids)
	{
		$objResponse->alert(JText::_('Please make a selection from the list to').' '.$alt);
		return $objResponse;
	}

	$db =& JFactory::getDBO();
	$publish ? $img  = 'publish_x.png' : $img  = 'tick.png';
	$set = ($publish ? 0 : 1);

	$id = implode(",", $ids);

	$sql = "UPDATE #__$table SET published = '$set' WHERE id IN ($id)";

	$db->setQuery($sql);
	$db->query();




	//$objResponse->alert("Lets's see:\n".$ids[0]);
	foreach ($ids AS $id)
	{
		$href = "<a href=\"javascript:void(0);\"  ".
            "id=\"publish_$id\" onclick=\"document.getElementById('pdiv_$id').innerHTML = '<img src=components/com_resource/images/load.gif>';xajax_jcPublish('$id', '$table', '$set')\">".
            "<img src=\"images/$img\" border=\"0\" alt=\"$alt\"/></a>";
		$objResponse->assign("pdiv_$id", "innerHTML", $href);
	}
	//$objResponse->assign("progress_bar", "innerHTML", '');
	//$objResponse->script("pBarOut();");
	return $objResponse;

}
function jcDeleteList($ids, $table, $trash = false)
{
	$objResponse = new JS_SAFE_xajaxResponse();
//	$objResponse->script("pBarOut();");
	//$objResponse->alert("Test");
	//return $objResponse;

	//$objResponse->assign('bar_delete', 'style.backgroundImage', 'url(components/com_jcommerce/images/toolbar/icon-32-trash.png)');

	if(!$ids)
	{
		$objResponse->alert(JText::_('Please make a selection from the list to Delete'));
		return $objResponse;
	}

	$db =& JFactory::getDBO();
	
	foreach ($ids as $key => $value)
	{
		if(is_array($ids[$key]))
		{
			unset($ids[$key]);
		}
	}
	
	$id = implode(",", $ids);

	// let's take care of related records. Means if delete group
	// olso delete items in that group. This structure should grow
	// with component developing.
	SWITCH($table)
	{
		// if deleting property groups, delete group items as well.
		case 'js_res_types':
			$sql = "DELETE FROM #__js_res_fields  WHERE type_id IN ($id)";
			$db->setQuery($sql);
			$db->query();
			break;

		case 'js_res_fields':
			$sql = "DELETE FROM #__js_res_record_values  WHERE field_id IN ($id)";
			$db->setQuery($sql);
			$db->query();
			break;
		case 'js_res_record':
				
			$dispatcher =& JDispatcher::getInstance();
			JPluginHelper::importPlugin('joomsuite_content_fields');
			$dispatcher->trigger('onDeleteRecords', array($ids) );
				
			$sql = "DELETE FROM #__js_res_record_category  WHERE record_id IN ($id)";
			$db->setQuery($sql);
			$db->query();
			$sql = "DELETE FROM #__js_res_vote  WHERE record_id IN ($id)";
			$db->setQuery($sql);
			$db->query();
			$sql = "DELETE FROM #__js_res_tags_history  WHERE record_id IN ($id)";
			$db->setQuery($sql);
			$db->query();
			$sql = "DELETE FROM #__js_res_record_values  WHERE record_id IN ($id)";
			$db->setQuery($sql);
			$db->query();
			$sql = "DELETE FROM #__js_res_hits WHERE record_id IN ($id)";
			$db->setQuery($sql);
			$db->query();
			$sql = "DELETE FROM #__js_res_favorite WHERE record_id IN ($id)";
			$db->setQuery($sql);
			$db->query();
			$sql = "DELETE FROM #__js_res_comments WHERE record_id IN ($id)";
			$db->setQuery($sql);
			$db->query();
				
			break;
	}

	$sql = "DELETE FROM #__$table  WHERE id IN ($id)";

	if($trash) $sql = "UPDATE #__$table SET trash = '1'  WHERE id IN ($id)";

	$db->setQuery($sql);
	$db->query();

	// Hide deleted rows. For that row have to have id="row_ID"
//	foreach ($ids AS $id)
//	{
		//$objResponse->assign("row_$id", "style.display", 'none');
		//$objResponse->script("var myAnim = new YAHOO.util.Anim('row_$id', { height: { to: 0 } }, 1, YAHOO.util.Easing.easeOut); myAnim.animate();");
//	}
	//$objResponse->alert(JText::_('Records Deleted'));
	//$objResponse->assign("progress_bar", "innerHTML", '');
	//return $objResponse;

}
function jcAccess($id, $table, $access)
{
	$db =& JFactory::getDBO();

	switch ($access)
	{
		case 0:
			$set   = 1;
			$name  = 'Registered';
			$color = 'Red';
			break;
		case 1:
			$set   = 2;
			$name  ='Special';
			$color = 'Black';
			break;
		case 2:
			$set   = 0;
			$name  = 'Public';
			$color = 'Green';
			break;
	}
	$sql = "UPDATE #__$table SET access = '$set' WHERE id = '$id'";
	$db->setQuery($sql);
	$db->query();


	$href = "<a href=\"javascript:void(0);\"  id=\"access_$id\" onclick=\"document.getElementById('adiv_$id').innerHTML = '<img src=components/com_resource/images/load.gif>';xajax_jcAccess('$id', '$table', '$set')\">$name</a>";
	$objResponse = new JS_SAFE_xajaxResponse();
	//$objResponse->alert($sql);
	//$objResponse->alert($id);
	$objResponse->assign("adiv_$id", "innerHTML", $href);
	$objResponse->assign("access_$id", "style.color", $color);
	return $objResponse;
}

/*
 * Removes media file from the RES_GENERAL_UPLOAD directory.
 * The path is chosen according to the file extension, and the
 * id of current user.
 */
// entodo: remove debug stuff.
function jcRemoveMediaFile($filename, $recordId, $prefix) {
	require_once JPATH_ADMINISTRATOR.'/components/com_resource/tables/record_values.php';
	require_once JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php';

	$enDebug = false;

	$user = & JFactory::getUser();
	$userId = $user->get('id');

	ResControllerConfig::initialyze ();
	JTable::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_resource/tables/');

	$objResponse = new JS_SAFE_xajaxResponse();
	$objResponse->setReturnValue(false);
	$enDebug && $objResponse->alert($filename.' - '. $prefix);

	$record = & JTable::getInstance('Record', 'Res');
	$record->set('id', $recordId);

	if ($record->load()) {
		$userId = $record->get('user_id');
	}
	$enDebug && $objResponse->alert('userid - '. $userId);

	// Now, check, if we have our file
	// Delete the file, if it is already uploaded.
	$ext = JString::strtolower(JFile::getExt($filename));
	if ($ext == 'jpeg')
	$ext = 'jpg';

	$fileToDelete = RES_GENERAL_UPLOAD.DS.$userId.DS.$ext.DS.$filename;
	$enDebug && $objResponse->alert('File to delete: '.$fileToDelete);

	// entodo: remove debug stuff;
	if (JFile::exists($fileToDelete)) {
		$enDebug && $objResponse->alert('File to delete exists');
		JFile::delete($fileToDelete);
	}

	// Good.. now, delete that '<tr>' on the page!
	$guid = substr($prefix, 0, strlen($prefix) - 1);
	$trId = $prefix.$filename;
	$command = 'MediaHelper'.$guid.'.onSuccess("'.$trId.'");';
	$enDebug && $objResponse->alert($command);
	$objResponse->script($command);

	$objResponse->setReturnValue(true);
	return $objResponse;
}
function jcProductTypeParams($type, $fid)
{
	$objResponse = new JS_SAFE_xajaxResponse();

	$db =& JFactory::getDBO();
	$fparams = '';
	if($fid != '')
	{
		$sql = "SELECT params FROM #__js_res_fields WHERE id='$fid'";
		$db->setQuery($sql);
		$fparams = $db->loadResult();
	}
	$params = new JParameter($fparams, JPATH_ROOT.DS.'plugins'.DS.'joomsuite_product_type'.DS.$type.'.xml');
	//$objResponse->alert($params);
	//$objResponse->alert($params->render());
	$objResponse->assign('product-type-params', "innerHTML", $params->render());
//	$objResponse->script("pBarOut();");
	//$objResponse->script("listAdmin();");
	return $objResponse;
}
function deleteCategory($article, $category)
{
	$objResponse = new JS_SAFE_xajaxResponse();

	$db =& JFactory::getDBO();
	$sql = "DELETE FROM #__js_res_record_category WHERE record_id='$article' AND catid = '$category'";
	$db->setQuery($sql);
	$db->query();

	$sql = "SELECT * FROM #__js_res_record_category WHERE record_id='$article'";
	$db->setQuery($sql);
	$categories = $db->loadObjectList();
	if(count($categories) == 1)
	{
		$objResponse->assign("img_{$article}_{$categories[0]->catid}", "style.display", 'none');
	}
	$objResponse->assign("cat_{$article}_{$category}", "style.display", 'none');

	//$objResponse->alert(JText::_('Category Deletes'));
	return $objResponse;
}

function jsCallPlugin( $plugin_group, $plugin_name, $plugin_function, $params )
{
	if (JString::strpos(JString::strtolower($plugin_function), 'xajax') === false)
	return;

	$dispatcher =& JDispatcher::getInstance();

	JPluginHelper::importPlugin( $plugin_group, $plugin_name );

	$objResponse = new JS_SAFE_xajaxResponse();

	array_unshift( $params, 1 );

	$params[0] = & $objResponse;

	$dispatcher->trigger( $plugin_function, $params );

	return $objResponse;
}

function jsGetCategoryList($catid = 0, $multiple, $disabled, $name){
	$responce = new JS_SAFE_xajaxResponse();
	
	if(!is_integer($catid)){
		$parts = explode('_', $catid);
		$id = $parts[1];
	}else{
		$id = $catid;
	}
	$db = JFactory::getDBO();
	
	$sql = "select c.id AS value, c.name as text, count(c1.id)  as leaf 
				FROM #__js_res_category as c
				LEFT JOIN #__js_res_category as c1 on c1.parent = c.id WHERE c.parent = $id AND c.published = 1 GROUP BY c.id";
	$db->setQuery($sql);
	$res = $db->loadObjectList();
	
	$node = array();
	$amount = count($res);
	$i = 0;
	foreach ($res as $key => $r) {
		$i++;
		$node[] = '<li id="catid_'.$r->value.'" class="Node '.($i == $amount ? ' IsLast ' : ''). (!$r->leaf ? ' ExpandLeaf ' : ' ExpandClosed ').' ">
					    <div id="catid_'.$r->value.'_control" class="Expand" '.(!$r->leaf ? '' : 'onclick="my_load($(\'catid_'.$r->value.'\'));"').'></div>
					    <div class="Content">'.(!in_array($r->value, $disabled) ? '<input type="'.($multiple ? 'checkbox' : 'radio').'" name="'.$name.'" value="'.$r->value.'">' : '').'<span '.(!$r->leaf ? '' : 'ondblclick="my_load($(\'catid_'.$r->value.'\'));"').'>'.$r->text.'</span></div>
					    <ul id="catid_'.$r->value.'_container" class="Container">
					    </ul>
				    </li>';
	}
	if($amount){
		$responce->assign($catid.'_container', 'innerHTML', implode($node));
	}else{
		$responce->append($catid, 'className', ' ExpandLeaf');
	}
	$responce->replace($catid, 'className', 'ExpandClosed', 'ExpandOpen');
	$responce->replace($catid.'_control', 'className', 'ExpandLoading', 'Expand');
	
	return $responce;
}

$xajax = new JS_SAFE_xajax(JURI::root().'administrator/index3.php?option=com_resource&controller='.JRequest::getVar('controller'));
//$xajax->debugOn(); // Uncomment this line to turn debugging on

$xajax->registerFunction("jcFeature");
$xajax->registerFunction("jsrEmptyX");
$xajax->registerFunction("jsrBlockUser");
$xajax->registerFunction("jsrBlockIP");
$xajax->registerFunction("jsrResetX");
$xajax->registerFunction("deleteCategory");
$xajax->registerFunction("jcTypeParams");
$xajax->registerFunction("jcResetHits");
$xajax->registerFunction("jcFilterTypeParams");
$xajax->registerFunction("jcAccess");
$xajax->registerFunction("jcPublish");
$xajax->registerFunction("jcPublishList");
$xajax->registerFunction("jcDeleteList");
//$xajax->registerFunction("jcNew");
//$xajax->registerFunction("jcSaveForm");
//$xajax->registerFunction("jcLoadList");
//$xajax->registerFunction("jcSaveFormClose");
$xajax->registerFunction("jcRemoveMediaFile");
$xajax->registerFunction("jcProductTypeParams");
$xajax->registerFunction( "jsCallPlugin" );
$xajax->registerFunction( "jsGetCategoryList" );

//$xajax->bDebug = true;
$xajax->processRequest();
$xajax->printJavascript(JURI::root().'media/mightyextensions/xajax/');
//$xajax->printJavascript('components/com_resource/js/');

?>
