<?php
/**
 * $Id: category.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access');

/**
* @package JCommerce
*/

class ResCategory extends JTable
{

    /** @var int */
    var $id	= null;
    /** @var int */
    var $name	= '';
    /** @var string */
    var $description = '';
    /** @var string */
    //var $level	= 0;
    /** @var int */
    var $ordering = 0;
    /** @var int */
    var $published = 0;
    /** @var int */
    var $trash = 0;
    /** @var string */
    var $icon	= '';
    /** @var string */
    var $ctime	= null;
    /** @var date */
    var $mtime	= null;
    /** @var int */
    var $parent	= 0;
    /** @var string */
    var $access	= '';
    /** @var string */
    var $checked_out = null;
    /** @var time */
    var $checked_out_time = null;
    /** @var int */
    var $clicks = 0;
    /** @var string */
    var $image	= '';
    /** @var string */
    var $image_position	= '';
    /** @var string */
    var $title	= '';
    var $params	= '';
	var $meta_descr = '';
	var $meta_key = '';
	var $section_id = 0;
	var $alias = 0;
    
	function __construct( &$_db ) {
		parent::__construct( '#__js_res_category', 'id', $_db );
		$this->set( 'mtime', date( 'Y-m-d G:i:s' ) );
	}
	function bind($array, $ignore = '')
	{
		if(is_array($array))
		{
			if (key_exists('params', $array )) {
				if(is_array($array['params']))
				{
					$registry = new JRegistry();
					$registry->loadArray($array['params']);
					$array['params'] = $registry->toString();
				}
			}
		}
				
		return parent::bind($array, $ignore);
	}
	//function store()
	//{
	//	parent::store();
	//	echo $this->_error; exit;
	//}
	function click() {
		$query = "UPDATE #__js_res_category"
		. "\n SET clicks = ( clicks + 1 )"
		. "\n WHERE id = " . (int) $this->id
		;
		$this->_db->setQuery( $query );
		$this->_db->query();
	}

	function check() {
		/*/ check for valid client id
		if (is_null($this->cid) || $this->cid == 0) {
			$this->_error = jcText::_('BNR_CLIENT');
			return false;
		}

		if(trim($this->name) == '') {
			$this->_error = jcText::_('BNR_NAME');
			return false;
		}
    */
		/*if(trim($this->imageurl) == '') {
			$this->_error = jcText::_('BNR_IMAGE');
			return false;
		}
		if(trim($this->clickurl) == '' && trim($this->custombannercode) == '') {
			$this->_error = jcText::_('BNR_URL');
			return false;
		}*/
		if (!$this->alias) {
			$this->alias = JString::strtolower(JString::str_ireplace(" ", "-", $this->name));
		}
		$this->alias = aliasConverter($this->alias);
		$this->alias = JString::strtolower(JString::str_ireplace(Array(" ", "--"), "-", $this->alias));
		
		

		return true;
	}
}
?>
