<?php
/**
 * $Id: default.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access'); ?>

<?php JHTML::_('behavior.tooltip'); ?>

<?php
  // Set toolbar items for the page
  JToolBarHelper::title( JText::_('Rating Manager' ), 'generic.png');
  JToolBarHelper::deleteList();
  JSToolBar::helpW('http://help.mightyextensions.com/resources/index.html?rating.htm', 1000, 500);
  ?>
<form action="index.php" method="post" name="adminForm">
<table>
<tr>
  <td align="left" width="100%">
    <?php echo JText::_('Filter'); ?>:
    <input type="text" name="search" id="search" value="<?php echo $this->lists['search'];?>" class="text_area" onchange="document.adminForm.submit();" />
    <button onclick="this.form.submit();"><?php echo JText::_('Go'); ?></button>
    <button onclick="document.getElementById('search').value='';this.form.getElementById('filter_catid').value='0';"><?php echo JText::_('Reset'); ?></button>
  </td>
  <td nowrap="nowrap">
    <?php
      echo $this->lists['vote'];  
      echo $this->lists['catid'];
    ?>
  </td>
</tr>
</table>
<div id="editcell">
  <table class="adminlist">
  <thead>
    <tr>
      <th width="1%">
        <?php echo JText::_('NUM'); ?>
      </th>
      <th width="1%">
        <input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count( $this->items ); ?>);" />
      </th>
      <th width="200" nowrap="nowrap">
        <?php echo JHTML::_('grid.sort',  'Vote', 'a.vote',     $this->lists['order_Dir'], $this->lists['order'] ); ?>
      </th>
      <th class="title">
        <?php echo JHTML::_('grid.sort',  'Item', 'r.title',    $this->lists['order_Dir'], $this->lists['order'] ); ?>
      </th>
      <th width="10%">
        <?php echo JHTML::_('grid.sort',  'User', 'u.username', $this->lists['order_Dir'], $this->lists['order'] ); ?>
      </th>
      <th width="8%" nowrap="nowrap">
        <?php echo JHTML::_('grid.sort',  'Voted', 'a.ctime',   $this->lists['order_Dir'], $this->lists['order'] ); ?>
      </th>
      <th width="1%" nowrap="nowrap">
        <?php echo JHTML::_('grid.sort',  'ID',    'a.id',      $this->lists['order_Dir'], $this->lists['order'] ); ?>
      </th>
    </tr>
  </thead>
  <tfoot>
    <tr>
      <td colspan="9">
        <?php echo $this->pagination->getListFooter(); ?>
      </td>
    </tr>
  </tfoot>
  <tbody>
  <?php
  $k = 0;
  for ( $i = 0, $n = count( $this->items ); $i < $n; $i++ ) {
    $row = &$this->items[$i];
    ?>
    <tr class="<?php echo "row$k"; ?>">
      <td>
        <?php echo $this->pagination->getRowOffset( $i ); ?>
      </td>
      <td>
        <?php echo JHTML::_('grid.id', $i, $row->id ); ?>
      </td>
      <td>
        <?php echo $row->vote; ?>
      </td>
      <td>
        <a href="<?php echo $row->record_href; ?>"><?php echo $row->recordtitle; ?></a>
      </td>
      <td width="5%" nowrap="nowrap">
        <?php 
		$user = &JFactory::getUser($row->user_id); 
		$link = 'index.php?option=com_users&task=edit&cid[]='.$user->get('id');
		if(is_dir(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_juser'))
			$link = 'index.php?option=com_juser&task=edit&cid[]='.$user->get('id');
		if($user->get('username')){
			echo JHTML::link('javascript:void(0);' ,$user->get('username'), array('title' => JText::_('Filter by this user'), 'onclick' => 'document.getElementById(\'search\').value=\''.$user->get('email').'\'; document.adminForm.submit();'));
			echo ' '.JHTML::link($link , JHTML::image(JURI::root(). 'administrator/components/com_resource/images/edit_user.png', JText::_('Edit'), array('align' => 'absmiddle', 'alt' => JText::_('Edit'))));
			echo ' '.jcHtml::getDefenderSign2($row->user_id, $row->id);
		}
		else
			echo Jtext::_('Anonymous'); 
		?>
		<?php if($row->ip): ?>
			<br />
			<?php getCountryByIP($row->ip);?>
			<?php echo JHTML::link('javascript:void(0);' ,$row->ip, array('title' => JText::_('Filter by IP'), 'onclick' => 'document.getElementById(\'search\').value=\''.$row->ip.'\'; document.adminForm.submit();')); ?>	
			<?php echo jcHtml::getDefenderSign($row->ip, $row->id); ?>
		<?php endif; ?>
      </td>
      <td align="center">
        <?php $data = new JDate($row->ctime); echo $data->toFormat(JText::_('%d-%b-%Y')); ?>
      </td>
      <td align="center">
        <?php echo $row->id; ?>
      </td>
    </tr>
    <?php
    $k = 1 - $k;
  }
  ?>
  </tbody>
  </table>
</div>

  <input type="hidden" name="option"           value="com_resource" />
  <input type="hidden" name="controller"       value="rating" />
  <input type="hidden" name="task"             value="" />
  <input type="hidden" name="boxchecked"       value="0" />
  <input type="hidden" name="filter_order"     value="<?php echo $this->lists['order']; ?>" />
  <input type="hidden" name="filter_order_Dir" value="<?php echo $this->lists['order_Dir']; ?>" />
  <?php echo JHTML::_('form.token'); ?>
</form>