<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die( 'Restricted access');

jimport( 'joomla.application.component.view');
jimport( 'joomla.filesystem.folder');

JHTML::_('behavior.modal', 'a.modal');

class ResViewTag extends JView
{
  function display($tpl = null)
  {
   
    switch ( $this->getLayout() ) {
      case "form" :
        $this->display_form( $tpl );
        break;
      default : 
      case "default" :
        $this->display_default( $tpl );
        break;
    }
  }
  
  function display_default($tpl = null)
  {
    global $mainframe, $option;
    
    $uri =& JFactory::getURI();

    $filter_catid     = $mainframe->getUserStateFromRequest( $option.'.tags.filter_catid',     'filter_catid',     0,         'int');
    $filter_order     = $mainframe->getUserStateFromRequest( $option.'.tags.filter_order',     'filter_order',     'a.ctime', 'cmd');
    $filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'.tags.filter_order_Dir', 'filter_order_Dir', '',        'word');
    $search           = $mainframe->getUserStateFromRequest( $option.'.tags.search',           'search',           '',        'string');
    $search           = JString::strtolower( $search );

    // Get data from the model
    $items      = & $this->get( 'Data');
    $total      = & $this->get( 'Total');
    $pagination = & $this->get( 'Pagination');
    
    // table ordering
    $lists['order_Dir'] = $filter_order_Dir;
    $lists['order']     = $filter_order;
    
    $lists['search']    = $search;
    
    $this->assignRef('user',       JFactory::getUser());
    $this->assignRef('lists',      $lists);
    $this->assignRef('items',      $items);
    $this->assignRef('pagination', $pagination);

    parent::display($tpl);
  }
  
}