<?php
/**
 * $Id: utility.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

class ResControllerUtility extends JController
{
	function display()
	{
		if (JRequest::getCmd('task') == 'edit') {
			JRequest::setVar('view', 'utility' );
			JRequest::setVar('layout', 'edit' );
		}
		parent::display();
	}
	
	function check_key()
	{
		global $mainframe;
		$id = JRequest::getInt('id');
		$key = trim(JRequest::getVar('access_key'));
		$session = & JFactory::getSession();
		
		if(!$id)
		{
			JError::raiseWarning(500, JText::_('No article ID'));
			$mainframe->redirect();
		}

		$article = & JTable::getInstance('Record', 'Res');
		$article->load($id);
		
		if($article->access_key == $key)
		{
			$session->set('access_'.$article->id, 1);
			$article_cat = ResHelper::getArticleSection($id);
			JError::raiseNotice(400, JText::_('Access Key Valid'));
			JRequest::setVar('view', 'article' );
			JRequest::setVar('layout', 'form' );
			JRequest::setVar('article', $id );
			JRequest::setVar('category_id', $article_cat );
			JRequest::setVar('redirect', base64_encode('index.php?option=com_resource&controller=article&article='.$id.'&category_id='.$article_cat));
		}
		else
		{
			JError::raiseNotice(400, JText::_('Access key does not match. New access key is sent to you. Please check your email again and try once more.'));
			JRequest::setVar('view', 'utility' );
			JRequest::setVar('layout', 'edit' );
		}
		parent::display();
	}
}
?>