<?php
/**
 * $Id: jscombsectionswithcatsbysections.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();
jimport('joomla.filesystem.file');

class JElementJscombsectionswithcatsbysections extends JElement
{
	function fetchElement($name, $value, &$node, $control_name)
	{
		global $mainframe;
		
    	$ini = JFile::read( JPATH_ADMINISTRATOR.DS."components".DS."com_resource".DS."config.ini" );
		$components_params = new JParameter( $ini, JPATH_ADMINISTRATOR.DS."components".DS."com_resource".DS.'xml'.DS."params.xml" );
		
		$db	=& JFactory::getDBO();

		$sql = "SELECT id, name, parent, section_id  FROM #__js_res_category WHERE published = 1 ".($components_params->get('mode') ? "" : " AND parent = 0 ")." ORDER BY parent = 0 DESC, name ASC";
		$db->setQuery( $sql );
		
		$cats = $db->loadObjectList();
		
		$sorted_cats = array();
		
		foreach( $cats as $key => $cat ) {
		  if( $cat->parent == 0 ) {
		    $cat->level = 0;
		    $sorted_cats[] = $cat;
		    unset( $cats[$key] );
		  } else  break;
	  }
	  
		while( count($cats) > 0 ){
  	  foreach( $cats as $key => $cat ) {
  	    foreach( $sorted_cats as $skey => $sorted_cat ){
  	      if( $cat->parent == $sorted_cat->id ) {
  	        $cat->level = $sorted_cat->level+1;
  	        while( isset( $sorted_cats[$skey+1] ) &&  $sorted_cats[$skey+1]->parent == $cat->parent ) $skey++;
            array_splice( $sorted_cats, $skey, 1, array( $sorted_cats[$skey], $cat ) );
            unset( $cats[ $key ] );
  	        break;
  	      }
  	    }
  	  }
	  }
		
	  $options = array();
		foreach( $sorted_cats as $key => $cat ) {
		  $prefix = str_repeat( "&nbsp;&nbsp;-&nbsp;", $cat->level );
		  $options[] = JHTML::_( 'select.option', ( $cat->section_id ? $cat->section_id : $cat->id ).'_'.$cat->id, $prefix.$cat->name );
		}
				
		
		$multiselect = 'size="'.count($sorted_cats).'" multiple';

		$html	= JHTML::_('select.genericlist',  $options, "{$control_name}[{$name}][]", $multiselect, 'value', 'text', $value);
  	return $html;
	}
}
?>
