<?php
/**
 * $Id: jsfields.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('JPATH_BASE') or die();

class JElementJsfields extends JElement
{

	function fetchElement($name, $value, &$node, $control_name)
	{
    
		$db	=& JFactory::getDBO();
		$filters = '';
		$filters = $node->attributes('filters');
		if($filters) $where = " AND f.type IN({$filters}) "; else $where = '';
		
		$sql = "SELECT
		  t.id AS type_id,
		  t.name AS type_name,
		  f.id AS field_id,
		  f.title AS field_name,
		  f.type AS field_type
		FROM
		  #__js_res_types AS t,
		  #__js_res_fields AS f
		WHERE
		  t.published = 1 AND f.type_id = t.id AND f.published = 1 {$where}
		ORDER BY
		  t.id";
	 	
	 	$db->setQuery( $sql );
		$result = $db->loadObjectList();

		$options[] = JHTML::_( 'select.option', '', ' - '.JText::_( 'Select Field' ).' - ' );
		
		$current_optgroup = '';
		foreach ( $result as $field ) {
		
			if( $current_optgroup !=  $field->type_name ) {
			  //$options[] = JHTML::_( 'select.option', $field->type_id, $field->type_name );
			  $options[] = JHTML::_( 'select.optgroup', $field->type_name );
			  $current_optgroup = $field->type_name;
			}
			$options[] = JHTML::_( 'select.option', $field->field_id, $field->field_name );
		}

		$out = JHTML::_( 'select.genericlist', $options, $control_name.'['.$name.']', 'style="width:100%"', 'value', 'text', $value );

		return $out;
	}
}