<?php
/**
 * $Id: jssubscriptionplanlist.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('JPATH_BASE') or die();
class JElementJSSubscriptionPlanList extends JElement
{
	function fetchElement($name, $value, &$node, $control_name)
	{
		if( !is_dir(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jcs') ){
			return '<b>'.JText::_('REQUIREMIGHTYMEMBER').'</b>';
		}
		if( !is_array($value) ) {
			$value = array( $value );
		}
		$db = &JFactory::getDBO();

		$query = "SELECT sp.id AS value, 
						 sp.name AS label, 
						 sp.catid, 
						 c.title AS cat_title
				    FROM #__jcs_plans  AS sp
			   LEFT JOIN #__categories AS c ON c.id = sp.catid
			   	   WHERE sp.published = 1
				ORDER BY c.ordering, c.id, sp.name";

		$db->setQuery($query);
		$plans = $db->loadObjectList();

		$options[] = JHTML::_('select.option', '-1', JText::_( 'Everybody' ) );

		if( !$plans ) $plans = Array();
		$ccatid = '';
		foreach ( $plans as $key => $plan ) {
			if ( $ccatid != $plan->catid ) {
				$options[] = JHTML::_('select.optgroup', $plan->cat_title );
				$ccatid = $plan->catid;
			}
			$options[] = JHTML::_('select.option', $plan->value, $plan->label );
		}

		if( count( $options ) >= 11 ) {
			$size = 11;
		} else {
			$size = count( $options );
		}
		return JHTML::_('select.genericlist',   $options, 
			$control_name.'['.$name.'][]', 
			'size="'.$size.'" multiple="multiple"', 
			'value', 'text', $value );
	}
}
?>
