<?php
/**
 * $Id: mesubtmpls.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('JPATH_BASE') or die();

require_once JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helpers'.DS.'subtmpls.php';

class JElementMesubtmpls extends JElement
{

	var	$_name = 'Mesubtmpls';

	function fetchElement($name, $value, &$node, $control_name)
	{
		jimport( 'joomla.filesystem.folder' );
		jimport( 'joomla.filesystem.file'   );
		
		$tmpltype	    = $node->attributes( 'tmpltype' );
		$invite_label   = $node->attributes( 'invite_label' );
		$paramtype    	= $node->attributes( 'paramtype' );
		$multi    	= $node->attributes( 'multi' );
		
		if($multi) $multi = 'size="5" multiple="multiple"';
		
		$options = JElementMesubtmpls::getTmplObjectList( $tmpltype );
		
		if($paramtype != 'global' ){
			array_unshift($options, JHTML::_('select.option', '', '- '.JText::_('Use global').' -'));
		}
		
		return JHTML::_('select.genericlist',  $options, ''.$control_name.'['.$name.']'.($multi ? '[]' : NULL), 'class="inputbox" '.$multi, 'value', 'text', $value, "param{$name}");
	}
	
	function getTmplObjectList( $type )
	{
	  $result = array();

	  $layouts_path = subTemplate::getTmplPath( $type );
	  $tmpl_mask    = subTemplate::getTmplMask( $type );
	  
	  $files = JFolder::files( $layouts_path, $tmpl_mask['index_file'] );
	      
    foreach( $files as $key => $file ){
	    $tmplname = preg_replace ( $tmpl_mask['ident'], '', $file );
	    $result[] = JHTML::_( 'select.option', $tmplname, $tmplname );
	  }

	  return $result;
	}
}