<?php
/**
 * $Id: record.php 7763 2012-01-26 07:47:42Z kostya $
 * $LastChangedDate: 2012-01-26 13:47:42 +0600 (Thu, 26 Jan 2012) $
 * $LastChangedBy: kostya $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

class MRRecordHelper
{
	function prepareItems(&$items, $params, $category = 0, $callback = null)
	{
		global $mainframe;
		static $script = '';

/*		if(!$script)
		{
			$script = 'function mrEditFieldSave(field, element, record)
{
	var block = document.getElementById(\'jip_\' + element);
	block.innerHTML = \' <img src="'.JURI::root().'components/com_resource/images/load.gif" align="absmiddle" />\';
	//var form = document.getElementById(\'form_\' + element);
	name = \'jip_form_\' + element;
	var form = document.getElementById(name);
	alert(form);
	
	xajax_jsrEditFieldSave(xajax.getFormValues(\'adminForm\'), field, element, record);
}
function mrEditField(field, element, record, category)
{
	var block = document.getElementById(\'jip_\' + element);
	block.innerHTML = \' <img src="'.JURI::root().'components/com_resource/images/load.gif" align="absmiddle" />\';
	//img.onclick = function(){void(0);};
	
	xajax_jsrEditField(field, element, record, category);
}';
			$document = & JFactory::getDocument();
			$document->addScriptDeclaration($script);
		}*/

		if(!$items) return array();

		$db 	= & JFactory::getDBO();
		$model 	= JModel::getInstance('list', 'ResModel');
		$section= ResHelper::getCategorySection($category->id);
		$cuser	= &JFactory::getUser();
		$uri 	= JFactory::getURI();
		$return = base64_encode($uri->toString());
		$config 	= JFactory::getConfig();
		$columns = array();
		$time = JFactory::getDate();
		$session = & JFactory::getSession();

		//require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'view.html.php';

		require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'community'.DS.RES_COMMUNITY;
		$classname = 'MRCommunity'.ucfirst(substr(RES_COMMUNITY, 0, -4));
		$class = new $classname();

		$dispatcher =& JDispatcher::getInstance();
		JPluginHelper::importPlugin('joomsuite_content');
		JPluginHelper::importPlugin('joomsuite_content_fields');

		MECommunityHelper::loadApi();

		$query = "SELECT template FROM #__templates_menu WHERE client_id='0' AND menuid='0'";
		$db->setQuery( $query );
		$template = $db->loadResult();

//		for ($i = 0; $i < count($items); $i++)
//echo '<pre>';
//var_dump($items);
//		while (list($key, $value) = each($items))
		$item_ids = array();
		foreach ($items as $key => $value) {
			$item_ids[$key] = $value->id;
		}
		
		$fields = $model->getFields($item_ids);
		
		foreach ($items as $key => $value) 
		{
			
			$cache = FALSE;

			$orig_item = $items[$key];
			$item = & $items[$key];
			
			if(@$orig_item->content && $params->get('cache_enable', 0))
			{
				$item = unserialize($orig_item->content);
				$item->content = '';
				$cache = TRUE;
				$item->published = $orig_item->published;
				$item->votes = $orig_item->votes;
				$item->user_id = $orig_item->user_id;
				$item->hits = $orig_item->hits;
				$item->archive = $orig_item->archive;
				$item->featured = $orig_item->featured;
				$item->ucatid = $orig_item->ucatid;
				$item->favorite_num = $orig_item->favorite_num;
				$item->hidden = $orig_item->hidden;
				$item->votes_result = $orig_item->votes_result;
				$item->ftime = $orig_item->ftime;
				$item->mtime = $orig_item->mtime;
				//$item->ctime = $orig_item->ctime;
				$item->extime = $orig_item->extime;
				$item->exalert = $orig_item->exalert;
				$item->favorite = @$orig_item->favorite;
				$item->Itemid = @$orig_item->Itemid;
				$item->categories = @$orig_item->categories;
				//$item->fieldsdata = @$orig_item->fieldsdata;
				//$item->params = @$orig_item->params;
				//if(!$item->user_category) $item->user_category = @$orig_item->user_category;
			}
			$iparams = ResHelper::initArticleParams($item->type_id, $item->params);
			$item_categories = unserialize($item->categories);
			settype($item_categories, 'array');
			if(count($item_categories) > 0)
			{
				$keys = array_keys($item_categories);
				$iparams->set('exact_item_category', $keys[0]);
			}
			else
			{
				$iparams->set('exact_item_category', $category->id);
			}
			if( JRequest::getWord('option') != 'com_resource' &&  $params->get('list_clients') == 0 ) {
				$iparams->set('item_categories', 0);
			}
			// TODO use one query
			
//			var_dump($fields);exit;
			$nfields = array(); $ifields = array();

			if(isset($fields[$item->id])){
				foreach ($fields[$item->id] AS $k => $field)
				{
					$field->record = $item; $get = false;
					$get = MightyResourcesApi::getFieldValue($field, $item, $iparams->get('exact_item_category'));
	
					if($get)
					{
						$ifields[$field->title] = $get;
						$ifields[$field->fid] 	= $get;
	
						$nfields[$field->fid] = $field;
						$nfields[$field->fid]->result = $get;
					}
				}
			}
			$item->fields = $nfields;
			$item->ifields = $ifields;
			$item->rating = ''; 
			if($iparams->get('rating_access') !== 'none')
			{
				$item->rating = subTemplate::loadRatingTemplateMCR($iparams->get('tmpl_rating'), round(@$item->votes_result), 'r'.uniqid($item->id), $item->id, 'ItemRatingCallBack', (int)$model->canRate($item->id, $iparams, $item->user_id) );
				$iparams->set('rating', 1);
			}

			if(MECommunityHelper::isEnabled())
			{
				$atr = array('title' => JText::_('List of users'));
				if($iparams->get('item_fav_link', 1) == 1 && ((int)strip_tags($item->favorite_num) > 0))
				{
					$link = MERoute::_("index.php?option=com_community&view=customlist&client=resource&article={$item->id}&view_what=favourited&title=".base64_encode($item->title)."&return=".$return);
					$item->favorite_num = JHTML::link($link, (int)strip_tags($item->favorite_num), $atr);
				}
				if($iparams->get('item_hit_link', 1) == 1 && ((int)strip_tags($item->hits) > 0))
				{
					$link = MERoute::_("index.php?option=com_community&view=customlist&client=resource&article={$item->id}&view_what=hit&title=".base64_encode($item->title)."&return=".$return);
					$item->hits = JHTML::link($link, (int)strip_tags($item->hits), $atr);
				}
				if($iparams->get('item_vote_link', 1) == 1 && ((int)strip_tags($item->votes) > 0))
				{
					$link = MERoute::_("index.php?option=com_community&view=customlist&client=resource&article={$item->id}&view_what=rated&title=".base64_encode($item->title)."&return=".$return);
					$item->votes = JHTML::link($link, (int)strip_tags($item->votes), $atr);
				}
			}

			$ftime = (is_object($item->ftime) ? $item->ftime : JFactory::getDate($item->ftime));
			$p = array();
			
			if($params->get('category_mode') == 1){
				$p['user_id'] = 0;
			}
			
			$article_link = MEUrl::link_record($item, $iparams->get('exact_item_category', $category->id), $p);
			$item->link = MERoute::_($article_link);

			if(($item->ftime != '0000-00-00 00:00:00') && ($ftime->toUnix() < $time->toUnix()) && $item->featured)
			{
				$sql = "UPDATE #__js_res_record SET featured = 0 WHERE id = {$item->id}";
				$db->setQuery($sql);
				$db->query();
				MEAlerts::featured_finished($item, $iparams, $params);
			}

			$extime = (is_object($item->extime) ? $item->extime : JFactory::getDate($item->extime));
			if(($item->extime != '0000-00-00 00:00:00') &&
			( ($extime->toUnix() - $time->toUnix()) <= ($iparams->get('alert_expire_day', 1) * 86400)) &&
			( $extime->toUnix() > $time->toUnix()) &&
			($item->exalert == 0))
			{
				$sql = "UPDATE #__js_res_record SET exalert = 1 WHERE id = {$item->id}";
				$db->setQuery($sql);
				$db->query();
				MEAlerts::expire($item, $iparams, $params);
			}
			if(($item->extime != '0000-00-00 00:00:00') && ( $extime->toUnix() < $time->toUnix()) && ($item->exalert == 1))
			{
				$sql = "UPDATE #__js_res_record SET exalert = 0 WHERE id = {$item->id}";
				$db->setQuery($sql);
				$db->query();
				MEAlerts::expired($item, $iparams, $params);
			}

			if($item->mtime > 0)
			{
				$item->mtime  = &JFactory::getDate($item->mtime);
				//$item->mtime->setOffset($config->getValue('config.offset'));
			}
			else $item->mtime  = false;
			if($item->extime > 0)
			{
				$item->extime  = &JFactory::getDate($item->extime);
				//$item->extime->setOffset($config->getValue('config.offset'));
			}
			else $item->extime  = false;


			$item->isNew = MRRecordHelper::isNew($item, $iparams);
			if($cuser->get('id')){
				$buttons = MRRecordHelper::editButtons($item, $iparams, $params, $category, $cuser, $return);
				$item->edit = $buttons[0];
				$item->buttons = $buttons[1];
			}else{
				$item->edit = '';
				$item->buttons = array();
			}
			$item->favorite = null;
			if( $cuser->get('id') && $iparams->get('favorite') > 0 && (JRequest::getCmd('option', 'get') == 'com_resource') )
			{
				$sql = "SELECT COUNT(*) AS total FROM #__js_res_favorite WHERE record_id = {$item->id} AND user_id = ".$cuser->get('id');
				$db->setQuery($sql);
				if($db->loadResult())
				{
					$icon = MRRecordHelper::button($template, 'favorite1.png', JText::_('Delete from favorites'), array('id' => 'favorite'.$item->id));
				}
				else
				{
					$icon = MRRecordHelper::button($template, 'favorite0.png', JText::_('Add to favorites'), array('id' => 'favorite'.$item->id));
				}
				$onclick = "xajax_jsFavorite('{$item->id}', '".$cuser->get('id')."');";
				$item->favorite = JHTML::link('javascript:void(0);', $icon, array('onclick' => $onclick, 'id' => 'link'.$item->id));
			}
			$item->compare = '';
			if($iparams->get('item_compare') > 0 && (JRequest::getCmd('option', 'get') == 'com_resource'))
			{
				$compare_ids = $session->get('compare');
				settype($compare_ids, 'array');
				if(!is_array(@$compare_ids[$item->type_id])) $compare_ids[$item->type_id] = array();
				if(@in_array($item->id, $compare_ids[$item->type_id]))
				{
					$icon = MRRecordHelper::button($template, 'compare1.png', JText::_('Delete from compare'), array('id' => 'compare'.$item->id));
				}
				else
				{
					$icon = MRRecordHelper::button($template, 'compare0.png', JText::_('Add to compare'), array('id' => 'compare'.$item->id));
				}
				$onclick = "xajax_jsCompare('{$item->id}');";
				$item->compare = JHTML::link('javascript:void(0);', $icon, array('onclick' => $onclick, 'id' => 'link'.$item->id));
			}

			if(MEAccess::isModerator($item->user_id) && @$item->user)
			{
				$icons = array();
				if($params->get('moder_icons')) $icons = unserialize($params->get('moder_icons'));
				if(@$icons[$item->user_id])
				{
					$name = substr($icons[$item->user_id], 0, -4);
					$item->user .= ' '.JHTML::image(JURI::root().'components/com_resource/images/moderator/'.$icons[$item->user_id],
					JText::_(JString::ucfirst($name)), array('align'=>'absmiddle'));
				}
			}

			$item->params = $iparams->toString();
			
			$item->categories = array();
			if($iparams->get('item_categories'))
			{
				//$item_categories_names = explode(':#:', $item->category);
				foreach ($item_categories AS $ckey => $cat)
				{
					$link = MEUrl::link_list($ckey, array('user_id' => 0, 'view_what' => 0, 'client' => 0, 'client_id' => 0, 'ucid' => 0));
					$item->categories[] = JHTML::link(MERoute::_($link), JText::_($item_categories[$ckey]));
				}
			}

			if($cache)
			{
				if($callback)
				{
					call_user_func_array($callback, array($item, $category, $params, $iparams));
				}
				continue;
			}

			$item->ctime  = &JFactory::getDate($item->ctime);
			//$item->ctime->setOffset($config->getValue('config.offset'));
			
			$item->comments = $model->countComments($item, $iparams);
			if(MECommunityHelper::isEnabled()  && $iparams->get('item_comment_link', 1) == 1 && ((int)strip_tags($item->comments) > 0))
			{
				$link = MERoute::_("index.php?option=com_community&view=customlist&client=resource&article={$item->id}&view_what=commented&title=".base64_encode($item->title)."&return=".$return);
				$item->comments = JHTML::link($link, (int)strip_tags($item->comments),$atr);
			}

			/*$link_options = array();
			if($item->ucatid && $params->get('category_mode') > 1)
			{
				$link_options['ucid'] = $item->ucatid;
			}
			if($item->client_id)
			{
				$link_options['client_id'] = $item->client_id;
				$link_options['client'] = $item->client;
			}
			if($params->get('category_mode') > 1 && $item->user_id)
			{
				$link_options['user_id'] = $item->user_id;
			}*/
			

			$base = $uri->toString(array('scheme', 'host', 'port'));
			// Create article title as link and flag
			$item->ntitle = $item->title;
			if($iparams->get('item_link') > 0)
			{
				$item->ntitle = "<a  class=\"contentpagetitle\" href=\"{$item->link}\">{$item->title}</a>";
			}
			$item->ntitle = '<a name="flag'.$item->id.'"></a>'.$item->ntitle;


			if(isset($item->user_category))
			{
				$link_options['ucid'] = $item->ucatid;
				$link_options['view_what'] = 'created';
				if($item->client_id == 0) {
					$link_options['user_id'] = $item->user_id;
				}else{
					$link_options['client_id'] = $item->client_id;
					$link_options['client'] = $item->client;
				}
				$link = MEUrl::link_list($category->id, $link_options);
				$item->user_category = JHTML::link($link, strip_tags($item->user_category));
			}

			$item->tags = JHTML::_('tags.list_tags', $item, $iparams->get('exact_item_category', $category->id), $iparams, $params);

			$session = &JFactory::getSession();

			$events['onAfterArticleRender'] = array();
			$events['onBeforeArticleRender'] = array();

			$item->events['onAfterArticleRender'] = $dispatcher->trigger('onAfterArticleRender', array (&$item, &$iparams));
			$item->events['onBeforeArticleRender'] = $dispatcher->trigger('onBeforeArticleRender', array (&$item, &$iparams));

			
			if($iparams->get('item_pdf') > 0 && $iparams->get('item_icons') && !JRequest::getVar('print'))
			{
				$link = $article_link."&format=pdf";
				if($iparams->get('item_button') == 'Icon')
				{
					$icon = MRRecordHelper::button($template, 'pdf_button.png', JText::_('Open as PDF'));
				}
				else $icon = JText::_('PDF');
				$onclick = "window.open(this.href,'win2','status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no'); return false;";
				$item->pdf = JHTML::link(JURI::root().$link, $icon,	array( "onclick" => $onclick, 'rel' => "nofollow"));
			}
			if($iparams->get('item_print') > 0 && $iparams->get('item_icons'))
			{
				$link = $article_link."&tmpl=component&print=1";
				if($iparams->get('item_button') == 'Icon')
				{
					$icon = MRRecordHelper::button($template, 'printButton.png', JText::_('Print Version'));
				}
				else $icon = JText::_('Print');

				if(JRequest::getVar('print') == 1)
				{
					$item->print = JHTML::link("javascript:void(0)", $icon, array( "onclick" => "window.print();return false;"));
				}
				else
				{
					$onclick = "window.open(this.href,'win2','status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no'); return false;";
					$item->print = JHTML::link(JURI::root().$link, $icon, array( "onclick" => $onclick, 'rel' => "nofollow"));
				}
			}
			if($iparams->get('item_send') > 0 && $iparams->get('item_icons') && !JRequest::getVar('print'))
			{
				if (!JFile::exists(JPATH_SITE.DS.'components'.DS.'com_mailto'.DS.'helpers'.DS.'mailto.php'))
				{
					$item->send = '';
				}
				else
				{
					require_once(JPATH_SITE.DS.'components'.DS.'com_mailto'.DS.'helpers'.DS.'mailto.php');
					$uri	=& JURI::getInstance();
					$base	= $uri->toString( array('scheme', 'host', 'port'));
					$link = "index.php?option=com_mailto&tmpl=component&link=".MailToHelper::addLink($base.$item->link);
					if($iparams->get('item_button') == 'Icon')
					{
						$icon = MRRecordHelper::button($template, 'emailButton.png', JText::_('Send to a friend'));
					}
					else $icon = JText::_('Send');
					$onclick = "window.open(this.href,'win2','status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no'); return false;";
					$item->send = JHTML::link(MERoute::_($link), $icon,	array( "onclick" => $onclick, 'rel' => "nofollow"));
				}
			}

			// User name
			$item->user = JText::_('Anonymous');
			if($item->user_id)
			{
				$user = JFactory::getUser($item->user_id);
				$item->user = $user->get($iparams->get('item_author_mode', 'username'));
			}

			$link = ''; $links = array();
			if(
				(
					($params->get('category_mode') > 1)
					&& $item->user_id
					&& (JRequest::getVar('client', 'resource') == 'resource') 
					//&& (JRequest::getInt('user_id', 0) == 0 || (JRequest::getInt('user_id') != $item->user_id))
					&& ((JRequest::getInt('user_id') != $item->user_id) || JRequest::getVar('view') == 'article')
				) 
				|| (JRequest::getInt('client_id') && $params->get('menu_personalize_group')) 
			)
			{
				$res = getNumbers('created', $item->user_id, $section, $params);

				$url = MEUrl::link_list($category->id, array('user_id' => $item->user_id, 'view_what' => 'created'));
				$link = JHTML::link(MERoute::_($url),  JText::_($iparams->get('item_show_all_label', 'Show all records by this user')).' '.($res ? " ({$res})" : null)  );

				$links[0]->link = MERoute::_($url);
				$links[0]->alt = JText::_($iparams->get('item_show_all_label', 'Show all records by this user'));
				if($res) $links[0]->alt .= " ($res)";
				$links[0]->icon = 'components/com_resource/images/user_record.png';
			}

			if(MECommunityHelper::isEnabled() && $iparams->get('item_author_link'))
			{
				MECommunityHelper::loadApi();
				if($iparams->get('item_avatar')) $uparams['avatar'] = true; else $uparams['avatar'] = false;
				If($iparams->get('item_author') == 1) $uparams['name'] = $iparams->get('item_author_mode', 'username');
				$item->user = JSCommunityApi::getUserSlideMenu($item->user_id, strip_tags($item->user), $links, $uparams);
			}
			elseif (JComponentHelper::isEnabled(substr(RES_COMMUNITY, 0, -4)))
			{
				If(method_exists($class, 'userName') && $iparams->get('item_author_link') == 1 && $item->user_id)
				{
					$item->user = $class->userName($item->user_id, $item->user);
				}
				if($link) $item->user .= ' '.$link;
			}
			else
			{
				if($link) $item->user .= ' '.$link;
			}

			$item->avatar = '';
			if($iparams->get('item_avatar')) $item->avatar = MECommunityHelper::getAvatar($item->user_id, $iparams);

			$key = MECache::getKey('record');
			unset($item->fieldsdata);
			if($params->get('cache_enable', 0)) MECache::set($item, $item->id, $key, 'record', $section);

			if(MEAccess::isModerator($item->user_id))
			{
				$icons = array();
				if($params->get('moder_icons')) $icons = unserialize($params->get('moder_icons'));
				if(@$icons[$item->user_id])
				{
					$name = substr($icons[$item->user_id], 0, -4);
					$item->user .= ' '.JHTML::image(JURI::root().'components/com_resource/images/moderator/'.$icons[$item->user_id],
					JText::_(JString::ucfirst($name)), array('align'=>'absmiddle'));
				}
			}
			if($callback)
			{
				call_user_func_array($callback, array($item, $category, $params, $iparams));
			}
			//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
			
		}

	}
	function linkListFiles($params)
	{
		$document = & JFactory::getDocument();

		if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_subtmpl_'.$params->get('tmpl_list', 'default').'.css'))
		{
			$document->addStyleSheet(JURI::root().'components/com_resource/views/list/tmpl/default_subtmpl_'.$params->get('tmpl_list', 'default').'.css');
		}
		if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_subtmpl_'.$params->get('tmpl_list', 'default').'.js'))
		{
			$document->addScript(JURI::root().'components/com_resource/views/list/tmpl/default_subtmpl_'.$params->get('tmpl_list', 'default').'.js');
		}

	}
	function linkFiles($params)
	{
		$document = & JFactory::getDocument();

		if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_menu_'.$params->get('tmpl_menu', 'default').'.css'))
		{
			$document->addStyleSheet(JURI::root().'components/com_resource/views/list/tmpl/default_menu_'.$params->get('tmpl_menu', 'default').'.css');
		}
		if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_menu_'.$params->get('tmpl_menu', 'default').'.js'))
		{
			$document->addScript(JURI::root().'components/com_resource/views/list/tmpl/default_menu_'.$params->get('tmpl_menu', 'default').'.js');
		}

		if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_cindex_'.$params->get('tmpl_category', 'default').'.css'))
		{
			$document->addStyleSheet(JURI::root().'components/com_resource/views/list/tmpl/default_cindex_'.$params->get('tmpl_category', 'default').'.css');
		}
		if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_cindex_'.$params->get('tmpl_category', 'default').'.js'))
		{
			$document->addScript(JURI::root().'components/com_resource/views/list/tmpl/default_cindex_'.$params->get('tmpl_category', 'default').'.js');
		}

		if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_filters_'.$params->get('tmpl_filters', 'default').'.css'))
		{
			$document->addStyleSheet(JURI::root().'components/com_resource/views/list/tmpl/default_filters_'.$params->get('tmpl_filters', 'default').'.css');
		}
		if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_filters_'.$params->get('tmpl_filters', 'default').'.js'))
		{
			$document->addScript(JURI::root().'components/com_resource/views/list/tmpl/default_filters_'.$params->get('tmpl_filters', 'default').'.js');
		}
	}
	function button($template, $image, $alt, $options = array(), $path = false)
	{
		static $buttons = array();
		$key = md5($template.$image.$alt.serialize($options).intval($path));
		if (isset($buttons[$key]))
			return $buttons[$key];
		$template_icon = JPATH_THEMES.DS.$template.DS.'images'.DS.$image;
		$icon = JURI::root()."/templates/$template/images/{$image}";

		if(!JFile::exists($template_icon))
		{
			$template_icon = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'images'.DS.$image;
			$icon = JURI::root().'components/com_resource/images/'.$image;
		}

		if($path) return $icon;

		$fav = getimagesize($template_icon);
		$options['width'] = $fav[0];
		$options['height'] = $fav[1];
		$options['align'] = 'absmiddle';
		$options['class'] = 'hasTip';
		$options['title'] = '::'.$alt;
		$button = JHTML::image($icon, $alt,$options );
		$buttons[$key] = $button;
		return $button;
	}
	function editButtons($item, $iparams, $params, $category, $cuser, $return)
	{
		$edit = ''; $buttons = array();
		if(MEAccess::isModerator($cuser->get('id'), 'moder_edit_record', $params)  || MEAccess::isAdmin() || MEAccess::isPublisher() || MEAccess::isEditor() || (MEAccess::isAuthor($item->user_id, $iparams->get('item_edit'))))
		{
			$attr = array('border'=>'0', 'class' => 'reditbutton hasTip', 'title'=> '::'.JText::_('Edit'));
			$img = JHTML::image(JURI::root().'components/com_resource/images/admin_menu/a.edit.png', JText::_('Edit'), $attr);
			$link = MEUrl::link_record($item, $category->id);
			$link .= "&layout=form&redirect={$return}";
			$edit = JHTML::link(JURI::root().$link, $img);
			$buttons[0]['icon'] = $edit;
			$buttons[0]['img'] = $img;
			$buttons[0]['text'] = JHTML::link(JURI::root().$link, JText::_('Edit'));
		}

		if (MEAccess::isModerator($cuser->get('id'), 'moder_delete_record', $params) || MEAccess::isAdmin() || MEAccess::isPublisher() || MEAccess::isEditor() || (MEAccess::isAuthor($item->user_id, $iparams->get('item_delete'))))
		{
			$attr = array('border'=>'0', 'class' => 'reditbutton hasTip', 'title'=> '::'.JText::_('Delete'));
			$img = JHTML::image(JURI::root().'components/com_resource/images/admin_menu/a.delete.png', JText::_('Delete'), $attr);
			if(JRequest::getInt('article') && JRequest::getVar('view') == 'article')
			{
				$back = base64_encode(MEUrl::link_list($iparams->get('exact_item_category', JRequest::getInt('category_id', ResHelper::getArticleSection($item->id)))));
			}
			else
			{
				$back = $return;
			}
			$link = 'index.php?option=com_resource&task=delete&id='.$item->id.'&category_id='.JRequest::getInt('category_id', $category->id).'&return='.$back;
			if(MEAccess::isAuthor($item->user_id))
			{
				$icon = JHTML::link('javascript:void(0);', $img, array('onclick'=>'javascript:if(confirm(\''.JText::_('Do you really want to delete?').'\')){window.location=\''.$link.'\'};'));
				$text = JHTML::link('javascript:void(0);', JText::_('Delete'), array('onclick'=>'javascript:if(confirm(\''.JText::_('Do you really want to delete?').'\')){window.location=\''.$link.'\'};'));
				
			}
			else 
			{
				$icon = JHTML::link('javascript:void(0);', $img, array('onclick'=>'javascript:if(confirm(\''.JText::_('Do you really want to delete?').'\')){window.location=\''.htmlentities(JURI::root().'index.php?option=com_resource&view=moderator&layout=reason&action='.base64_encode($link)).'\'};'));
				$text = JHTML::link('javascript:void(0);', JText::_('Delete'), array('onclick'=>'javascript:if(confirm(\''.JText::_('Do you really want to delete?').'\')){window.location=\''.htmlentities(JURI::root().'index.php?option=com_resource&view=moderator&layout=reason&action='.base64_encode($link)).'\'};'));
			}
			$buttons[1]['icon'] = $icon;
			$buttons[1]['img'] = $img;
			$buttons[1]['text'] = JHTML::link('javascript:void(0);', JText::_('Delete'), array('onclick'=>'javascript:if(confirm(\''.JText::_('Do you really want to delete?').'\')){window.location=\''.htmlentities(JURI::root().'index.php?option=com_resource&view=moderator&layout=reason&action='.base64_encode($link)).'\'};'));

			$edit .= ' '.$icon;
		}

		if(MEAccess::isModerator($cuser->get('id'), 'moder_publish_record', $params) || MEAccess::isAdmin() || MEAccess::isPublisher() || MEAccess::isEditor())
		{
			$attr = array('border'=>'0', 'class' => 'reditbutton hasTip', 'title'=> '::'.JText::_($item->published ? 'Unpublish' : 'Publish'));
			$img = JHTML::image(JURI::root().'components/com_resource/images/admin_menu/a.'.($item->published ? 'unpublish' : 'publish' ).'.png', JText::_($item->published ? 'Unpublish' : 'Publish'), $attr);
			$link = 'index.php?option=com_resource&task='.($item->published ? 'unpublish' : 'publish' ).'&id='.$item->id.'&category_id='.JRequest::getInt('category_id', $category->id).'&return='.$return;
			if($item->published) $link = 'index.php?option=com_resource&view=moderator&layout=reason&action='.base64_encode($link);
			
			$icon = JHTML::link(JURI::root().$link, $img);
			
			$buttons[2]['icon'] = $icon;
			$buttons[2]['img'] = $img;
			$buttons[2]['text'] = JHTML::link(JURI::root().$link, JText::_($item->published ? 'Unpublish' : 'Publish'));
			
			$edit .= ' '.$icon;
		}

		if(MEAccess::isAuthor($item->user_id, $params->get('menu_show_hidden')))
		{
			$attr = array('border'=>'0', 'class' => 'reditbutton hasTip', 'title'=> '::'.JText::_($item->hidden ? 'Unhide' : 'Hide'));
			$img = JHTML::image(JURI::root().'components/com_resource/images/admin_menu/a.'.($item->hidden ? 'unhide' : 'hide' ).'.png', JText::_($item->hidden ? 'Unhide' : 'Hide'), $attr);
			$link = 'index.php?option=com_resource&task='.($item->hidden ? 'unhide' : 'hide' ).'&id='.$item->id.'&return='.$return;
			
			$icon = JHTML::link(JURI::root().$link, $img);
			
			$buttons[3]['icon'] = $icon;
			$buttons[3]['img'] = $img;
			$buttons[3]['text'] = JHTML::link(JURI::root().$link, JText::_($item->hidden ? 'Unhide' : 'Hide'));
			
			$edit .= ' '.$icon;
		}
		
		if((@$item->expired && ($params->get('show_past_records') == 0)) && (MEAccess::isModerator($cuser->get('id'), 'moder_extend_record', $params) || MEAccess::isAdmin() || MEAccess::isPublisher() || MEAccess::isEditor() || (MEAccess::isAuthor($item->user_id,($params->get('allow_extend') <= $cuser->get('aid'))))))
		{
			$attr = array('border'=>'0', 'class' => 'reditbutton hasTip', 'title'=> '::'.JText::sprintf('Prolong %d Days', $iparams->get('default_extend')));
			$img = JHTML::image(JURI::root().'components/com_resource/images/admin_menu/a.extend.png', JText::sprintf('Prolong %d Days', $iparams->get('default_extend')), $attr);
			$link = 'index.php?option=com_resource&task=extend&category_id='.$category->id.'&id='.$item->id.'&return='.$return;
			
			$icon = JHTML::link(JURI::root().$link, $img);
			
			$buttons[4]['icon'] = $icon;
			$buttons[4]['img'] = $img;
			$buttons[4]['text'] = JHTML::link(JURI::root().$link, JText::_('Prolong'));
			
			$edit .= ' '.$icon;
		}
		if(((((int)$iparams->get('type_feature_subscription') > 0 && (MEAccess::isAuthor($item->user_id)))) && ($item->featured == 0))|| MEAccess::isAdmin())
		{
			$attr = array('border'=>'0', 'class' => 'reditbutton hasTip', 'title'=> '::'.JText::_('Make this record featured'));
			$img = JHTML::image(JURI::root().'components/com_resource/images/admin_menu/a.feature.png', JText::_('Make this record featured'), $attr);
			$link = 'index.php?option=com_resource&task=feature&id='.$item->id.'&return='.$return;
			$icon = JHTML::link(JURI::root().$link, $img);
			
			$buttons[5]['icon'] = $icon;
			$buttons[5]['img'] = $img;
			$buttons[5]['text'] = JHTML::link(JURI::root().$link, JText::_('Make Featured'));
			
			$edit .= ' '.$icon;
		}
		if(MEAccess::isAdmin() && $item->user_id)
		{
			$img = JHTML::image(JURI::root().'components/com_resource/images/admin_menu/a.security.png', JText::_('Moderator'),
			array('border'=>'0', 'class' => 'reditbutton hasTip', 'title' => JText::_('Set/Unset author of this record as moderator')));
			$link = 'index.php?option=com_resource&view=moderator&layout=set_moderator&user_id='.$item->user_id.'&category_id='.$category->id.'&return='.$return;

			$icon = JHTML::link(JURI::root().$link, $img);
			
			$buttons[6]['icon'] = $icon;
			$buttons[6]['img'] = $img;
			$buttons[6]['text'] = JHTML::link(JURI::root().$link, JText::_('User Access'));
			
			$edit .= ' '.$icon;
			
		}

		if(($item->published >= 0) && (MEAccess::isModerator($cuser->get('id'), 'moder_archive_record', $params) || MEAccess::isAdmin() || MEAccess::isPublisher() || MEAccess::isEditor() || (MEAccess::isAuthor($item->user_id,($params->get('allow_archive') == 1)))))
		{

			$task = 'archive';
			$text = JText::_('Archive Record');
			
			$attr = array('border'=>'0', 'class' => 'reditbutton hasTip', 'title'=> '::'.$text);
			$img = JHTML::image(JURI::root().'components/com_resource/images/admin_menu/a.'.$task.'.png', $text, $attr);
			$link = 'index.php?option=com_resource&task='.$task.'&category_id='.$category->id.'&id='.$item->id.'&return='.$return;
			$icon = JHTML::link(JURI::root().$link, $img);
			
			$buttons[7]['icon'] = $icon;
			$buttons[7]['img'] = $img;
			$buttons[7]['text'] = JHTML::link(JURI::root().$link, JText::_('Archive'));
			
			$edit .= ' '.$icon;
			
		}

		if($iparams->get('comments') && ((MEAccess::isModerator($cuser->get('id'), 'moder_uncomment_record', $params) || MEAccess::isAdmin() || MEAccess::isPublisher() || MEAccess::isEditor() || (MEAccess::isAuthor($item->user_id) && $params->get('allow_block_comment') == 1))))
		{
			if($iparams->get('comments_access') > 2)
			{
				$task = 'comment_unblock';
				$text = JText::_('Allow comments for this record');
			}
			else
			{
				$task = 'comment_block';
				$text = JText::_('Disallow comments for this record');
			}
			$attr = array('border'=>'0', 'class' => 'reditbutton hasTip', 'title'=> '::'.$text);
			$img = JHTML::image(JURI::root().'components/com_resource/images/admin_menu/a.'.$task.'.png', $text, $attr);
			$link = 'index.php?option=com_resource&task='.$task.'&category_id='.$category->id.'&id='.$item->id.'&return='.$return;
			$icon = JHTML::link(JURI::root().$link, $img);
			
			$buttons[8]['icon'] = $icon;
			$buttons[8]['img'] = $img;
			$buttons[8]['text'] = JHTML::link(JURI::root().$link, JText::_(($iparams->get('comments_access') > 2 ? 'Enable Comments' : 'Disable Comments')));
			
			$edit .= ' '.$icon;
			
		}
		return array($edit, $buttons);
	}
	function isNew($item, &$params)
	{
		if($params->get('new_days', 3) == 0) return 0;

		if(!is_object($item->mtime)) $item->mtime = new JDate($item->mtime);
		$mtime = $item->mtime->toUnix();

		$time = JFactory::getDate();
		$time = $time->toUnix() - ($params->get('new_days', 3) * 86400);
		if($mtime < $time) return 0;

		if($mtime < (int)@$_COOKIE['hit_record_'.$item->id]) return 0;

		$session = & JFactory::getSession();
		if($mtime < (int)$session->get('hit_record_'.$item->id)) return 0;

		$cuser =& JFactory::getUser();
		$db = & JFactory::getDBO();
		$sql = "SELECT MAX(ctime) FROM #__js_res_hits WHERE record_id = $item->id AND user_id = ".$cuser->get('id');
		$db->setQuery($sql);
		$res = $db->loadResult();
		if($res)
		{
			$timehit = JFactory::getDate($res);
			$htime = $timehit->toUnix();
		}
		if(@$htime > $mtime)
		{
			return 0;
		}

		return 1;
	}
}
?>