/* My library!!  %)) */
var Lib01 = {
	opts: {
		debug: false
	},
	
	/* Log to firebug console */
	log: function(text) {
		if (this.opts.debug && window.console) console.log(text);
		//alert(text);
	},
	
	
	uploader: function(status, list, options) {
		this.log = function(t) {
			if (this.options.debug)
				Lib01.log( t );
		},
		/* The files are here %))) */
		this.bytesTotal = 0,
		this.files = [],
		
		this.movie = null,
		/* HTML Elements */
		this.status = status,
		this.fileList = list,
		this.flashBox = null,
		this.target = null,
		
		this.options = options;
		
		this.init = function() {
			this.UID = 0;
			this.log('Initializing uploader');
			
			if (!this.options.data)
				this.options.data = null;
			
			/* -------------------------  Initialize the FlashObject --------------------------*/
			var flashvars = {};
			/* Register callback functions */
			this.log("Registering flash callbacks: ");
			for (var i in this) 
				if (i.substr(0, 2) == 'on') 
					flashvars[ i ] = this.options.varName + '.' + i;
			
			var params = {
				menu: "false",
				width: this.options.swf.width,
				height: this.options.swf.height,
				wMode: 'transparent'
			};

			this.log(this.options.swf.movie + ' ' + this.options.swf.id + ' ' + this.options.swf.width + ' ' + this.options.swf.height);
			
			var temp = this;
			
			media_1234_swfobject.embedSWF(
				this.options.swf.movie, this.options.swf.id, 
				this.options.swf.width, this.options.swf.height, 
				"9.0.0", "expressInstall.swf", 
				flashvars, params, false,
				function( e ) {
					temp.onSWFEmbed( e );
				}
			);
			
			
			
			if (!this.options.validateFile) {
				this.options.validateFile = function() {
					return true;
				}
			}
		},
		
		this.onSWFEmbed = function( e ) {
			if (!e.success) {
				alert('Cannot initialize uploader');
				return false;
			}
			/* The SWFObject */
			// this.movie = media_1234_swfobject.getObjectById(this.options.swf.id);
			this.movie = document.getElementById(e.id);
			this.flashBox = document.getElementById(this.options.swf.outerContainer);
			
			this.log('Embed: ' + Lib01.util.objectToString(e, null));
			this.log(this.flashBox);
			
			if (this.movie)
				this.log('Flashka gotova :)');
			else
				this.log(this.movie);
			
			/* ----------------------------------  Initialize elements  -----------------------------------------*/
			this.overallTitle = Lib01.util.DOM.findElement(this.status, '.overall-title');
			this.currentTitle = Lib01.util.DOM.findElement(this.status, '.current-title');
			this.currentText = Lib01.util.DOM.findElement(this.status, '.current-text');
			
			this.target = document.getElementById(this.options.target);
			
			var tmpResFunc = eval('new function() {' + this.options.varName + '.reposition()};');
			Lib01.util.DOM.addListener(window, 'resize', tmpResFunc);
			
			var progress = Lib01.util.DOM.findElement(this.status, '.overall-progress');
			var overallText = Lib01.util.DOM.newElement('span', {'class': 'progress-text'});
			progress.parentNode.insertBefore(overallText, progress.nextSibling);
			this.overallProgress = new Lib01.animagaForToolbar(progress, {
				text: overallText
			});
			
			progress = Lib01.util.DOM.findElement(this.status, '.current-progress');
			var currentText = Lib01.util.DOM.newElement('span', {'class': 'progress-text'});
			progress.parentNode.insertBefore(currentText, progress.nextSibling);
			this.currentProgress = new Lib01.animagaForToolbar(progress, {
				text: currentText
			});
			
			
			this.overallProgress.set(0);
			this.currentProgress.set(0);
		},

		this.callFlash = function(fn){
			this.log('<invoke name="' + fn + '" returntype="javascript">' + __flash__argumentsToXML(arguments, 1) + '</invoke>');
			var rs = this.movie.CallFunction('<invoke name="' + fn + '" returntype="javascript">' + __flash__argumentsToXML(arguments, 1) + '</invoke>');
			return eval(rs);
		},
		
		this.reposition = function( e ) {
			this.flashBox.style.width = this.target.offsetWidth + 'px';
			this.flashBox.style.height = this.target.offsetHeight + 'px';
			
			var dims = Lib01.util.DOM.getPosition(this.target);
			
			this.flashBox.style.left = dims.left + 'px';
			this.flashBox.style.top = dims.top + 'px';
		},
		/* ================================= Callback functions =======================================*/
		// OK
		this.onLoad = function() {
			this.log('Uploader ready!');
//			Lib01.util.potom(
//				this,
//				'registerFlash',
//				50
//			);
			Lib01.util.later(
					this,
					this.registerFlash,
					[],
					50
			);
		},

		this.registerFlash = function() {
			this.callFlash('register', this.options.swf.id, this.options.multiple, this.options.queued);
		},

		// OK
		this.onBeforeOpen = function(file, options) {
			this.log('Initialize upload for ' + file.name);
			var fn = this.options.fileUpload;
			var obj = (fn) ? fn.call(this, this.getFile(file), options) : options;
			return obj;
		},

		// OK
		this.onOpen =  function(file, overall) {
			this.log('Starting upload ' + file.name);
			file = this.getFile(file);
			Lib01.util.DOM.addClass(file.element, 'file-uploading');
			
			this.currentProgress.set(0);
			
			var title = this.options.texts['fileProgress'] || 'File Progress';
			this.currentTitle.innerHTML = title + ' "' + file.name + '"';
		},

		// OK
		this.onProgress =  function(file, current, overall) {
			this.overallProgress.start(overall.bytesLoaded, overall.bytesTotal);
			this.log('onProgress: ' + overall.bytesLoaded + ' ' + overall.bytesTotal);
			
			var title = this.options.texts['uploadWith'] || 'Upload with'; 
			var rate = (current.rate) ? this.sizeToKB(current.rate) : '- B';
			var timeLeft = Lib01.util.Date.fancyDuration(current.timeLeft || 0);
			this.currentText.innerHTML = title + ' ' + rate + '/s. Time left: ~' + timeLeft;
			
			this.currentProgress.start(current.bytesLoaded, current.bytesTotal);
			this.log('onProgress call end');
		},
		
		this.onBrowse = function() {
			return this.options.typeFilter;
		},

		// OK
		this.onSelect =  function(file, index, length) {
			this.log('Adding: ' + file.name + ' ' + file.size);
			var errors = [];
			if (this.options.limitSize && (file.size > this.options.limitSize)) 
				errors.push('size');
			if (this.options.limitFiles && (this.countFiles() >= this.options.limitFiles)) 
				errors.push('length');
			this.log('onSelect: allowDuplicates = ' + this.options.allowDuplicates);
			this.log('onSelect: getFile = ' + this.getFile(file));
			
			if (!this.options.allowDuplicates && this.getFile(file)) 
				errors.push('duplicate');
			if (!this.options.validateFile.call(this, file, errors)) 
				errors.push('custom');
			if (errors.length) {
				this.log('	got some errors');
				var fn = this.options.fileInvalid;
				if (fn) fn.call(this, file, errors);
				return false;
			}
			(this.options.fileCreate || this.fileCreate).call(this, file);
			this.files.push(file);
			return true;
		},

		// Must test with 'instantStart'
		this.onAllSelect =  function(files, current, overall) {
			this.log('Added ' + files.length + ' files, now we have (' + current.bytesTotal + ' bytes).');
			this.updateOverall(current.bytesTotal);
			
			Lib01.util.DOM.removeClass(this.status, 'status-browsing');
			if (this.files.length && this.options.instantStart) 
				Lib01.util.potom(this, 'upload', 100);
		},
		
		// Seems done
		this.onComplete =  function(file, response) {
			this.log('Completed upload "' + file.name + '".');
			var title = this.options.texts['uploadComplete'] || 'Upload complete'; 
			this.currentText.innerHTML = title;
			
			// Set animaga to "Complete" state.
			this.currentProgress.start(100, 100);
			
			if (this.options.fileComplete)
				this.options.fileComplete.call(this, file, response);
			if (this.fileComplete)
				this.fileComplete.call(this, this.finishFile(file), response);
		},

		// OK, won't alter
		this.onError =  function(file, error, info) {
			this.log('Upload "' + file.name + '" failed. ' + error + ' ' + info);
			(this.options.fileError || this.fileError).call(this, this.finishFile(file), error, info);
		},

		// OK, won't alter
		this.onCancel =  function() {
			this.log('Filebrowser cancelled.', arguments);
			Lib01.util.DOM.removeClass(this.status, 'file-browsing');
		},

		// OK
		this.onAllComplete =  function(current) {
			this.log('Completed all files, ' + current.bytesTotal + ' bytes.', arguments);
			
			this.updateOverall(current.bytesTotal);
			this.overallProgress.start(100, 100);
			this.currentProgress.start(100, 100);
			
			Lib01.util.DOM.removeClass(this.status, 'file-uploading');
		},

		// OK
		this.browse = function(fileList) {
			var ret = this.callFlash('browse');
			
			if (ret !== true){
				if (ret) this.log('An error occured: ' + ret);
				else this.log('Browse in progress.');
			} else {
				this.log('Browse started.');
				Lib01.util.DOM.addClass(this.status, 'file-browsing');
			}
		},

		// Seems OK.
		this.upload =  function(options) {
			var current = this.options;
			
			var o = {
				data: current.data, 
				url: current.url, 
				method: current.method, 
				fieldName: current.fieldName
			};
			//console.log(o);
			
			var ret = this.callFlash('upload', Lib01.util.merge(options, o));
			
			if (ret !== true) {
				this.log('Upload in progress or nothing to upload.');
			} else {
				this.log('Upload started.');
				Lib01.util.DOM.addClass(this.status, 'file-uploading');
				
				this.overallProgress.set(0);
			}
		},

		// Seems OK
		this.removeFile =  function(file) {
			var remove = this.options.fileRemove || this.fileRemove;
			if (!file) {
				// Remove all nahren.
				for (var i = 0; i < this.files.length; i++)
					remove.call(this, this.files[ i ]);
				this.files = [];
				
				this.updateOverall(0);
			} else {
				if (!file.element) 
					file = this.getFile(file);
				
				this.log('Removing file: ' + file.name + ' sized: ' + file.size);
				
				for (var i = 0; i < this.files.length; i++){
					if (this.files[i] === file) 
						this.files.splice(i, 1);
				}
				remove.call(this, file);
				if (!file.finished)
					this.updateOverall(this.bytesTotal - file.size);
			}
			var f = file ? {name: file.name, size: file.size} : null;
			this.callFlash('removeFile', f);
		},

		// OK
		this.getFile =  function(file) {
			for (var i = 0; i < this.files.length; i++)
				if (this.files[ i ].name == file.name && this.files[ i ].size == file.size)
					return this.files[ i ];
			
			return null;
		},

		// OK
		this.countFiles =  function() {
			var ret = 0;
			for (var i = 0, j = this.files.length; i < j; i++) {
				if (!this.files[i].finished) ret++;
			}
			return ret;
		},

		// OK
		this.updateOverall =  function(bytesTotal) {
			this.bytesTotal = bytesTotal;
			var title = this.options.texts['overallProgress'] || 'Overall Progress';
			this.overallTitle.innerHTML = title + ' (' + this.sizeToKB(bytesTotal) + ')';
		},

		// OK
		this.finishFile =  function(file) {
			this.log('Finishing file: ' + file.name);
			file = this.getFile(file);
			Lib01.util.DOM.removeClass(file.element, 'file-uploading');
			file.finished = true;
			return file;
		},

		// OK
		this.fileCreate =  function(file) {
			this.log('fileCreate');
			
			var li = Lib01.util.DOM.newElement(
				'li', {'class': 'file'}, null, null
			);
			
			var spanFileSize = Lib01.util.DOM.newElement(
				'span', {'class': 'file-size', 'html': this.sizeToKB(file.size)}, null, null
			);
			
			var fileStr = '{name: "' + file.name + '", size:' + file.size + '}';
			var cmdStr = 'var myTempFunc = function() {' + this.options.varName + '.removeFile(' + fileStr + ');}' 
			eval(cmdStr);
			var spanRemove = Lib01.util.DOM.newElement(
				'a', {'class': 'file-remove', 'html': 'Remove', 'href': 'javascript:void(0);'},	null, 
				{'click':  myTempFunc}
			);
			
			var spanFileName = Lib01.util.DOM.newElement(
				'span', {'class': 'file-name', 'html': file.name}, null, null
			);
			
			var spanFileInfo = Lib01.util.DOM.newElement(
				'span', {'class': 'file-info'}, null, null
			);
			
			file.info = spanFileInfo;
			
			li.appendChild(spanFileSize);
			li.appendChild(spanRemove);
			li.appendChild(spanFileName);
			li.appendChild(spanFileInfo);
			
			this.fileList.appendChild( li );
			/* Append the element to file :)) */
			file.element = li;
			/*
			I'm creating the following layout:
			<li class="file">
				<span class="file-size">388.5 kB</span>
				<a class="file-remove" href="#">Remove</a>
				<span class="file-name">AND 1 (42).jpg</span>
				<span class="file-info"/>
			</li>
			*/
		},
		
		// Seems OK
		this.fileComplete =  function(file, response) {
			this.log('fileComplete');
			var json = Lib01.util.Json.evaluate(response, true);
			
			// If no response, then OK ;)
			if (json == null || json.result == 'success') {
				Lib01.util.DOM.addClass(file.element, 'file-success');
				if (json)
					file.info.innerHTML = json.size;
			} else {
				Lib01.util.DOM.addClass(file.element, 'file-failed');
				file.info.innerHTML = json.error || response;
			}
		},

		// Seems ok
		this.fileError =  function(file, error, info) {
			Lib01.util.DOM.addClass(file.element, 'file-failed');
			file.info.innerHTML = '<strong>' + error + '</strong><br />' + info;
		},
		
		// In progress: add animation
		this.fileRemove =  function(file) {
			/* make some weird animation here */
			var vater = file.element.parentNode;
			vater.removeChild(file.element);
		},
		
		// OK, won't alter.
		this.sizeToKB = function(size) {
			var unit = 'B';
			size = parseInt(size);
			if ((size / 1048576) > 1) {
				unit = 'MB';
				size /= 1048576;
			} else if ((size / 1024) > 1) {
				unit = 'kB';
				size /= 1024;
			}
			return Math.round(size) + ' ' + unit;
		}
	},
	
	/* This class mimics FancyUploader2 Fx.Toolbar behavior */
	animagaForToolbar: function(element, options) {
		this.options = options;
		this.element = element;
		this.UID = 0;
		
		this.init = function() {
			this.text = options.text;
			this.set( 0 );
			this.now = 0;
			// UID is used for hacks using window object.
			this.UID = 'animaga_for_toolbar' + (new Date().getTime());
		},
		
		this.start = function(now, total) {
			var newNow = parseInt(100 * now / total);
			this.total = total;
			
			// Run the animation
			this.animate([this.now, newNow, 5, 20]);
			
			this.now = newNow;
			
			return this;
		},
		
		this.set = function( to ) {
			this.now = to;
			this.element.style.backgroundPosition = (100 - to) + '% 0px';
			if (this.text) 
				this.text.innerHTML = Math.round(to) + '%';
			return this;
		},
		// seems ok
		this.animate = function(args /*[from, to, step, timeout]*/) {
			if (! (args instanceof Array) )
				return;
			var from 	= args[ 0 ];
			var to		= args[ 1 ];
			var step	= args[ 2 ];
			var timeout = args[ 3 ];
			
			// positive step.
			var lastCall = false;
			from += step;
			if (step > 0) {
				if (from > to) {
					from = to;
					lastCall = true;
				}
			}
			else {
				if (from < to) {
					from = to;
					lastCall = true;
				}
			}
			
			this.from = from;
			this.to	= to;
			this.step = step;
			this.timeout = timeout;
			
			this.set( from );
			
			if (!lastCall)
				Lib01.util.potom(this, 'next', timeout);
		},
		
		this.next = function() {
			this.animate([this.from, this.to, this.step, this.timeout]);
		},
		
		this.init();
	}
}

/* Various useful functions */
Lib01.util = {
	/* 1'st level merge */
	merge: function(a, b) {
		var ret = {};
		if ( a )
			for (var i in a)
				ret[ i ] = a[ i ];
		if ( b )
			for (var i in b)
				ret[ i ] = b[ i ];
		
		return ret;
	},
	/* ENTODO: COMPLETE, do not use 'args' :)  */
	potom: function(context, func, time, args) {
		
		var uid = 0;
		if (context.UID)
			uid = context.UID;
		else
			uid = (new Date().getTime()) + parseInt(Math.random() * 10023) + parseInt(Math.random() * 53050023);
			
		// A weird hack here :)
		window['en____' + uid] = context;
		
		var s1 = "window.en____" + uid + "." + func + '(';
		var s2 = ')';
		if (args) s2 = args.join(', ') + s2;
		
		var cmdString =  s1 + s2 + ';';
		//Lib01.log('Potom: ' + cmdString);
		
		setTimeout(cmdString, time);
	},
	
	later: function(context, func, args, time) {
		setTimeout(function() {
			func.apply(context, args);
		}, time);
	},
	
	objectToString: function (obj, whatToConvert) {
		if (!obj) {
			return null;
		}
		var str = '';
		for (var i in obj) {
			if (whatToConvert) {
				var found = false;
				for (var j = 0; j < whatToConvert.length; j++) {
					if (whatToConvert[ j ] == i) {
						found = true;
						break;
					}
				}
				if (!found)
					continue;
			}
			if (typeof obj[ i ] == 'function')
				str += i + ' = function\n';
			else
				str += i + ' = ' + obj[ i ] + '\n';
		}
		return str;
	},
	
	alertObject: function(obj, whatToEcho) {
		alert( Lib01.util.objectToString(obj, whatToEcho) );
	},
	
	Date: {
		parseDuration: function(sec) {
			var units = {}, conv = Lib01.util.Date.durations;
			for (var unit in conv) {
				var value = Math.floor(sec / conv[unit]);
				if (value) {
					units[unit] = value;
					if (!(sec -= value * conv[unit])) break;
				}
			}
			return units;
		},

		fancyDuration: function(sec) {
			var ret = [], units = Lib01.util.Date.parseDuration(sec);
			for (var unit in units) ret.push(units[unit] + Lib01.util.Date.durationsAbbr[unit]);
			return ret.join(', ');
		},

		durations: {years: 31556926, months: 2629743.83, days: 86400, hours: 3600, minutes: 60, seconds: 1, milliseconds: 0.001},
		durationsAbbr: {
			years: 'j',
			months: 'm',
			days: 'd',
			hours: 'h',
			minutes: 'min',
			seconds: 'sec',
			milliseconds: 'ms'
		}
	},
	// Copied from MooTools 1.11
	Json: {
		evaluate: function(str, secure){
			return ((typeof (str) != 'string') || (secure && !str.test(/^("(\\.|[^"\\\n\r])*?"|[,:{}\[\]0-9.\-+Eaeflnr-u \n\r\t])+?$/))) ? null : eval('(' + str + ')');
		}
	}
};

/* DOM helper library */
Lib01.util.DOM = {
	/**/
	newElement: function(type, props, style, actions) {
		var n = document.createElement(type);
		
		if (props) {
			for (var p in props) {
				if (p == 'html')
					n.innerHTML = props[ p ];
				else if (p == 'class')
					n.className = props[ p ];
				else
					n.setAttribute(p, props[ p ]);
			}
		}
		
		if (style) {
			for (var s in styles)
				n.style.s = styles[ s ];
		}
		
		if (actions) {
			for (var a in actions) {
				Lib01.util.DOM.addListener(n, a, actions[ a ]);
			}
		}
		
		return n;
	},
	
	/* Finds child nodes by classname or id */
	findElement: function(base, str) {
		if (!base)
			return;
	
		var modifier = str.substr( 1 );
		var wha = null;
		switch (str.substr(0, 1)) {
		case '#': // find by id
			wha = 'id';
			break;
		case '.': // find by class
			wha = 'className';
			break;
		default:
			return null;
		}
		
		for (var i = 0; i < base.childNodes.length; i++) {
			if (base.childNodes[ i ][wha]) {
				var temp = base.childNodes[ i ][ wha ];
				temp = temp.split(' ');
				for (var j = 0; j < temp.length; j++)
					if (temp[ j ] == modifier)
						return base.childNodes[ i ];
			}
		}
		
		for (var i = 0; i < base.childNodes.length; i++) {
			var ret = Lib01.util.DOM.findElement(base.childNodes[ i ], str);
			if (ret !== null)
				return ret;
		}
		
		return null;
	},
	
	getPosition: function( p ) {
		var top = 0, left = 0;
		for ( ; p; p = p.offsetParent ){
	        top  += p.offsetTop;
	        left += p.offsetLeft;
		}
		Lib01.log('getPosition: ' + [left, top].join(', '));
		return {'left': left, 'top': top};
	},
	
	addClass: function(obj, cls) {
		obj.className += ' ' + cls;
	},
	/* Use with care, this function can be dangerous, if wrong or bad className provided. */
	removeClass: function(obj, cls) {
		obj.className.replace(new RegExp(cls), ' ');
	},
	
	addListener: function(obj, event, func) {
		if (obj.addEventListener) {
			obj.addEventListener(event, func, false);
		} else if (obj.attachEvent) {
			obj.attachEvent("on" + event, func);
		}
	}
};
