<?php
/**
 * $Id: com_juser.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

class MRCommunityCom_juser
{
	function userName($id, $name)
	{
		$user_profile_link = MERoute::_("index.php?option=com_juser&view=userlist&layout=profile&id={$id}");
		$out = JHTML::link($user_profile_link, $name);
		return $out;
	}
	function userAvatar($id, $params, $prefix = '')
	{
		
		static $users = array();
		
		if(array_key_exists($id, $users)) return $users[$id];
		
		$user = JFactory::getUser($id);
		
		jimport('joomla.filesystem.file');
		//load ini file if exists
		if (JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_juser'.DS.'config.ini'))
		{
			$ini = JFile::read(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_juser'.DS.'config.ini');
			$juserParams = new JParameter($ini);
			$juserFolder = $juserParams->get("general::avatars_dir");
			$juserFolder = $juserFolder.'/'.strtolower($user->get('username')).'.jpg';

			if (JFile::exists(JPATH_ROOT.DS.$juserFolder))
			{
				$users[$id] =  JHTML::image(JURI::root().$juserFolder,	$user->get('username'). JText::_('Avatar'));
			}
			else
			{
				$users[$id] = '';
			}
			return $users[$id];

		}
	}
}

?>