<?php
/**
 * $Id: tags.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.model');
class ResModelTags extends JModel
{
	function __construct()
	{
		parent::__construct();
	}
	function hit($id, $section_id)
	{
		if(!$id || !$section_id) return;
		
		$sql = "UPDATE  #__js_res_tags_history SET `hits` = `hits` + 1 WHERE tag_id = {$id} AND section_id = {$section_id}";
		$this->_db->setQuery($sql);
		$this->_db->query();
	}
	function getTags($section)
	{
		global $mainframe;

		$params = & $mainframe->getParams();
		$uid = JRequest::getVar('user_id');
		$where = "";
		if ($uid)
		{
			$where  = " AND h.user_id = {$uid} ";
			/*$sql = "SELECT t.tag, t.id FROM #__js_res_tags AS t "
			.' LEFT JOIN #__js_res_tags_history AS th ON t.id = th.tag_id '
			.' WHERE th.user_id ='.(int)$user->id.' AND th.section_id = '.(int)$this->params->get('section')
			.'';*/

		}
		if(!$params->get('relevance_mode'))
		{
			$total = ' SUM(h.hits) AS total ';
		}else{
			$total = ' COUNT(r.id) AS total ';
		}
		$sql = "SELECT {$total}, t.tag, t.slug, t.id, rc.catid
		FROM #__js_res_tags AS t
		LEFT JOIN #__js_res_tags_history AS h ON h.tag_id = t.id
		LEFT JOIN #__js_res_record AS r ON r.id = h.record_id
		LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = h.record_id
		WHERE h.section_id = $section.$where
		GROUP BY t.id
		ORDER BY total DESC";

		if($params->get('limit') > 0)
		{
			$sql .= ' LIMIT 0, '.$params->get('limit');
		}
		//echo $sql;
		return $this->_getList($sql);

	}

	function getTag( $id )
	{
		global $mainframe;

		$sql = "SELECT tag FROM #__js_res_tags WHERE id = ". $id;


		$this->_db->setQuery($sql);
		return $this->_db->loadObject();

	}

	function getSectionName($section)
	{
		$section = ResHelper::getSection($section);
		return $section->name;
/*		$db = & JFactory::getDBO();
    	$sql = "SELECT name FROM #__js_res_category WHERE id = $section";
    	$db->setQuery($sql);
    	return  $db->loadResult();
*/	}
}