<?php
/**
 * $Id: ucategory.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.model');
class ResModelUcategory extends JModel
{
	var $_id = null;
	var $_data = null;
	var $_total = null;
	var $_utotal = null;
	var $_pagination = null;
	var $_category = '';
	var $_sid = null;

	function __construct()
	{
		parent::__construct();
		global $mainframe, $option;
		$config = JFactory::getConfig();

		//$sid = JRequest::getVar('category_id', array(0), '', 'array');
		$array = JRequest::getVar('cid', array(0), '', 'array');
		$this->setId((int)$array[0]);

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'.cat.filter_order',		'filter_order',		'ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.cat.filter_order_Dir',	'filter_order_Dir',	'',	'word' );

		$this->setState('filter_order', $filter_order);
		$this->setState('filter_order_dir', $filter_order_Dir);
	}

	function setId($id)
	{
		$this->_id			= $id;
		$this->_category	= null;
	}
	
	function getId()
	{
		return $this->_id;
	}

	function &getData()
	{
		//$this->_sid = $sid;
		// Load the weblink data
		if ($this->_loadData())
		{
		}
		else  $this->_initData();

		return $this->_data[$this->_id];
	}
	function _loadData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data[$this->_id]))
		{
			$query = 'SELECT * FROM #__js_res_category_user WHERE id = '.(int) $this->_id;
			$this->_db->setQuery($query);
			$this->_data[$this->_id] = $this->_db->loadObject();
			return (boolean) $this->_data[$this->_id];
		}
		return true;
	}
	function store($data)
	{
		$user = &JFactory::getUser();
		$row = JTable::getInstance('ucat', 'Res');

		// Bind the form fields to the web link table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		if (!$row->id) {
			$where = 'user_id = ' . (int) $user->get('id') ;
			$where .= ' AND section_id = ' . (int) $$data['section_id'] ;
			$row->ordering = $row->getNextOrder( $where );
		}

		// Make sure the web link table is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		$this->_id = $row->id;

		return true;
	}

	//felix code start

	function checkUserCategoryLimit( $params, $section_id )
	{
		$user = &JFactory::getUser();

		//echo $params->get( 'pcat_limit' ); exit;

		if( !$params->get( 'pcat_limit' )){
			return true;
		}

		$query = "SELECT count(*) FROM #__js_res_category_user WHERE section_id = {$section_id}";
		if(JRequest::getVar('client_id')) $query .= " AND client_id = '".JRequest::getVar('client_id')."'";
		else
		$query .= " AND client_id = 0 AND user_id = {$user->id}";

		if((JRequest::getVar('client', 'resource') != 'resource')) $query .= " AND client = '".addslashes(stripslashes(JRequest::getVar('client')))."'";

		$this->_db->setQuery( $query );
		$data = $this->_db->loadResult();
		if( $data >= $params->get( 'pcat_limit' ) ){
			return false;
		}
		return true;
	}

	//felix code end

	function _initData()
	{
		// Lets load the content if it doesn't already exist

		if (empty($this->_data[$this->_id]))
		{
			$cat = new stdClass();

			$cat->id				= 0;
			$cat->user_id			= 0;
			$cat->section_id		= 0;
			$cat->mtime				= ResHelper::getDate();
			$cat->ctime				= ResHelper::getDate();
			$cat->params			= '';
			$cat->name				= '';
			$cat->ordering			= 0;
			$cat->published			= 1;
			$cat->access			= 0;
			$cat->description		= '';
			$cat->checked_out		= 0;
			$cat->checked_out_time	= null;
			$cat->hits	= 0;
			$cat->rate	= 0;
			$cat->rate_count = 0;
			$cat->icon = '';
			$cat->alias = '';
			$cat->client_id = 0;
			$cat->client = JRequest::getVar('client', 'resource');

			$this->_data[$this->_id] = $cat;
			return (boolean) $this->_data[$this->_id];
		}
		return true;
	}

	function getItems($user_id = 0, $client_id = 0, $all = false)
	{
		if(!$user_id)
		{
			$user = JFactory::getUser();
			$user_id = $user->get('id');
		}

		if(!$user_id)
		{
			JError::raiseNotice(100, JText::_('Error: User ID is not set'));
			return;
		}

		if (empty($this->_data2[$user_id]))
		{
			$query = $this->_buildQuery($user_id, $client_id, $all);
			$this->_data2[$user_id] = $this->_getList($query);
		}

		return $this->_data2[$user_id];
	}

	function isCheckedOut( $uid=0 )
	{
		if ($this->_loadData())
		{
			if ($uid) {
				return ($this->_data[$this->_id]->checked_out && $this->_data[$this->_id]->checked_out != $uid);
			} else {
				return $this->_data[$this->_id]->checked_out;
			}
		}
	}
	function checkin()
	{
		if ($this->_id)
		{
			$cat = & JTable::getInstance('ucat', 'Res');
			if(! $cat->checkin($this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return false;
	}

	function checkout($uid = null)
	{
		if ($this->_id)
		{
			// Make sure we have a user id to checkout the article with
			if (is_null($uid)) {
				$user	=& JFactory::getUser();
				$uid	= $user->get('id');
			}
			// Lets get to it and checkout the thing...

			//$cat = & $this->getTable();
			$cat = & JTable::getInstance('ucat', 'Res');
			if(!$cat->checkout($uid, $this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}

			return true;
		}
		return false;
	}

	function getCategory($id)
	{
		global $mainframe;

		$user = &JFactory::getUser();
		if(!$id)
		{
			$cat = new stdClass();
			$cat->title = '';
			$cat->name = '';
			$cat->image = '';
			$cat->description = '';
			$cat->id = '';
			$cat->parent = '';
			$cat->meta_key = '';
			$cat->meta_descr = '';
			return $cat;
		}
/*		$sql = "SELECT * FROM #__js_res_category WHERE id = $id";
		$this->_db->setQuery($sql);
		$category = $this->_db->loadObject();*/
		$category = ResHelper::getSection($id);
		if (!$category->published) {
			JError::raiseError(404, JText::_("Category Not Found"));
			return false;
		}
			
		if($category->access > $user->get('aid', 0))
		{
			if($category->access == 1)
			$msg = JText::_('Only Registered Users can access this page');
			if($category->access == 2)
			$msg = JText::_('Only Publishers or Authors can access this page');
			JError::raiseWarning(403, $msg);
			$mainframe->redirect(MERoute::_('index.php?option=com_resource&view=list&Itemid='.JRequest::getInt('Itemid'), FALSE));
			return;
		}
		return $category;
	}


	function _buildQuery($user_id, $client_id, $all = false)
	{
		global $mainframe, $option;

		$model 		= &JModel::getInstance('List','ResModel');
			
//		$filter_order		= $this->getState('filter_order');
		$filter_order_dir	= $this->getState('filter_order_dir');

//		if(!$filter_order) 
		$filter_order = 'c.ordering';

		$url_params = &$mainframe->getParams();
		$params 	= ResHelper::initListParams(JRequest::getInt('category_id', $url_params->get('mod_cat_id', $url_params->get('category_id'))));
		$section 	= $model->getCategory(ResHelper::getCategorySection($params->get('category_id', JRequest::getInt('category_id'))));

		$query = "SELECT c.id as value, c.name as text, c.*, count(r.ucatid) AS nums FROM #__js_res_category_user AS c" .
				' LEFT JOIN #__js_res_record AS r ON r.ucatid = c.id ' .
				' WHERE c.user_id = '.$user_id.' AND c.client_id = '. ($client_id ? $client_id :  0) .
				' AND c.section_id =  ' . $section->id .
		((JRequest::getVar('client', 'resource') != 'resource') ? " AND c.client = '".addslashes(stripslashes(JRequest::getVar('client')))."'"  : NULL).
		($all == false ? ' AND c.published = 1 ' : null ) .
				' GROUP BY c.id ORDER BY '.$filter_order. ' '.$filter_order_dir
		;
			
		//echo $query;
		return $query;
	}
	function move($direction)
	{
		$user = & JFactory::getUser();
		$row =& Jtable::getInstance('Ucat', 'Res');
		$section_id = ResHelper::getCategorySection(JRequest::getInt('category_id'));
		if (!$row->load($this->_id)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		if(JRequest::getInt('client_id'))
		{
			$where  = ' client_id = '.JRequest::getInt('client_id').' AND section_id = '.$section_id;
		}
		else
		{
			$where = ' user_id = '.(int) $user->get('id'). ' AND client_id = 0 AND section_id = '.$section_id;
		}

		//echo $where; exit;

		if (!$row->move( $direction,  $where)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		return true;
	}
	function saveorder($cid = array(), $order)
	{
		$user = & JFactory::getUser();
		$row =& Jtable::getInstance('Ucat', 'Res');
		$section_id = ResHelper::getCategorySection(JRequest::getInt('category_id'));

		if(JRequest::getInt('client_id'))
		{
			$type ='client_id';
		}
		else
		{
			$type = 'user_id';
		}
		
		$groupings = array();

		// update ordering values
		for( $i=0; $i < count($cid); $i++ )
		{
			$row->load( (int) $cid[$i] );
			// track categories
			$groupings[] = $row->$type;

			if ($row->ordering != $order[$i])
			{
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
		}

		// execute updateOrder for each parent group
		$groupings = array_unique( $groupings );
		foreach ($groupings as $group){
			$row->reorder($type.' = '.(int) $group.' AND section_id = '.$section_id);
		}
		
		return;
	}
}
?>