<?php
/**
 * $Id: router_old.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.model');

function debugTable( $index, $value, $brs = 0 ) {
	static $q = 0;
	$value = htmlentities( $value );
	$brs = $brs ? "<br>" : "";
	$value = str_replace( array( "\n", "\r" ), array( $brs, "" ), $value );
	?>
<script language="javascript" type="text/javascript">
    <?php if( $q == 0 ) {?>
      document.write("<table id='debugTable' border cellspacing='0'></table>");
    <?php
      $q=1;
    }
    ?>
    var table = document.getElementById('debugTable');
    table.innerHTML += "<tr><td nowrap='nowrap'><b><?php echo $index; ?></b></td><td><?php echo $value; ?></td></tr>";
  </script>
<?php

}

function ResourceBuildRoute(&$query)
{
	global $mainframe;

	//static $q = 0; debugTable( 'query '.++$q, print_r($query,1) );
	//print'<b>this:</b>'.print_r($query,1).'<br>';

	require_once ( JPATH_BASE.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php' );
	require_once ( JPATH_BASE.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
	ResControllerConfig::initialyze();

	JModel::addIncludePath( JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models' );
	//$list_model      = JModel::getInstance( 'list',      'ResModel' );
	require_once (JPATH_BASE . DS . 'components' . DS . 'com_resource' . DS . 'models' . DS . 'list.php');
	$list_model = new ResModelList();
	$article_model   = JModel::getInstance( 'article',   'ResModel' );
	$tags_model      = JModel::getInstance( 'tags',      'ResModel' );
	$ucategory_model = JModel::getInstance( 'ucategory', 'ResModel' );

	$key_segments = array();
	$segments = array();
	$slashesSkipes = array();
	$pregPrepareSkipes = array();

	$keywords_replacement = array (
		"myarticle-list"     => RES_SEO_MYARTICLE_LIST,
		"edit-user-category" => RES_SEO_EDIT_USER_CATEGORY,
		"add-user-category"  => RES_SEO_ADD_USER_CATEGORY,
		"manage-categories"  => RES_SEO_MANAGE_CATEGORIES,
		"list"               => RES_SEO_LIST,
		"clientarticle-list" => RES_SEO_CLIENTARTICLE_LIST,
		"userarticle-list"   => RES_SEO_USERARTICLE_LIST,
		"children-list"      => RES_SEO_CHILDREN_LIST,
		"add-new-child"      => RES_SEO_ADD_NEW_CHILD,
		"article"            => RES_SEO_ARTICLE,
		"tags"               => RES_SEO_TAGS,
		"edit-record"        => RES_SEO_EDIT_RECORD,
		"new-record"         => RES_SEO_NEW_RECORD,
		"favorites"          => RES_SEO_FAVORITES,
		"rated"              => RES_SEO_RATED,
		"last-visited"       => RES_SEO_LAST_VISITED,
		"created"            => RES_SEO_CREATED,
		"commented"          => RES_SEO_COMMENTED,
		"related"          	 => 'related',
		"hidden"          	 => 'hidden',
		"expired"          	 => 'expired',
		"unpublished"          	 => 'unpublished'
	);
	$vw_array = array( 'favorites', 'rated', 'last-visited', 'created', 'commented', 'related', 'expired', 'unpublished', 'hidden' ); 

	if( isset( $query['controller'] ) && $query['controller'] ) $c = $query['controller']; else $c = '';
	if( isset( $query['view'] )       && $query['view'] )       $v = $query['view'];       else $v = '';
	if( isset( $query['layout'] )     && $query['layout'] )     $l = $query['layout'];     else $l = '';

	if( isset( $query['section_id'] )  && $query['section_id'] )  $sid  = $query['section_id'];  else $sid = '';
	if( isset( $query['category_id'] ) && $query['category_id'] ) $cid  = $query['category_id']; else $cid = '';
	if( isset( $query['article'] )     && $query['article'] )     $aid  = $query['article'];     else $aid = '';
	if( isset( $query['tag'] )         && $query['tag'] )         $tid  = $query['tag'];         else $tid = '';
	if( isset( $query['user_id'] )     && $query['user_id'] )     $uid  = $query['user_id'];     else $uid = '';
	if( isset( $query['ucid'] )        && $query['ucid'] )        $ucid = $query['ucid'];        else $ucid = '';

	if( isset( $query['view_what'] ) && $query['view_what'] ) $vw = $query['view_what']; else $vw = '';

	if( isset( $query['child_field'] )    && $query['child_field'] )    $cfieldid   =  $query['child_field'];    else $cfieldid = '';
	if( isset( $query['parent_record'] )  && $query['parent_record'] )  $precordid  =  $query['parent_record'];  else $precordid = '';
	if( isset( $query['child_record'] )   && $query['child_record'] )  	$crecordid  =  $query['child_record'];   else $crecordid = '';
	if( isset( $query['parent_article'] ) && $query['parent_article'] ) $particleid =  $query['parent_article']; else $particleid = '';
	
	if( isset( $query['client'] ) && $query['client'] ) $client =  $query['client']; else $client = '';
	if( isset( $query['client_id'] ) && $query['client_id'] ) $client_id =  $query['client_id']; else $client_id = '';

	if( isset( $query['cid'] ) && $query['cid'] ) $_cid = $query['cid']; else $_cid = array();

	//if( $cid )print str_replace('#__', 'jos_', $list_model->_getCategoryRoutePath( $cid ) ).'<br><br>';

	if( $v == 'category' &&  $l == 'form' && $cid && count( $_cid ) ) {

		$segments[] = $keywords_replacement['edit-user-category'];

		$segments[] = $list_model->_getCategoryRoutePath( $cid, 1 );
		$slashesSkipes[] = count($segments)-1;

		$ucategory_model->setId( $_cid[0] );
		$ucategory = $ucategory_model->getData();
		$segments[] = $_cid[0].'-'.$ucategory->alias;
		$slashesSkipes[] = count($segments)-1;
	} else if( $v == 'category' &&  $l == 'form' && $cid ) {

		$segments[] = $keywords_replacement['add-user-category'];

		$segments[] = $list_model->_getCategoryRoutePath( $cid, 1 );
		$slashesSkipes[] = count($segments)-1;

	} else if( $vw == 'tag' && $l == 'useritems' && $v == 'list') {

		$segments[] = $keywords_replacement['tags'];

		$segments[] = $list_model->_getCategoryRoutePath( $cid, 1 );
		$slashesSkipes[] = count($segments)-1;

		$tag = $tags_model->getTag( $tid );
		$segments[] = $tid.'-'.urlencode($tag->tag);
		//$pregPrepareSkipes[] = count($segments)-1;

		if( $uid ) {
			$user = JFactory::getUser( $uid );
			$segments[] = $uid.'-'.$user->username;
		}

	} else if ( $v == 'category' && $c == 'category' && $cid ) {
		
		$segments[] = $keywords_replacement['manage-categories'];
		$segments[] = $list_model->_getCategoryRoutePath( $cid );
		$slashesSkipes[] = count($segments)-1;

	}
	/* else if ( $v == 'list' && $cfieldid && $pfieldid && $precordid ) {

		$article = $article_model->getArticle( $precordid, 1 );

		$segments[] = $keywords_replacement['children-list'];
		$segments[] = $list_model->_getCategoryRoutePath( $cid );
		$slashesSkipes[] = count($segments)-1;
		$segments[] = $cfieldid.'-'.$list_model->_getFieldTitle($cfieldid);
		$segments[] = $pfieldid.'-'.$list_model->_getFieldTitle($pfieldid);
		$segments[] = $precordid.'-'.$article->alias;

	} */ 
	else if ( in_array( $vw, $vw_array) && $v == 'list' && ( $cid || $sid ) ) {


		$segments[] = $keywords_replacement[ $vw ];

		/*if( !is_array($sid) )	{
		 $sida = array($sid);
		 } else {
		 $sida = $sid;
		 }
		 foreach( $sida as $sidi ) {
		 $segments[] = $list_model->_getCategoryRoutePath( $sidi, 1 );
		 $slashesSkipes[] = count($segments)-1;
		 }*/
			
		$segments[] = $list_model->_getCategoryRoutePath( ( $cid ? $cid : $sid ), 1 );
		$slashesSkipes[] = count($segments)-1;

		if($uid)
		{
			$user = JFactory::getUser( $uid );
			$segments[] = $uid.'-'.$user->username;
		}
		
		if ($cfieldid && $crecordid) {
			$childRecord = $article_model->getRecord($crecordid);
			
			$segments[] = 'c-'.$childRecord->id.'-'.$childRecord->alias;
			$segments[] = $cfieldid;
		}
		else if ($cfieldid && $precordid) {
			$parentRecord = $article_model->getRecord($precordid);
			
			$segments[] = 'p-'.$parentRecord->id.'-'.$parentRecord->alias;
			$segments[] = $cfieldid;
		}

	} else if( $v == 'utility'  ) {
		$segments[] = 'utility';
	} else if ( $v == 'list' && $cid && $ucid && $client_id  && $client ) {

		$user = new JUser( $uid );

		$segments[] = $keywords_replacement['clientarticle-list'];
		$segments[] = $list_model->_getCategoryRoutePath( $cid );
		$slashesSkipes[] = count($segments)-1;

		$ucategory_model->setId( $ucid );
		$ucategory = $ucategory_model->getData();
		$segments[] = $ucid.'-'.$ucategory->name;
		$slashesSkipes[] = count($segments)-1;

	} else if ( $v == 'list' && $uid && $ucid ) {

		$user = new JUser( $uid );

		$segments[] = $keywords_replacement['userarticle-list'];
		$segments[] = $list_model->_getCategoryRoutePath( $cid );
		$slashesSkipes[] = count($segments)-1;

		$ucategory_model->setId( $ucid );
		$ucategory = $ucategory_model->getData();
		$segments[] = $ucid.'-'.urlencode( $ucategory->alias );
		$slashesSkipes[] = count($segments)-1;

		$segments[] = $uid.'-'.$user->name;

	} else if ( $v == 'list' && $uid && $cid ) {

		$user = new JUser( $uid );
			
		$segments[] = $keywords_replacement['myarticle-list'];
		$segments[] = $list_model->_getCategoryRoutePath( $cid );
		$slashesSkipes[] = count($segments)-1;
			
		$segments[] = $uid.'-'.$user->name;
			
	} else if( $v == 'list'  ) {

		$segments[] = $keywords_replacement['list'];
		$segments[] = $list_model->_getCategoryRoutePath( $cid );
		$slashesSkipes[] = count($segments)-1;

	} else if( $c == "article" && $l == 'form' && $v == 'article' && $cfieldid && $particleid ) {
		$segments[] = $keywords_replacement['add-new-child'];

		$segments[] = $list_model->_getCategoryRoutePath( $cid, 1 );
		$slashesSkipes[] = count($segments)-1;
		$segments[] = $cfieldid.'-'.$list_model->_getFieldTitle($cfieldid);
		$segments[] = $precordid.'-'.$article->alias;

	} else if( $c == "article" && $l == 'form' && $v == 'article' ) {

		if( $aid ) {
			$segments[] = $keywords_replacement['edit-record'];
		} else {
			$segments[] = $keywords_replacement['new-record'];
		}

		if( $cid ) {
			$segments[] = $list_model->_getCategoryRoutePath( $cid, 1 );
			$slashesSkipes[] = count($segments)-1;
		}

		if( $aid ) {
			$article = $article_model->getRecord($aid);
			$segments[] = $aid.'-_____________'.$article->alias;
		}
			
	} else if( $c == 'article') {
		$segments[] = $keywords_replacement['article'];

		if($cid) $segments[] = $list_model->_getCategoryRoutePath( $cid );
		$slashesSkipes[] = count($segments)-1;

		if($aid) 
		{
			$article = $article_model->getRecord( $aid );
			$segments[] = $aid.'-'.$article->alias;
		}

	}

	if( isset($query['filter_reset']) && $query['filter_reset'] ){
		if (isset($segments[1]))
			array_splice( $segments, 1, 1, array( "filter-reset", $segments[1] ) );
	}

	if( isset( $client ) && $client && isset( $client_id ) && $client_id && $client != "resource" ){

		if( isset($segments[1]) ) {
			array_splice( $segments, 1, 1, array( "client", $segments[1] ) );
		} else {
			$segments[] = "client";
		}
		$segments[] = $client_id."-".urlencode(stripslashes($client));
		$pregPrepareSkipes[] = count($segments)-1;
	}

	/*print'<div style="border:1px solid #FF0000 !important; background:#FFFFFF !important;">';
	 print_r( $segments );
	 print'<br>';
	 print_r( $query );
	 print'</div>';*/
	//if( isset($query['user_id']) ) exit;


	if($v != 'utility')
	{
		unset($query['view']);
		unset($query['category_id']);
		unset($query['controller']);
		unset($query['article']);
		unset($query['active_option_asigner']);
		unset($query['filter_reset']);
		unset($query['layout']);
		unset($query['view_what']);
		unset($query['tag']);
		unset($query['userid']);
		unset($query['user_id']);
		unset($query['child_field']);
		unset($query['parent_field']);
		unset($query['parent_record']);
		unset($query['child_record']);
		unset($query['cid']);
		unset($query['ucid']);
		unset($query['section_id']);
		unset($query['client_id']);
		unset($query['client']);
	}


	foreach( $segments as $key => $segment) {

		if( ! in_array( $key, $pregPrepareSkipes ) ) {
			if(is_array($segments[$key])) $segments[$key] = implode("-", $segments[$key]);
			if( in_array( $key, $slashesSkipes ) ) {
				//var_dump($segments[$key]);
				//$segments[$key] = preg_replace( '#[^\%[:alnum:]\/]#', '-', strtolower($segments[$key]) );
			} else {
				$segments[$key] = preg_replace( '#[^\%[:alnum:]]#', '-', strtolower($segments[$key]) );
			}

			$replases = true;
			while( $replases ) {
				$tmp = $segments[$key];
				$segments[$key] = str_replace( '--', '-', $segments[$key] );
				if($tmp != $segments[$key] ) {
					$replases = true;
				} else {
					$replases = false;
				}
			}
			$segments[$key] = preg_replace("/-$/i", '', $segments[$key]);
		}
	}

	return $segments;
}

function ResourceParseRoute($segments)
{
	require_once ( JPATH_BASE.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
	ResControllerConfig::initialyze();

	$keywords_replacement = array (
		"myarticle-list"     => RES_SEO_MYARTICLE_LIST,
		"edit-user-category" => RES_SEO_EDIT_USER_CATEGORY,
		"add-user-category"  => RES_SEO_ADD_USER_CATEGORY,
		"manage-categories"  => RES_SEO_MANAGE_CATEGORIES,
		"list"               => RES_SEO_LIST,
		"clientarticle-list" => RES_SEO_CLIENTARTICLE_LIST,
		"userarticle-list"   => RES_SEO_USERARTICLE_LIST,
		"children-list"      => RES_SEO_CHILDREN_LIST,
		"add-new-child"      => RES_SEO_ADD_NEW_CHILD,
		"article"            => RES_SEO_ARTICLE,
		"tags"               => RES_SEO_TAGS,
		"edit-record"        => RES_SEO_EDIT_RECORD,
		"new-record"         => RES_SEO_NEW_RECORD,
		"favorites"          => RES_SEO_FAVORITES,
		"rated"              => RES_SEO_RATED,
		"last-visited"       => RES_SEO_LAST_VISITED,
		"created"            => RES_SEO_CREATED,
		"commented"          => RES_SEO_COMMENTED,
		"related"          	 => 'related',
		"hidden"          	 => 'hidden',
		"expired"          	 => 'expired',
		"unpublished"          	 => 'unpublished'
	);

	$vars = array();
	

	if (!empty($segments[1]) && $segments[1] == "client" ) {
		array_splice( $segments, 1, 1 );
		$vars['client'] = array_splice( $segments, -1 );
		$vars['client'] = $vars['client'][0];
		$vars['client_id'] = JFilterInput::clean( preg_replace( '#^[^0-9]*#', '', $vars['client'] ), 'INT' );
		$vars['client'] = preg_replace( '#^[0-9]*[-:]#', '', $vars['client'] );
	}

	$additional_keywords = array();
	foreach( $keywords_replacement as $key => $keyword ) {
		$additional_keywords[$key."_add"] = preg_replace( array( "#^([^-]+)-(.+)$#", "#^([^-]+)$#" ), array( "$1:$2", "$1" ), $keyword );
	}
	$keywords_replacement = array_merge( $keywords_replacement, $additional_keywords );


	//Get the active menu item
	$menu =& JSite::getMenu();
	$item =& $menu->getActive();
	
	$last_segment = count( $segments ) - 1;

	switch( $segments[0] ) {
		case $keywords_replacement['myarticle-list'] :
		case $keywords_replacement['myarticle-list_add'] :
			$vars['view'] = 'list';
			$vars['category_id'] = JFilterInput::clean( preg_replace( '#^[^0-9]*#', '', $segments[$last_segment-1] ), 'INT' );
			$vars['user_id'] = JFilterInput::clean( preg_replace( '#^[^0-9]*#', '', $segments[$last_segment] ), 'INT' );
			break;
		case $keywords_replacement['edit-user-category'] :
		case $keywords_replacement['edit-user-category_add'] :
			$vars['view']        = 'category';
			$vars['layout']      = 'form';
			$vars['category_id'] = JFilterInput::clean( preg_replace( '#^[^0-9]*#', '', $segments[$last_segment-1] ), 'INT' );
			$vars['cid']         = array( JFilterInput::clean( preg_replace( '#^[^0-9]*#', '', $segments[$last_segment] ), 'INT' ) );
			break;
		case $keywords_replacement['add-user-category'] :
		case $keywords_replacement['add-user-category_add'] :
			$vars['view'] = 'category';
			$vars['layout'] = 'form';
			$vars['category_id'] = JFilterInput::clean( preg_replace( '#^[^0-9]*#', '', $segments[$last_segment] ), 'INT' );
			break;
		case $keywords_replacement['manage-categories'] :
		case $keywords_replacement['manage-categories_add'] :
			$vars['view'] = 'category';
			$vars['controller'] = 'category';
			$vars['category_id'] = JFilterInput::clean( preg_replace( '#^[^0-9]*#', '', $segments[$last_segment] ), 'INT' );
			break;
		case $keywords_replacement['list'] :
		case $keywords_replacement['list_add'] :
			$vars['view'] = 'list';
			$vars['category_id'] = JFilterInput::clean( preg_replace( '#^[^0-9]*#', '', $segments[$last_segment] ), 'INT' );
			break;
		case $keywords_replacement['clientarticle-list'] :
		case $keywords_replacement['clientarticle-list_add'] :
			$vars['view'] = 'list';
			$vars['category_id'] = JFilterInput::clean( preg_replace( '#^[^0-9]*#', '', $segments[$last_segment-1] ), 'INT' );
			$vars['ucid'] = JFilterInput::clean( preg_replace( '#^[^0-9]*#', '', $segments[$last_segment] ), 'INT' );
			break;
		case $keywords_replacement['userarticle-list'] :
		case $keywords_replacement['userarticle-list_add'] :
			$vars['view'] = 'list';
			$vars['category_id'] = JFilterInput::clean( preg_replace( '#^[^0-9]*#', '', $segments[$last_segment-2] ), 'INT' );
			$vars['ucid'] = JFilterInput::clean( preg_replace( '#^[^0-9]*#', '', $segments[$last_segment-1] ), 'INT' );
			$vars['user_id'] = JFilterInput::clean( preg_replace( '#^[^0-9]*#', '', $segments[$last_segment] ), 'INT' );

			break;
		case $keywords_replacement['children-list'] :
		case $keywords_replacement['children-list_add'] :
			$vars['view'] = 'list';
			$vars['category_id'] = JFilterInput::clean( $segments[$last_segment-3], 'INT' );
			$vars['child_field'] = JFilterInput::clean( $segments[$last_segment-2], 'INT' );
			$vars['parent_field'] = JFilterInput::clean( $segments[$last_segment-1], 'INT' );
			$vars['parent_record'] = JFilterInput::clean( $segments[$last_segment], 'INT' );

			break;
		case $keywords_replacement['add-new-child'] :
		case $keywords_replacement['add-new-child_add'] :
			$vars['controller'] = 'article';
			$vars['layout']     = 'form';
			$vars['view']       = 'article';
			$vars['category_id'] = JFilterInput::clean( $segments[$last_segment-2], 'INT' );
			$vars['child_field'] = JFilterInput::clean( $segments[$last_segment-1], 'INT' );
			$vars['parent_article'] = JFilterInput::clean( $segments[$last_segment], 'INT' );
			break;
		case $keywords_replacement['article'] :
		case $keywords_replacement['article_add'] :
			//index.php?option=com_resource&controller=article&article=1036&category_id=2&Itemid=85&lang=en&client_id=1&client=admin
			$vars['controller'] = 'article';
			if( count( $segments ) > 1) $vars['article'] = JFilterInput::clean( $segments[$last_segment], 'INT' );
			if( count( $segments ) > 2) {
				$vars['category_id'] = JFilterInput::clean( $segments[$last_segment-1], 'INT' );
			}
			break;
		case $keywords_replacement['tags'] :
		case $keywords_replacement['tags_add'] :
			$vars['layout']    = 'useritems';
			$vars['view']      = 'list';
			$vars['view_what'] = 'tag';

			$t = -1;
			if( count( $segments ) == 4 ) {
				$vars['user_id'] = JFilterInput::clean( $segments[$last_segment], 'INT' );
				$t = 0;
			}

			$vars['tag'] = JFilterInput::clean( $segments[$last_segment-(++$t)], 'INT' );
			$vars['category_id'] = JFilterInput::clean( $segments[$last_segment-(++$t)], 'INT' );
			break;
		case $keywords_replacement['edit-record'] :
		case $keywords_replacement['edit-record_add'] :
			$vars['controller'] = 'article';
			$vars['layout']     = 'form';
			$vars['view']       = 'article';

			if(count( $segments ) > 2 ) {
				$vars['category_id'] = JFilterInput::clean( $segments[$last_segment-1], 'INT' );
			}

			$vars['article'] = JFilterInput::clean( $segments[$last_segment], 'INT' );
			break;
		case $keywords_replacement['new-record'] :
		case $keywords_replacement['new-record_add'] :
			$vars['controller'] = 'article';
			$vars['layout']     = 'form';
			$vars['view']       = 'article';

			if(count( $segments ) > 1 ) {
				$vars['category_id'] = JFilterInput::clean( $segments[$last_segment], 'INT' );
			}
			break;
		case $keywords_replacement['favorites'] :
		case $keywords_replacement['favorites_add'] :
		case $keywords_replacement['rated'] :
		case $keywords_replacement['rated_add'] :
		case $keywords_replacement['last-visited'] :
		case $keywords_replacement['last-visited_add'] :
		case $keywords_replacement['created'] :
		case $keywords_replacement['created_add'] :
		case $keywords_replacement['commented'] :
		case $keywords_replacement['commented_add'] :
			//$vars['layout']     = 'useritems';
			$vars['view']       = 'list';
			$vars['view_what'] = array_search($segments[0], $keywords_replacement);
			/*$vars['section_id'] = array();

			for( $i = 1; $i<=count( $segments )-2; $i++ ){
			$vars['section_id'][] = JFilterInput::clean( $segments[$i], 'INT' );
			}*/
			$vars['category_id'] = JFilterInput::clean( $segments[$last_segment-1], 'INT' );
			$vars['user_id'] = JFilterInput::clean( $segments[$last_segment], 'INT' );

			break;
		case $keywords_replacement['related'] :
			//$vars['layout']     = 'useritems';
			$vars['view']       = 'list';
			$vars['view_what'] = $segments[0];
			
			// Hadle related field stuff.
			if ($last_segment - 1 >= 0) {
				$prefix = substr($segments[$last_segment - 1], 0, 2);
				if (in_array($prefix, array('p-', 'p:'))) {
					$vars['parent_record'] 	= JFilterInput::clean( $segments[$last_segment - 1], 	'INT' );
					$vars['child_field'] 	= JFilterInput::clean( $segments[$last_segment], 		'INT' );
					$vars['category_id'] 	= JFilterInput::clean( $segments[$last_segment - 2], 	'INT' );
				}
				if (in_array($prefix, array('c-', 'c:'))) {
					$vars['child_record'] 	= JFilterInput::clean( $segments[$last_segment - 1], 	'INT' );
					$vars['child_field'] 	= JFilterInput::clean( $segments[$last_segment], 		'INT' );
					$vars['category_id'] 	= JFilterInput::clean( $segments[$last_segment - 2], 	'INT' );
				}
			}
			else {
				$vars['category_id'] = JFilterInput::clean( $segments[$last_segment], 'INT' );
			}
			
			break;
	}
	
	if( in_array( "filter:reset", $segments ) || in_array( "filter-reset", $segments )) {
		$vars['filter_reset'] = 1;
	}
	//print_r($vars);
	
	return $vars;
}
