<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class ResViewCategory extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option;

		$itemid =   JRequest::getInt('Itemid');
		$user 	=   JFactory::getUser();
		$uri 	= & JFactory::getURI();
		
		if(!$user->get('id'))
		{
			JError::raiseWarning(403, JText::_('You are not authorized to this page. Please login'));
			$mainframe->redirect(JRoute::_('index.php?option=com_user&view=login&Itemid='.JRequest::getInt('Itemid').'&return='.base64_encode($uri->toString()), FALSE));
			return ;
		}

		if(JRequest::getWord('layout') == 'form')
		{
			$this->_form($tpl);
			return;
		}

		$document	= &JFactory::getDocument();
		$pathway	= &$mainframe->getPathway();
		$config 	= &JFactory::getConfig();
		$model 		= &JModel::getInstance('List','ResModel');
		$cmodel 		= &JModel::getInstance('Ucategory','ResModel');

		$menus	= &JSite::getMenu();
		$menu	= $menus->getActive();
		$url_params = new JParameter( @$menu->params );

		//ResHelper::initListParams(JRequest::getInt('category_id', $url_params->get('mod_cat_id', $url_params->get('category_id'))));
		$params 	= ResHelper::initListParams(JRequest::getInt('category_id', $url_params->get('mod_cat_id', $url_params->get('category_id'))));
		//exit;
		if(($params->get('pcat_submit') == 'none'))
		{
			JError::raiseWarning(403, JText::_('You cannot crete personal categories. Personal categories in this section are not allowed.'));
			//$link = 'index.php?option=com_resource&view=list&category_id='.JRequest::getInt('category_id').
			//"&user_id=".$user->get('id').
			//"&Itemid=".MEUrl::itemid(NULL, JRequest::getInt('category_id'));
			//$link = MEUrl::linkAdditions($link);
			$link = MEUrl::link_list(JRequest::getInt('category_id'));
			$mainframe->redirect(MERoute::_($link, FALSE));
			return ;
		}


		$params->merge($url_params);
		//$params->merge($tmpl_params);

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'.filter_order.category',		'filter_order',		'ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.filter_order_Dir.category',	'filter_order_Dir',	'',	'word' );

		// Get data from the model
		$items	= $cmodel->getItems(JRequest::getInt('user_id', 0), JRequest::getInt('client_id'), true);

		$section = $model->getCategory(ResHelper::getCategorySection($params->get('category_id', JRequest::getInt('category_id'))));

		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;


		//$link = sprintf('index.php?option=com_resource&view=list&category_id=%d&Itemid=%d', $section->id, MEUrl::itemid(NULL, $section->id));
		//$link = MEUrl::linkAdditions($link);
		$link = MEUrl::link_list($section->id);
		$pathway->addItem(stripslashes(JRequest::getVar('client', $user->get($params->get('item_author_mode', 'username')))), $link);

		$pathway->addItem(JRequest::getVar('client', JText::_('My')).' '.$params->get('pcat_mean2') , $uri->toString());

		$model = JModel::getInstance('article', 'ResModel');
		//$type = $model->getTypeName($params->get('type'));
		//$this->assignRef('type',	$type);

		$this->assignRef('section',		$section);
		$this->assignRef('user',		$user);
		$this->assignRef('params',		$params);
		$this->assignRef('items',		$items);
		$this->assignRef('lists',		$lists);
		$this->assignRef('pagination',	$pagination);
		$this->assign('action',	$uri->toString());

		parent::display($tpl);
	}
	function _form($tpl = null)
	{
		global $mainframe, $option;

		$db		=& JFactory::getDBO();
		$uri 	=& JFactory::getURI();
		$user 	=& JFactory::getUser();
		$document	= &JFactory::getDocument();

		$document->addScript(JURI::root().'includes/js/joomla.javascript.js');
		$pathway	= &$mainframe->getPathway();

		$model	= &JModel::getInstance('List','ResModel');
		$cmodel = &JModel::getInstance('Ucategory','ResModel');

		$itemid = JRequest::getInt('Itemid');

		$uparams = &$mainframe->getParams();
		$params	= ResHelper::initListParams(JRequest::getInt('category_id', $uparams->get('mod_cat_id', $uparams->get('category_id'))));
		$params->merge($uparams);

		//echo $params->get('pcat_limit');

		//felix code start
		$section = $model->getCategory(ResHelper::getCategorySection($params->get('category_id', JRequest::getInt('category_id'))));

		$category	=& $cmodel->getData();

		$isNew		= ($category->id < 1);

		if( !$cmodel->checkUserCategoryLimit( $params, $section->id ) && $isNew) {

			JError::raiseWarning( 500, JText::_( 'You can`t add new category, because you have reached the limit for the categories in this section.' ) );
			$link = 'index.php?option=com_resource&view=category&controller=category&category_id='.$section->id.'&Itemid='.MEUrl::itemid(NULL, $section->id);
			$link = MEUrl::linkAdditions($link);
			
			$mainframe->redirect( MERoute::_($link, FALSE) );
			return;
		}

		if($params->get('pcat_submit') > $user->get('aid'))
		{
			if($params->get('pcat_submit') == 1)
			{
				JError::raiseWarning(404, JText::_('Only Registered User can add category'));

				$return		= $uri->toString();

				$url  = 'index.php?option=com_user&view=login&Itemid='.JRequest::getInt('Itemid');
				//$url = MEUrl::linkAdditions($url);
				$url .= '&return='.base64_encode($return);

				$mainframe->redirect( JRoute::_($url, FALSE) );
				return;
			}
			if($params->get('pcat_submit') == 2)
			{
				JError::raiseNotice(403, 'You need administrator rights to add categories');
				$url  = 'index.php?option=com_resource&view=category&controller=category&category_id='.$section->id.'&Itemid='.MEUrl::itemid(NULL, $section->id);
				$url = MEUrl::linkAdditions($url);
			
				$mainframe->redirect( MERoute::_($url, FALSE) );
				return ;
			}
		}


		//felix code end


		if ($cmodel->isCheckedOut( $user->get('id') )) {
			$msg = JText::sprintf( 'DESCBEINGEDITTED', JText::_( $params->get('pcat_mean') ), $category->name );
			JError::raiseWarning(101, $msg);
			return;
		}

		// Edit or Create?
		if (!$isNew)
		{
			$cmodel->checkout( $user->get('id') );
		}
		else
		{
			$category->published = 1;
			$category->order 	= 0;
		}

		$lists = array();
		$query = 'SELECT ordering AS value, name AS text' .
		' FROM #__js_res_category_user' .
		' WHERE user_id = ' . (int) $user->get('id').
		' AND section_id = ' . (int) $section->id .
		' ORDER BY ordering';

		if($isNew)
		$lists['ordering'] = JHTML::_('list.specificordering', $category, '', $query, 1);
		else
		$lists['ordering'] = JHTML::_('list.specificordering', $category, $category->id, $query, 1);

		$lists['publish']  = JHTML::_('select.booleanlist', 'published', 'class="inputbox"', JRequest::getVar('published', $category->published) );
		$lists['access']  = JHTML::_('select.booleanlist', 'access', 'class="inputbox"', JRequest::getVar('access', $category->access), JText::_('Registered') , JText::_('Public'));

		//$link = sprintf('index.php?option=com_resource&view=list&category_id=%d&Itemid=%d', $section->id, MEUrl::itemid(NULL, $section->id));
		//$link = MEUrl::linkAdditions($link);
		$link = MEUrl::link_list($section->id);
		$pathway->addItem(JRequest::getVar('client', $user->get($params->get('item_author_mode', 'username'))), $link);

		$pathway->addItem(JRequest::getVar('client', ($isNew ? JText::_('Add') : JText::_('Edit'))).' '.$params->get('pcat_mean2') , $uri->toString());

		$this->assign('action',		JFilterOutput::ampReplace($uri->toString()));
		$this->assignRef('section',	$section);
		$this->assignRef('category',	$category);
		$this->assignRef('lists',	$lists);
		$this->assignRef('params',	$params);
		$this->assignRef('isNew',	$isNew);
		$this->assignRef('user',	$user);

		parent::display($tpl);
	}
}