<?php defined('_JEXEC') or die('Restricted access'); ?>
<div class="contentpane">
<?php if($this->params->get('filters_search')): ?>
	<input type="text" class="inputbox" value="<?php echo $this->search_default;?>" name="filter_search" />
	<input type="button" value="<?php echo JText::_('Go')?>" class="button" onclick="document.adminForm.submit()" /> 
<?php endif; ?>

<?php if($this->params->get('filter_order')): ?>
	<?php if($this->params->get('order_ctime')):?>
 		<?php $order[] = JHTML::_('grid.sort',  JText::_('Created'), 'r.ctime', @$this->lists['order_Dir'], @$this->lists['order'] ); ?>
	<?php endif;?>

	<?php if($this->params->get('order_title')):?>
		<?php $order[] =  JHTML::_('grid.sort',  JText::_('Title'), 'r.title', @$this->lists['order_Dir'], @$this->lists['order'] ); ?>
	<?php endif;?>
	
	<?php if($this->params->get('order_autor')):?>
 		<?php $order[] =  JHTML::_('grid.sort',  JText::_('Author'), 'u.username', @$this->lists['order_Dir'], @$this->lists['order'] ); ?>
	<?php endif;?>
 	
	<?php if($this->params->get('order_hits')):?>
 		<?php $order[] =  JHTML::_('grid.sort',  JText::_('Hits'), 'r.hits', @$this->lists['order_Dir'], @$this->lists['order'] ); ?>
	<?php endif;?>
	
	<?php if($this->params->get('order_mtime')):?>
 		<?php $order[] =  JHTML::_('grid.sort',  JText::_('Modified'), 'r.mtime', @$this->lists['order_Dir'], @$this->lists['order'] ); ?>
	<?php endif;?>
	
	<?php if($this->params->get('order_rate')):?>
 		<?php $order[] =  JHTML::_('grid.sort',  JText::_('Rated'), 'rate', @$this->lists['order_Dir'], @$this->lists['order'] ); ?>
	<?php endif;?>
 	
	<?php if($this->params->get('order_comment')):?>
 		<?php $order[] =  JHTML::_('grid.sort',  JText::_('Commented'), 'comment', @$this->lists['order_Dir'], @$this->lists['order'] ); ?>
	<?php endif;?>
 	
	<?php if($this->params->get('order_favorite')):?>
 		<?php $order[] =  JHTML::_('grid.sort',  JText::_('Favorited'), 'favorite', @$this->lists['order_Dir'], @$this->lists['order'] ); ?>
	<?php endif;?>
	
	<?php if($this->params->get('order_fields')):?>
	<?php foreach ($this->columns AS $col):?>
		<?php if($col['params']->get('sortable')): ?>
			<?php $order[] =  $this->params->get('client') == 'module' ? JText::_('Modified') : JHTML::_('grid.sort',  $col['title'], 'vo'.$col['id'].'.field_value', @$this->lists['order_Dir'], @$this->lists['order'] ); ?>
		<?php endif; ?>
	<?php endforeach; ?>
	<?php endif; ?>
	
	<?php $elements = addslashes(htmlspecialchars('<div class="small">'.JText::_('Choose property to reorder records').'</div><ul class="menu"><li>'.implode(" </li><li> ", $order).'</li></ul>', ENT_QUOTES, 'UTF-8')); ?>
		
	&nbsp;&nbsp; <img src="<?php echo JURI::root() ?>/components/com_resource/images/order.png" align="absmiddle" border="0" vspace="5">
	<a href="javascript:void(0);" class="myTip" title="<?php echo JText::_('Ordering Menu') ?>::<?php echo $elements ?>"><?php echo JText::_('Ordering'); ?></a>
<?php endif; ?>

<?php if($this->views && $this->params->get('template_switcher')): ?>
	<?php foreach($this->views As $view): ?>
		<?php $views[] = '<a href="javascript:void(0);" onclick="document.adminForm.filter_tpl.value = \''.$view->name.'\'; document.adminForm.submit();">'.$view->title.'</a>'; ?>
	<?php endforeach; ?>	
	<?php $elements = addslashes(htmlspecialchars('<div class="small">'.JText::_('Choose different view to display list of records').'</div><ul class="menu"><li>'.implode(" </li><li> ", $views).'</li></ul>', ENT_QUOTES, 'UTF-8')); ?>
		
	&nbsp;&nbsp; <img src="<?php echo JURI::root() ?>/components/com_resource/images/views.png" align="absmiddle" border="0" vspace="5">
	<a href="javascript:void(0);" class="myTip" title="<?php echo JText::_('View Menu') ?>::<?php echo $elements ?>"><?php echo JText::_('Switch View'); ?></a>
<?php endif; ?>

<?php $text = JText::_('To put records to compare click same icon by record title'); ?>
<?php if(count(@$this->menu['compare']) > 1): ?>
	<?php $elements = addslashes(htmlspecialchars("<div class=\"small\">{$text}</div>".implode(" <br /> ", $this->menu['compare']), ENT_QUOTES, 'UTF-8')); ?>
	&nbsp;&nbsp; <img src="<?php echo JURI::root() ?>components/com_resource/images/user_menu/compare.png" align="absmiddle" /> 
	<a href="javascript:void(0);" class="myTip" title="<?php echo JText::_('Comparision Menu') ?>::<?php echo $elements ?>">Compare</a>
<?php elseif(count(@$this->menu['compare']) == 1): ?>
	<span class="myTip" title="::<?php echo $text; ?>"><?php echo $this->menu['compare'][0]; ?></span>
<?php endif; ?>

<?php if($this->params->get('filters_category')): ?>
	<span style="float: right;">
	<?php
	echo $filter_category = JHTML::_('select.genericlist', $this->filter_category, 'id_category', 
		"class=\"inputbox\" onchange=\"window.location = this.value;\"", 'value', 'text', MERoute::_(MEUrl::link_list(JRequest::getInt('category_id')))).'&nbsp;';
	$this->filter_category;
	?>
	</span>
<?php endif; ?>

<?php if($this->params->get('filters_fields') && (count($this->ifilters) || $this->ifilters_ext)): ?>
	<?php $pane = &JPane::getInstance(); ?>
	<div style="clear: both;"></div>
	<div>
		<?php if($this->params->get('filters_fields')): ?>
			<td align="right">
			<?php 
			if(count($this->ifilters))
			{
				foreach($this->ifilters AS $title => $filter)
				{
					//print_r($filter['filter']->default);
					
					if(is_array($filter['values']))
					{
						$list = array();
						$list[] = JHTML::_('select.option', '', '- '.$filter['filter']->title.' -');
						$list = array_merge($list, $filter['values']);
					}
					 echo JHTML::_('select.genericlist', $list, 'filter'.$filter['filter']->id.'[]',
					"class=\"inputbox\"  onchange=\"document.adminForm.submit();\"", 'value', 'text', @$filter['filter']->default[0])."&nbsp;";
				}
			}
			if($this->ifilters_ext)
			{
				echo '<br /><p>';
				foreach ($this->ifilters_ext AS $filter_ext){
					echo $filter_ext->title; 
					echo $filter_ext->result;
					echo '<br /><p>';
				}
			}
			?>
			</td>
		<?php endif; ?>
	</div>	
<?php endif; ?>


<!--  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	Show alphaindex if it is turned on for section. Please always use 
	this condition if you want create 100% compatible filter template.
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  -->
<?php if($this->params->get('alpha_index')): ?>
	<p><center style="color:#505050">
	<?php 
	$print[] = "<a class=\"alpha\" href=\"javascript:void(0);\" onclick=\"document.adminForm.filter_alpha.value='".JText::_('All')."';submitform();\">".JText::_('All')."</a>";
	foreach ($this->lists['alpha'] AS $a) :
		$print[] = $this->renderAlpha($a, $this->params, true);	
	endforeach;
	Echo implode(' <span style="color: #d0d0d0"> | </span> ', $print);
	?>
	</center></p>
<?php endif; ?>

</div>

<!--  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	Show Filter warrning boxes if it is turned on for section
	and there are filters applied. Please always use this condition 
	if you want create 100% compatible filter template.
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  -->
<?php if($this->params->get('filters_worn') && (count($this->fworn) > 0)): ?>
	<br />
	<?php if($this->filter_rss): ?>
		<img src="<?php echo JURI::root() ?>/components/com_resource/images/rss.png" align="absmiddle" border="0" vspace="5"> <a title="<?php echo JText::_('RSS Current Search'); ?>" href="<?php echo $this->filter_rss ?>" target="_blank"><?php echo JText::_('RSS Current Search') ?></a>
	<?php endif; ?>

	<?php
		if(count($this->fworn) > 1)
		{
			$url = JURI::getInstance($this->action);
			$url->setVar('filter_reset', 1);
			echo '<img src="'.JURI::root().'components/com_resource/images/cancel.png" align="absmiddle" border="0" vspace="5">'.JHTML::link($url->toString(), JText::_('Reset All Filters'));
		}
	?>
	<div style="clear: both;"></div>
	<?php foreach ($this->fworn as $filter_name => $worn): ?>
		<div class="filter_button"><div>
		<img hspace="0" title="<?php echo JText::_('Close Filter'); ?>" src="<?php echo JURI::root() ?>components/com_resource/images/f-c2.png" onclick="document.adminForm.<?php echo $filter_name ?>.value=1; document.adminForm.submit();" />
		<span class="small"><?php echo $worn['name']; ?></span><br />
		<b><?php if(is_array($worn['value'])) echo implode(", ", $worn['value']); else echo $worn['value']; ?></b>
		<b><?php //if(count($worn['value']) > 0) echo implode(", ", $worn['value']); ?></b>
		</div></div>
	<?php endforeach; ?>
	<div style="clear: both;"></div>
<?php endif; ?>

