<?php
/**
 * $Id: relation.php 7313 2011-08-22 06:36:21Z dima $
 * $LastChangedDate: 2011-08-22 12:36:21 +0600 (Mon, 22 Aug 2011) $
 * $LastChangedBy: dima $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined ('_JEXEC') or die('Access Restricted');

$doc = & JFactory::getDocument();
$doc->addScript(JURI::root().'plugins/joomsuite_content_fields/article_selector.js');
?>
<style>
<!--

#selected_label {
	margin-right: 10px;
	font-weight: bold;
}

#pagination_outer {
	text-align: center;
}
-->
</style>
<script>
	var articleSelector = null;
	var keyPressed = false;
	var options = {};

	options['category'] = '<?php echo $this->filter_cat; ?>';
	
	function onSearchComplete() {
		markSelected();
		setUpEvents(articleSelector);

		$('ajax_loader_img').setStyle('display', 'none');
	}

	function markSelected() {
		$$('#maintable_outer input').each(function( i ) {
			if (articleSelector.itemExists(i.value))
				i.setAttribute('checked', 'checked');
		});
	}

	function setUpEvents(articleSelector) {
		$$('#maintable_outer input[type!=text]').each(function( i ) {
			i.addEvent('change', function() {
				if (i.checked){
					articleSelector.addArticle(i.value, i.getAttribute('title'));
					//$('params_' + i.value).type = 'text';
				}
				else{
					articleSelector.removeArticle(i.value);
					//$('params_' + i.value).type = 'hidden';
				}
			});
		});

		$$('#pagination_outer a').each(function( i ) {
			var h = i.getAttribute('href');
			var limitstart = parseInt(h.substr(h.indexOf('limitstart=') + 'limitstart='.length));


			i.setAttribute('href', 'javascript:void(0);');
			i.addEvent('click', function() {
				options['limitstart'] = limitstart;
				keyPressed = true;
			});
		});
		
		$$('#pagination_outer select').each(function( i ) {
			i.removeAttribute('onchange', '');
			
			i.addEvent('change', function() {
				options['limit'] = i.value;
				keyPressed = true;
			});
		});
	}

	window.addEvent('domready', function() {
		articleSelector = new MEArticleSelector();
		articleSelector.STRINGS.REMOVE = '<?php echo addslashes(JHTML::image(JURI::root().'components/com_resource/images/f-c2.png', JText::_('Remove', true))); ?>';
		articleSelector.CLASSES.SPAN = 'article_selector_span';
		<?php if ($this->multiple): ?>
		articleSelector.maxItems = 99999;
		<?php else: ?>
		articleSelector.maxItems = 1;
		<?php endif; ?>
		var domHelper = new MEArticleSelectorDomHelper($('choice_container'));
		domHelper.onArticleRemove = function(id) {
			$$('#maintable_outer input').each(function( i ) {
				if (i.value == id) {
					i.removeProperty('checked');
				}

				if (domHelper.count == 0 && $('selected_label')){
					$('selected_label').remove();
				}
			});
		}

		domHelper.onArticleAdd = function() {
			if ( ! $('selected_label'))
				new Element('div', {id: 'selected_label', styles: {'float': 'left'}}).setHTML('<?php echo JText::_('Selected items:', true); ?>').injectTop(domHelper.container);
		}
		
		articleSelector.bind(domHelper);

		// set up the events.
		setUpEvents(articleSelector);

		// Choose button click
		$('choose_button').addEvent('click', function() {
			var ids = articleSelector.getArticleIds();
			
			// Call function from parent window.
			if (parent && parent.onRelatedArticlesSelected)
			{
				parent.onRelatedArticlesSelected(<?php echo $this->article->id; ?>, <?php echo $this->field->id; ?>, ids, articleSelector.domHelper.getArticleTitles(), articleSelector.domHelper.getArticleParams());
			}

			parent.SqueezeBox.close();
		});

		
		$('filter_categories').addEvent('change', function() {
			if (parseInt(this.value) > 0)
				options['category'] = this.value;
			else
				options['category'] = 0;
			
			keyPressed = true;
		});


		/// Search box decoration
		$('search_box').addEvent('focus', function() {
			if (this.value == '<?php echo JText::_('search...', true); ?>')
				this.value = '';
		});
		
		$('search_box').addEvent('blur', function() {
			if (this.value == '')
				this.value = '<?php echo JText::_('search...', true); ?>';
		});


		/// -------------------
		/// Xajax updater timer		

		var lastCallTime = 0;

		$('search_box').addEvent('keyup', function() {
			keyPressed = true;
		});

		$$('#maintable_outer input').each(function( i ) {
			if (i.checked)
				articleSelector.addArticle(i.value, i.getAttribute('title'));
		});

		function keyListener() {
			if (!keyPressed)
				return;
			
			if (new Date().getTime() < lastCallTime + 1000)
				return;
			
			var search = $('search_box').value;
			if (search == '<?php echo JText::_('search...', true); ?>')
				search = ''; 

			// Load HTML
			xajax_jsrGetRelatedRecords(
				search, 
				'<?php echo $this->field->id; ?>', 
				'<?php echo $this->article->id; ?>', 
				'<?php echo $this->filter_cat; ?>',
				options, 
				'onSearchComplete'
			);

			$('ajax_loader_img').setStyle('display', 'block');
			
			lastCallTime = new Date().getTime();
			keyPressed = false;

			options['limitstart'] = 0;
		}

		var timer = setInterval(keyListener, 200);
	});
</script>
<form id="adminForm" name="adminform" method="post" action="<?php echo $this->uri->toString(); ?>">
	<table>
		<tr>
			<td><input id="search_box" type="text" class="inputbox" name="search" value="<?php echo $this->escape(JText::_('search...'), ENT_QUOTES); ?>" /></td>
			<td><?php echo $this->lists['category']; ?></td>
			<td><input type="button" id="choose_button" class="button" value="<?php echo $this->escape(JText::_('Done choosing'), ENT_QUOTES); ?>" /></td>
			<td><?php echo JHTML::image(JURI::root().'components/com_resource/images/load.gif', JText::_('Loading...'), array('id' => 'ajax_loader_img', 'style' => 'display:none;')); ?></td>
		</tr>
	</table>
	<div id="choice_container"></div>
	<div style="clear:both;height:5px"></div>
	<?php $k = 0; $i = 0; ?>
	<div id="maintable_outer">
		<?php if ( ! count($this->records)) : ?>
			<?php echo JText::_('No items'); ?>
		<?php endif; ?>
		<table class="joomlatable">
			<tbody id="maintable">
				<?php foreach ($this->records as $rec) : ?>
				<tr class="row<?php echo $k; $k = 1 - $k; $i++; ?>">
					<td>
						<?php if ($this->multiple) : ?>
						<input type="checkbox" name="toAdd[]" class="inputbox" id="ctrl_<?php echo $i; ?>" <?php echo (in_array($rec->id, $this->selected) ? 'checked="checked"' : '');?> value="<?php echo $rec->id; ?>" title="<?php echo $this->escape($rec->title, ENT_QUOTES); ?>" />
						<?php else: ?>
						<input type="radio" name="toAdd[]" class="inputbox" id="ctrl_<?php echo $i; ?>" <?php echo (in_array($rec->id, $this->selected) ? 'checked="checked"' : '');?>  value="<?php echo $rec->id; ?>" title="<?php echo $this->escape($rec->title, ENT_QUOTES); ?>" />
						<?php endif; ?>
					</td>
					<td>
						<label for="ctrl_<?php echo $i; ?>">
							<?php echo $this->escape($rec->title, ENT_QUOTES); ?>
						</label>
						<?php if($this->relate_tags):?>
							<?php if(isset($this->fparams[$rec->id]))
							{
								$fparam_val = $this->fparams[$rec->id];
							}
							else
							{
								$fparam_val = '';
							}
							?>
							<input type="hidden" class="inputbox params_<?php echo $rec->id; ?>" value="<?php echo $fparam_val ?>" />
						<?php endif; ?>
					</td>
				</tr>
				<?php endforeach; ?>
			</tbody>
		</table>
	</div>
	<div id="pagination_outer">
		<?php echo $this->pagination->getListFooter();?>
	</div>
	<?php foreach ($this->hiddenVars as $name => $v) : ?>
		<input type="hidden" name="<?php echo $name; ?>" value="<?php echo $this->escape($v, ENT_QUOTES); ?>" />
	<?php endforeach; ?>
</form>