<?php
/**
 * $Id: controller.php 8086 2012-04-24 05:12:25Z kostya $
 * $LastChangedDate: 2012-04-24 11:12:25 +0600 (Tue, 24 Apr 2012) $
 * $LastChangedBy: kostya $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access');

jimport( 'joomla.application.component.controller');

class ResController1 extends JController
{
	function __construct()
	{
		parent::__construct();

		$this->registerTask( 'add',  'edit');
		$this->registerTask( 'apply', 'save');
	}
	function user_list()
	{
		$model	= &$this->getModel('user_list');
		$view	= &$this->getView('user_list');
		$view->setModel( $model, true );
		$view->display();
	}
	function change_field()
	{
		JRequest::setVar( 'layout', 'change_field'  );
		JRequest::setVar( 'view', 'record'  );
		parent::display();

	}
	function change_category()
	{
		JRequest::setVar( 'layout', 'change_category'  );
		JRequest::setVar( 'view', 'record'  );
		parent::display();

	}
	function change_core()
	{
		JRequest::setVar( 'layout', 'change_core'  );
		JRequest::setVar( 'view', 'record'  );
		parent::display();

	}
	function element()
	{
		$model	= &$this->getModel( 'element');
		$view	= &$this->getView( 'element');
		$view->setModel( $model, true );
		$view->display();
	}
	function display( )
	{
		//global $mainframe;
		//JRequest::setVar( 'hidemainmenu', 1 );
		//JRequest::setVar( 'layout', 'form'  );
		if(!JRequest::getVar('view')) JRequest::setVar( 'view'  , 'record');
		//JRequest::setVar( 'edit', false );
		//if()
		parent::display();
	}

	function edit()
	{
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar( 'view', 'record'  );
		parent::display();
	}
	function start()
	{
		JRequest::setVar( 'layout', 'start'  );
		JRequest::setVar( 'view', 'record'  );
		parent::display();
	}
	function archive()
	{
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array');
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_('Select an item to publish' ) );
		}

		$model = $this->getModel('record');
		if(!$model->publish($cid, -1)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_resource', Jtext::_('Archived Successfuly') );
	}
	function unarchive()
	{
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array');
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_('Select an item to publish' ) );
		}

		$model = $this->getModel('record');
		if(!$model->publish($cid, 1)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_resource', Jtext::_('Unarchived Successfuly') );
	}
	function publish()
	{
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array');
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_('Select an item to publish' ) );
		}

		$model = $this->getModel('record');
		if(!$model->publish($cid, 1)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_resource');
	}


	function unpublish()
	{
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array');
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_('Select an item to unpublish' ) );
		}

		$model = $this->getModel('record');
		if(!$model->publish($cid, 0)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_resource');
	}
	function copyart()
	{
		$db = & JFactory::getDBO();
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array');
		JArrayHelper::toInteger($cid);
		$ids = implode(", ", $cid);

		$sql = "SELECT * FROM #__js_res_record WHERE id IN({$ids})";
		$db->setQuery($sql);
		$result = $db->loadObjectList();
		$now = ResHelper::getDate();

		foreach ($result AS $article)
		{
			$sql = "INSERT INTO #__js_res_record (`title`, `published`, `access`, `params`, `user_id`, `ctime`, `extime`, `type_id`,
			`meta_descr`, `meta_key`, `featured`, `archive`, `categories`, `fieldsdata` )
			SELECT CONCAT(`title`, ' - Copy'), 1, `access`, `params`, `user_id`, '{$now}', `extime`, `type_id`, `meta_descr`, `meta_key`, `featured`, `archive` , `categories`, `fieldsdata` FROM #__js_res_record WHERE id = {$article->id}";
			$db->setQuery($sql);
			$db->query();
			$id = $db->insertid();

			$sql = "INSERT INTO #__js_res_record_category (catid, record_id) SELECT catid, {$id} FROM  #__js_res_record_category WHERE record_id = {$article->id}";
			$db->setQuery($sql);
			$db->query();
			
			$sql = "SELECT rv.field_id, rv.field_value, f.type FROM  #__js_res_record_values AS rv
					INNER JOIN #__js_res_fields AS f ON rv.field_id = f.id  WHERE rv.record_id = {$article->id}";
			$db->setQuery($sql);
			$fields = $db->loadObjectList();
			$out = array();
			foreach ($fields as $field)
			{
				$out[] = "({$field->field_id},'".$db->getEscaped($field->field_value)."',{$id})";
				if($field->type == 'gallery2')
				{
					$fvalue = unserialize($field->field_value);
					foreach ($fvalue['files']['name'] as $f) {
						$ext = JString::strtolower(JFile::getExt( $f ));
						if ($ext == 'jpeg')
							$ext = 'jpg';
						
						$f = JFile::makeSafe(JFile::stripExt( $f ).'.'.$ext);
						
						$originalImage = JPath::clean(RES_GENERAL_UPLOAD.'/'.$article->user_id.'/'.$ext.'/'. $article->id.'_'.$f);
						if (JFile::exists($originalImage))
						{
							$copy_originalImage = JPath::clean(RES_GENERAL_UPLOAD.'/'.$article->user_id.'/'.$ext.'/'. $id.'_'.$f);
							JFile::copy($originalImage, $copy_originalImage);
						}
					}
				}
			}

			$sql = "INSERT INTO #__js_res_record_values (field_id, field_value, record_id) VALUES ".implode(',', $out);//SELECT field_id, field_value, {$id} FROM  #__js_res_record_values WHERE record_id = {$article->id}";
			$db->setQuery($sql);
			$db->query();

		}

		$link = 'index.php?option=com_resource';
		$this->setRedirect($link, JText::_('Article(s) Copied'));
	}
	function cancel()
	{
		// Checkin the weblink
		$model = $this->getModel('record');
		$model->checkin();

		$this->setRedirect( 'index.php?option=com_resource');
	}
	function save_category()
	{
		global $mainframe, $option;
		$db = & JFactory::getDBO();
		$mode = JRequest::getInt('m_method');
		$categoryies = JRequest::getVar( 'categories', array(0), 'post', 'array');
		$ids = JRequest::getVar('cids');

		if($mode == 1)
		{
			$sql = "DELETE FROM #__js_res_record_category WHERE record_id IN({$ids})";
			$db->setQuery($sql);
			$db->query();
		}

		$ids = explode(",",$ids);
		JArrayHelper::toInteger($categoryies);
		
		$sql = "SELECT id, name FROM #__js_res_category WHERE id IN (".implode(',', $categoryies).") ";
		$db->setQuery( $sql );
		$record_categories = $db->loadObjectList();
		foreach ($record_categories AS $category)
		{
			$store_categories[$category->id] = $category->name;
		}
		$store_categories = serialize($store_categories);

		foreach ($categoryies AS $category)
		{
			foreach ($ids AS $id)
			{
				$sql = "SELECT id FROM #__js_res_record_category WHERE catid = {$category} AND record_id = {$id}";
				$db->setQuery($sql);
				$res = $db->loadResult();

				if(!$res)
				{
					$sql = "INSERT INTO #__js_res_record_category VALUES(NULL, '{$category}', '{$id}', 0, NOW())";
					$db->setQuery($sql);
					$db->query();
				}
				
				$sql = "UPDATE #__js_res_record SET categories = '{$store_categories}' WHERE id = {$id}";
				$db->setQuery($sql);
				$db->query();
			}
		}
		
		

		$link = 'index.php?option=com_resource';
		$this->setRedirect($link, JText::_('Changed Successfuly'));
	}
	function save_core()
	{
		global $mainframe, $option;
		$db = & JFactory::getDBO();

		$ids = JRequest::getVar('cids');

		$extime = JRequest::getVar('extime');
		$ctime = JRequest::getVar('ctime');
		$author = JRequest::getVar('user_id');
		$tags = JRequest::getVar('tags');
		$access = JRequest::getVar('access');
		
		$dispatcher = & JDispatcher::getInstance();

		if($extime)
		{
			$sql = "UPDATE #__js_res_record SET extime = '{$extime}' WHERE id IN({$ids})";
			$db->setQuery($sql);
			$db->query();
		}
		if($ctime)
		{
			$sql = "UPDATE #__js_res_record SET ctime = '{$ctime}' WHERE id IN({$ids})";
			$db->setQuery($sql);
			$db->query();
		}
		if($author)
		{
			JPluginHelper::importPlugin('joomsuite_content_fields');
			
			$q = 'SELECT * FROM #__js_res_record WHERE id IN ('.$ids.')';
			$db->setQuery( $q );
			$records = $db->loadObjectList();
			
			$newAuthor = $author;
			$dispatcher->trigger('onArticleAuthorChange', array(& $records, $newAuthor));
			
			$sql = "UPDATE #__js_res_record SET user_id = '{$author}' WHERE id IN({$ids})";
			$db->setQuery($sql);
			$db->query();
		}
		if(!($access === 0))
		{
			$sql = "UPDATE #__js_res_record SET access = '{$access}' WHERE id IN({$ids})";
			$db->setQuery($sql);
			$db->query();
		}
		if($tags)
		{
			$mode = JRequest::getInt('tag_mode');
			$tags = explode(",", $tags);

			if($mode == 2)
			{
				$sql = "DELETE FROM #__js_res_tags_history WHERE record_id IN({$ids})";
				$db->setQuery($sql);
				$db->query($sql);
			}
			foreach ($tags AS $tag)
			{
				$tag = JFilterOutput::cleanText($tag);
				$tag = trim($tag);

				if($tag == '') continue;

				$sql = "SELECT id FROM #__js_res_tags WHERE LOWER(`tag`) = '".JString::strtolower($tag)."'";
				$db->setQuery($sql);
				$tid = $db->loadResult();

				if(!$tid) {
					$sql = "INSERT INTO #__js_res_tags VALUES(NULL, '$tag', NOW())";
					$db->setQuery($sql);
					$db->query($sql);
					$tid = $db->insertid();
				}
				$aid = explode(",", $ids);
				$model = & JModel::getInstance('Record', 'ResModel');
				foreach ($aid as $id) {
					$model->_id = $id;
					$article = $model->getRecord();
					$section_id = ResHelper::getArticleSection($id);

					$sql = "SELECT id FROM #__js_res_tags_history WHERE record_id = {$id} AND tag_id = {$tid} AND section_id = {$section_id} AND user_id = {$article->user_id}";
					$db->setQuery($sql);
					$is_tag = $db->loadResult();

					if(!$is_tag)
					{
						$sql = "INSERT INTO #__js_res_tags_history VALUES (NULL, $id, {$tid}, {$article->user_id}, NOW(), {$section_id})";
						$db->setQuery($sql);
						$db->query($sql);
					}
				}
			}
		}

		//echo $sql; exit;
		$link = 'index.php?option=com_resource';
		$this->setRedirect($link, JText::_('Changed Successfuly'));
	}
	function save_field()
	{
		global $mainframe, $option;
		$db = & JFactory::getDBO();
		$to_save = array();
		$error = null;

		$ids = JRequest::getVar('cids');
		$extime = JRequest::getVar('extime');
		$model = $this->getModel('record');
		$data	= JRequest::get('post');

			
		$sql = "SELECT * FROM #__js_res_record WHERE id IN($ids)";
		$db->setQuery($sql);
		$records = $db->loadObjectList();

		$sql = "SELECT DISTINCT r.type_id, t.name FROM #__js_res_record AS r LEFT JOIN #__js_res_types AS t ON t.id = r.type_id WHERE r.id IN($ids)";
		$db->setQuery($sql);
		$types = $db->loadRowList();
		foreach ($types AS $type)
		{
			$fields = $model->getTypeFields($type[0]);
			foreach ($fields AS $field)
			{
				$id = $field->id;
				$value = @$data['fields'][$id];
                $no_value = false;
				if( is_array($value) ){
				    foreach ($value as $val) {
				    	if( empty($val) ){
				    	    $no_value = true;
				    	}else{
				    	    $no_value = false;
				    	    break;
				    	}
				    }
				    if( $no_value )
				        continue;
				}elseif(!$value){
				    continue;
				}
				$to_save[$type[0]][$id]['value'] = $value;
				$to_save[$type[0]][$id]['type'] = ResHelper::getFieldType($id);
				$to_save[$type[0]][$id]['params'] = ResHelper::getFieldParams($id);
			}
		}
		foreach($records AS $record)
		{
			$dispatcher    =& JDispatcher::getInstance();

			foreach ($to_save[$record->type_id] AS $field_id => $info)
			{
				$value = $info['value'];

				JPluginHelper::importPlugin('joomsuite_content_fields');
				$dispatcher->trigger( 'onBeforeSave', array (&$value, &$info['params'], $info['type'], $field_id, $record, &$error) );

				if( $error ) {
					JError::raiseNotice(402, $error);
					continue;
				}
				if(!trim($value))
				{
					continue;
				}

				$sql = "SELECT id FROM #__js_res_record_values WHERE record_id = {$record->id} AND field_id = {$field_id}";
				$db->setQuery($sql);
				$num_v = $db->LoadResult();

				if($num_v)
				{
					$sql = "UPDATE #__js_res_record_values SET `field_value` = '$value' WHERE record_id = {$record->id} AND field_id = {$field_id}";
					$db->setQuery($sql);
					$db->query();
				}
				else
				{
					$record_value =& JTable::getInstance('record_values','Res');
					$record_value->bind(array( null, 'field_value' => $value, 'record_id' => $record->id, 'field_id' => $field_id));
					$record_value->store();
				}
			}
		}
		//echo $sql; exit;
		$link = 'index.php?option=com_resource';
		$this->setRedirect($link, JText::_('Changed Successfuly'));
	}
	function save()
	{
		$post	= JRequest::get('post');
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array');
		$post['id'] = (int) $cid[0];
		if(!$post['user_id']) $post['user_id'] = 62;

		$model = $this->getModel('record');

		if ($model->store($post)) {
			$msg = JText::_('Record Saved');
		} else {
			JRequest::getVar('task', 'apply');
			$msg = JText::_('Error Saving Record'. $model->getError() );
		}

		// Check the table in so it can be edited.... we are done with it anyway
		$model->checkin();
		$link = 'index.php?option=com_resource';
		if(JRequest::getVar('task') == 'apply')
		$link = "index.php?option=com_resource&view=record&task=edit&cid[]=".($post['id'] ? $post['id'] :$model->id)."&type_id=".$post['type_id'];
		$this->setRedirect($link, $msg);
	}
	function saveorder()
	{
		global $mainframe, $option;

		$catid = $mainframe->getUserStateFromRequest( $option.'rec_ord.filter_catid', 'filter_catid', 0, 'int');
		$clients = $mainframe->getUserStateFromRequest( $option.'rec_ord.filter_clients','filter_clients', 'resource','var');
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array');
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array');
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);

		$model = $this->getModel('record');
		$model->saveorder($catid, $cid, $order, $clients);

		JError::raiseNotice(200, 'Order chanded');
		$link = 'index.php?option=com_resource';
		$this->setRedirect($link);
		//if(!JRequest::getVar('view')) JRequest::setVar( 'view'  , 'record');
		//parent::display();
	}
	function orderup()
	{
		global $mainframe, $option;

		$catid = $mainframe->getUserStateFromRequest( $option.'rec_ord.filter_catid', 'filter_catid', 0, 'int');
		$clients = $mainframe->getUserStateFromRequest( $option.'rec_ord.filter_clients','filter_clients', 'resource','var');

		$model = $this->getModel('record');
		$model->move(-1, $catid, $clients);

		JError::raiseNotice(200, 'Moved Down');
		//$link = 'index.php?option=com_resource';
		//$this->setRedirect($link);
		if(!JRequest::getVar('view')) JRequest::setVar( 'view'  , 'record');
		parent::display();
	}

	function orderdown()
	{
		global $mainframe, $option;

		$catid = $mainframe->getUserStateFromRequest( $option.'rec_ord.filter_catid', 'filter_catid', 0, 'int');
		$clients = $mainframe->getUserStateFromRequest( $option.'rec_ord.filter_clients','filter_clients', 'resource','var');

		$model = $this->getModel('record');
		$model->move(+1, $catid, $clients);

		JError::raiseNotice(200, 'Moved Up');
		//$link = 'index.php?option=com_resource';
		//$this->setRedirect($link);
		if(!JRequest::getVar('view')) JRequest::setVar( 'view'  , 'record');
		parent::display();
	}
	function support()
	{
		$doc = &JFactory::getDocument();
		$js = 'window.open("http://support.mightyextensions.com/en/mighty-resources-cck-joomla-component.html")';
		$doc->addScriptDeclaration($js);
		JRequest::setVar( 'view'  , 'record');
		parent::display();
	}
}
?>
