<?php
/**
 * $Id: category.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access');

class ResControllerCategory extends ResController1 {


	function __construct()
	{
		parent::__construct();

		//$this->registerTask( 'add',  'edit');
		$this->registerTask( 'apply', 'save');
		$this->registerTask( 'copysect', 'movesect');
		JRequest::setVar( 'view', 'category');

	}
	function movesect()
	{
		JRequest::setVar( 'view', 'category');
		JRequest::setVar( 'layout', 'select');
		parent::display();
	}
	function edit()
	{
		JRequest::setVar( 'view', 'category');
		JRequest::setVar( 'layout', 'form');
			
		parent::display();
	}
	function add()
	{
		JRequest::setVar( 'view', 'category');
		JRequest::setVar( 'layout', 'form');
			
		parent::display();
	}

	function display( )
	{
		JRequest::setVar( 'view', 'category');
		parent::display();

	}

	function cancel()
	{
		// Checkin the weblink
		$model = $this->getModel('category');
		$model->checkin();

		$this->setRedirect( 'index.php?option=com_resource&controller=category&section_id='.JRequest::getInt('section_id') );
	}
	function save()
	{
		$post	= JRequest::get('post');
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array');
		$post['id'] = (int) $cid[0];


		$model = $this->getModel('category');
		$text = JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWRAW );
		//jimport('joomla.filter.filteroutput');
		$text		= str_replace( '<br>', '<br />', $text );
		$post['description'] = $text;

		if ($model->store($post)) {
			$msg = JText::_('Category Saved');
		} else {
			JRequest::getVar('task', 'apply');
			$msg = JText::_('Error Saving Category'. $model->getError() );
		}

		// Check the table in so it can be edited.... we are done with it anyway
		$model->checkin();
		$link = 'index.php?option=com_resource&controller=category&section_id='.JRequest::getInt('section_id');
		if(JRequest::getVar('task') == 'apply')
		$link = "index.php?option=com_resource&controller=category&view=category&task=edit&cid[]=".($post['id'] ? $post['id'] :$model->id)."&type_id=".$post['type_id'].'&section_id='.JRequest::getInt('section_id');
		$this->setRedirect($link, $msg);
	}

	function remove($parent = 0)
	{
		$db   =& JFactory::getDBO();
		$cid 	= JRequest::getVar('cid', array(0));
		$cids = implode(",", $cid);

		$parent ? $where = " parent IN ( $parent )  " : $where = " id IN ( $cids ) ";
		$parent ? $where2 = " catid IN ( $parent )  " : $where2 = " catid IN ( $cids ) ";

		$sql  = "SELECT * FROM #__js_res_category WHERE $where";
		$db->setQuery($sql);
		$rows = $db->loadObjectList();
		//echo $db->stderr();
		//echo $db->_sql;
		//return;
		if(count($rows) == 0) return;
		foreach($rows AS $row)
		{
			$this->remove($row->id);
		}
		//return;
		$sql  = "DELETE FROM #__js_res_category WHERE $where";
		$db->setQuery($sql);
		$db->query();

		$sql  = "DELETE FROM #__js_res_record_category WHERE $where2";
		$db->setQuery($sql);
		$db->query();
		//echo $db->stderr();
		$link = 'index.php?option=com_resource&controller=category&section_id='.JRequest::getInt('section_id');
		$this->setRedirect($link, JText::_('Category removed'));
	}
	function orderup()
	{
		$model = $this->getModel('category');
		$model->move(-1);

		$this->setRedirect('index.php?option=com_resource&controller=category&section_id='.JRequest::getInt('section_id'));
	}

	function orderdown()
	{
		$model = $this->getModel('category');
		$model->move(1);

		$this->setRedirect('index.php?option=com_resource&controller=category&section_id='.JRequest::getInt('section_id'));
	}

	function saveorder()
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array');
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array');
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);

		$model = $this->getModel('category');
		$model->saveorder($cid, $order);

		$msg = 'New ordering saved';
		$this->setRedirect( 'index.php?option=com_resource&controller=category&section_id='.JRequest::getInt('section_id'), $msg );
	}

	function domove()
	{
		global $mainframe;
			
		$db 	=& JFactory::getDBO();
		$model 	= $this->getModel('category');
		$ids	= JRequest::getVar( 'cid', array(0), 'post', 'array');
		$section = JRequest::getInt('category');
		$what 	= JRequest::getVar('what');
		$copy_records 	= JRequest::getVar('copy_records');
			
		$sql = "SELECT * FROM #__js_res_category WHERE id IN (".implode(", ", $ids).")";
		$db->setQuery($sql);
		$cats = $db->loadAssocList();
		
		foreach($cats AS $cat)
		{
			$this->_move($cat, $section, $model, $what, $copy_records);
		}
		
		$msg = JText::_('Done');
		$this->setRedirect( 'index.php?option=com_resource&controller=category&section_id='.JRequest::getInt('section_id'), $msg );
			
	}
	function _move($cat, $section, $model, $what, $copy_records)
	{
		$db 	=& JFactory::getDBO();
		
		$id = $cat['id'];
		
		$cat['id'] = null;
		$cat['section_id'] = ResHelper::getCategorySection($section);
		$cat['parent'] = $section;

		if ($model->store($cat))
		{
			$iid = $model->id;
			
			
			$sql = "SELECT * FROM #__js_res_category WHERE parent = {$id}";
			$db->setQuery($sql);
			$cats = $db->loadAssocList();
			
			foreach($cats AS $c)
			{
				$this->_move($c, $iid, $model, $what, $copy_records);
			}
			
			if($copy_records)
			{
				$sql = "SELECT * FROM #__js_res_record_category WHERE catid = ".$id;
				$db->setQuery($sql);
				$result = $db->loadObjectList();
				if(is_array($result))
				{
					foreach ($result AS $res)
					{
						$sql = "INSERT INTO #__js_res_record_category VALUES (NULL, {$iid}, {$res->record_id}, {$res->ordering}, NOW())";
						$db->setQuery($sql);
						$db->query();
					}
				}
			}
			if($what == 'movesect')
			{
				$sql = "DELETE FROM #__js_res_category WHERE id = {$id}";
				$db->setQuery($sql);
				$db->query();

				$sql = "DELETE FROM #__js_res_record_category WHERE catid = id = {$id}";
				$db->setQuery($sql);
				$db->query();
			}
		}
	}
}

?>
