<?php
/**
 * $Id: comments.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access');

jimport( 'joomla.application.component.controller');

/**
 * Weblinks Weblink Controller
 *
 * @package    Joomla
 * @subpackage  Weblinks
 * @since 1.5
 */
class ResControllerComments extends JController
{
	function __construct($config = array())
	{

		if( !JRequest::getVar('view') ) JRequest::setVar( 'view'  , 'comments');

		parent::__construct($config);

		$this->registerTask( 'apply',  'save');
	}

	function display( )
	{
		parent::display();
	}

	function remove( )
	{
		$model = $this->getModel( 'comments');
		$model->_deleteItem();

		$this->setRedirect( 'index.php?option=com_resource&controller=comments', JText::_('Comment has been deleted successfully') );
	}

	function save( )
	{
		global $mainframe;

		$task = Jrequest::getWord( 'task');
		$id   = Jrequest::getInt( 'id');

		$model = $this->getModel( 'comments');
		if( $model->_saveItem() ) {
			$msg = JText::_('Comment has been saved successfully');
		} else {
			JError::raiseWarning( 500, $model->_error_msg );
			$msg = '';
		}


		switch ( $task ) {
			case 'apply':
				$mainframe->redirect( 'index.php?option=com_resource&controller=comments&layout=form&id='.$id, $msg );
				break;
			case 'save':
			default:
				$mainframe->redirect( 'index.php?option=com_resource&controller=comments', $msg );
				break;
		}

	}

	function cancel()
	{
		global $mainframe;
		$link = 'index.php?option=com_resource&controller=comments';
		$mainframe->redirect( $link );
	}
}
?>