<?php
/**
 * $Id: field.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

class ResControllerField extends ResController1
{
	function __construct()
	{
		parent::__construct();
		//$this->registerTask( 'add', 'edit');
	}
	function display(){
		global $mainframe;
		if(!JRequest::getInt('type_id'))
		{
			JError::raiseWarning('Type Id is lost');
			$mainframe->redirect('index.php?option=com_resource&controller=type');
		}
		JRequest::setVar('view', 'field');
		JRequest::setVar('hidemenu', 0);
		parent::display();
	}
	function edit()
	{
		JRequest::setVar( 'view', 'field');
		JRequest::setVar( 'layout', 'form');
		$model = $this->getModel('type');
		$model->checkout();
		//print_r($_POST); exit();
		parent::display();
	}
	function add()
	{
		JRequest::setVar( 'view', 'field');
		JRequest::setVar( 'layout', 'form');
		//print_r($_POST); exit();
		parent::display();
	}
	function close()
	{
		JRequest::setVar( 'view', 'field');
		 
		parent::display();
	}
	function cancel()
	{
		JRequest::setVar( 'view', 'field');
		 
		//$record = & $this->getTable('type','Res');
		//$record->checkin(JRequest::getVar('id'));

		$this->setRedirect( 'index.php?option=com_resource&controller=field&type_id='.JRequest::getVar('type_id') );
	}
	function copyfields()
	{
		$new_type = JRequest::getInt('new_type');

		if(!$new_type)
		{
			JRequest::setVar( 'view', 'field');
			JRequest::setVar( 'layout', 'chose');
			parent::display();
			return;
		}
		$db = & JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array');
		$tid = JRequest::getVar('type_id');
		JArrayHelper::toInteger($cid);

		$ids = implode(", ", $cid);

		$sql = "SELECT * FROM #__js_res_fields WHERE id IN({$ids})";
		$db->setQuery($sql);
		$result = $db->loadObjectList();
		foreach ($result AS $type)
		{
			if(!$type) continue;

			$sql = "INSERT INTO #__js_res_fields (`type_id`, `type`, `params`, `published`, `ordering`, `title`, `show_intro`,
			`show_detail`, `searchable`, `filter`, `access`) SELECT {$new_type}, `type`, `params`, `published`, `ordering`, CONCAT(`title`, ' - ".JText::_('Copy')."'), `show_intro`,
			`show_detail`, `searchable`, `filter`, `access` FROM  #__js_res_fields WHERE id = {$type->id}";
			$db->setQuery($sql);
			$db->query();

			JError::raiseNotice(200, JText::_('Field copies sucessfuly'). " [{$type->title}]");
		}
		switch(JRequest::getInt('return'))
		{
			case 1:
				$link = 'index.php?option=com_resource&controller=field&type_id='.$tid;
				break;
			case 2:
				$link = 'index.php?option=com_resource&controller=field&type_id='.$new_type;
				break;
			default:
				$link = 'index.php?option=com_resource&controller=type';
				break;
		}

		$this->setRedirect($link);
	}
	function save()
	{
		//JRequest::checkToken() or jexit( 'Invalid Token');

		$post	= JRequest::get('post');
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array');
		$post['id'] = (int) $cid[0];
		
		if(!$post['type'])
		{
			JError::raiseWarning(403, JText::_('Error: Field type is not selected. Please install field plugins and publish them.'));
			parent::display();
			return;
		}
			

		$model = $this->getModel('field');
		
		$post['filter'] = $post['params']['filter_enable'];

		if ($model->store($post)) {
			$msg = JText::_('Field Saved');

		} else {
			$msg = JText::_('Error Saving Filed');
			$msg .= $model->getError();
		}

		// Check the table in so it can be edited.... we are done with it anyway
		$model->checkin();

		$link = 'index.php?option=com_resource&controller=field&type_id='.JRequest::getVar('type_id');
		if(JRequest::getVar('task') == 'apply') $link = "index.php?option=com_resource&controller=field&view=field&task=edit&cid[]=".($post['id'] ? $post['id'] : $model->id).'&type_id='.JRequest::getVar('type_id');

		$this->setRedirect($link, $msg);
	}

	/*function display(){
	 JRequest::setVar('view', 'field');
	 global $mainframe;
	 $type = JRequest::getInt('type_id');
	 if(!$type)
	 {
	 $type = JRequest::getVar('cid', array(0), '', 'array');
	 $type = $type[0];
	 }
	 if(!$type)
	 {
	 JError::raiseWarning(400, 'Type is not defined');
	 $mainframe->redirect('index.php?option=com_resource&controller=type');
	 }
	  
	 parent::display();
	 }

	 function edit($id = 0, $type_id = 0)
	 {
	  
	 $db     =& JFactory::getDBO();
	 $user   =& JFactory::getUser();
	 $option = JRequest::getVar('option');
	 //$model = JModel::getInstance('field');

	 $row =& JTable::getInstance('field', 'Res');
	 $row->load( $id );

	 $sql = "SELECT element as value, element as text FROM #__plugins WHERE `folder` = 'joomsuite_content_fields' AND published = 1 ORDER BY element ASC";
	 $db->setQuery($sql);
	 $f = $db->loadObjectList();


	 $types = JHTML::_('select.genericlist', $f, 'type', "onchange=\"loadTypeParams(this.value);\"", 'value', 'text', $row->type );

	 $publish = JHTML::_('select.booleanlist', 'published', 'class="inputbox"', $row->published );

	 $show_intro = JHTML::_('select.booleanlist', 'show_intro', 'class="inputbox"', $row->show_intro );
	 $show_full = JHTML::_('select.booleanlist', 'show_detail', 'class="inputbox"', $row->show_detail );
	 $search = JHTML::_('select.booleanlist', 'searchable', 'class="inputbox"', $row->searchable );
	 $filter = JHTML::_('select.booleanlist', 'filter', 'class="inputbox"', $row->filter );
	 $access 	 = JHTML::_('list.accesslevel', $row );

	 $sql = "SELECT ordering as value, CONCAT('(', ordering,') ', title) as text FROM #__js_res_fields WHERE type_id = {$type_id}";
	 $db->setQuery($sql);
	 $res[] = JHTML::_('select.option', '0', '(0) - first -');
	 $add = $db->loadObjectList();
	 if(is_array($add)) $res = array_merge($res, $add);
	 $order = JHTML::_('select.genericlist', $res, 'ordering', '', 'value', 'text', $row->ordering );
	  
	 $params = new JParameter($row->params, JPATH_COMPONENT_ADMINISTRATOR.DS.'fields.xml');
	 //$param = $params->render();
	 $type_params = new JParameter($row->params, JPATH_ROOT.DS.'plugins'.DS.'joomsuite_content_fields'.DS.$row->type.'.xml');

	 require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'views'.DS.'field'.DS.'tmpl'.DS.'form.php');
	 }
	 function show_list()
	 {
	 JRequest::setVar('view', 'field');
	 JRequest::setVar('layout', 'default_list');
	 parent::display();
	 }*/
	function orderup()
	{
		$model = $this->getModel('field');
		$model->move(-1);

		$this->setRedirect( 'index.php?option=com_resource&controller=field&type_id='.JRequest::getVar('type_id'));
	}

	function orderdown()
	{
		$model = $this->getModel('field');
		$model->move(1);

		$this->setRedirect( 'index.php?option=com_resource&controller=field&type_id='.JRequest::getVar('type_id'));
	}

	function saveorder()
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array');
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array');
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);

		$model = $this->getModel('field');
		$model->saveorder($cid, $order);

		$msg = 'New ordering saved';
		$this->setRedirect( 'index.php?option=com_resource&controller=field&type_id='.JRequest::getVar('type_id'));
	}
}
?>
