<?php
/**
 * $Id: section.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access');

class ResControllerSection extends ResController1 {
	
    
    function __construct()
	{
		parent::__construct();

		//$this->registerTask( 'add',  'edit');
		$this->registerTask( 'apply', 'save');
		JRequest::setVar( 'view', 'section');
		
	}
	function edit()
	{
	    JRequest::setVar( 'view', 'section');
	    JRequest::setVar( 'layout', 'form');
	    
	    parent::display();
	}
	function add()
	{
	    JRequest::setVar( 'view', 'section');
	    JRequest::setVar( 'layout', 'form');
	    
	    parent::display();
	}
	
	function display( )
	{
		JRequest::setVar( 'view', 'section');
		parent::display();
		
	}

    function cancel()
	{
		// Checkin the weblink
		$model = $this->getModel('category');
		$model->checkin();

		$this->setRedirect( 'index.php?option=com_resource&controller=category');
	}
	function save()
	{
		$post	= JRequest::get('post');
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array');
		$post['id'] = (int) $cid[0];

		
		$model = $this->getModel('category');
		$text = JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWRAW );
		//jimport('joomla.filter.filteroutput');
		$text		= str_replace( '<br>', '<br />', $text );
		$post['description'] = $text;

		if ($model->store($post)) {
			$msg = JText::_('Section Saved');
		} else {
			JRequest::getVar('task', 'apply');
			$msg = JText::_('Error Saving Category'. $model->getError() );
		}

		// Check the table in so it can be edited.... we are done with it anyway
		$model->checkin();
		$link = 'index.php?option=com_resource&controller=section';
		if(JRequest::getVar('task') == 'apply') 
		$link = "index.php?option=com_resource&controller=category&view=category&task=edit&cid[]=".($post['id'] ? $post['id'] :$model->id)."&type_id=".$post['type_id'];
		$this->setRedirect($link, $msg);
	}
	
	function remove($parent = 0)
    {
        $db   =& JFactory::getDBO();
        $cid 	= JRequest::getVar('cid', array(0));
        $cids = implode(",", $cid);
        
        $parent ? $where = " parent IN ( $parent )  " : $where = " id IN ( $cids ) ";
        
        $sql  = "SELECT * FROM #__js_res_category WHERE $where";
        $db->setQuery($sql);
        $rows = $db->loadObjectList();
        //echo $db->stderr();
        //echo $db->_sql;
        //return;
        if(count($rows) == 0) return;
        foreach($rows AS $row)
        {
            $this->remove($row->id);
        }
        //return;
        $sql  = "DELETE FROM #__js_res_category WHERE $where";
        $db->setQuery($sql);
        $db->query();
        //echo $db->stderr();
        $link = 'index.php?option=com_resource&controller=section';
		$this->setRedirect($link, JText::_('Category removed'));
    }
    function orderup()
	{
		$model = $this->getModel('category');
		$model->move(-1);

		$this->setRedirect('index.php?option=com_resource&controller=section');
	}

	function orderdown()
	{
		$model = $this->getModel('category');
		$model->move(1);

		$this->setRedirect('index.php?option=com_resource&controller=section');
	}

	function saveorder()
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array');
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array');
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);

		$model = $this->getModel('category');
		$model->saveorder($cid, $order);

		$msg = 'New ordering saved';
		$this->setRedirect( 'index.php?option=com_resource&controller=section', $msg );
	}
    function _select_list($parent = 0, $level = 0)
    {
        $db =& JFactory::getDBO();

        $sql = "SELECT id, name FROM #__jc_products_categories WHERE parent = $parent";
        //echo $sql;
        $db->setQuery($sql);
        $rows = $db->loadObjectList();
        if(count($rows) == 0) return false;
        foreach($rows AS $row)
        {
            $level == 0 ? $ind = '- ' : $ind = str_repeat("&nbsp;&nbsp;&nbsp;", $level).'- ';
            
            $clientlis[] = JHTML::_('select.option', $row->id, $ind.$row->name, 'id', 'name');
            $new = $this->_select_list($row->id, ($level + 1));
            if($new && is_array($new)) $clientlis = array_merge($clientlis, $new);
        }
        
        return $clientlis;
    }
}

?>
