<?php
/**
 * $Id: tag.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access');

jimport( 'joomla.application.component.controller');

/**
 * Weblinks Weblink Controller
 *
 * @package		Joomla
 * @subpackage	Weblinks
 * @since 1.5
 */
class ResControllerTag extends JController
{
	function __construct($config = array())
	{
		if(!JRequest::getVar('view')) JRequest::setVar( 'view'  , 'tag');
		parent::__construct($config);
	}

	function display( )
	{
		parent::display();
	}

	function remove( )
	{
		$model = $this->getModel( 'tag');
		$model->_deleteTag();

		$this->setRedirect( 'index.php?option=com_resource&controller=tag', JText::_('Tag has been deleted successfully') );
	}

	function save( )
	{
		$model = $this->getModel( 'tag');
		if( $model->_saveTag() ) {
			$msg = JText::_('Tag has been saved successfully');
			$this->setRedirect( 'index.php?option=com_resource&controller=tag', $msg );
		} else {
			JError::raiseWarning( 500, $model->_error_msg );
			$this->setRedirect( 'index.php?option=com_resource&controller=tag');
		}
	}
}
?>