<?php
/**
 * $Id: subtmplsuninstall.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport( 'joomla.application.component.model');
jimport( 'joomla.filesystem.file');

class ResModelSubtmplsuninstall extends JModel
{

	function __construct()
	{
		parent::__construct();
	}

	function uninstall( $tmpls )
	{
		global $mainframe;

		foreach( $tmpls as $tmpl){
			preg_match ( "/^\[(.*)\]\,\[(.*)\]$/i", $tmpl, $matches );

			$layouts_path = subTemplate::getTmplPath( $matches[2] );

			$masks = subTemplate::getTmplFullMask( $matches[2], $matches[1] );

			if( $masks['index_file'] ){

				$files = JFolder::files( $layouts_path, $masks['index_file'] );

				foreach( $files as $file ){
					JFile::delete( $layouts_path.DS.$file );
				}
			}
			//if(JFolder::exists($layouts_path.DS.$masks['folder'].$matches[1]))
			//{
			//	JFolder::delete($layouts_path.DS.$masks['folder'].$matches[1]);
			//}
			if( $masks['folder'] ){

				$folders = JFolder::folders( $layouts_path, $masks['folder'], false, true );
				
				foreach( $folders as $folder ){
					JFolder::delete( $folder );
				}
			}

		}

		return true;
	}

}