<?php
/**
 * $Id: tools.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.model');

class ResModelTools extends JModel
{
	var $_tools       = array();
	var $_form        = array();
	
	function __construct()
	{
	  $this->_id = JRequest::getInt('id');
		parent::__construct();
	}

	function getTools()
	{
		if (empty($this->_tools)) {
			
			$dispatcher =& JDispatcher::getInstance();	
			JPluginHelper::importPlugin( 'joomsuite_content');
			$results = $dispatcher->trigger( 'onToolsGetIcons', array());
			
			$total = array();
			foreach ($results As $result)
				$total = array_merge($total, $result);
			
			$this->_tools = $total;
		}
		settype($this->_tools, 'array');
		return $this->_tools;
	}
	
	function getForm()
	{
		$name = JRequest::getVar('name');
		$id = JRequest::getVar('id');
		$form = '';
		if(!$name || !$id) return JText::_('Not all values passed');
		
		$key = md5($name.$id);
		
		if (!@$this->_form[$key]) {
			
			$dispatcher =& JDispatcher::getInstance();	
			JPluginHelper::importPlugin( 'joomsuite_content', $name);
			$dispatcher->trigger( 'onToolGetForm', array(&$form, $name, $id));
			
			$this->_form[$key] = $form;
		}
		return $this->_form[$key];
	}
}