<?php
/**
 * $Id: activity.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access');

/**
 * @package JCommerce
 */

jimport('joomla.database.table');

class ResActivity extends JTable
{
	var $id = null;
	var $icon = '';
	var $text = '';
	var $client = 'user';
	var $client_id = '';
	var $component = 'com_resource';
	var $ctime = null;
	var $params = '';
	var $type = '';
	var $user_id = 0;

	function __construct( &$_db ) {
		parent::__construct( '#__community_activity', 'id', $_db );
		$this->set( 'ctime', date( 'Y-m-d G:i:s' ) );
	}
	function bind($array, $ignore = '')
	{
		if(is_array($array))
		{
			if (key_exists('params', $array )) {
				if(is_array($array['params']))
				{
					$registry = new JRegistry();
					$registry->loadArray($array['params']);
					$array['params'] = $registry->toString();
				}
			}
		}
		
		return parent::bind($array, $ignore);
	}
	function check() {
		if (!$this->ctime) {
			$this->ctime =  date( 'Y-m-d G:i:s');
		}
		return true;
	}
}
?>
