<?php
/**
 * $Id: comments.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access');

/**
 * @package JCommerce
 */

class  ResComments extends JTable
{

	var $id	= '';
	var $record_id	= '';
	var $user_id	= '';
	var $subject	= '';
	var $comment	= '';
	var $ctime	= '';
	var $published	= '';
	var $email	= '';
	var $name	= '';
	var $langs	= '';
	var $access	= 0;
	var $rate	= 0;
	var $level	= 0;
	var $parent	= 0;
	var $hide	= 0;
	var $params	= '';
	var $attachment	= '';
	var $attach_hit	= 0;
	var $ip	= '';

	function __construct( &$_db ) {
		parent::__construct( '#__js_res_comments', 'id', $_db );
	}
	function bind($array, $ignore = '')
	{
		if(is_array($array))
		{
			if (key_exists('params', $array )) {
				if(is_array($array['params']))
				{
					$registry = new JRegistry();
					$registry->loadArray($array['params']);
					$array['params'] = $registry->toString();
				}
			}
		}
		return parent::bind($array, $ignore);
	}
	function check($prm) {

		if (!$this->comment || !$this->record_id || !$this->email || !$this->name || (!$this->subject && $prm->get('comments_title')) ) {
			$this->setError('Not all values set<br />'. $val);
			return false;
		}
		if(preg_match('/\[url/iU', $this->comment) || preg_match('/\&lt;a/iU', $this->comment)){
			$this->setError('Unsupported characters in the comment. Looks like your are spammer. No way.');
			return false;
		}

		if (!$this->langs) {
			$lang =& JFactory::getLanguage();
			$this->langs = $lang->getTag();
		}
		if(!$this->ip) $this->ip = $_SERVER['REMOTE_ADDR'];

		if(!JMailHelper::isEmailAddress($this->email)) {
			$this->setError('Email is not correct');
			return false;
		}
		return true;
	}
}
?>