<?php
/**
 * $Id: field.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access');

/**
* @package JCommerce
*/

class  TableField extends JTable
{

    var $id	= '';
    var $title	= '';
    var $params	= '';
    var $checked_out	= '';
    var $checked_out_time	= '';
    var $type_id = '';
    var $type = '';
    var $published = '';
    var $ordering = '';
    var $show_intro = '';
    var $show_detail = '';
    var $show_cart = '';
    var $searchable = '';
    var $filter = '';
    var $access = 0;
    var $show_compare = 0;
    var $show_dummy1 = 0;
    var $show_dummy2 = 0;
  
	function __construct( &$_db ) {
		parent::__construct( '#__js_res_fields', 'id', $_db );
	}
    
	function bind($array, $ignore = '')
	{
		if(is_array($array))
		{
			if (key_exists('params', $array )) {
				if(is_array($array['params']))
				{
					$registry = new JRegistry();
					$registry->loadArray($array['params']);
					$array['params'] = $registry->toString();
				}
			}
		}
		return parent::bind($array, $ignore);
	}
	
	function check() {
		if(trim($this->title) == '') {
			$this->_error = JText::_('No Name');
			return false;
		}
    
		/*if(trim($this->imageurl) == '') {
			$this->_error = jcText::_('BNR_IMAGE');
			return false;
		}
		if(trim($this->clickurl) == '' && trim($this->custombannercode) == '') {
			$this->_error = jcText::_('BNR_URL');
			return false;
		}*/

		return true;
	}
}
?>
