<?php
/**
 * $Id: form.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access'); ?>
<?php
JHTML::_('behavior.tooltip');
JHTML::_('behavior.calendar');
if($this->row->parent)
$this->isNew ? JSToolBar::title(JText::_('New Category')) : JSToolBar::title(JText::_('Edit Category'));
else
$this->isNew ? JSToolBar::title(JText::_('New Section')) : JSToolBar::title(JText::_('Edit Section'));
JSToolBar::save();
JSToolBar::apply();
if (!$this->isNew)  {
	JToolBarHelper::cancel();
} else {
	// for existing items the button is renamed `close`
	JToolBarHelper::cancel( 'cancel', 'Close');
}
JSToolBar::helpW('http://help.mightyextensions.com/resources/index.html?'.($this->row->parent != NULL ? 'adding_a_category.htm' : 'adding_a_section.htm'), 1000, 500);
$editor =& JFactory::getEditor();
?>
<form action="index.php" method="post" name="adminForm">
<table width="100%"">
	<tr valign="top">
		<td>
			<TABLE class="admintable" width="100%">
		         <TR>
		          <TD class="key"><?php echo ($this->row->parent ? JText::_('Category Name') : JText::_('Section Name')); ?>:</TD>
		          <td><input type="text" name="name" value="<?php echo $this->row->name ?>" size="60" /></td>
		        </TR>  
		        <TR>
		          <TD class="key"><?php echo ($this->row->parent ? JText::_('Category Title') : JText::_('Section Title')); ?>:</TD>
		          <td><input type="text" name="title" value="<?php echo $this->row->title ?>" size="60" /></td>
		        </TR>  
		        <TR>
		          <TD class="key"><?php echo ($this->row->parent ? JText::_('Category Alias') : JText::_('Section Alias')); ?>:</TD>
		          <td><input type="text" name="alias" value="<?php echo $this->row->alias ?>" size="60" /></td>
		        </TR>
		        <?php if(JRequest::getInt('section_id')):?>
		        <TR>
		          <TD class="key"><?php echo JText::_('Published'); ?>:</TD>
		          <td><?php echo $this->lists['published'] ?></td>
		        </TR>  
		        <TR>
		          <TD class="key"><?php echo JText::_('Access'); ?>:</TD>
		          <td><?php echo $this->lists['access'] ?></td>
		        </TR>  
		        <TR>
		          <TD class="key"><?php echo JText::_('Parent Category'); ?>:</TD>
		          <td><?php echo $this->lists['category'] ?></td>
		        </TR>  
		        <TR>
		          <TD class="key"><?php echo JText::_('Ordering'); ?>:</TD>
		          <td><?php echo $this->lists['ordering'] ?></td>
		        </TR>  
		        <?php else : ?>
		        <TR>
		          <TD colspan="2">
		          <input type="hidden" name="access" value="0">
		          <input type="hidden" name="published" value="1">
		          </td>
		        </TR>  
		        <?php endif;?>
		        <TR valign="top">
		          <TD class="key"><?php echo JText::_('Image'); ?>:</TD>
		          <td><?php echo $this->lists['image'] ?></td>
		        </TR>
		        <TR valign="top">
		          <TD class="key"><?php echo JText::_('Image Position'); ?>:</TD>
		          <td><?php echo $this->lists['image_position'] ?></td>
		        </TR>
		        <TR>
		          <td>&nbsp;</td>
		          <TD>
		              <script language="javascript" type="text/javascript">
		              if (document.forms[0].image.options.value!=''){
		              jsimg='../images/stories/' + getSelectedValue( 'adminForm', 'image');
		              } else {
		              jsimg='../images/M_images/blank.png';
		              }
		              document.write('<img src=' + jsimg + ' name="imagelib" width="80" height="80" border="2" alt="<?php echo JText::_('Image Preview'); ?>" />');
		              </script>
		
		          </td>
		        </TR>  
		      </table>
		    
		     <table class="adminform">
				<tr>
					<td>
						<?php
						// parameters : areaname, content, width, height, cols, rows
		                echo $editor->display( 'description',  $this->row->description, '100%', '300', '60', '20' ) ;
						//echo $editor->getButtons('text');
						?>
					</td>
				</tr>
			</table>
			<TABLE class="admintable" width="100%">
		        <TR>
		          <TD class="key" width="50%"><?php echo JText::_('Meta Description'); ?>:</TD>
		          <TD class="key" width="50%"><?php echo JText::_('Meta keywords'); ?>:</TD>
		        </TR>  
		        <TR>
		          <TD><textarea name="meta_descr" rows="5" style="width:98%"><?php echo $this->row->meta_descr; ?></textarea></TD>
		          <TD><textarea name="meta_key" rows="5" style="width:98%"><?php echo $this->row->meta_key; ?></textarea></TD>
		        </TR>  
		      </table>
		</td>
		
		<?php if(RES_MODE || !JRequest::getInt('section_id')):?>
		<td width="340" style="padding:0 0 0 7px;width:340px">
			<?php 
			if(JRequest::getInt('section_id'))
			{
				$params = $this->gparams;
			}
			else 
			{
				$params = $this->params;
			}
		        
			echo $this->slider->startPane('properties');
			
			echo $this->slider->startPanel(JText::_('General'), 'general');
			echo $params->render('params', 'general');
			
			echo '<fieldset style="margin:8px; "><legend>'.JText::_('Cache').'<span></legend>';
			echo $params->render('params', 'cache');
			echo '</fieldset>';
			
			echo '<fieldset style="margin:8px; "><legend>'.JText::_('Templates').'<span></legend>';
			echo $params->render('params', 'general_tmpl');
			echo '</fieldset>';
			
			echo '<fieldset style="margin:8px; "><legend>'.JText::_('Mobile Templates').'<span></legend>';
			echo $params->render('params', 'general_tmpl_mobile');
			echo '</fieldset>';
			
			echo '<fieldset style="margin:8px; "><legend>'.JText::_('Submission').'</legend>';
			echo $params->render('params', 'submission');
			echo '</fieldset>';
			
			echo '<fieldset style="margin:8px; "><legend>'.JText::_('Moderation').'</legend>';
			echo $params->render('params', 'moderators');
			echo '</fieldset>';
			echo '&nbsp;';
			
			echo $this->slider->endPanel();

			echo $this->slider->startPanel(JText::_('Properties'), 'properties');
			echo '<fieldset style="margin:8px; "><legend>'.JText::_('Feed & Syndication').'</legend>';
			echo $params->render('params', 'general_rss');
			echo '</fieldset>';
			echo '<fieldset style="margin:8px; "><legend>'.JText::_('Elements').'</legend>';
			echo $params->render('params', 'general_show');
			echo '</fieldset>';
			echo '<fieldset style="margin:8px; "><legend>'.JText::_('Rating Sort & Count').'</legend>';
			echo $params->render('params', 'rating_sect');
			echo '</fieldset>';
			echo '<fieldset style="margin:8px; "><legend>'.JText::_('Search').'</legend>';
			echo $params->render('params', 'general_search');
			echo '</fieldset>';
			echo '&nbsp;';
			
			echo $this->slider->endPanel();
			/*
			echo $this->slider->startPanel('Submission', 'submission');
			echo $params->render('params', 'submission');
			echo '<fieldset style="margin:8px; "><legend>'.JText::_('Category').'</legend>';
			echo $params->render('params', 'submit_category');
			echo '</fieldset>';
			echo '<fieldset style="margin:8px; "><legend>'.JText::_('Alerts').'</legend>';
			echo $params->render('params', 'submit_alert');
			echo '</fieldset>';
			echo '<fieldset style="margin:8px; "><legend>'.JText::_('Elements').'</legend>';
			echo $params->render('params', 'submit_element');
			echo '</fieldset>';
			echo '<fieldset style="margin:8px; "><legend>'.JText::_('Labels').'</legend>';
			echo $params->render('params', 'submit_labels');
			echo '</fieldset>';
			echo '&nbsp;';
			echo $this->slider->endPanel();
			*/
			if(!JRequest::getInt('section_id'))
			{
				echo $this->slider->startPanel(JText::_('User Menu'), 'user-menu');
				echo $params->render('params', 'user_menu');
				echo '<fieldset style="margin:8px; "><legend>'.JText::_('Menu Elements Labels').'</legend>';
				echo $params->render('params', 'user_menu_labels');
				echo '</fieldset>';
				echo '<fieldset style="margin:8px; "><legend>'.JText::_('Menu Elements Icons').'</legend>';
				echo $params->render('params', 'user_menu_icons');
				echo '</fieldset>';
				echo '&nbsp;';
				echo $this->slider->endPanel();
			
				echo $this->slider->startPanel(JText::_('Filter Box'), 'order-box');
				echo $params->render('params', 'general_filters');
				echo '<fieldset style="margin:8px; "><legend>'.JText::_('Filters').'</legend>';
				echo $params->render('params', 'filter_box');
				echo '</fieldset>';
				echo '<fieldset style="margin:8px; "><legend>'.JText::_('Order box').'</legend>';
				echo $params->render('params', 'Order Box');
				echo '</fieldset>';
				echo '&nbsp;';
				echo $this->slider->endPanel();
			
				
				echo $this->slider->startPanel(JText::_('Categories Public'), 'categories-pub');
				echo $params->render('params', 'Categories Public');
				echo '<fieldset style="margin:8px; "><legend>'.JText::_('Subcategories').'</legend>';
				echo $params->render('params', 'Categories Public Sub');
				echo '</fieldset>';
				echo '&nbsp;';
				echo $this->slider->endPanel();
				
				echo $this->slider->startPanel(JText::_('Categories Private'), 'categories-priv');
				echo $params->render('params', 'Categories Private');
				echo '<fieldset style="margin:8px; "><legend>'.JText::_('Category Submission').'</legend>';
				echo $params->render('params', 'Private Category Submission');
				echo '</fieldset>';
				echo '&nbsp;';
				echo $this->slider->endPanel();
				
				echo $this->slider->startPanel(JText::_('Commerce'), 'commerce');
				echo $this->cparams->render('params', 'General Settings');
				
				echo '<fieldset style="margin:8px; "><legend>'.JText::_('Cart Settings').'</legend>';
				echo $this->cparams->render('params', 'Cart Settings');
				echo '</fieldset>';
				
				echo '<fieldset style="margin:8px; "><legend>'.JText::_('Payment Flow').'</legend>';
				echo $this->cparams->render('params', 'Payment Flow');
				echo '</fieldset>';
				
				echo '<fieldset style="margin:8px; "><legend>'.JText::_('Standart sellers settings').'</legend>';
				echo $this->cparams->render('params', 'Standard sellers settings');
				echo '</fieldset>';
				
				echo '<fieldset style="margin:8px; "><legend>'.JText::_('Silver sellers settings').'</legend>';
				echo $this->cparams->render('params', 'Silver sellers settings');
				echo '</fieldset>';
				
				echo '<fieldset style="margin:8px; "><legend>'.JText::_('Gold sellers settings').'</legend>';
				echo $this->cparams->render('params', 'Gold sellers settings');
				echo '</fieldset>';
				
				echo '<fieldset style="margin:8px; "><legend>'.JText::_('Seller CPanel settings').'</legend>';
				echo $this->cparams->render('params', 'Seller CPanel settings');
				echo '</fieldset>';
				
				echo '<fieldset style="margin:8px; "><legend>'.JText::_('Customer settings').'</legend>';
				echo $this->cparams->render('params', 'Customer settings');
				echo '</fieldset>';
				
				echo '<fieldset style="margin:8px; "><legend>'.JText::_('Bill To fields settings').'</legend>';
				echo $this->cparams->render('params', 'Bill To fields settings');
				echo '</fieldset>';
				
				echo '&nbsp;';
				
				echo $this->slider->endPanel();
			}

			echo $this->slider->endPane();
			?>
		</td>
		<?php endif;?>
	</tr>
</table>

<input type="hidden" name="section_id" value="<?php echo ($this->row->section_id ? $this->row->section_id : JRequest::getInt('section_id'))?>" />
<input type="hidden" name="filter_catid" value="<?php echo (JRequest::getInt('filter_catid'))?>" />
<input type="hidden" name="option" value="<?php echo $option; ?>" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="controller" value="category" />
<input type="hidden" name="id" value="<?php echo $this->row->id?>" />
<input type="hidden" name="ctime" value="<?php echo $this->row->ctime?>" />
<input type="hidden" name="cid[]" value="<?php echo $this->row->id?>" />
<input type="hidden" name="boxchecked" value="0" />
<input type="hidden" name="hidemainmenu" value="0" />
</form>
