<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access');

jimport ( 'joomla.application.component.view');

class ResViewCategory extends JView {
	
	function display($tpl = null) {
		global $mainframe, $option;
		$model = & $this->getModel ();
		//var_dump($this->getLayout());
		//var_dump(JRequest::getVar('layout'));
		//print_r($_POST);
		if (($this->getLayout () == 'form') || (JRequest::getVar ( 'layout' ) == 'form')) {
			$this->_form ();
			return;
		}
		if (($this->getLayout () == 'select') || (JRequest::getVar ( 'layout' ) == 'select')) {
			$this->_select ();
			return;
		}
		
		global $mainframe, $option;
		
		$db = & JFactory::getDBO ();
		$user = & JFactory::getUser ();
		
		$context = "$option.viewcategory1";
		$filter_state = $mainframe->getUserStateFromRequest ( $option . 'category.filter_state', 'filter_state', '', 'word');
		$filter_catid = $mainframe->getUserStateFromRequest ( $option . 'category.filter_catid', 'filter_catid', 0, 'int');
		$filter_order = $mainframe->getUserStateFromRequest ( $option . '.category.filter_order', 'filter_order', 'j.ordering', 'var');
		$filter_order_Dir = $mainframe->getUserStateFromRequest ( $option . '.category.filter_order_Dir', 'filter_order_Dir', 'ASC');
		$search = $mainframe->getUserStateFromRequest ( $option . 'category.search', 'search', '', 'string');
		$search = JString::strtolower ( $search );
		$lists ['search'] = $search;
		
		$sql = "SELECT id FROM #__js_res_category LIMIT 1";
		$db->setQuery($sql);
		$atall = $db->loadResult();
		
		$limit = $mainframe->getUserStateFromRequest ( "$context.limit", 'limit', $mainframe->getCfg ( 'list_limit' ), 0 );
		$limitstart = JRequest::getVar ( 'limitstart', 0, '', 'int');
		
		$items = & $this->get ( 'Categories');
		$pagination = & $this->get ( 'Pagination');
		$up = $model->getUpId ( $filter_catid );
		
		$javascript = 'onchange="document.adminForm.submit();"';
		$lists ['catid'] = '';
		if(RES_CATEGORIES_VIEW == 'tree'){
			$doc = &JFactory::getDocument();
			$doc->addScriptDeclaration('
				function toggle_category(){
					if($("cat_filter").hasClass("cat_filter_close")){
						$("cat_filter").removeClass("cat_filter_close");
						$("cat_filter").addClass("cat_filter_open");
					}else{
						$("cat_filter").removeClass("cat_filter_open");
						$("cat_filter").addClass("cat_filter_close");
					}
				}
				
				function reset_category(){
					document.adminForm.filter_catid[0].checked = "checked";
					document.adminForm.filter_catid[0].value = "";
					submitform();
				}
			');
			
			$doc->addStyleDeclaration('
				.cat_filter_open{
					display:block;
					position:absolute;
					border:1px solid #cccccc;
					background-color:#ffffcc;
					overflow:auto;
					text-align:left;
				}
				.cat_filter_close{
					display:none;
				}
				
				#cat_filter input[type=radio]{
					border:none;
					outline:none;
				}
			');
			
			$lists['catid'] = '<button type="button" onclick="toggle_category();">'.JText::_('Category filter').'</button>'
							.'<div id="cat_filter" class="cat_filter_close" >'
							.ResHelper::getAjaxTreeCategoryList(0, array($filter_catid), false, array(), 'filter_catid')
							.'<button type="button" onclick="submitform();">'.JText::_('Submit').'</button>'
							.'<button type="button" onclick="reset_category();">'.JText::_('Reset').'</button>'
							.'</div>';
		}else{
			$c [] = JHTML::_ ( 'select.option', JRequest::getInt ( 'section_id' ), JText::_ ( '- Select Category -' ) );
			$clist = $model->_getCategoriesList ( JRequest::getInt ( 'section_id' ) );
			if (is_array ( $clist ))
				$c = array_merge ( $c, $clist );
			$lists ['catid'] = JHTML::_ ( 'select.genericlist', $c, 'filter_catid', 'onchange="submitform()"', 'value', 'text', $filter_catid );
		}
		
		// state filter
		$lists ['state'] = JHTML::_ ( 'grid.state', $filter_state );
		
		$javascript = 'onchange="document.adminForm.submit();"';
		$c2 [] = JHTML::_ ( 'select.option', 0, JText::_ ( '- Select Section -' ) );
		$clist = $model->_getCategoriesList ( 0, 0, 1 );
		if (is_array ( $clist ))
			$c2 = array_merge ( $c2, $clist );
		$lists ['section'] = JHTML::_ ( 'select.genericlist', $c2, 'filter_sec', 'onchange="self.location = \'index.php?option=com_resource&controller=category&filter_catid=\'+ this.value +\'&section_id=\'+ this.value;"', 'value', 'text', JRequest::getInt ( 'section_id' ) );
		
		$lists ['order'] = $filter_order;
		$lists ['order_Dir'] = $filter_order_Dir;
		
		$this->assignRef ( 'user', JFactory::getUser () );
		$this->assignRef ( 'lists', $lists );
		$this->assignRef ( 'rows', $items );
		$this->assignRef ( 'pagination', $pagination );
		$this->assignRef ( 'up', $up );
		$this->assignRef('atall',		$atall);
		//$this->assign('section_id',	$section_id);
		

		parent::display ( $tpl );
	}
	
	function _form($tpl = '') {
		global $mainframe, $option;
		
		$db = & JFactory::getDBO ();
		$user = & JFactory::getUser ();
		$option = JRequest::getVar ( 'option');
		$model = & $this->getModel ();
		
		$lists = array ();
		
		//get the weblink
		$record = & $this->get ( 'category');
		$isNew = ($record->id < 1);
		
		// fail if checked out not by 'me'
		if ($model->isCheckedOut ( $user->get ( 'id' ) )) {
			$msg = JText::_ ( 'Record is edited iat this moment');
			$mainframe->redirect ( 'index.php?option=' . $option, $msg );
		}
		
		// Edit or Create?
		if (! $isNew) {
			$model->checkout ( $user->get ( 'id' ) );
		} else {
			$filter_catid = $mainframe->getUserStateFromRequest ( $option . 'category.filter_catid', 'filter_catid', 0, 'int');
			$record->parent = $filter_catid;
			$record->published = 1;
			//$record->type_name = $model->getTypeName($record->type_id);
		}
		
		
		JFilterOutput::objectHTMLSafe ( $record, ENT_QUOTES, 'description');
		
		$file = JPATH_COMPONENT_ADMINISTRATOR.DS.'xml'.DS.'commerce.xml';
		$file2 = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_commerce'.DS.'commerce.xml';
		if(JFile::exists($file2)) {	$file = $file2; }
		
		$params = new JParameter ( $record->params, JPATH_COMPONENT_ADMINISTRATOR . DS . 'xml' .DS . 'config.xml');
		$gparams = new JParameter ( $record->params, JPATH_COMPONENT_ADMINISTRATOR . DS .'xml' .DS . 'config_g.xml');
		$cparams = new JParameter ( $record->params,  $file);
		
		$slider = &JPane::getInstance('sliders', array('allowAllClose' => true));
		$query = 'SELECT ordering AS value, name AS text' . ' FROM #__js_res_category' . ' WHERE parent = ' . ( int ) $record->parent . //' AND state >= 0' .
		' ORDER BY ordering';
		if ($isNew)
			$lists ['ordering'] = JHTML::_ ( 'list.specificordering', $record, '', $query, 1 );
		else
			$lists ['ordering'] = JHTML::_ ( 'list.specificordering', $record, $record->id, $query, 1 );
			
		//$lists['ctime'] 	 = JHTML::_('calendar', $record->ctime, 'ctime', 'ctime', '%Y-%m-%d %H:%M:%S', array('class' => 'inputbox'));//JHTML::_('date', $record->ctime, '%Y-%m-%d %H:%M:%S');
		$lists ['published'] = JHTML::_ ( 'select.booleanlist', 'published', 'class="inputbox"', $record->published );
		$lists ['access'] = JHTML::_ ( 'list.accesslevel', $record );
		$lists ['image'] = JHTML::_ ( 'list.images', 'image', $record->image );
		$active = ($record->image_position ? $record->image_position : 'left');
		$lists ['image_position'] = JHTML::_ ( 'list.positions', 'image_position', $active, NULL, 0, 0 );
		
		if ($record->parent > 0 || $isNew) {
			if(RES_CATEGORIES_VIEW != 'tree'){
				$categories [] = JHTML::_ ( 'select.option', JRequest::getInt ( 'section_id' ), '- Top -');
				$add = $model->_getCategoriesList ( JRequest::getInt ( 'section_id' ) );
				if (is_array ( $add ))
					$categories = array_merge ( $categories, $add );
				$lists ['category'] = JHTML::_ ( 'select.genericlist', $categories, 'parent', '', 'value', 'text', $record->parent );
			}else{
				$lists['category'] = ResHelper::getAjaxTreeCategoryList( JRequest::getInt ( 'section_id' ), array($record->parent), false, array(), 'parent' );
			}
		} else {
			$lists ['category'] = '';
		}
		$this->assignRef ( 'user', JFactory::getUser () );
		$this->assignRef ( 'lists', $lists );
		$this->assignRef ( 'row', $record );
		$this->assignRef ( 'params', $params );
		$this->assignRef ( 'gparams', $gparams );
		$this->assignRef ( 'cparams', $cparams );
		$this->assignRef ( 'isNew', $isNew );
		$this->assignRef ( 'slider', $slider );
		
		parent::display ();
	}
	function _select($tpl = '') {
		global $mainframe, $option;
		
		$db = & JFactory::getDBO ();
		$user = & JFactory::getUser ();
		$option = JRequest::getVar ( 'option');
		$model = & $this->getModel();
		$records = &JModel::getInstance('Record','ResModel');
		
		$cid = JRequest::getVar ( 'cid', array (0 ), 'post', 'array');
		
		$sql = "SELECT id, name, section_id FROM #__js_res_category WHERE id IN (" . implode ( ", ", $cid ) . ")";
		$db->setQuery ( $sql );
		$cats = $db->loadObjectList();
		
		$categories = $records->_getCategories();
		if(count($categories) > 15) $n = 15; else $n = count($categories);
		$sections = JHTML::_('select.genericlist', $categories,
		'category', ' class="inputbox" size="'.$n
		.'" ', 'value', 'text');
		
		$this->assignRef ( 'cats', $cats );
		$this->assignRef ( 'sections', $sections );

		parent::display ();
	}
	function getRecords($catid)
	{
		$db = & JFactory::getDBO ();
		
		$sql = "SELECT count(*) FROM #__js_res_record_category WHERE catid = $catid";
		$db->setQuery ( $sql );
		$cats = $db->loadResult();
		return $cats;
	}
}
?>
