<?php
/**
 * $Id: default.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access'); ?>

<style type="text/css">
  .icon-32-types {
    background: url(components/com_resource/images/type.png) no-repeat;
  }
  .icon-32-record {
    background: url(components/com_resource/images/record.png) no-repeat;
  }
</style>

<TABLE cellpadding="2" cellspacing="0" height="20px" border="0" width="100%">
  <TR>
    <TD> </TD>
    <TD align="right">Filters Here:</TD>
  </TR>
</TABLE>
<form action="index.php" method="post" name="adminForm">
  <div id="editcell">
  	<table class="adminlist">
  	<thead>
  		<tr>
  			<th width="1%">
  				<?php echo JText::_('NUM'); ?>
  			</th>
  			<th width="1%">
  				<input type="checkbox" name="toggle" value="" id="checkMain" onclick="checkAll(<?php echo count( $this->items ); ?>);" />
  			</th>
  			<th width="5%">
  				<?php echo JHTML::_('grid.sort',  'Type', 'f.type', $this->lists['order_Dir'], $this->lists['order'] ); ?>
  			</th>
  			<th class="title">
  				<?php echo JHTML::_('grid.sort',  'Title', 'f.title', $this->lists['order_Dir'], $this->lists['order'] ); ?>
  			</th>
  			<th width="10%">
  				<?php echo JHTML::_('grid.sort',  'Order', 'f.ordering', $this->lists['order_Dir'], $this->lists['order'] ); ?>
  				<?php echo JHTML::_('grid.order',  $this->items ); ?>
  			</th>
  			
  			<th width="7%"><?php echo JHTML::_('grid.sort',  'Access', 'groupname', @$this->lists['order_Dir'], @$this->lists['order'] ); ?></th>
      		<th width="5%">
  				<?php echo JHTML::_('grid.sort',  'Publish', 'f.published', $this->lists['order_Dir'], $this->lists['order'] ); ?>
  			</th>
  			<th width="1%" nowrap="nowrap">
  				<?php echo JHTML::_('grid.sort',  'ID', 'f.id', $this->lists['order_Dir'], $this->lists['order'] ); ?>
  			</th>
  		</tr>
  	</thead>
  	<?php
  	$k = 0;
  	for ($i=0, $n=count( $this->items ); $i < $n; $i++)
  	{
  		$row = &$this->items[$i];
  		$checked 	= JHTML::_('grid.checkedout',   $row, $i );
  		$ordering = ($this->lists['order'] == 'f.ordering');
  		$access 	= ResHelper::AccessProcessingX( $row, 'js_res_filters');
      $link = 'index2.php?option=com_resource&controller=filters&task=edit&cid[]='. $row->id;
  		?>
  		<tbody id="row_<?php echo $row->id ?>">
  		<tr class="<?php echo "row$k"; ?>" >
  			<td>
  				<?php echo $i; ?>
  			</td>
  			<td>
  				<?php echo $checked; ?>
  			</td>
  			<td nowrap>
  				<?php echo ucwords(str_replace("_", " ", $row->type)); ?>
  			</td>
  			<td>
  				<?php
  				if (  JTable::isCheckedOut($this->user->get('id'), $row->checked_out ) ) {
  					echo $row->name;
  				} else {
  					echo '<a href="'.$link.'">'. $row->title.'</A>';
  				}
  				?>
  			</td>
  			<td class="order">
  				<span><?php echo $this->pagination->orderUpIcon( $i, ($i > 0),'orderup', 'Move Up', $ordering ); ?></span>
  				<span><?php echo $this->pagination->orderDownIcon( $i, $n, ($n > ($i + 1)), 'orderdown', 'Move Down', $ordering ); ?></span>
  				<?php $disabled = $ordering ?  '' : 'disabled="disabled"'; ?>
  				<input type="text" name="order[]" size="5" value="<?php echo $row->ordering;?>" <?php echo $disabled ?> class="text_area" style="text-align: center" />
  			</td>
  			<td align="center">
  				<?php echo $access; ?>
  			</td>
  			<td align="center" nowrap>
  			  <?php echo ResHelper::PublishedProcessingX( $row, 'js_res_filters', $i)?>
  			</td>
  			<td align="center">
  				<?php echo $row->id; ?>
  			</td>
  		</tr>
  		</tbody>
  		<?php
  		$k = 1 - $k;
  	}
  	?>
  	</table>
  </div>
	<input type="hidden" name="option"       value="<?php echo $option; ?>" />
	<input type="hidden" name="task"         value="" />
	<input type="hidden" name="controller"   value="filters" />
	<input type="hidden" name="boxchecked"   value="0" />
	<input type="hidden" name="hidemainmenu" value="0" />
</form> 