<?php
/**
 * $Id: change_core.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access'); ?>
<?php
JSToolBar::title(JText::_('Change Core Fields'));
JSToolBar::save('save_core');
JSToolBar::cancel('', 'Cancel');
JSToolBar::helpW('http://help.mightyextensions.com/resources/index.html?changing_columns.htm', 1000, 500);
?>
<style>
<!--
#extime_img 
{
 text-align: center;
 vertical-align: middle;
 margin:5px; 
}
-->
</style>

<form action="index.php" method="post" name="adminForm">

<table class="adminlist">
	<thead>
		<tr>
			<th width="30%" align="left"><?php echo JText::_('Records(s)')?></th>
			<th align="left"><?php echo JText::_('Date Time')?></th>
		</tr>
	</thead>	
	<tbody>
		<tr valign="top">
			<td>
				<ul>
					<?php foreach ($this->records AS $record): ?>
					<li><?php echo $record->title ?></li>
					<?php endforeach; ?>
				</ul>
			</td>
			<td>
				<h3><?php echo JText::_('Please, leave fields you do not want to be affected blank') ?></h3>
				<table class="admintable">
					<tr>
						<td class="key"><?php echo JText::_('Expire Date') ?>:</td>
						<td><?php echo JHTML::_('calendar', '', 'extime', 'extime', '%Y-%m-%d %H:%M:%S', array('class' => 'inputbox')); ?></td>
					</tr>
					<tr>
						<td class="key"><?php echo JText::_('Create Date') ?>:</td>
						<td><?php echo JHTML::_('calendar', '', 'ctime', 'ctime', '%Y-%m-%d %H:%M:%S', array('class' => 'inputbox')); ?></td>
					</tr>
					<tr>
						<td class="key"><?php echo JText::_('Author') ?>:</td>
						<td><?php echo $this->list['user_id']; ?></td>
					</tr>
					<tr>
						<td class="key"><?php echo JText::_('Access') ?>:</td>
						<td>
							<select name="access" size="3">
								<option value="0"><?php echo JText::_('Public'); ?></option>
								<option value="1"><?php echo JText::_('Registered'); ?></option>
								<option value="2"><?php echo JText::_('Special'); ?></option>
							</select>
						</td>
					</tr>
					<tr>
						<td class="key"><?php echo JText::_('Tags') ?>:</td>
						<td><textarea rows="3" cols="60" name="tags"></textarea>
						<br>
						<select name="tag_mode">
							<option value="1"><?php echo JText::_('Append to articles') ?></option>
							<option value="2"><?php echo JText::_('Replace') ?></option>
						</select>
						</td>
					</tr>
				</table>
				
			</td>
		</tr>
	</tbody>
</table>

<input type="hidden" name="cids" value="<?php echo $this->ids; ?>" />
<input type="hidden" name="option" value="com_resource" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="boxchecked" value="0" />
<input type="hidden" name="hidemainmenu" value="0" />
</form>
