<?php
/**
 * $Id: change_field.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access'); ?>
<?php
JSToolBar::title(JText::_('Change Field Value'));
JSToolBar::save('save_field');
JSToolBar::cancel('', 'Cancel');
JSToolBar::helpW('http://help.mightyextensions.com/resources/index.html?changing_columns.htm', 1000, 500);
?>

<p>You can set any field. Thenages will be applied only to field you entered value to.</p>

<form action="index.php" method="post" name="adminForm">

<table class="adminlist">
	<thead>
		<tr>
			<th width="20%" align="left"><?php echo JText::_('Records(s)')?></th>
			<th align="left"><?php echo JText::_('Field Values')?></th>
		</tr>
	</thead>	
	<tbody>
		<tr valign="top">
			<td>
				<ul>
					<?php foreach ($this->records AS $record): ?>
					<li><?php echo $record->title ?></li>
					<?php endforeach; ?>
				</ul>
			</td>
			<td>
				<?php 
				$tabs = JPane::getInstance('tabs'); 
				
				echo $tabs->startPane('fields');
				foreach ($this->types AS $id => $type)
				{
					echo $tabs->startPanel($type['name'], 'folder'.$id);
					?>
					<TABLE class="admintable" width="100%">
					<?php	
					foreach ($type['fields'] AS $field)
					{
					?>
					<tr valign="top">
						<?php if($field->type != 'html'):?><td class="key"><?php echo $field->title ?>:</td><?php endif;?>
						<td<?php if($field->type == 'html') echo ' colspan="2" '?>><?php if($field->type == 'html') echo $field->title.'<br>'?><?php $this->renderField($field) ?></td>
					</tr>
					<?php
					}
				    ?> 
					</table>
					<?php	
					echo $tabs->endPanel(); 
				}
				echo $tabs->endPane();
				?>
			</td>
		</tr>
	</tbody>
</table>

<input type="hidden" name="cids" value="<?php echo $this->ids; ?>" />
<input type="hidden" name="option" value="com_resource" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="boxchecked" value="0" />
<input type="hidden" name="hidemainmenu" value="0" />
</form>
