<?php
/**
 * $Id: view.html.php 7431 2011-11-07 02:10:32Z peter $
 * $LastChangedDate: 2011-11-07 08:10:32 +0600 (Mon, 07 Nov 2011) $
 * $LastChangedBy: peter $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access');

jimport( 'joomla.application.component.view');

class ResViewRecord extends JView
{

	function display($tpl = null)
	{
		global $mainframe, $option;
		$model	=& $this->getModel();
		if($this->getLayout() == 'form'){
			$this->_form();
			return;
		}
		if($this->getLayout() == 'start'){
			$this->_start();
			return;
		}
		if($this->getLayout() == 'change_category'){
			$this->_change_category($tpl);
			return;
		}
		if($this->getLayout() == 'change_core'){
			$this->_change_core($tpl);
			return;
		}
		if($this->getLayout() == 'change_field'){
			$this->_change_field($tpl);
			return;
		}
		if($this->getLayout() == 'about'){
			$data2 = array('version' => 'Not Installed');
			$file = JPATH_COMPONENT_ADMINISTRATOR.DS.'com_resource.xml';
			$file2 = JPATH_COMPONENT_ADMINISTRATOR.DS.'update_com_resource.xml';

			if(JFile::exists($file2)) $file = $file2;
			$data = JApplicationHelper::parseXMLInstallFile($file);

			//if(JFile::exists($file3)) $data2 = JApplicationHelper::parseXMLInstallFile($file3);

			$this->assignRef('data', $data);
			$this->assignRef('data2', $data2);

			parent::display();
			return;
		}

		$db		=& JFactory::getDBO();
		$uri	=& JFactory::getURI();

		$filter_state		= $mainframe->getUserStateFromRequest( $option.'rec_ord.filter_state',	'filter_state',	'',	'word');
		$filter_catid		= $mainframe->getUserStateFromRequest( $option.'rec_ord.filter_catid',	'filter_catid',	0,	'int');
		$filter_type		= $mainframe->getUserStateFromRequest( $option.'rec_ord.filter_type',	'filter_type', 0,	'int');
		$filter_clients		= $mainframe->getUserStateFromRequest( $option.'rec_ord.filter_clients','filter_clients', 'resource','var');
		$filter_status		= $mainframe->getUserStateFromRequest( $option.'rec_ord.filter_status','filter_status', 0,'var');

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'rec_ord1.filter_order',	'filter_order',	'r.ctime', 'var');
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'rec_ord1.filter_order_dir', 'filter_order_Dir', 'DESC', 'word');

		$search				= $mainframe->getUserStateFromRequest( $option.'rec_ord.search', 'search', '', 'string');
		$search				= JString::strtolower( $search );

		//$state->set('filter_order', $filter_order);
		//$state->set('filter_order_dir', $filter_order_Dir);
		$model->setState('filter_order', $filter_order);
		$model->setState('filter_order_dir', $filter_order_Dir);
		
		$sql = "SELECT id FROM #__js_res_record LIMIT 1";
		$db->setQuery($sql);
		$atall = $db->loadResult();


		$lists['search']= $search;
		// Get data from the model
		$items		= & $this->get('Records');
		$total		= & $this->get('Total');
		$pagination = & $this->get('Pagination');

		// build list of categories
		$javascript 	= 'onchange="document.adminForm.submit();"';
		
		if(RES_CATEGORIES_VIEW == 'tree'){
			$doc = &JFactory::getDocument();
			$doc->addScriptDeclaration('
				function toggle_category(){
					if($("cat_filter").hasClass("cat_filter_close")){
						$("cat_filter").removeClass("cat_filter_close");
						$("cat_filter").addClass("cat_filter_open");
					}else{
						$("cat_filter").removeClass("cat_filter_open");
						$("cat_filter").addClass("cat_filter_close");
					}
				}
				
				function reset_category(){
					document.adminForm.filter_catid[0].checked = "checked";
					document.adminForm.filter_catid[0].value = "";
					submitform();
				}
			');
			
			$doc->addStyleDeclaration('
				.cat_filter_open{
					display:block;
					position:absolute;
					border:1px solid #cccccc;
					background-color:#ffffcc;
					overflow:auto;
				}
				.cat_filter_close{
					display:none;
				}
				
				#cat_filter input[type=radio]{
					border:none;
					outline:none;
				}
			');
			
			$lists['catid'] = '<button type="button" onclick="toggle_category();">'.JText::_('Category filter').'</button>'
							.'<div id="cat_filter" class="cat_filter_close" >'
							.ResHelper::getAjaxTreeCategoryList(0, array($filter_catid), false, array(), 'filter_catid')
							.'<button type="button" onclick="submitform();">'.JText::_('Submit').'</button>'
							.'<button type="button" onclick="reset_category();">'.JText::_('Reset').'</button>'
							.'</div>';
		}else{
			$c[] = JHTML::_('select.option', 0, JText::_('- Select Category -'));
			$clist = $model->_getCategories();
			if(is_array($clist)) $c = array_merge($c, $clist);
			$lists['catid'] = JHTML::_('select.genericlist',  $c,'filter_catid', 'onchange="submitform()"', 'value', 'text', $filter_catid);
		}
		// state filter
		$lists['state']	= JHTML::_('grid.state', $filter_state, 'Published', 'Unpublished', 'Archived');

		$options = array(array('value'=>0, 'text'=> JText::_('- Select Status -')), array('value'=>1, 'text'=> JText::_('Featured')), array('value' => 2, 'text'=> JText::_('Expired')));
		$lists['status'] = JHTML::_('select.genericlist', $options, 'filter_status', array('onchange' => 'submitform()'), 'value', 'text', $filter_status);

		$t[] = JHTML::_('select.option', 0, JText::_('- Select Type -'));
		$types = $model->getTypes();
		if(is_array($types)) $t = array_merge($t, $types);
		$lists['type']	= JHTML::_('select.genericlist',  $t,
		'filter_type', 'onchange="submitform()"', 'value', 'text', $filter_type);

		$cl[] = JHTML::_('select.option', 0, JText::_('- Select Client -'));
		$cl_list = $model->getClients();
		if(is_array($cl_list)) $cl = array_merge($cl, $cl_list);

		$lists['clients']	= JHTML::_('select.genericlist',  $cl,
		'filter_clients', 'onchange="submitform()"', 'value', 'text', $filter_clients);

		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;

		// search filter

		$this->assign('show_order',	($filter_catid && $filter_clients));
		$this->assignRef('user',		JFactory::getUser());
		$this->assignRef('atall',		$atall);
		$this->assignRef('lists',		$lists);
		$this->assignRef('items',		$items);
		$this->assignRef('pagination',	$pagination);

		parent::display($tpl);
	}

	function _change_category($tpl = '')
	{
		global $option, $mainframe;

		$db     =& JFactory::getDBO();
		$user   =& JFactory::getUser();
		$option = JRequest::getVar('option');
		$model	=& $this->getModel();
		$lang =& JFactory::getLanguage();

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array');
		JArrayHelper::toInteger($cid);
		$ids = implode(",", $cid);

		$sql = "SELECT * FROM #__js_res_record WHERE id IN($ids)";
		$db->setQuery($sql);
		$records = $db->loadObjectList();

		$categories = $model->_getCategories();
		if(count($categories) > 25) $n = 25; else $n = count($categories);
		$category = JHTML::_('select.genericlist', $categories,
		'categories[]', ' multiple="multiple" class="inputbox" size="'.$n
		.'" ', 'value', 'text');



		$this->assignRef('ids',	$ids);
		$this->assignRef('records',	$records);
		$this->assignRef('categories', $category);
		parent::display($tpl);

	}
	function _change_core($tpl = '')
	{
		global $option, $mainframe;

		$db     =& JFactory::getDBO();
		$user   =& JFactory::getUser();
		$option = JRequest::getVar('option');
		$model	=& $this->getModel();
		$lang =& JFactory::getLanguage();

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array');
		JArrayHelper::toInteger($cid);
		$ids = implode(",", $cid);

		$sql = "SELECT * FROM #__js_res_record WHERE id IN($ids)";
		$db->setQuery($sql);
		$records = $db->loadObjectList();

		$lists['user_id'] = $this->getUser();

		$this->assignRef('list', $lists);
		$this->assignRef('ids',	$ids);
		$this->assignRef('records',	$records);
		parent::display($tpl);

	}
	function getUser() {
		global $mainframe;

		$db = & JFactory::getDBO ();
		$doc = & JFactory::getDocument ();
		$template = $mainframe->getTemplate ();

		$user = & JTable::getInstance ( 'user');

		$js = "
		function jSelectArticle(id, name) {
			document.getElementById('user_id').value = id;
			document.getElementById('user_name').value = name;
			document.getElementById('sbox-window').close();
		}";
		$doc->addScriptDeclaration ( $js );

		$link = 'index.php?option=com_resource&amp;task=user_list&amp;tmpl=component';

		JHTML::_ ( 'behavior.modal', 'a.modal');

		$html = "\n" . '<div style="float: left;">
		<input style="background: #ffffff;" type="text" id="user_name" value="' . htmlspecialchars ( $user->name, ENT_QUOTES, 'UTF-8' ) . '" disabled="disabled" /></div>';
		$html .= '<div class="button2-left"><div class="blank"><a class="modal" title="' . JText::_ ( 'Select an User' ) . '"  href="' . $link . '" rel="{handler: \'iframe\', size: {x: 550, y: 500}}">' . JText::_ ( 'Select' ) . '</a></div></div>' . "\n";
		$html .= '<div class="button2-left"><div class="blank"><a title="' . JText::_ ( 'Clear User' ) . '"  onclick="jSelectArticle(0, \'None\')">' . JText::_ ( 'Clear' ) . '</a></div></div>' . "\n";
		$html .= "\n" . '<input type="hidden" id="user_id" name="user_id" value="" />';

		return $html;
	}
	function _change_field($tpl = '')
	{
		global $option, $mainframe;

		$db     =& JFactory::getDBO();
		$user   =& JFactory::getUser();
		$option = JRequest::getVar('option');
		$model	=& $this->getModel();
		$lang =& JFactory::getLanguage();

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array');
		JArrayHelper::toInteger($cid);
		$ids = implode(",", $cid);

		$sql = "SELECT * FROM #__js_res_record WHERE id IN($ids)";
		$db->setQuery($sql);
		$records = $db->loadObjectList();

		$sql = "SELECT DISTINCT r.type_id, t.name FROM #__js_res_record AS r LEFT JOIN #__js_res_types AS t ON t.id = r.type_id WHERE r.id IN($ids)";
		$db->setQuery($sql);
		$types = $db->loadRowList();

		foreach ($types AS $type)
		{
			$new_type[$type[0]]['name'] = $type[1];
			$new_type[$type[0]]['fields'] = $model->getTypeFields($type[0]);
		}
		//echo $sql; exit;

		$this->assignRef('types',	$new_type);
		$this->assignRef('ids',	$ids);
		$this->assignRef('records',	$records);
		parent::display($tpl);

	}

	function _form($tpl = '')
	{
		global $option, $mainframe;

		$db     =& JFactory::getDBO();
		$user   =& JFactory::getUser();
		$option = JRequest::getVar('option');
		$model	=& $this->getModel();
		$lang =& JFactory::getLanguage();

		$lists = array();

		//get the weblink
		$record	=& $this->get('record');
		$isNew		= ($record->id < 1);

		// fail if checked out not by 'me'
		if ($model->isCheckedOut( $user->get('id') )) {
			$msg = JText::_('Record is edited at this moment');
			$mainframe->redirect( 'index.php?option='. $option, $msg );
		}

		// Edit or Create?
		if (!$isNew)
		{
			$model->checkout( $user->get('id') );
			$record->mtime = ResHelper::getDate();
		}
		else
		{
			$record->type_id = JRequest::getInt('type_id');
			$record->type_name = $model->getTypeName($record->type_id);
			$record->ctime = ResHelper::getDate();
			$record->mtime = ResHelper::getDate();
			$record->user_id = $user->get('id');
			$record->langs = $lang->getTag();
		}
		$fields = $model->getFields($record);
		foreach ($fields as $key => $f) {
			if($f->type == 'custom_categories'){
				unset($fields[$key]);
			}
		}

		JFilterOutput::objectHTMLSafe( $record, ENT_QUOTES, 'description');
		
//		$query = 'SELECT ordering AS value, title AS text' .
//		' FROM #__js_res_record' .
		//' WHERE catid = ' . (int) $row->catid .
		//' AND state >= 0' .
//		' ORDER BY ordering';

		$lists['ctime'] 	= JHTML::_('calendar', $record->ctime, 'ctime', 'ctime', '%Y-%m-%d %H:%M:%S', array('class' => 'inputbox'));//JHTML::_('date', $record->ctime, '%Y-%m-%d %H:%M:%S');
		$lists['extime'] 	= JHTML::_('calendar', (int)$record->extime > 0 ? $record->extime : '0000-00-00 00:00:00', 'extime', 'extime', '%Y-%m-%d %H:%M:%S', array('class' => 'inputbox'));//JHTML::_('date', $record->extime, '%Y-%m-%d %H:%M:%S');
		$lists['publish']  	= JHTML::_('select.booleanlist', 'published', 'class="inputbox"', $record->published );
		$lists['access'] 	= JHTML::_('list.accesslevel', $record );
		$lists['author'] 	= $model->getAuthor($record->user_id);//JHTML::_('list.users', 'user_id', $record->user_id);
		$lists['featured'] 	= JHTML::_('select.booleanlist', 'featured', 'class="inputbox"', $record->featured);
		$lists['tags'] 	 	= $model->getTags($record->id);//JHTML::_('list.users', 'user_id', $record->user_id);

		jimport('joomla.language.helper');
		$languages = JLanguageHelper::createLanguageList($lang->getTag(), constant('JPATH_SITE'), true);
		array_unshift($languages, JHTML::_('select.option', '', '- '.JText::_('Select Language').' -'));

		$lists['lang'] = JHTML::_('select.genericlist',  $languages, 'langs', 'class="inputbox"', 'value', 'text', ($record->langs ? $record->langs : $lang->getTag()) );

		if(RES_CATEGORIES_VIEW == 'tree'){
			
			$sql = "SELECT catid AS value FROM #__js_res_record_category WHERE record_id = ".$record->id;
			$db->setQuery($sql);
			$def = $db->loadResultArray();
			
			$lists['category'] = ResHelper::getAjaxTreeCategoryList(0, $def, true);
		}else{
			$categories = $model->_getCategories();
			if(count($categories) > 15) $n = 15; else $n = count($categories);
			$sql = "SELECT catid AS value FROM #__js_res_record_category WHERE record_id = ".$record->id;
			$db->setQuery($sql);
			$def = $db->loadObjectList();
			$lists['category'] = JHTML::_('select.genericlist', $categories,
			'categories[]', ' multiple="multiple" class="inputbox" size="'.$n
			.'" ', 'value', 'text', $def);
		}

		$params = new JParameter($record->params, JPATH_COMPONENT_ADMINISTRATOR.DS.'xml'.DS.'config_g.xml');
		$slider = &JPane::getInstance('sliders', array('allowAllClose' => true));
		
		$this->assignRef('user',		JFactory::getUser());
		$this->assignRef('lists',		$lists);
		$this->assignRef('item',		$record);
		$this->assignRef('slider',		$slider);
		$this->assignRef('params',		$params);
		$this->assignRef('fields',		$fields);
		$this->assignRef('isNew',		$isNew);

		parent::display();

	}
	function _start($tpl = '')
	{
		global $option;

		$option = JRequest::getVar('option');
		$types	=& $this->get('types');
		$this->assignRef('items',		$types);
		parent::display();

	}
	function renderField($obj)
	{
		global $mainframe;


		$params = new JParameter($obj->params."\n".$obj->fparams);
		$params->set('selected', '');
		$params->set('values2', '');

		$user = &JFactory::getUser();
		$article_id = JRequest::getInt('article');

		$dispatcher =& JDispatcher::getInstance();
		JPluginHelper::importPlugin( 'joomsuite_content_fields', $obj->type);
		$dispatcher->trigger( 'onRenderField', array(&$obj, &$params, $obj->type) );

		return;
		/*




		$user_obj = & JFactory::getUser();


		$denied_by_subscription = false;

		if( $params->get('edit_submit_sp') && !$mainframe->isAdmin())
		{
		$plans = $params->get('edit_submit_sp');
		if(is_array($plans)) $plans = implode(",", $plans);

		if(jscCheckSubscription(
		$params->get('edit_submit_sp'),
		$params->get('subscr_message_add', JText::_('You can edit this field if only you have following subscription(s).')),
		$params->get('subscr_iid', JRequest::getInt('Itemid')),
		false,
		$params->get('field_submit_subscription_count')
		))
		{
		if( $params->get( 'show_value_if_edit_denied_sp' ) ) {
		$get = '';

		if( $article_id ) {
		$dispatcher =& JDispatcher::getInstance();
		JPluginHelper::importPlugin( 'joomsuite_content_fields', $obj->type );
		$dispatcher->trigger( 'onRenderFieldValue', array (&$get, & $obj, $params, $obj->type, $user));
		}

		echo $get;
		}
		echo'<div class="subscription_alert">';
		echo $params->get('subscr_message_add', JText::_('You can edit this field if only you have following subscription(s).' ));
		echo ' <a href="'.JURI::root().'index.php?option=com_jcs&view=jcs&layout=form&Itemid='.$params->get('subscr_iid', JRequest::getInt('Itemid')).'&id='.$plans.'">'.JText::_('List Subscription(s)' ).'</a>';
		echo'</div>';

		if( $article_id ) {
		ResViewRecord::renderHidden($obj);
		}
		$denied_by_subscription = true;
		}
		else
		{
		jscCountLimit($params->get('edit_submit_sp'), $params->get('field_submit_subscription_count'));
		}
		}

		$denied_by_group = false;

		if( !$mainframe->isAdmin() &&  !$denied_by_subscription ) {
		$denied_submit = $params->get( 'denied_submit', -1 );
		$denied_edit   = $params->get( 'denied_edit'  , -1 );


		if ( !is_array( $denied_submit ) ) $denied_submit = array( $denied_submit );
		if ( !is_array( $denied_edit ) )   $denied_edit   = array( $denied_edit );



		if( !$article_id && in_array( $user_obj->gid, $denied_submit ) ) {

		echo $params->get( 'denied_submit_description');
		$denied_by_group = true;
		} else if( $article_id && in_array( $user_obj->gid, $denied_edit ) ) {

		if( $params->get( 'show_value_if_edit_denied' ) ) {
		$get = '';
		$dispatcher =& JDispatcher::getInstance();
		JPluginHelper::importPlugin( 'joomsuite_content_fields', $obj->type );
		$dispatcher->trigger( 'onRenderFieldValue', array (&$get, & $obj, $params, $obj->type, $user));

		echo $get;
		}

		ResViewRecord::renderHidden($obj);
		//echo '<input type="hidden" name="fields['.$obj->id.']" id="fields'.$obj->id.'" value="'.$obj->field_value.'">';

		if( trim( $params->get( 'denied_edit_description' ) ) ) {
		echo '<div>';
		echo $params->get( 'denied_edit_description');
		echo '</div>';
		}
		$denied_by_group = true;
		}
		}

		if( !$denied_by_subscription && !$denied_by_group ) {

		$dispatcher =& JDispatcher::getInstance();
		JPluginHelper::importPlugin( 'joomsuite_content_fields', $obj->type);
		$dispatcher->trigger( 'onRenderField', array($obj, $params, $obj->type) );
		}

		//felix code end

		//if($params->get('description')) echo sprintf('<br><span class="small">%s</span>', $params->get('description'));
		*/
	}
	function renderHidden($obj)
	{
		$enc_types = array('checkbox', 'multipleselect', 'select_simple', 'radiobutton');

		if(@unserialize($obj->field_value) !== false)
		{
			$values = @unserialize($obj->field_value);
			if(is_array($values))
			{
				foreach ($values AS $value)
				{
					if(in_array($obj->type, $enc_types)) $value = base64_encode($value);
					echo '<input type="hidden" name="fields['.$obj->id.'][]" id="fields'.$obj->id.'" value="'.$value.'">';
				}
			}
		}
		else
		{
			if(in_array($obj->type, $enc_types)) $obj->field_value = base64_encode($obj->field_value);
			echo '<input type="hidden" name="fields['.$obj->id.']" id="fields'.$obj->id.'" value="'.$obj->field_value.'">';
		}
	}
	function renderField2($obj, &$out, $gparams, $record, $category)
	{
		global $mainframe;

		$out = '';

		$params = new JParameter($obj->params."\n".$obj->fparams);
		$user = &JFactory::getUser();

		if($user->get('aid') < $obj->access)
		{
			if($obj->access == 1)
			$msg = JText::_('This field available only for Registered users');
			if($obj->access == 2)
			$msg = JText::_('This field available only for Special users');
			$out .= $msg;
			return;
		}
		$article_id = JRequest::getInt('article');

		$access_s = TRUE;
		if(!$params->get('edit_submit_sp')) $access_s = FALSE;
		if($params->get('subscr_skip_admin') &&  MEAccess::isAdmin()) $access_s = FALSE;
		if($params->get('subscr_skip_author') &&  MEAccess::isAuthor(JRequest::getInt('user_id'))) $access_s = FALSE;
		if($params->get('subscr_skip_moder') &&  MEAccess::isModerator($user->get('id'), 'moder_edit_record', $gparams)) $access_s = FALSE;

		if($access_s)
		{
			$plans = $params->get('edit_submit_sp');
			if(is_array($plans)) $plans = implode(",", $plans);

			if(jscCheckSubscription(
			$params->get('edit_submit_sp'),
			JText::_($params->get('subscr_message_add', 'You can edit this field if only you have following subscription(s).')),
			$params->get('subscr_iid', JRequest::getInt('Itemid')),
			false,
			$params->get('field_submit_subscription_count')
			))
			{
				if( $params->get( 'show_value_if_edit_denied_sp' ) ) {
					$get = '';

					if( $article_id ) {
						$dispatcher =& JDispatcher::getInstance();
						JPluginHelper::importPlugin( 'joomsuite_content_fields', $obj->type );
						$dispatcher->trigger( 'onRenderFieldValue', array (&$get, &$obj, &$record, $category));
					}

					$out .= $get;
				}
				$out .= '<div class="subscription_alert">';
				$out .=  JText::_($params->get('subscr_message_add',  'You can edit this field if only you have following subscription(s).' ));
				$out .=  ' <a href="'.JURI::root().'index.php?option=com_jcs&view=jcs&layout=form&Itemid='.$params->get('subscr_iid', JRequest::getInt('Itemid')).'&id='.$plans.'">'.JText::_('List Subscription(s)' ).'</a>';
				$out .= '</div>';

				if( $article_id ) {
					$out .= '<input type="hidden" name="fields['.$obj->id.']" id="fields'.$obj->id.'" value="'.$obj->field_value.'">';
				}
				return;
			}
			else
			{
				jscCountLimit($params->get('edit_submit_sp'), $params->get('field_submit_subscription_count'));
			}
		}

		if($params->get('karma_edit') > 0 && MECommunityHelper::isEnabled())
		{
			if(!$user->get('id'))
			{
				$out = JText::sprintf($params->get('karma_msg_login'), $params->get('karma_edit'));
				if($article_id) {
					$out .= '<input type="hidden" name="fields['.$obj->id.']" id="fields'.$obj->id.'" value="'.$obj->field_value.'">';
				}
				return;
			}
			else
			{
				MECommunityHelper::loadApi();
				$karma = JSCommunityApi::getUserCarma($user->get('id'));

				if($karma->points < $params->get('karma_edit'))
				{
					$access_k = TRUE;
					if($params->get('karma_skip_admin') &&  MEAccess::isAdmin()) $access_k = FALSE;
					if($params->get('karma_skip_author') &&  MEAccess::isAuthor(JRequest::getInt('user_id'))) $access_k = FALSE;
					if($params->get('karma_skip_moder') &&  MEAccess::isModerator($user->get('id'), 'moder_edit_record', $gparams)) $access_k = FALSE;

					if($access_k)
					{
						$out = JText::sprintf($params->get('karma_edit_msg'), $params->get('karma_edit'));
						if($article_id) {
							$out .= '<input type="hidden" name="fields['.$obj->id.']" id="fields'.$obj->id.'" value="'.$obj->field_value.'">';
						}
					}
					return;
				}
			}
		}


		$access_g = TRUE;
		if($article_id)
		{
			if(!$params->get('denied_submit')) $access_g = FALSE;
		}
		else
		{
			if(!$params->get('denied_edit')) $access_g = FALSE;
		}
		if($params->get('subscr_skip_admin') &&  MEAccess::isAdmin()) $access_g = FALSE;
		if($params->get('subscr_skip_author') &&  MEAccess::isAuthor(JRequest::getInt('user_id'))) $access_g = FALSE;
		if($params->get('subscr_skip_moder') &&  MEAccess::isModerator($user->get('id'), 'moder_edit_record', $gparams)) $access_g = FALSE;

		if($access_g)
		{
			if($article_id)	{ $type = 'edit'; }	else { $type = 'submit'; }

			$deny_group = $params->get('denied_'.$type);
			
			settype($deny_group, 'array');

			if(in_array($user->get('gid'), $deny_group))
			{
				if( $params->get('show_value_if_edit_denied') && $params->get('denied_'.$type.'_description'))
				{
					$out .= '<div>';
					$out .= $params->get('denied_'.$type.'_description');
					$out .= '</div>';
				}
				if( $params->get('show_value_if_edit_denied') )
				{
					$get = '';
					$dispatcher =& JDispatcher::getInstance();
					JPluginHelper::importPlugin( 'joomsuite_content_fields', $obj->type );
					$dispatcher->trigger( 'onRenderFieldValue',  array (&$get, &$obj, &$record, $category));
					$out .= $get;
				}

				$hidden = '';
				if(is_array($obj->field_value))
				{
					foreach ($obj->field_value AS $key => $val)
					{
						$hidden .= '<input type="hidden" name="fields['.$obj->id.'][]" id="fields'.$obj->id.'" value="'.$val.'">';
					}
				}
				else
				{
					$hidden = '<input type="hidden" name="fields['.$obj->id.']" id="fields'.$obj->id.'" value="'.$obj->field_value.'">';
				}
				$newval = @unserialize($obj->field_value);
				if(is_array($newval))
				{
					foreach ($newval AS $key => $val)
					{
						$hidden .= '<input type="hidden" name="fields['.$obj->id.'][]" id="fields'.$obj->id.'" value="'.$val.'">';
					}
				}
				$out .= $hidden;
				return $out;
			}
		}

		$dispatcher =& JDispatcher::getInstance();
		JPluginHelper::importPlugin( 'joomsuite_content_fields', $obj->type);
		
		ob_start();
		$dispatcher->trigger('onRenderField', array(&$obj, &$params, $obj->type));
		$out .= ob_get_contents();
		ob_end_clean();
	}

	function files($dir, $params, $default, $filter, $subdir = true)
	{
		$dirr = JPath::clean(JPATH_ROOT.DS.$dir);
		$out[] = "<option value=\"-1\">- Choose -</option>";
		//echo $dirr; exit;
		//return $out;
		if(!is_dir($dirr))
		{
			return array("<option>Directory is not a directory ($dirr)</option>");
		}
		if(!is_readable($dirr))
		{
			return array("<option>Directory is not readable ($dirr)</option>");
		}
		if ($dh = opendir($dirr)) {
			while (($file = readdir($dh)) !== false) {
				//$out[] = "<option value=\"1\">$file</option>";
				if($file == '.' || $file == '..') continue;
				$path = str_replace(realpath(JPATH_ROOT.DS).DS, "", realpath($dirr.DS.$file));

				//if(!is_dir($dirr.DS.$file) && !in_array($ext, $filter)) continue;

				if(is_dir($dirr.DS.$file) && $subdir)
				{
					//$out[] = "<option>".$path."</option>";
					$add = ResViewRecord::files($path, $params, $default, $filter);
					if(is_array($add))
					{
						unset($add[0]);
						if(count($add) > 0)
						{
							$out = array_merge($out, $add);
						}
					}
				}

				$ext  = substr($file, strrpos($file, '.')+1);

				if(in_array(strtolower($ext), $filter)){
					$value = str_replace("\\", "/", $dir.'/'.$file);
					if($value == $default) $s = ' selected="selected" '; else $s = '';
					$out[] = "<option value=\"$value\"$s>$value</option>";
				}
			}

			closedir($dh);
		}
		return $out;
	}
	function _renderCategory($id, $name, $row, $ajax = true)
	{
		if(!$id)
		{
			echo JText::_('No category');
			return ;
		}
		$name = JHTML::link('javascript:void(0);', $name, array('title' => JText::_('Filter by this category'), 'onclick' => 'document.getElementById(\'filter_catid\').value=\''.$id.'\'; document.adminForm.submit();'));
		$patern = ' <div nowrap="nowrap" id="cat_'.$row->id.'_'.$id.'" class="cat_button"><span>'.$name.'</span>';
		if($ajax) $patern .= '<img id="img_'.$row->id.'_'.$id.'" align="top" src="components/com_resource/images/close-rounded.gif" onclick="xajax_deleteCategory('.$row->id.', '.$id.')">';
		$patern .= '</div> ';
		echo $patern;

	}
	function getNum($table, $row_id)
	{
		$db = & JFactory::getDBO ();
		$sql = "SELECT COUNT(*) FROM #__js_res_{$table} WHERE record_id = $row_id";
		$db->setQuery ( $sql );
		$res = $db->loadResult();
		return $res;
	}

}
?>
