<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');
jimport( 'joomla.application.component.view');

JHTML::_('behavior.tooltip');
JHTML::_('behavior.switcher');
jimport('joomla.html.pane');

class ResViewSubtmpls extends JView
{

	function display( $tpl = null )
	{
		if(($this->getLayout() == 'form') || (JRequest::getVar('layout') == 'form')){
			$this->display_form();
			return;
		} else if(($this->getLayout() == 'form_rating') || (JRequest::getVar('layout') == 'form_rating')){
			$this->display_form_rating();
			return;
		}

		global $mainframe, $option;

		$document =& JFactory::getDocument();

		$document->addScript(JURI::root().'components/com_resource/library/js/felixrating.js');

		$filter_types = $mainframe->getUserStateFromRequest( $option.'category.filter_types', 'filter_types', '', 'word');

		JToolBarHelper::title(   JText::_('Custom Templates' ), 'thememanager.png');

		JToolBarHelper::deleteList( '', 'doUninstall', 'Uninstall');
		JSToolBar::install();
		JSToolBar::cr();
		JSToolBar::helpW('http://help.mightyextensions.com/resources/index.html?templates2.htm', 1000, 500);
		
		$uri	= & JFactory::getURI();

		JModel::addIncludePath(JPATH_COMPONENT.DS.'models');
		$model = & JModel::getInstance('Subtmpls', 'ResModel');

		$items      = $model->getData();
		$pagination = $model->getPagination();
		$ftp        = & JClientHelper::setCredentialsFromRequest('ftp');

		$this->assignRef('ftp',         $ftp);
		$this->assignRef('items',       $items);
		$this->assignRef('pagination',  $pagination);
		$this->assignRef('request_url',	$uri->toString());

		parent::display($tpl);
	}

	function display_form( $tpl = null )
	{
		global $mainframe, $option;

		JToolBarHelper::title(   JText::_('Product Templates' ), 'thememanager.png');
		JToolBarHelper::save();
		JToolBarHelper::apply();
		JToolBarHelper::cancel();

		$uri  = & JFactory::getURI();
		$model = & JModel::getInstance('Subtmpls', 'ResModel');
		$tmpl = JRequest::getVar('cid');
		$tmpl = $tmpl[0];

		preg_match ( "/^\[(.*)\]\,\[(.*)\]$/i", $tmpl, $matches );

		$img_path = subTemplate::getTmplImgSrc( $matches[2], $matches[1] );
		$file_ini = subTemplate::getTmplFile( $matches[2], $matches[1].'.ini');
		$file_xml = subTemplate::getTmplFile( $matches[2], $matches[1].'.xml');

		$ini = JFile::exists($file_ini) ? JFile::read( $file_ini ) : '';
		$xml_data = $model->parseXMLTemplateFile($file_xml);

		$params = new JParameter( $ini, $file_xml );

		$this->assignRef('xml_data',     $xml_data);
		$this->assignRef('params',      $params);
		$this->assignRef('name',        $matches[1]);
		$this->assignRef('type',        $matches[2]);
		$this->assignRef('img_path',    $img_path);
		$this->assignRef('request_url',	$uri->toString());

		parent::display($tpl);
	}
}
?>