<?php
/**
 * $Id: default.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access'); ?>

<?php JHTML::_('behavior.tooltip'); ?>

<?php
  // Set toolbar items for the page
  JToolBarHelper::title( JText::_('Tag Manager' ), 'generic.png');
  JToolBarHelper::deleteList();
  JSToolBar::helpW('http://help.mightyextensions.com/resources/index.html?tags.htm', 1000, 500);
?>

<script language="javascript" type="text/javascript">

  var showedForm = 0;
  var linkView   = '';
  
  function showForm( id )
  {
    if( showedForm == 0 ) {
      
      showedForm = id;
      
      var container = document.getElementById( "tag_container_"+id );
      var link      = document.getElementById( "tag_"+id );
      linkView = container.innerHTML;
      var tag = link.innerHTML;
      
      container.innerHTML = '<?php echo JText::_('Tag'); ?>: <input type="text" name="tag" value="' + tag + '" size="45" /> '+
      '<button onclick="submitbutton(\'save\');"><?php echo JText::_('Save Changes'); ?></button> ' +
      '<button onclick="cancelForm();"><?php echo JText::_('Cancel'); ?></button>'+
      '<input type="hidden" name="id" value="' + id + '" />';
      
    } else {
      
      cancelForm( showedForm );
      showForm( id );
      
    }
  }

  function cancelForm( )
  {
    var container = document.getElementById( "tag_container_"+showedForm );
    container.innerHTML = linkView;
    showedForm = 0;
  }
</script>

<form action="index.php" method="post" name="adminForm">
<table>
<tr>
  <td align="left" width="100%">
    <?php echo JText::_('Filter'); ?>:
    <input type="text" name="search" id="search" value="<?php echo $this->lists['search'];?>" class="text_area" onchange="document.adminForm.submit();" />
    <button onclick="this.form.submit();"><?php echo JText::_('Go'); ?></button>
    <button onclick="document.getElementById('search').value='';"><?php echo JText::_('Reset'); ?></button>
  </td>
</tr>
</table>
<div id="editcell">
  <table class="adminlist">
  <thead>
    <tr>
      <th width="1%">
        <?php echo JText::_('NUM'); ?>
      </th>
      <th width="1%">
        <input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count( $this->items ); ?>);" />
      </th>
      <th class="title">
        <?php echo JHTML::_('grid.sort',  'Tag',     'a.tag',     $this->lists['order_Dir'], $this->lists['order'] ); ?>
      </th>
      <th width="8%" nowrap="nowrap">
        <?php echo JHTML::_('grid.sort',  'Created', 'a.ctime',   $this->lists['order_Dir'], $this->lists['order'] ); ?>
      </th>
      <th width="1%" nowrap="nowrap">
        <?php echo JHTML::_('grid.sort',  'ID',      'a.id',      $this->lists['order_Dir'], $this->lists['order'] ); ?>
      </th>
    </tr>
  </thead>
  <tfoot>
    <tr>
      <td colspan="9">
        <?php echo $this->pagination->getListFooter(); ?>
      </td>
    </tr>
  </tfoot>
  <tbody>
  <?php
  $k = 0;
  for ( $i = 0, $n = count( $this->items ); $i < $n; $i++ ) {
    $row = &$this->items[$i];
    ?>
    <tr class="<?php echo "row$k"; ?>">
      <td>
        <?php echo $this->pagination->getRowOffset( $i ); ?>
      </td>
      <td>
        <?php echo JHTML::_('grid.id', $i, $row->id ); ?>
      </td>
      <td id="tag_container_<?php echo $row->id; ?>">
        <a href="javascript: void(0); showForm(<?php echo $row->id; ?>)" id="tag_<?php echo $row->id; ?>"><?php echo $row->tag; ?></a>
      </td>
      <td align="center">
        <?php $data = new JDate( $row->ctime ); echo $data->toFormat( JText::_('%d-%b-%Y') ); ?>
      </td>
      <td align="center">
        <?php echo $row->id; ?>
      </td>
    </tr>
    <?php
    $k = 1 - $k;
  }
  ?>
  </tbody>
  </table>
</div>

  <input type="hidden" name="option"           value="com_resource" />
  <input type="hidden" name="controller"       value="tag" />
  <input type="hidden" name="task"             value="" />
  <input type="hidden" name="boxchecked"       value="0" />
  <input type="hidden" name="filter_order"     value="<?php echo $this->lists['order']; ?>" />
  <input type="hidden" name="filter_order_Dir" value="<?php echo $this->lists['order_Dir']; ?>" />
  <?php echo JHTML::_('form.token'); ?>
</form>