<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access');

jimport( 'joomla.application.component.view');

class ResViewType extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option;
		
		if(($this->getLayout() == 'form') || (JRequest::getVar('layout') == 'form')){
		    $this->_form();
		    return;
		}
		
	    $db		=& JFactory::getDBO();
		$uri	=& JFactory::getURI();
		$user = & JFactory::getUser();

		$sql = "SELECT id FROM #__js_res_types LIMIT 1";
		$db->setQuery($sql);
		$atall = $db->loadResult();
		
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'types.filter_order',		'filter_order',		't.name',	'cmd');
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'types.filter_order_Dir',	'filter_order_Dir',	'',				'word');

		// Get data from the model
		$items =  $this->get('Types');

		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;
		
		$this->assignRef('user',		JFactory::getUser());
		$this->assignRef('lists',		$lists);
		$this->assignRef('items',		$items);
		$this->assignRef('atall',		$atall);
	    
		parent::display($tpl);
	}
	function _form($tpl = '')
	{
		global $mainframe, $option;

		$db		=& JFactory::getDBO();
		$uri 	=& JFactory::getURI();
		$user 	=& JFactory::getUser();
		$model	=& $this->getModel();
		
		JHTML::_('behavior.tooltip');


		$lists = array();

		$type	=& $this->get('data');
		$isNew		= ($type->id < 1);

		if ($model->isCheckedOut( $user->get('id') )) {
			$msg = JText::sprintf( 'DESCBEINGEDITTED', JText::_('The Type' ), $type->name );
			$mainframe->redirect( 'index.php?option='. $option, $msg );
		}

		if (!$isNew)
		{
			$model->checkout( $user->get('id') );
		}
		else
		{
			$type->published = 1;
		}
		
		$slider = &JPane::getInstance('sliders', array('allowAllClose' => true));
        $params = new JParameter($type->params, JPATH_COMPONENT_ADMINISTRATOR.DS.'xml'.DS.'config.xml');
		$lists['published']  = JHTML::_('select.booleanlist', 'published', 'class="inputbox"', $type->published );
       
        JSToolBar::title(JText::_('Edit Content Type'));
		JSToolBar::save();
		JSToolBar::apply();
		if (!$isNew)  {
			JToolBarHelper::cancel();
		} else {
			// for existing items the button is renamed `close`
			JToolBarHelper::cancel( 'cancel', 'Close');
		}
		JSToolBar::helpW('http://help.mightyextensions.com/resources/index.html?adding_a_type.htm', 1000, 500);
		
		
        $this->assignRef('row',		$type);
		$this->assignRef('lists',	$lists);
		$this->assignRef('params',	$params);
		$this->assignRef('slider',	$slider);
		parent::display();
	}
}
?>
