<?php
/**
 * $Id: controller.php 7344 2011-09-21 05:29:23Z kostya $
 * $LastChangedDate: 2011-09-21 11:29:23 +0600 (Wed, 21 Sep 2011) $
 * $LastChangedBy: kostya $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

class ResController extends JController
{
	/**
	 *
	 *
	 * @access	public
	 * @since	1.5
	 */
	function display()
	{
		// Set a default view if none exists
		if ( ! JRequest::getCmd( 'view' ) )
		{
			JRequest::setVar('view', 'list' );
		}

//		if(JRequest::getCmd('view') == 'list')
//		{
			//$model =& $this->getModel('category');
			//$model->hit();
//		}

		//update the hit count for the weblink
		if(JRequest::getCmd('format') == 'feed')
		{
			parent::display();
			return;
			//$model =& $this->getModel('article');
			//$model->hit();
		}

		//print JRequest::getCmd( 'view', 'list' );exit;

		$this->_path['view'] = array(JPATH_BASE.DS.'components'.DS.'com_resource'.DS.'views'.DS);
		$viewType   = 'html';

		$viewName   = JRequest::getCmd( 'view', 'list' );
		$viewLayout = JRequest::getCmd( 'layout', 'default' );

		$view = &$this->getView( $viewName, $viewType, '', array( 'base_path'=>JPATH_BASE.DS.'components'.DS.'com_resource'));
		$model = &$this->getModel($viewName);
		if ($model)
		{
			$view->setModel($model, true);
		}

		$view->setLayout($viewLayout);
		$view->display();
	}
	
	function apply(){
		ResController::add_user_category(false);
	}
	
	function add_user_category($redirect = true)
	{
		// TODO add aliases for user categories.
		Global $mainframe;
		$post	= JRequest::get('post');
		$files	= JRequest::get('files');
		$uri 	=& JFactory::getURI();
		$url_params = &$mainframe->getParams();
		$db = & JFactory::getDBO();

		$params 	= ResHelper::initListParams(JRequest::getInt('category_id', $url_params->get('mod_cat_id', $url_params->get('category_id'))));
		$params->merge($url_params);

		$model = &JModel::getInstance('Ucategory','ResModel');


		//felix code start

		$section = $model->getCategory(ResHelper::getCategorySection($params->get('category_id', JRequest::getInt('category_id'))));

		if( !$model->checkUserCategoryLimit( $params, $section->id ) )
		{
			JError::raiseWarning( 500, JText::_( 'You can`t add new category, because you have reached the limit for the categories in this section.' ) );
			$link = 'index.php?option=com_resource&view=category&controller=category&category_id='.$post['section_id'].'&Itemid='.MEUrl::itemid(NULL, $post['section_id']);
			$link = MEUrl::linkAdditions($link);

			$this->setRedirect( MERoute::_($link, FALSE) );
		}

        if(!$post['id'])
        {
        	$sql = "SELECT id FROM #__js_res_category_user WHERE user_id = ".$post['user_id']." AND name = ".$db->Quote($post['name']);
	        $db->setQuery($sql);
	        if($db->loadResult() > 0)
	        {
	        	$msg = JText::_('Category with the same name already exists');
	            $link = $uri->toString();
	            $this->setRedirect($link, $msg);
	        	$this->redirect();
	        }
        }
		//felix code end

		$files = $files['icon'];

		if(JRequest::getVar('remove_icon'))
		{
			$post['icon'] = '';
		}

		if($files['name'])
		{
			iconResize($files['name'], $files['tmp_name'], $params->get('pcat_icon_w'), $params->get('pcat_icon_h'), 100, $files['type']);
			$post['icon'] = $files['name'];
		}

		if ($model->store($post))
		{

			$msg = JText::_( 'Category Saved' );
			$link = 'index.php?option=com_resource&view=category&controller=category&category_id='.$post['section_id'].'&Itemid='.MEUrl::itemid(NULL, $post['section_id']);
			$link = MEUrl::linkAdditions($link);

		} else
		{
			$msg = JText::_( 'Error Saving Category' );
			$link = $uri->toString();
		}
		if(JRequest::getVar('return'))
			$link = re64(JRequest::getVar('return'));

			
		if(!$redirect){
			if( !$uri->getVar('cid', false) ){
				$uri->setVar('cid', $model->getId());
			}
			$link = $uri->toString();
		}
			
		$model->checkin();
		$this->setRedirect($link, $msg);
		$this->redirect();
	}
	function cancel()
	{
		$model = JModel::getInstance('Ucategory', 'ResModel');
		$model->checkin();

		if ($redirectURL = JRequest::getString('return'))
		{
			$url = re64($redirectURL);
			$this->setRedirect($url);
			return;
		}
		$post	= JRequest::get('post');
		$link = 'index.php?option=com_resource&view=category&controller=category&category_id='.$post['section_id'].'&Itemid='.MEUrl::itemid(NULL, $post['section_id']);
		$link = MEUrl::linkAdditions($link);

		$this->setRedirect($link);
		return;
	}
	function custom_task()
	{

	}
	function display2()
	{
		// Set a default view if none exists
		if ( ! JRequest::getCmd( 'view' ) )
		{
			JRequest::setVar('view', 'list' );
		}

		if(JRequest::getCmd('view') == 'list')
		{
			//$model =& $this->getModel('category');
			//$model->hit();
		}

		//update the hit count for the weblink
		if(JRequest::getCmd('view') == 'article')
		{
			//$model =& $this->getModel('article');
			//$model->hit();
		}

		parent::display();
	}


	function uni_mail()
	{
		include_once(JPATH_COMPONENT_SITE.DS.'controllers'.DS.'article.php');
		ResControllerArticle::uni_mail();
	}
	function mail()
	{
		include_once(JPATH_COMPONENT_SITE.DS.'controllers'.DS.'article.php');
		ResControllerArticle::mail();
	}
	function add_comment()
	{
		include_once(JPATH_COMPONENT_SITE.DS.'controllers'.DS.'article.php');
		ResControllerArticle::add_comment();
	}
	function g()
	{
		$db = & JFactory::getDBO();
		$id = JRequest::getInt('link');

		//if(JRequest::getVar('controller') == 'article') $type = '';

		$sql = "SELECT f.field_value, r.user_id
		FROM #__js_res_record_values AS f
		LEFT JOIN #__js_res_record AS r ON r.id = f.record_id
		LEFT JOIN #__js_res_fields AS rf ON rf.id = f.field_id
		WHERE  rf.published = 1 AND r.published = 1 AND f.id = $id"
		;
		//echo $sql;
		$db->setQuery($sql);
		$res = $db->loadObject();
		if(!$res)
		{
			JError::raiseError(500, JText::_('Item Not found'));
		}
		$this->hit($id);
		//print_r($res);
		header('location:'.$res->field_value);
		exit;
	}
	function show_picture()
	{
		$db = & JFactory::getDBO();
		$id = JRequest::getInt('picture');
		$type = JRequest::getWord('size');

		//if(JRequest::getVar('controller') == 'article') $type = '';


		$sql = "SELECT f.field_value, r.user_id, rf.params, rf.type
		FROM #__js_res_record_values AS f
		LEFT JOIN #__js_res_record AS r ON r.id = f.record_id
		LEFT JOIN #__js_res_fields AS rf ON rf.id = f.field_id
		WHERE rf.published = 1 AND f.id = $id"
		;
		//echo $sql; exit;
		$db->setQuery($sql);
		$res = $db->loadObject();
		//print_r($res); exit;

		if(!$res)
		{
			JError::raiseError(500, JText::_('Item Not found'));
		}

		$file = RES_GENERAL_UPLOAD.DS.'picture'.DS.$res->user_id;
		$type ? $file .= DS.'thumbnail_'.$type : null;
		$file .= DS.$res->field_value;
		$file = realpath($file);

		// Security check
		JPath::check($file);


		if(JFile::exists($file))
		{
			$params = new JParameter($res->params);

			$view_sb = $params->get('view_sp');
			$field_view_subscription_count = $params->get('field_view_subscription_count', 0);

			$edit_submit_sp = $params->get('edit_submit_sp');
			$field_submit_subscription_count = $params->get('field_submit_subscription_count');
			$show_value_if_edit_denied_sp = $params->get('show_value_if_edit_denied_sp');

			$pass = true;

			if($view_sb || $edit_submit_sp)
			{
				if ($view_sb != -1 && jscCheckSubscription($view_sb, null, 1, false, $field_view_subscription_count))
				{
					$pass = false;
				}
				if ($edit_submit_sp != -1 && jscCheckSubscription($edit_submit_sp, null, 1, false, $field_submit_subscription_count) && $show_value_if_edit_denied_sp == 0)
				{
					$pass = false;
				}
			}
			if($pass)
			{
				header("Content-Type: image/jpg");
				header('Expires: '.date('D, d M Y H:i:s', time() + 86400).' GMT');
				header('Pragma: private');
				JSFileManager::readFileChunked($file);
			}
		}
		exit;
	}

	/*
     * This task can be used to download files from RES_GENERAL_UPLOAD directory.
     * You must supply to it the following GET/POST parameters:
     * 		file: 	base64 encoded filename, relative to "RES_GENERAL_UPLOAD / UID / Extension /",
     * 					where:
     * 						UID is the userid of the article owner.
     * 						Extension is the extension of downloaded file. If file = 'test.FoO', then it will be 'foo'.
     * 							(The extension is lowercased)
     * 		downloadName:
     * 					base64 encoded filename to display for downloading,
     * 					(Optional, if not provided, "file" will be used)
     * 		id:		the recordValueId
     * If any of these parameters are not specified, or incorrect, the function just halts.
	*/
	function show_file()
	{
		jimport ('joomla.filesystem.file');

		$recordValueId 	= JRequest::getInt('id');

		$fileManager = & JSFileManager::getInstance();

		$db = & JFactory::getDBO();
		$sql = 'SELECT f.field_value,f.record_id,r.user_id, rf.params, rf.type, rf.id AS fid, r.id
                        FROM #__js_res_record_values AS f
                        INNER JOIN #__js_res_record AS r ON r.id = f.record_id
                        INNER JOIN #__js_res_fields AS rf ON rf.id = f.field_id
                        WHERE f.id = '.$recordValueId;

		$recordValue = &JTable::getInstance('Record_values', 'Res');
		$recordValue->load($recordValueId);

		$db->setQuery($sql);
		$res = $db->loadObject();
		if(!$res)
		{
			JError::raiseError(500, JText::_('Item Not found'));
		}

		$dispatcher = & JDispatcher::getInstance();
		JPluginHelper::importPlugin('joomsuite_content_fields');
		$filePath = $dispatcher->trigger('onDownloadFile', array($res, $recordValue));

		for($i = 0; $i < count($filePath); $i++)
		{
			if(is_object($filePath[$i]))
			{
				$filePath = $filePath[$i];
				break;
			}
		}
		if(!$filePath)
		{
			JError::raiseError(500, JText::_('Item Not found'));
		}
		if($filePath->error || !$filePath->path)
		{
			if($return = JRequest::getVar('return'))
			{
				$this->setRedirect(re64($return), $filePath->error, 'notice');
				return;
			}
			else
			{
				JError::raiseError(404, JText::_("File not found"));
				return;
			}
		}
		if(JFile::exists($filePath->path))
		{
			$fileManager->downloadFile($filePath->path);
			if($res->type == 'files')
				$this->hit2($res->id, $res->fid, $recordValueId, $filePath->filename);
			else
				$this->hit($recordValueId);
		}
		exit;
	}

	function download()
	{
		$user = & JFactory::getUser();
		$id = JRequest::getInt('file');
		$db = & JFactory::getDBO();

		$browser =  $_SERVER['HTTP_USER_AGENT'];
		//echo $browser;

		if(ereg('Opera(/| )([0-9].[0-9]{1,2})', $browser))
		{
			$browser =  'OPERA';
		} else if(ereg('MSIE ([0-9].[0-9]{1,2})', $browser))
		{
			$browser =  'IE';
		} else if(ereg('OmniWeb/([0-9].[0-9]{1,2})', $browser))
		{
			$browser =  'OMNIWEB';
		} else if(ereg('(Konqueror/)(.*)', $browser))
		{
			$browser =  'KONQUEROR';
		} else if(ereg('Mozilla/([0-9].[0-9]{1,2})', $browser))
		{
			$browser =  'MOZILLA';
		} else
		{
			$browser =  'OTHER';
		}

		$sql = "SELECT f.field_value, r.user_id, rf.params, rf.type, r.id , rf.id as field_id
		FROM #__js_res_record_values AS f
		LEFT JOIN #__js_res_record AS r ON r.id = f.record_id
		LEFT JOIN #__js_res_fields AS rf ON rf.id = f.field_id
		WHERE rf.published = 1 AND r.published = 1 AND f.id = $id"
		;
		//echo $sql;
		$db->setQuery($sql);
		$res = $db->loadObject();

		if(!$res)
		{
			JError::raiseError(500, JText::_('Item Not found'));
		}
		//print_r($res);
		$params = new JParameter($res->params);

		// Check subscriptions
		$subscriptions = $params->get('viewSp', null);
		if ($subscriptions !== null)
		{
			$isPublic = !is_array($subscriptions) && $subscriptions == -1;
			if (!$isPublic && !jscCheckSubscription(
							$subscriptions,
							$params->get('alertText', ''),
							$params->get('Itemid'),
							true,
							$params->get('count_mode')))
			{
				jscCountLimit($subscriptions, $params->get('count_mode'));
			}
		}

		if($params->get('type', 1) == 1)
		{
			$file = RES_GENERAL_UPLOAD.DS.$res->type.DS.$res->user_id;
			$file .= DS.$res->field_value;
		}
		else
		{
			$file = JPath::clean(JPATH_ROOT.DS.$res->field_value);
		}

		// Security check
		JPath::check($file);

		if(file_exists($file))
		{
			@ob_end_clean();
			header('Content-Type: '.(($browser=='IE' || $browser=='OPERA')?
							'application/octetstream':'application/octet-stream'));
			header('Expires: '.gmdate('D, d M Y H:i:s').' GMT');
			header('Content-Transfer-Encoding: binary');
			header('Content-Length: '.filesize($file));
			header("Content-Encoding: none");
			if($browser=='IE')
			{
				header('Content-Disposition: attachment; filename="'.basename($res->field_value).'"');
				header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
				header('Pragma: public');
			} else
			{
				header('Content-Disposition: attachment; filename="'.basename($res->field_value).'"');
				header('Cache-Control: no-cache, must-revalidate');
				header('Pragma: no-cache');
			}

			JSFileManager::readFileChunked($file);
			$this->hit($id);

		}
		exit;

	}

	function hit($id)
	{
		$user = &JFactory::getUser();
		$db = &JFactory::getDBO();
		$uid = $user->get('id');
		$now = ResHelper::getDate();

		$sql = "INSERT INTO #__js_res_download_hits VALUES(NULL, '{$uid}', '{$id}', '{$now}', '".$_SERVER['REMOTE_ADDR']."')";
		//echo $sql; exit();
		$db->setQuery($sql);
		$db->query();
	}

	function hit2($recordId, $fieldId, $fieldValueId, $file)
	{
		$user = &JFactory::getUser();
		$db = &JFactory::getDBO();
		$uid = $user->get('id');
		$now = ResHelper::getDate();

		$sql = "INSERT INTO #__js_res_field_extra ".
						"(id, user_id, ref_id, ctime, ip, value, field_id, field_value_id, record_id) ".
						"VALUES (NULL, '{$uid}', ".$db->Quote($file).", '{$now}', '".$_SERVER['REMOTE_ADDR']."', '', ".(int)$fieldId.','.
						(int)$fieldValueId.','.(int)$recordId.")";

		$db->setQuery($sql);
//		var_dump($db->getQuery());exit;
		$db->query();

	}


	function feature()
	{
		Global $mainframe;

		$user = & JFactory::getUser();
		$db = & JFactory::getDBO();
		$id = JRequest::getInt('id');
		$row =& JTable::getInstance('record','Res');
		$row->load(JRequest::getInt('id'));

		$params = ResHelper::initArticleParams($row->type_id, $row->params);

		if(MEAccess::isAdmin() || MEAccess::isAuthor($row->user_id))
		{
			if ($params->get('type_feature_subscription') && !(MEAccess::isAdmin() && $params->get('subscription_admin_skip')))
			{
				IF(!jscCheckSubscription(
				$params->get('type_feature_subscription'),
				$params->get('type_feature_subscription_msg', JText::_('To make your record feature you need to subscribe')),
				$params->get('subscription_iid', JRequest::getInt('Itemid')), TRUE,
				$params->get('type_feature_subscription_count')
				))
				{
					jscCountLimit($params->get('type_feature_subscription'), $params->get('type_feature_subscription_count'));
				}
			}
			$row->featured = 1;
			$time = time() + ($params->get('type_feature_subscription_time', 30) * 86400);
			$time = JFactory::getDate($time);
			$row->ftime = $time->toMysql();
			$row->store();
			$mainframe->enqueueMessage(JText::_('You made this record featured'));

			MEAlerts::now_featured($row, $params, $params->get('type_feature_subscription_time', 30));
		}
		else
		{
			JError::raiseWarning(405, JText::_('No access rights to make this record featured'));
		}


		if($redirect = JRequest::getVar('return'))
		{
			$mainframe->redirect(re64($redirect));
			return;
		}
	}
	function extend()
	{
		Global $mainframe;

		$cuser = & JFactory::getUser();
		$db = & JFactory::getDBO();
		$id = JRequest::getInt('id');
		$row =& JTable::getInstance('record','Res');
		$row->load(JRequest::getInt('id'));

		$params = ResHelper::initArticleParams($row->type_id, $row->params);
		$lparams = ResHelper::initListParams(JRequest::getInt('category_id', ResHelper::getArticleSection($id)));

		if(MEAccess::isModerator($cuser->get('id'), 'moder_extend_record', $lparams) || MEAccess::isAuthor($row->user_id, ($params->get('allow_extend') <= $cuser->get('aid'))) ||
						MEAccess::isAdmin() || MEAccess::isPublisher() || MEAccess::isEditor() )
		{
			if ($params->get('type_extend_subscription'))
			{
				if(!jscCheckSubscription(
				$params->get('type_extend_subscription'),
				$params->get('type_extend_subscription_msg', JText::_('To prolong you need to subscribe')),
				$params->get('subscription_iid', JRequest::getInt('Itemid')), TRUE,
				$params->get('type_extend_subscription_count')
				))
				{
					jscCountLimit($params->get('type_extend_subscription'), $params->get('type_extend_subscription_count'));
				}
			}
			
			$default_extend = $params->get('default_extend');
			
			if($params->get('default_extend') == 0){
				$query = "SELECT u.id, u.extime, IF(u.access_limit > 0, IF(u.access_count >= u.access_limit, 0, 1), 1) AS cl
					FROM #__jcs_plans AS s 
					LEFT JOIN #__jcs_user_subscr AS u ON s.id = u.subscription_id
				   WHERE s.id IN (" .$params->get('type_extend_subscription') . ")
	                 AND u.user_id = ".$cuser->get('id')."
	                 AND u.extime > NOW()
	                 AND u.ctime < NOW()
	                 AND u.published = 1
	               GROUP BY u.id
	              HAVING cl > 0
	               ORDER BY u.extime DESC LIMIT 1";
				$db->setQuery($query);
				$res = $db->loadObject();
				$row->extime = $res->extime;
			}else{
				$row->extime = ResHelper::getDate($default_extend * 86400);
			}

			$row->exalert = 0;
			$row->store();
			$mainframe->enqueueMessage(JText::_('Article extended successfuly'));

			//if(!MEAccess::isAuthor($row->user_id))
			MEAlerts::extended($row, $params, ResHelper::getDate($default_extend * 86400));
		}
		else
		{
			JError::raiseWarning(405, JText::_('No access rights to prolong this record'));
		}
		if($redirect = JRequest::getVar('return'))
		{
			$mainframe->redirect(re64($redirect));
			return;
		}
	}
	function unhide()
	{
		ResController::hide(0);
	}
	function hide($val = 1)
	{
		Global $mainframe;

		$user = & JFactory::getUser();
		$db = & JFactory::getDBO();
		$id = JRequest::getInt('id');
		$row =& JTable::getInstance('record','Res');
		$row->load(JRequest::getInt('id'));

		if($user->get('id') == $row->user_id)
		{
			$row->hidden = $val;
			$row->store();
			$mainframe->enqueueMessage($val == 1 ? JText::_('Article hidden successfully') : JText::_('Article unhidden successfully'));
		}
		else
		{
			JError::raiseWarning(405, JText::_('No access rights to hide/unhide this record'));
		}
		if($redirect = JRequest::getVar('return'))
		{
			$mainframe->redirect(re64($redirect));
			return;
		}
	}
	function publish($client = 'me')
	{
		Global $mainframe;

		$cuser = & JFactory::getUser();
		if(!$cuser->get('id')) MEAccess::login();

		$db = & JFactory::getDBO();
		$iid = JRequest::getInt('Itemid');

		$params = ResHelper::initListParams(JRequest::getInt('category_id'));

		if(MEAccess::isAdmin() || MEAccess::isPublisher() || MEAccess::isEditor() || MEAccess::isModerator($cuser->get('id'), 'moder_publish_record', $params))
		{
			$row =& JTable::getInstance('record','Res');
			$row->load(JRequest::getInt('id'));
			$row->published = 1;
			$row->store();
			$mainframe->enqueueMessage(JText::_('Article published successfully'));
			MEAlerts::publish($row, 1);
		}
		else
		{
			JError::raiseNotice(403, JText::_('Error: You do not have enough rights to publish this article'));
		}
		if($redirect = JRequest::getVar('return'))
		{

			$mainframe->redirect(re64($redirect));
			return;
		}

		if($client == 'me') parent::display();
	}
	function unpublish($client = 'me')
	{
		Global $mainframe;

		$cuser = & JFactory::getUser();

		if(!$cuser->get('id')) MEAccess::login();

		$db = & JFactory::getDBO();
		$iid = JRequest::getInt('Itemid');

		$params = ResHelper::initListParams(JRequest::getInt('category_id'));

		if(MEAccess::isAdmin() || MEAccess::isPublisher() || MEAccess::isEditor() || MEAccess::isModerator($cuser->get('id'), 'moder_publish_record', $params))
		{
			$row =& JTable::getInstance('record','Res');
			$row->load(JRequest::getInt('id'));
			$row->published = 0;
			$row->store();
			$mainframe->enqueueMessage(JText::_('Article unpublished successfully'));
			MEAlerts::publish($row, 0);
		}
		else
		{
			JError::raiseNotice(403, JText::_('Error: You do not have enough rights to publish this article'));
		}
		if($redirect = JRequest::getVar('return'))
		{
			$mainframe->redirect(re64($redirect));
			return;
		}
		if($client == 'me') parent::display();
	}

	function delete_comment_vote()
	{
		Global $mainframe;

		$cuser = & JFactory::getUser();
		if(!$cuser->get('id')) MEAccess::login();
		$db =& JFactory::getDBO();
		$id = JRequest::getInt('id');

		$params = ResHelper::initListParams(JRequest::getInt('category_id'));

		if(!(MEAccess::isAdmin() || MEAccess::isModerator($cuser->get('id'), 'moder_delete_comment_vote', $params)))
		{
			JError::raiseNotice(403, JText::_('Error: You do not have enough rights to delete this vote'));
			return;
		}

		$mode = JRequest::getVar('mode');
		$mode == '+' ? $mode = '-' : $mode = '+';
		$sql = "UPDATE #__js_res_comments SET rate = rate {$mode} 1 WHERE id = $id";
		$db->setQuery($sql);
		$db->query();

		MEAlerts::comment_rating_delete($id, $params);

		$mainframe->enqueueMessage(JText::_('Vote Deleted Successfuly'));
		if($redirect = JRequest::getVar('return'))
		{
			$mainframe->redirect(re64($redirect));
			return;
		}
	}
	function delete_vote()
	{
		Global $mainframe;

		$cuser = & JFactory::getUser();
		if(!$cuser->get('id')) MEAccess::login();


		$db = & JFactory::getDBO();
		$id = JRequest::getInt('id');

		if(!$id)
		{
			JError::raiseNotice(403, JText::_('ID unknown'));
			return;
		}

		$params = ResHelper::initListParams(JRequest::getInt('category_id'));
		if(!(MEAccess::isAdmin() || MEAccess::isModerator($cuser->get('id'), 'moder_delete_vote', $params)))
		{
			JError::raiseNotice(403, JText::_('Error: You do not have enough rights to delete this vote'));
			return;
		}

		$row =& JTable::getInstance('votes','Res');
		$row->load($id);

		if($row->user_id)
		{
			$params = ResHelper::initArticleParams(ResHelper::getArticleType($row->record_id));
			//if($params)
			MEAlerts::rating_delete($row, $params);
		}

		$row->delete();

		$mainframe->enqueueMessage(JText::_('Vote Deleted Successfuly'));

		if($redirect = JRequest::getVar('return'))
		{
			$mainframe->redirect(re64($redirect));
			return;
		}
		//if($client == 'me') parent::display();
	}
	function delete($client = 'me')
	{
		Global $mainframe;

		$cuser = & JFactory::getUser();

		if(!$cuser->get('id')) MEAccess::login();

		$db = & JFactory::getDBO();
		$iid = JRequest::getInt('Itemid');
		$id = JRequest::getInt('id');
		$row =& JTable::getInstance('record','Res');
		$row->load(JRequest::getInt('id'));

		/*$can_delete = false;
		 if($cuser->get('gid') == 25) $can_delete = true;
		 if($cuser->get('gid') == 21) $can_delete = true;
		 if($cuser->get('gid') == 23) $can_delete = true;
		 if($cuser->get('gid') == 24) $can_delete = true;
		 if(($row->user_id > 0) && ($cuser->get('id') == $row->user_id)) $can_delete = true;*/
		$params = ResHelper::initListParams(JRequest::getInt('category_id'));
		$iparams = ResHelper::initArticleParams($row->type_id);

		if (MEAccess::isModerator($cuser->get('id'), 'moder_delete_record', $params)  || MEAccess::isPublisher() || MEAccess::isEditor() || MEAccess::isAdmin() || MEAccess::isAuthor($row->user_id, $iparams->get('item_delete')))
		{
			$dispatcher =& JDispatcher::getInstance();
			JPluginHelper::importPlugin('joomsuite_content_fields');
			$dispatcher->trigger('onDeleteRecords', array(array($id)) );
		    

			MEAlerts::delete($row);

			$karma = $iparams->get('karma_add_record');
			if((int)$karma !== 0) MECommunityHelper::increasKarma($row->user_id, ($karma - $karma - $karma));

			$row->delete();

			$sql  = "DELETE FROM #__js_res_record_category  WHERE record_id IN ($id);";
			$sql .= "DELETE FROM #__js_res_vote  WHERE record_id IN ($id);";
			$sql .= "DELETE FROM #__js_res_tags_history  WHERE record_id IN ($id);";
			$sql .= "DELETE FROM #__js_res_record_values  WHERE record_id IN ($id);";
			$sql .= "DELETE FROM #__js_res_hits WHERE record_id IN ($id);";
			$sql .= "DELETE FROM #__js_res_favorite WHERE record_id IN ($id);";
			$sql .= "DELETE FROM #__js_res_comments WHERE record_id IN ($id);";
			$db->setQuery($sql);
			$db->queryBatch();

			$mainframe->enqueueMessage(JText::_('Article deleted successfully'));

		}
		else
		{
			JError::raiseNotice(403, JText::_('Error: You do not have enough rights to delete this article'));
		}

		if($redirect = JRequest::getVar('return'))
		{
			$mainframe->redirect(re64($redirect));
			return;
		}

		if($client == 'me') parent::display();
	}

	/*
	 * Uploads media to filesystem.
	 * If GET / POST 'fieldId' provided, then it checks maximum size restriction
	 * from field's "max" parameter. // $params->get('max')
	 *
	 * returns JSON formated response:
	 * 		on Success: HTTP status code 200
	 * 			{size: size_of_uploaded_file,
	 * 			result: 'success'}
	 * 		on Error: HTTP status codes 403 404 413 415
	 * 			{error: description_of_error}
	 *
	*/
	function uploadMedia()
	{
		jimport ('joomla.filesystem.file');

		$db 		= & JFactory::getDBO();
		$uri 		= & JURI::getInstance();
		$recordId 	= JFile::makeSafe(JRequest::getString('recordId', null));
		//illegal extensions never upload, or die!!!
		$illegal = explode(',', 'php,js,ini');

		// The response
		$response = new stdClass;
		$response->error = JText::_('No file submited');

		ob_end_clean();

		$user_id = JRequest::getInt('user_id');
		if ($user_id !== null && JRequest::getVar('upload', false, 'files'))
		{
			$tmpName 	= $_FILES['upload']['tmp_name'];
			$filename = JRequest::getString('Filename');
			if (!$filename)
			{
				header('HTTP/1.0 415');
				jexit();
			}
			$extension 	= JString::strtolower(JFile::getExt($filename));
			$name 		= JFile::stripExt(basename($filename));

			if ($_FILES['upload']['error'] || in_array($extension, $illegal))
			{
				header('HTTP/1.0 404');
				$response->error = JText::_('Error uploading file');
				echo en__anonymous_class__1234::toJSONSimple( $response );
				jexit();
			}

			// Check the max file size restriction
			$fieldId = JRequest::getInt('fieldId', false);
			if ($fieldId)
			{
				$field = & JTable::getInstance('Field', 'Table');
				$field->set('id', $fieldId);

				if ($field->load())
				{
					$params = new JParameter($field->get('params'));

					$maxSize = $params->get('max');
					if ($maxSize)
					{
						if ($_FILES['upload']['size'] > $maxSize * 1024)
						{
							header('HTTP/1.0 413 Request Entity Too Large');
							$r->error = JText::_('File too large, maximum allowed: '.$maxSize. 'KiB');
							jexit();
						}
					}
				}
			}

			if ($extension == 'jpeg')
				$extension = 'jpg';

			if ($recordId !== null)
				$name = $recordId.'_'.$name;

			$destFolder = RES_GENERAL_UPLOAD.DS;
			if($params->get('sub_directory'))
			{
			    $sub = $params->get('sub_directory');
			    $sub = preg_replace('/\/$/iU', '', $sub);
			    $sub = preg_replace('/^\//iU', '', $sub);
			    $destFolder .= $sub.DS;
			}
			$destFolder .= $user_id.DS.$extension;
			
			$destName = $destFolder .DS .JFile::makeSafe($name);

			if (!JFolder::exists($destFolder))
			{
				JFolder::create($destFolder, 0755);
			}

			$destName .= '.'.$extension;
			$destName = JPath::clean($destName);

			// Security check.
			JPath::check($destName);


			// Try to upload the file.
			if (!JFile::upload($tmpName, $destName))
			{
				header('HTTP/1.0 403');
				$response->error = JText::_('Error saving file');
			}
			else
			{
				$response->size = JText::_('Uploaded');
				$response->result = 'success';
				unset($response->error);

				if (JPath::canChmod($destName))
					@chmod($destName, 0644);
			}
		}
		else
		{
			header('HTTP/1.0 413');
			$r->error = JText::_('No file submitted, or file too large');
		}

		echo en__anonymous_class__1234::toJSONSimple($response);
		jexit();
	}

	function cron()
	{
		$mail = JFactory::getMailer();

		$db = &JFactory::getDBO();

		while(true)
		{
			$db->setQuery('SELECT * FROM #__js_res_alerts LIMIT 1');
			$alert = $db->loadObject();

			if(!$alert) break;

			$db->setQuery("DELETE FROM #__js_res_alerts WHERE id = {$alert->id}");
			$db->query();

			$mail->setSender(array($alert->sender_email, $alert->sender_name));
			if (JString::strlen(strip_tags($alert->body)) < JString::strlen($alert->body))
			{
				$mail->IsHTML(true);
			}
			else
			{
				$mail->IsHTML(false);
			}
			$mail->setBody(JMailHelper::cleanBody($alert->body));
			$mail->setSubject(JMailHelper::cleanSubject($alert->subject));

			$mail->ClearAllRecipients();
			$mail->AddAddress($alert->email, $alert->name);
			if(!$mail->Send())
			{
				echo "Fail to {$alert->email}<br />\n";
			}
			echo "Sent to {$alert->email}<br />\n";
		}

		exit;
	}

	function mod_set_rules()
	{
		global $mainframe;

		if(!MEAccess::isAdmin())
		{
			JError::raiseWarning(500, JText::_('You do not have rights to change moderation rules'));
			parent::display();
			return;
		}

		$post = JRequest::get('post');
		$section_id = ResHelper::getCategorySection(JRequest::getInt('category_id'));
		$user_id = JRequest::getInt('user_id');
		$member = JFactory::getUser($user_id);

		$row = JTable::getInstance('Category', 'Res');
		$row->load($section_id);
		$params = new JParameter($row->params);

		//$name = $user_id.'.png';
		//if(!JFolder::exists(JPATH_ROOT.DS.'images'.DS.'userstatus'))
		//{
		//	JFolder::create(JPATH_ROOT.DS.'images'.DS.'userstatus');
		//}
		//JFile::copy(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'images'.DS.'moderator'.DS.$post['icon'], JPATH_ROOT.DS.'images'.DS.'userstatus'.DS.$name);

		$rules = array('moder_delete_record', 'moder_extend_record',
						'moder_publish_record','moder_edit_record',
						'moder_delete_comment', 'moder_publish_comment',
						'moder_delete_vote', 'moder_delete_comment_vote',
						'moder_edit_fields', 'moder_archive_record', 'moder_uncomment_record' );


		$icons = array();
		if($params->get('moder_icons')) $icons = unserialize($params->get('moder_icons'));
		$icons[$user_id] = $post['icon'];
		$params->set('moder_icons', serialize($icons));


		foreach($rules as $rule)
		{
			$ids = explode(',', $params->get($rule));
			if(!in_array($user_id, $ids) && $post[$rule])
			{
				$ids[] = $user_id;
			}
			if(in_array($user_id, $ids) && ($post[$rule] == 0))
			{
				unset($ids[array_search($user_id, $ids)]);
			}
			if(in_array('', $ids)) unset($ids[array_search('', $ids)]);
			if(!is_array($ids)) $ids = array();
			$params->set($rule, implode(',', $ids));

		}

		$row->params = $params->toString();
		$row->store();

		$mainframe->redirect(re64(JRequest::getVar('return')), JText::sprintf('Modearation rules for % are set successfully', $member->get('username')));
	}
	function unarchive($status = 1)
	{
		ResController::archive(1);
	}
	function archive($status = -1)
	{
		Global $mainframe;

		$cuser = & JFactory::getUser();
		if(!$cuser->get('id')) MEAccess::login();

		$db = & JFactory::getDBO();
		$iid = JRequest::getInt('Itemid');

		$params = ResHelper::initListParams(JRequest::getInt('category_id'));
		
		$row =& JTable::getInstance('record','Res');
		$row->load(JRequest::getInt('id'));
		$type_params = ResHelper::getTypeParams($row->type_id);

		if( (MEAccess::isAuthor($row->user_id, $type_params->get('allow_archive') == 1)) || MEAccess::isAdmin() || MEAccess::isPublisher() || MEAccess::isEditor() || MEAccess::isModerator($cuser->get('id'), 'moder_archive_record', $params))
		{
			$row =& JTable::getInstance('record','Res');
			$row->load(JRequest::getInt('id'));
			$row->published = $status;
			$row->store();
			$mainframe->enqueueMessage($status ? JText::_('Article archived successfully') : JText::_('Article unarchived successfully'));
			MEAlerts::publish($row, 1);
		}
		else
		{
			JError::raiseNotice(403, JText::_('Error: You do not have enough rights to archive/unarchive this article'));
		}
		if($redirect = JRequest::getVar('return'))
		{
			$mainframe->redirect(re64($redirect));
			return;
		}
	}
	function comment_unblock()
	{
		ResController::comment_block(0);
	}
	function comment_block($status = 1)
	{
		Global $mainframe;

		$cuser = & JFactory::getUser();
		if(!$cuser->get('id')) MEAccess::login();

		$db = & JFactory::getDBO();
		$iid = JRequest::getInt('Itemid');

		$params = ResHelper::initListParams(JRequest::getInt('category_id'));
		$row =& JTable::getInstance('record','Res');
		$row->load(JRequest::getInt('id'));
		
		$iparams = ResHelper::initArticleParams($row->type_id);

		if(MEAccess::isAdmin() || MEAccess::isPublisher() || MEAccess::isEditor() || 
		MEAccess::isModerator($cuser->get('id'), 'moder_uncomment_record', $params) || (MEAccess::isAuthor($row->user_id, $iparams->get('allow_block_comment') == 1)))
		{
			$tp = new JParameter($row->params);
			if($status)
			{
				$tp->set('comments_access', 3);
				$row->params = $tp->toString();
				$row->store();
			}
			else
			{
				$sql = "SELECT params FROM #__js_res_types WHERE id = $row->type_id";
				$db->setQuery($sql);
				$str = $db->loadResult();

				$op = new JParameter($str);

				$tp->set('comments_access', $op->get('comments_access', 1));
				$row->params = $tp->toString();
				$row->store();
			}
			$mainframe->enqueueMessage($status ? JText::_('Comments are blocked successfully') : JText::_('Comments have been unblocked successfully'));
		}
		else
		{
			JError::raiseNotice(403, JText::_('Error: You do not have enough rights to allow/disallow comments for this article'));
		}
		if($redirect = JRequest::getVar('return'))
		{
			$mainframe->redirect(re64($redirect));
			return;
		}
	}
}

class en__anonymous_class__1234
{
	function toJSONSimple($obj)
	{
		$res = array();
		foreach ($obj as $k => $v)
		{
			$res[] = '"'.$k .'": "' .$v .'"';
		}
		return '{'. implode(', ', $res) .'}';
	}
}
?>