<?php
/**
 * $Id: dbtables.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die('Restricted Access');

class JElementDbtables extends JElement
{
	/**
	* Element name
	*
	* @access	protected
	* @var		string
	*/
	var	$_name = 'Text';

	function fetchElement($name, $value, &$node, $control_name)
	{
		$size = ( $node->attributes('size') ? 'size="'.$node->attributes('size').'"' : '' );
		$class = ( $node->attributes('class') ? 'class="'.$node->attributes('class').'"' : 'class="text_area"' );
        /*
         * Required to avoid a cycle of encoding &
         * html_entity_decode was used in place of htmlspecialchars_decode because
         * htmlspecialchars_decode is not compatible with PHP 4
         */
		$db = & JFactory::getDBO();
		$sql = "SHOW tables";
		$db->setQuery($sql);
		$tables = $db->loadRowList();
		
		foreach ($tables as $table)
		{
			$options[] = JHTML::_('select.option', $table[0], $table[0]);
		}
		
		return JHTML::_( 'select.genericlist', $options, $control_name.'['.$name.'][]', 'style="width:100%" multiple size="20"', 'value', 'text', $value );
		
	}
}