<?php
/**
 * $Id: jscategory.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

class JElementJscategory extends JElement
{
	function fetchElement($name, $value, &$node, $control_name)
	{
		global $mainframe;

		$db			=& JFactory::getDBO();
		$doc 		=& JFactory::getDocument();
		$template 	= $mainframe->getTemplate();
		$fieldName	= $control_name.'['.$name.']';
		$multi    	= $node->attributes( 'multi', 0 );
		$parent    	= (int)$node->attributes( 'parent', 0 );
		$global   	= $node->attributes('global', 1 );
		$emptyValue = $node->attributes('empty', 1 );
		$notFoundMessage = $node->attributes('empty_message', JText::_('There are no created sections yet'));
		
		if(!defined('RES_CATEGORIES_VIEW')){
			if ( !class_exists( 'ResHelper' ) ) {
				require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');
			}
			require_once(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'resource.xajax.php');
			require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
			ResControllerConfig::initialyze();
		}
		
		if(RES_CATEGORIES_VIEW == 'tree'){
			if(!is_array($value)){
				settype($value, 'array');
			}
			return ResHelper::getAjaxTreeCategoryList($parent, $value, $multi, array(), $fieldName);
			
		}else{
			
			include_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'models'.DS.'category.php');
			$cat = new ResModelCategory();
	
			$c = array();
			
			
			if($global)
			{
				if ( $emptyValue )
				{
					$c[] = JHTML::_('select.option', '', '- Select Category -');
				}
				
				$list =  $cat->_getCategoriesList($parent);
				if ( ! $list)
					$list = array();
					
				settype($list, 'array');
				$c = array_merge($c, $list);
			}
			else
			{
				$c = $cat->_getCategoriesList($parent);
				if ( ! $c )
					$c = array();
			}
			
			settype($c, 'array');
	
			if(count($c))
			{
				$multiselect = '';
				count(count($c)) > 20 ? $n = 20 : $n = count($c);		
				if($multi) $multiselect = 'size="'.$n.'" multiple';
				$html = JHTML::_('select.genericlist', $c,
	            "{$control_name}[{$name}]".($multi ? "[]" : null), ' class="inputbox" '.$multiselect, 'value', 'text', $value);
			}
			else
			{
				$html = $notFoundMessage;
			}
	
			return $html;
		}
	}
}
?>