<?php
/**
 * $Id: jsgrouplist.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('JPATH_BASE') or die();

class JElementJSGroupList extends JElement
{

	function fetchElement($name, $value, &$node, $control_name)
	{
		if( !is_array($value) ) {
			$value = array( $value );
		}

		$acl = &JFactory::getACL();
    $gtree = $acl->get_group_children_tree( null, 'USERS', false );
    
    $no_restrictions = JHTML::_('select.option', '-1', JText::_( 'No restrictions' ) );
    $not_registered  = JHTML::_('select.option', 0, JText::_( 'Public' ) );
    
    $gtree = array_merge( array( $no_restrictions, $not_registered ), $gtree );
    
    foreach ( $gtree as $key => $group ) {
    	if ( in_array( $group->value, array( 17, 28, 29, 30 ) ) ) {
    		$gtree[$key] = JHTML::_('select.optgroup', $group->text );
    	}
    }
    
    return JHTML::_('select.genericlist',   $gtree, $control_name.'['.$name.'][]', 'size="11" multiple="multiple"', 'value', 'text', $value );  
    
	}
}

?>