<?php
/**
 * $Id: jsresblockparam.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted Access');

class JElementJSResBlockParam extends JElement
{
	function fetchElement($name, $value, &$node, $control_name)
	{
		$def_access = $node->attributes('def_access');
		$def_order = $node->attributes('def_order');
		$def_activity = $node->attributes('def_activity');
		$def_menu_access = $node->attributes('def_menu_access');
		$def_limit = $node->attributes('def_limit');
		$plugin_name = $node->attributes('plugin_name');

		if (!isset($value[0]) or (trim($value[0])) == '')
		{
			$value[0] = $def_access;
		}
		if (!isset($value[1]))
		{
			$value[1] = $def_limit;
		}
		if (!isset($value[2]))
		{
			$value[2] = $def_order;
		}
		if (!isset($value[3]))
		{
			$value[3] = $def_activity;
		}
		if (!isset($value[4]))
		{
			$value[4] = $def_menu_access;
		}

		$html  = "";
		$html .= "<table>";
		$html .= "<tr>";

		$html .= "<td>";
		$options = array();
		$options[] = JHTML::_('select.option', 'hide', "Hide"  );
		$options[] = JHTML::_('select.option', 'owner', "Owner"  );
		$options[] = JHTML::_('select.option', 'all', "All"  );
		$html .= JHTML::_('select.genericlist',$options , "{$control_name}[{$name}][0]", ' class="inputbox" ', 'value', 'text', $value[0]);
		$html .= "</td>";

		$html .= "<td>";
		$html .= "<input type='text' name='{$control_name}[{$name}][1]' size='3' value='".$value[1]."' />";
		$html .= "</td>";

		$html .= "<td>";
		$options = array();
		$options[] = JHTML::_('select.option', 1, 1 );
		$options[] = JHTML::_('select.option', 2, 2 );
		$options[] = JHTML::_('select.option', 3, 3 );
		$options[] = JHTML::_('select.option', 4, 4 );
		$options[] = JHTML::_('select.option', 5, 5 );
		$options[] = JHTML::_('select.option', 6, 6 );
		$html .= JHTML::_('select.genericlist',$options , "{$control_name}[{$name}][2]", ' class="inputbox" ', 'value', 'text', $value[2]);
		$html .= "</td>";

		$html .= "<td>";
		$options = array();
		$options[] = JHTML::_('select.option', 'yes', "Yes" );
		$options[] = JHTML::_('select.option', 'no', "No" );
		$html .= JHTML::_('select.genericlist',$options , "{$control_name}[{$name}][3]", ' class="inputbox" ', 'value', 'text', $value[3]);
		$html .= "</td>";

		$html .= "<td>";
		$options = array();
		$options[] = JHTML::_('select.option', 'hide', "Hide"  );
		$options[] = JHTML::_('select.option', 'owner', "Owner"  );
		$options[] = JHTML::_('select.option', 'all', "All"  );
		$html .= JHTML::_('select.genericlist',$options , "{$control_name}[{$name}][4]", ' class="inputbox" ', 'value', 'text', $value[4]);
		$html .= "</td>";
		
		//$template = new JS_People_Touch_Resource_Section_Template($plugin_name, @$value[ 5 ]);
		
		//$html .= "<td>";
		//$options = array();
		//$html .= $template->getTemplateHTMLList("{$control_name}[{$name}][5]");
		//$html .= "</td>";

		$html .= "</tr>";
		$html .= "</table>";



		//$html = JHTML::_('select.genericlist', $c, "{$control_name}[{$name}]", ' class="inputbox" ', 'value', 'text', $value);

		return $html;
	}
}
?>