<?php
/**
 * $Id: jsresblockparam3.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted Access');

/**
 * The element that is similar to jsresblockparam3, except it doesn't have
 * the "Show menu" parameter.
 * @author Nurlan
 *
 */
class JElementJSResBlockParam3 extends JElement
{
	var $numItemsInArray = 5;
	
	function fetchElement($name, $value, &$node, $control_name)
	{
		if (!class_exists('JElementMenuItem'))
			require_once(JPATH_ROOT.DS.'libraries'.DS.'joomla'.DS.'html'.DS.'parameter'.DS.'element'.DS.'menuitem.php');
			
		$db = & JFactory::getDBO();
		$db->setQuery('SELECT id, name FROM #__js_res_category WHERE published = 1 AND section_id = 0');

		$categories = $db->loadObjectList();
		$categoriesCount = count($categories);
		
		$def_label = $node->attributes('def_label');
		$def_access = $node->attributes('def_access');
		$def_order = $node->attributes('def_order');
		$def_activity = $node->attributes('def_activity');
		$def_menu_access = $node->attributes('def_menu_access');
		$def_limit = $node->attributes('def_limit');
		$pluginName = $node->attributes('plugin_name');

		$options = array();
		
		$options = array();
		$options[] = JHTML::_('select.option', 'hide', "Hide"  );
		$options[] = JHTML::_('select.option', 'owner', "Owner"  );
		$options[] = JHTML::_('select.option', 'all', "All"  );
				
		ob_start();
		
		$node = new JSimpleXMLElement('dummy');
		$count = 0; $c = 0;
		for ($i = 0; $i < $categoriesCount; $i++) {
			$offset = 1; $c++;
			echo '<fieldset><legend><b>', $categories[ $i ]->name, '</b></legend>';
			echo '<input type="hidden" name="', $control_name, '[', $name, '][', $count++, ']" value="', $categories[ $i ]->id,'" />';
			//echo '<tr><td colspan="2"><b>', $categories[ $i ]->name, '</b></td></tr>';
			echo '<table cellpadding="0" cellspacing="0" width="100%">';
		
			$label = $this->_fetchSectionData($categories[ $i ]->id, $offset++, $value);
			if (empty($label))
				$label = JText::_($def_label) ." " .$categories[ $i ]->name;
			echo '<tr><td>', JText::_('Display Title'),'</td>';
			echo '<td><input type="text" size="30" name="', $control_name, '[', $name, '][', $count++, ']" value="', $label, '" /></td>';
			echo "</tr>";
			
			echo '<tr><td>', JText::_('Show blocks'), '</td><td>';
			echo  JHTML::_('select.genericlist', $options, $control_name.'['.$name.']['.$count++.']', ' class="inputbox" ', 'value', 'text', $this->_fetchSectionData($categories[ $i ]->id, $offset++, $value));
			echo '</td></tr>';
			
			echo '<tr><td>', JText::_('Limit'), '</td><td>';
			echo '<input type="text" name="', $control_name, '[', $name, '][', $count++, ']" size="6" value="', $this->_fetchSectionData($categories[ $i ]->id, $offset++, $value, 5), '" />';
			echo '</td></tr>';
			
			echo '<tr><td>', JText::_('Order'), '</td><td>';
			echo '<input type="text" name="', $control_name, '[', $name, '][', $count++, ']" size="6" value="', $this->_fetchSectionData($categories[ $i ]->id, $offset++, $value, $c), '" />';
			echo '</td></tr>';
		
			/*echo "<tr><td>", JText::_('ItemID'), '</td><td colspan="3">';
			echo JElementMenuItem::fetchElement($count++, $this->_fetchSectionData($categories[ $i ]->id, $offset++, $value), $node, $control_name.'['.$name.']');
			echo '</td></tr>';
			
			$template = new JS_People_Touch_Resource_Section_Template(
				$pluginName, $this->_fetchSectionData($categories[ $i ]->id, $offset++, $value, 'compact')
			);
			
			echo '<tr><td nowrap="1">', JText::_('Template'), '</td><td>';
			echo  $template->getTemplateHTMLList($control_name.'['.$name.']['.$count++.']');
			echo '</td></tr>';*/
			echo '</table></fieldset>';
		}
		

		return ob_get_clean();
	}
	
	/**
	 * Returns the section data from the given one dimensional array
	 *
	 * @param int $id The section id
	 * @param int $offset The offset
	 * @param array $data The original data
	 * 
	 * @return mixed null if no such item.
	 */
	function _fetchSectionData($id, $offset, &$data, $default = 0) {
		if (!is_array($data)) return $default;
		if (!count($data)) return $default;

		$total = count($data);
		$cur = 0;
		while ($cur < $total) {
			if ($data[ $cur ] == $id && isset($data[$cur + $offset]))
			{
				if(!$data[$cur + $offset]) $data[$cur + $offset] = $default;
				return $data[$cur + $offset];
			}
				
			$cur += $this->numItemsInArray;
		}
		
		return null;
	}
}
?>