<?php
/**
 * $Id: zipcodes.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('JPATH_BASE') or die();

/**
 * Renders a countries ZIP codes list
 */

class JElementZipcodes extends JElement
{
	/**
	* Element name
	*
	* @access	protected
	* @var		string
	*/
	function fetchElement($name, $value, &$node, $control_name)
	{
			$db	=& JFactory::getDBO();
			$config =& JFactory::getConfig();	
			$pref = $config->getValue( 'config.dbprefix' );
			$sql = "SHOW TABLES LIKE '{$pref}zip_code_%'";
			$db->setQuery($sql);
			$tables = $db->loadResultArray();
			if (!value) $value = $node->_attributes['default'];
			
			if ($tables){
				foreach ($tables as $key=>$table){
					$country = str_replace("{$pref}zip_code_", null, $table);
					$country_title  = strtoupper($country);
					//$countries[] = JHTML::_('select.option', $country, $country_title);
					if (is_array($value)){
						if (in_array($country, $value)) $checked = "checked='checked'";
						else $checked = null;
					}
					else {
						if ($country == $value)$checked = "checked='checked'";
						else $checked = null;
					}
					$countries .= "<input type='checkbox' name='{$control_name}[{$name}][{$key}]' value='$country' $checked class='inputbox'> $country_title<br>";
					//print_r ($value); exit;
				}
			$size  = count($countries); 	
			return $out = $countries; //$out = JHTML::_('select.genericlist', $countries, "$control_name[$name]", 'class="inputbox" size="'.$size.'" multiple="multiple"', 'value', 'text', $value);
			}
			else return $out = JText::_("You do not have any country zip codes table installed!");
	}
}
?>