<?php
/**
 * $Id: api_.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');
require_once (JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'helpers'.DS.'helper.php');

function jscGetFields( $record_id = 0, $show_anywhere = 0, $intro = false )
{
	global $mainframe;

	$user = & JFactory::getUser();
	$params 	= &$mainframe->getParams();

	$whole = 0;
	if(!$intro) $whole = JRequest::getInt('article', $params->get('item'));

	$query = "SELECT v.id, f.id as fid, v.field_value, v.params as vparams, f.params, f.title, f.type, f.ordering
			FROM #__js_res_record_values as v " .
			' LEFT JOIN #__js_res_fields AS f ON f.id = v.field_id' .
			' WHERE v.record_id = ' . $record_id .
			' AND f.access <= '.$user->get( 'aid', 0 ) .
			( $show_anywhere == 0 ? ($whole > 0 ? ' AND f.show_detail = 1 ' : ' AND f.show_intro = 1 ') : '').
			' AND f.published = 1 ' .
			' ORDER BY f.ordering ASC'
			;
			$fields = $this->_getList($query);
			return $fields;
}

function jscGetFieldValue( $field_id, $record_id)
{
	$db	=& JFactory::getDBO();

	$sql = "
	     SELECT v.`id`,
                f.access,
                f.`type_id`,
                f.`type`,
                f.`params`,
                f.`title`,
                r.user_id AS author_id,
                v.`field_value`,
                v.`params` AS fparams" 
	."\n      FROM #__js_res_fields AS f "
	."\n LEFT JOIN #__js_res_record_values AS v ON v.field_id = f.id"
	."\n LEFT JOIN #__js_res_record        AS r ON r.id = ".$record_id
	."\n     WHERE f.id = ".$field_id." AND f.published > 0 AND v.record_id = ".$record_id
	."\n  GROUP BY f.id "
	."\n  ORDER BY f.ordering ASC ";

	$db->setQuery( $sql );
	$field_for_show = $db->loadObject();
	if( !is_object($field_for_show) ) return false;
	
	$article = & JTable::getInstance('Record', 'Res');
	$article->load($record_id);

	$get = '';
	$dispatcher =& JDispatcher::getInstance();
	JPluginHelper::importPlugin( 'joomsuite_content_fields', $field_for_show->type );
	$dispatcher->trigger( 'onRenderFieldValue', array (&$get, & $field_for_show, &$article, $category) );

	return $get;
}
function jscGetTypeName($id)
{
	$db	=& JFactory::getDBO();
	$query = "SELECT `id`, `name` FROM #__js_res_types WHERE id = $id";
	$db->setQuery($query);
	$res =  $db->loadObject();
	return $res->name;
}
function jscGetSectionId($category_id = 0)
{
	if(!$category_id) $category_id = JRequest::getInt('category_id', ResHelper::getArticleSection(JRequest::getInt('article')));
	if(!$category_id) return false;
	return ResHelper::getCategorySection($category_id);
}

function jscGetSectionParams($section_id)
{
	return ResHelper::getSectionParams($section_id);
}

function jscGetCategories($section_id)
{
	$db	=& JFactory::getDBO();
	$query = "SELECT c.*, count(n.catid) AS nums FROM #__js_res_category AS c" .
	' LEFT JOIN #__js_res_record_category AS n ON n.catid = c.id ' .
	' LEFT JOIN #__js_res_record AS r ON r.id = n.record_id AND r.published = 1' .
	' WHERE parent = ' . (int)$section_id .
	' AND c.published = 1 ' .
	' GROUP BY c.id  ORDER BY ordering'
	;
	$db->setQuery($query);
	$res =  $db->loadObjectList();

	return $res;
}
function jscGetUserCategories($user_id, $section_id)
{
	if(!$user_id) return array();
	$now = ResHelper::getDate();
	$db	=& JFactory::getDBO();
	$user = &JFactory::getUser();
	$where = ' AND c.access <=  '.(int)$user->get('aid');

	$query = "SELECT c.id as value, c.name as text, c.*, count(r.ucatid) AS nums, c.params".
	' FROM #__js_res_category_user AS c' .
	' LEFT JOIN #__js_res_record AS r ON r.ucatid = c.id AND r.published = 1 AND (r.extime = "0000-00-00 00:00:00" OR r.extime > \''.$now.'\') ' .
	' WHERE c.user_id = ' . $user_id .
	' AND c.section_id =  ' . $section_id .
	' AND c.published = 1 ' . $where .
	' GROUP BY c.id ORDER BY c.ordering'
	;

	$db->setQuery($query);
	$res =  $db->loadObjectList();

	return $res;
}
/*function jscGetChildren(&$list, $parent, $params = null, $level = 1, $p = 0)
{
	$db	=& JFactory::getDBO();

	if($p == 0) $list = array();

	$query = "SELECT c.*, count(n.catid) AS nums  FROM #__js_res_category AS c" .

	' LEFT JOIN #__js_res_record_category AS n ON n.catid = c.id ' .
	' WHERE parent = ' . ($p ? $p : $parent) .
	' AND published = 1 ' . //$where .
	'  GROUP BY c.id ORDER BY ordering'
	;
	$db->setQuery($query);
	$res =  $db->loadObjectList();

	$list[($p ? $p : $parent)] = $res;
	$level++;
	foreach ($data AS $dat)
	{
		$this->getChildren($list, $parent, $params, $level, $dat->id);
	}
	return $list;
}*/
?>