<?php
/**
 * $Id: list.php 7857 2012-02-23 08:19:09Z kostya $
 * $LastChangedDate: 2012-02-23 14:19:09 +0600 (Thu, 23 Feb 2012) $
 * $LastChangedBy: kostya $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.model');
class ResModelList extends JModel
{
	var $_id = null;
	var $_filters = array();
	var $_data = array();
	var $_udata = null;
	var $_fworn = array();
	var $_tdata = null;
	var $_total = null;
	var $_utotal = null;
	var $_category = null;
	var $_pagination = null;
	var $_ext_filters = null;
	var $_upagination = null;
	var $_categories = array();
	var $_pcategories = array();
	var $_children = array();
	var $_fields = array();
	var $_rss = array();
	var $_params = null;
	var $_types = 0;
	var $_type = 0;
	var $select_key = 0;
	var $_isSearch = false;
	var $_isTags = false;
	var $_now;
	var $_isCategoey = false;

	//felix code
	var $_user_subscriptions = array();

	//felix code end

	function __construct()
	{
		parent::__construct();
		global $mainframe;

		$config = JFactory::getConfig();
		$itemid = JRequest::getInt('Itemid');

		$this->setState('limitstart', JRequest::getVar('limitstart', 0, '', 'int'));

		$id = JRequest::getVar('id', 0, '', 'int');
		$this->setId((int) $id);
		$this->_now = ResHelper::getDate();
	}


	function canRate($id, &$params, $user_id)
	{
		static $out = array();

		$user = &JFactory::getUser();
		$key = $id . $user->get('id');

		if(array_key_exists($key, $out)) return $out[$key];

		$out[$key] = true;

		if($params->get('rating_access') > $user->get('aid'))
		{
			$out[$key] = false;
		}
		if(MEAccess::isAuthor($user_id))
		{
			$out[$key] = false;
		}
		if($user->get('id') && JRequest::getVar("user_rate_{$id}_" . $user->get('id'), 0, 'COOKIE', 'INT'))
		{
			$out[$key] = false;
		}

		$ses = & JFactory::getSession();
		if($ses->get("user_rate_{$id}"))
		{
			$out[$key] = false;
		}
		if(JRequest::getVar('option') != 'com_resource')
		{
			$out[$key] = false;
		}

		if($out[$key] == false) return $out[$key];


		if($user->get('id'))
		{
			$sql = "SELECT id as total FROM #__js_res_vote WHERE record_id = {$id}  and user_id = " . $user->get('id');
		}
		else
		{
			$sql = "SELECT id as total FROM #__js_res_vote WHERE record_id = {$id}  and `ip` = '" . $_SERVER['REMOTE_ADDR'] . "'";
		}

		$db = & JFactory::getDBO();
		$db->setQuery($sql);
		$res = $db->loadResult();

		if($res) $out[$key] = false;

		return $out[$key];
	}

	function getTypeName($id)
	{
		if(! $id)
		{
			JError::raiseWarning(501, JText::_('Submission Type not set in section parameters'));
			return;
		}
		static $data = array();

		if(@! $data[$id])
		{
			$query = "SELECT `id`, `name` FROM #__js_res_types WHERE id = " . (int) $id;
			$this->_db->setQuery($query);
			$data[$id] = $this->_db->loadObject();
		}
		return $data[$id]->name;
	}

	function getType($id)
	{
		if(! $id)
		{
			JError::raiseWarning(501, JText::_('Submission Type not set in section parameters'));
			return;
		}
		static $data = array();

		if(@! $data[$id])
		{
			$query = "SELECT * FROM #__js_res_types WHERE id = " . (int) $id;
			$this->_db->setQuery($query);
			$data[$id] = $this->_db->loadObject();
		}
		return $data[$id];
	}

	/**
	 * This function is used only in one place. When send alert
	 * on add new record. We get field names
	 *
	 * @param int $id of the field
	 * @return string field name
	 */
	function getFieldName($id)
	{
		static $data = array();

		if(@! $data[$id])
		{
			$query = "SELECT `id`, `title` FROM #__js_res_fields WHERE id = " . (int) $id;
			$this->_db->setQuery($query);
			$data[$id] = $this->_db->loadObject();
		}
		return $data[$id]->title;
	}

	function setId($id)
	{
		$this->_id = $id;
		$this->_category = null;
	}

	/*
	 function setLimit(&$params)
	 {
		$num = ($params->get('leading') + $params->get('blog_intro') + $params->get('blog_links'));
		global $mainframe;
		$itemid = JRequest::getInt('Itemid');
		//echo 'com_resource.limit.'.$itemid;


		$this->setState('limit', $mainframe->getUserStateFromRequest('com_resource.limit.'.$itemid.$params->get('tmpl_list'), 'limit', $num, 'int'));
		}
		*/

	function setParams($params)
	{
		$this->_params = $params;
	}

	function getData($catid)
	{
		$query = $this->_buildQuery($catid);
		if(empty($this->_data[md5($query)]))
		{
//			echo str_replace( '#__', 'jos_', $query );
//			var_dump($query);
			$result = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit')); //$params->get('limit'));

			$this->_data[md5($query)] = $result;
		}
//		var_dump($result);exit;

		return $this->_data[md5($query)];
	}

/*	function getTotal($catid = 0)
	{
		if(empty($this->_total))
		{
			$query = "SELECT count(record_id) FROM #__js_res_tmp2 WHERE skey = '{$this->select_key}'";
			$this->_db->setQuery($query);
			$this->_total = $this->_db->loadResult();
			if(!$this->_total){
				$query = "SELECT count(record_id) FROM #__js_res_tmp1 WHERE skey = '{$this->select_key}'";
				$this->_db->setQuery($query);

				$this->_total = $this->_db->loadResult();
			}
		}

		//		echo $this->_total.'-';


		return $this->_total;
	}*/

	function getTotal($catid = 0)
	{
		// Lets load the content if it doesn't already exist
		//LEFT JOIN jos_js_res_cache AS ch ON ch.ref_id = r.id AND ch.`key` = '82f1c57355b51e5e485435beba1cc90f'

		Static $query;

		if (empty($this->_total))
		{
			$query = $this->_buildQuery($catid, FALSE);
			$query = preg_replace('/LEFT JOIN #__js_res_cache AS ch ON ch.ref_id = r\.id AND ch\.\`key\` = \'(.*)\'/iU', '', $query);
			$this->_total = $this->_getListCount($query);
		}

		if (empty($this->_types))
		{
			if(!$query)
			{
				$query = $this->_buildQuery($catid, FALSE);
			}

			$tp = str_replace('SELECT r.id', 'SELECT r.type_id', $query);
			$tp = "SELECT DISTINCT id from #__js_res_types WHERE id IN({$tp});";

			//echo str_replace( '#__', 'jos_', $tp );

			//$tp = $query.' GROUP BY r.type_id';
			//echo '<br>'.$tp;

			$types = $this->_getList($tp);
			$this->_types = count($types);
			if(@$types[0]) $this->_type = $types[0]->id;
		}

		return $this->_total;
	}

	function getPagination($catid, $total)
	{
		// Lets load the content if it doesn't already exist
		if(empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$url = &JFactory::getURI();
			$url->delVar('filter_reset');
			$this->_pagination = new JPagination($total, $this->getState('limitstart'), $this->getState('limit'));
		}
/*		if($this->select_key){
			$db = &JFactory::getDBO();
			$sql5 = "DELETE FROM #__js_res_tmp1 where skey = '{$this->select_key}'";
			$db->setQuery($sql5);
			$db->query();

			$sql6 = "DELETE FROM #__js_res_tmp2 where skey = '{$this->select_key}'";
			$db->setQuery($sql6);
			$db->query();
		}*/
		return $this->_pagination;
	}

	function getCategory($id)
	{
		global $mainframe;
		static $data = array();

		if(@$data[$id]) return $data[$id];

		$user = &JFactory::getUser();
		if(! $id)
		{
			$cat = new stdClass();
			$cat->title = '';
			$cat->name = '';
			$cat->image = '';
			$cat->description = '';
			$cat->id = '';
			$cat->parent = '';
			$cat->meta_key = '';
			$cat->meta_descr = '';
			return $cat;
		}

		//$sql = "SELECT * FROM #__js_res_category WHERE id = ".(int)$id;
		//$this->_db->setQuery($sql);
		//$data[$id] = $this->_db->loadObject();
		$data[$id] = ResHelper::getSection($id);

		$category = & $data[$id];

		if(! $category->published)
		{
			JError::raiseError(404, JText::_("Category Not Found"), $id);
			return false;
		}

		if($category->access > $user->get('aid', 0))
		{
			if(! $user->get('id') && $category->access == 1)
			{
				$msg = JText::_('You are not loged in or registered');
				$uri = &JFactory::getURI();
				$link = 'index.php?option=com_user&view=login&Itemid=' . JRequest::getInt('Itemid') . '&return=' . base64_encode($uri->toString());
			}
			else
			{
				if($category->access == 2) $msg = JText::_('Only Publishers or Authors can access this page');
				$parent = ResHelper::getCategorySection($category->id);
				//$link = 'index.php?option=com_resource&view=list&category_id='.$parent.'&Itemid='.MEUrl::itemid(NULL, $parent);
				$link = MEUrl::link_list($parent->id);
			}

			JError::raiseWarning(403, $msg);
			$mainframe->redirect(MERoute::_($link, FALSE));

			return;
		}
		if(JRequest::getVar('view') == 'list')
		{
			$tagPos = JString::strpos($category->description, '<hr id="system-readmore" />');
			$chars = 27;

			if(! $tagPos)
			{
				$chars = 25;
				$tagPos = JString::strpos($category->description, '<hr id="system-readmore">');
			}

			if($tagPos != false)
			{
				$category->description = JString::substr($category->description, ($tagPos + $chars));
			}
		}

		return $data[$id];
	}


	function getAverage($section, $prm)
	{
		static $avg_num_vote = array();
		static $avg_vote = array();

		if($prm->get('rate_bay_ns') == 2)
		{
			$section = ResHelper::getCategorySection($section);
			$sql1 = "SELECT count(*) FROM #__js_res_vote AS v
			LEFT JOIN #__js_res_record AS r ON r.id = v.record_id
			LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id
			LEFT JOIN #__js_res_category AS c ON c.id = rc.catid
			WHERE (c.id = {$section} OR c.section_id = {$section})
			GROUP BY v.record_id;";

			$sql2 = "SELECT AVG(v.vote) FROM #__js_res_vote as v
			LEFT JOIN #__js_res_record AS r ON r.id = v.record_id
			LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id
			LEFT JOIN #__js_res_category AS c ON c.id = rc.catid
			WHERE (c.id = {$section} OR c.section_id = {$section})";
		}
		else
		{
			$sql1 = "SELECT count(*) FROM #__js_res_vote AS v
			LEFT JOIN #__js_res_record AS r ON r.id = v.record_id
			LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id
			WHERE rc.catid = {$section}";

			$sql2 = "SELECT AVG(v.vote) FROM #__js_res_vote as v
			LEFT JOIN #__js_res_record AS r ON r.id = v.record_id
			LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id
			WHERE rc.catid = {$section}";
		}

		if(! @$avg_num_vote[$section])
		{
			$this->_db->setQuery($sql1);
			$result = $this->_db->loadResultArray();
			$avg_num_vote[$section] = array_sum($result) / count($result);
		}
		if(! @$avg_vote[$section])
		{
			$this->_db->setQuery($sql2);
			$avg_vote[$section] = $this->_db->loadResult();
		}

		$out['avg_num_vote'] = $avg_num_vote[$section];
		$out['avg_vote'] = $avg_vote[$section];

		return $out;

	}

	function _whereCoreFilters($catid)
	{
		global $mainframe, $option;

		$where = array();

		if(JRequest::getVar('content_client') == 'module') return array();

		$params = $this->_params;
		$db = JFactory::getDBO();
		$itemid = JRequest::getInt('Itemid');
		$section_id = ResHelper::getCategorySection($catid);
		$document = & JFactory::getDocument();

		switch($params->get('filters_mode', 1))
		{
			case 3:
			case 1:
				$fname_search = "{$option}.content.filter_search{$itemid}{$catid}" . $params->get('url_user_id');
				$fname_alpha = "{$option}.content.filter_alpha{$itemid}{$catid}" . $params->get('url_user_id');
				$fname_tag = "{$option}.content.filter_tag{$itemid}{$catid}" . $params->get('url_user_id');
				$date_name = "{$option}.calendar.date_view{$itemid}{$catid}" . $params->get('tmpl_list') . $params->get('url_user_id');
				$view_name = "{$option}.calendar.cal_view{$itemid}{$catid}" . $params->get('tmpl_list') . $params->get('url_user_id');
				break;
			case 2:
				$fname_search = "{$option}.content.filter_search{$itemid}" . $params->get('url_user_id');
				$fname_alpha = "{$option}.content.filter_alpha{$itemid}" . $params->get('url_user_id');
				$fname_tag = "{$option}.content.filter_tag{$itemid}" . $params->get('url_user_id');
				$date_name = "{$option}.calendar.date_view{$itemid}" . $params->get('tmpl_list') . $params->get('url_user_id');
				$view_name = "{$option}.calendar.cal_view{$itemid}" . $params->get('tmpl_list') . $params->get('url_user_id');
				break;

		}

		if(JRequest::getInt('filter_reset', 0) == 1)
		{
			JRequest::setVar('filter_alpha', JText::_('All'));
			JRequest::setVar('filter_search', '');
			JRequest::setVar('filter_tag', '');
		}


		$filter_alpha = $mainframe->getUserStateFromRequest($fname_alpha, 'filter_alpha', JText::_('All'), 'var');
		$filter_search = $mainframe->getUserStateFromRequest($fname_search, 'filter_search', '', 'var');
		$filter_tag = $mainframe->getUserStateFromRequest($fname_tag, 'filter_tag', 0, 'int');
		$filter_cal = $mainframe->getUserStateFromRequest($date_name, 'cal_date', 0, 'int');

		if(is_object($filter_cal)) $filter_cal = false;
		if(is_object($filter_alpha)) $filter_alpha = false;
		if(is_object($filter_search)) $filter_search = false;
		if(is_object($filter_tag)) $filter_tag = false;

		if($filter_alpha == 1)
		{
			$filter_alpha = false;
			$mainframe->setUserState($fname_alpha, null);
		}
		if($filter_search == 1)
		{
			$filter_search = false;
			$mainframe->setUserState($fname_search, null);
		}
		if($filter_tag == 1)
		{
			$filter_tag = false;
			$mainframe->setUserState($fname_tag, null);
		}
		if($filter_cal == 1)
		{
			$filter_cal = false;
			$mainframe->setUserState($date_name, null);
		}

		if(($filter_cal || (substr($params->get('tmpl_list'), 0, 8) == 'calendar')) /*&& $total*/)
		{
			if(! $filter_cal) $filter_cal = time();
			$cur_view = $mainframe->getUserStateFromRequest($view_name, 'cal_view', $params->get('tpl_cal_view', 3), 'int');
			switch($cur_view)
			{
				case 1:
					$start = mktime(0, 0, 0, date('n', $filter_cal), date('d', $filter_cal), date('Y', $filter_cal));
					$end = mktime(23, 59, 59, date('n', $filter_cal), date('d', $filter_cal), date('Y', $filter_cal));
					break;
				case 2:
					$day_of_week = strftime('%w', $filter_cal);
					if($params->get('tpl_cal_first_day') == 1) $day_of_week --;

					$start = mktime(0, 0, 0, date('n', $filter_cal), (date('d', $filter_cal) - $day_of_week), date('Y', $filter_cal));
					$end = mktime(23, 59, 59, date('n', $filter_cal), (date('d', $filter_cal) - $day_of_week) + 6, date('Y', $filter_cal));
					break;
				case 3:
					$start = mktime(0, 0, 0, date('n', $filter_cal), 1, date('Y', $filter_cal));
					$end = mktime(23, 59, 59, date('n', $filter_cal) + 1, 0, date('Y', $filter_cal));
					break;
				case 4:
					$start = mktime(0, 0, 0, date('n', $filter_cal), 1, date('Y', $filter_cal));
					$end = mktime(23, 59, 59, date('n', $filter_cal) + 2, 0, date('Y', $filter_cal));
					break;
				case 5:
					$start = mktime(0, 0, 0, date('n', $filter_cal), 1, date('Y', $filter_cal));
					$end = mktime(23, 59, 59, date('n', $filter_cal) + 4, 0, date('Y', $filter_cal));
					break;
				case 6:
					$start = mktime(0, 0, 0, date('n', $filter_cal), 1, date('Y', $filter_cal));
					$end = mktime(23, 59, 59, date('n', $filter_cal) + 6, 0, date('Y', $filter_cal));
					break;
				case 7:
					$start = mktime(0, 0, 0, date('n', $filter_cal), 1, date('Y', $filter_cal));
					$end = mktime(23, 59, 59, date('n', $filter_cal) + 3, 0, date('Y', $filter_cal));
					break;
			}
			if($start && $end)
			{
				$start_date = new JDate((int) $start);
				$end_date = new JDate((int) $end);
				$where[] = sprintf("(r.ctime >= '%s' AND r.ctime <= '%s')", $start_date->toMySQL(), $end_date->toMySQL());
			}
		}
		if($filter_alpha && $filter_alpha != JText::_('All'))
		{
			$this->_rss['&filter_alpha'] = urlencode($filter_alpha);
			$this->_fworn['filter_alpha']['name'] = JText::_('Alpha');
			$this->_fworn['filter_alpha']['value'] = JString::strtoupper($filter_alpha);
			$where[] = "r.title LIKE '{$filter_alpha}%'";
		}

		$filter_search = preg_replace("/[\+\=\;\`\~\?\>\<\!\#\$\%\^\*\/\\\]+/i", '', $filter_search);
		if($filter_search != '')
		{
			$swords = explode(' ', $filter_search);
			$wk = 1;
			$sw = array();
			$set = array();

			$joomfish = array();
			$isJoomfishEnabled = JComponentHelper::isEnabled('com_joomfish', true);

			$fsw[] = "fAll.searchable = 1";
			foreach($swords as $word)
			{
				$word = trim($word);
				if(JString::strlen($word) < $params->get('search_length_limit', 3)) continue;
				$word = $db->getEscaped($word);

				$sw[] = "r.title LIKE '%{$word}%'";
				$fsw[] = "vAll.field_value LIKE '%{$word}%'";
				$set[] = $word;
				//$w[] = "fAll.searchable = 1";
				$nw[] = "u.name LIKE '%{$word}%'";
				$unw[] = "u.username LIKE '%{$word}%'";
				$ew[] = "u.email LIKE '%{$word}%'";
				if($isJoomfishEnabled){
					$joomfish[] = "LOWER(jfc.value) LIKE '%{$word}%'";
				}
				if($wk >= $params->get('search_limit', 3)) break;
				$wk ++;
			}
			$mainframe->setUserState($fname_search, implode(' ', $set));


			if(@$set) $mainframe->setUserState($fname_search, implode(" ", $set));
			if(@$sw) $w[] = "(" . implode(" AND ", $sw) . ")";
			if(@$fsw) $w[] = "(" . implode(" AND ", $fsw) . ")";
			if(@$nw) $w[] = "(" . implode(" AND ", $nw) . ")";
			if(@$unw) $w[] = "(" . implode(" AND ", $unw) . ")";
			if(@$ew) $w[] = "(" . implode(" AND ", $ew) . ")";
			if(@$joomfish) $w[] = "(" . implode(" AND ", $joomfish) . ")";

			if(@$w)
			{
				$this->_fworn['filter_search']['name'] = JText::_('Keyword');
				$this->_fworn['filter_search']['value'] = $filter_search;
				$this->_rss['&filter_search'] = urlencode($filter_search);
				$this->_isSearch = true;
				$where[] = "(" . implode(" OR ", $w) . ")";
			}
		}
		if($filter_tag)
		{
			$tagname = $this->tagName($filter_tag);
			$this->_fworn['filter_tag']['name'] = JText::_('Tags');
			$this->_fworn['filter_tag']['value'] = $tagname;
			$this->_rss['&filter_tag'] = urlencode($filter_tag);

			$document->setMetadata('keywords', $tagname . ', ' . $document->getMetadata('keywords'));

			$where[] = "th.section_id = " . $section_id;
			$where[] = "th.tag_id = " . $filter_tag;
			$this->_isTags = true;
		}

		return $where;

	}


	function _buildQuery($catid, $total = TRUE)
	{
		global $mainframe, $option;
		static $out = array();

		//var_dump($total);

		$itemid = JRequest::getInt('Itemid');
		$user = &JFactory::getUser();
		$params = $this->_params;
		$now = ResHelper::getDate();
		$db = & JFactory::getDBO();

//		$this->_buildFirstTable($catid);
//		$this->_buildSecondTable($catid);

		switch ($params->get('filters_mode', 1))
		{
			case 3:
			case 1:
				$fname_order = "filter_order{$itemid}{$catid}".$params->get('url_user_id');
				$fname_order_dir =  "filter_order_dir{$itemid}{$catid}".$params->get('url_user_id');
				break;
			case 2:
				$fname_order = "filter_order{$itemid}".$params->get('url_user_id');
				$fname_order_dir =  "filter_order_dir{$itemid}".$params->get('url_user_id');
				break;
		}
		$filter_order		= $this->getState($fname_order);
		$filter_order_dir	= $this->getState($fname_order_dir);

		$itemid = JRequest::getInt('true_itemid', JRequest::getInt('Itemid'));

		//$fname_order = "filter_order.{$itemid}";
		//$fname_order_dir =  "filter_order_dir.{$itemid}";


		//echo '1'.$filter_order.$filter_order_dir.'1'; exit;

		if(is_object($filter_order) || $filter_order == 'Object' || !$filter_order) $filter_order = 'r.ctime';
		if(is_object($filter_order_dir) || $filter_order_dir == 'Object' || !$filter_order_dir) $filter_order_dir = 'ASC';

		//$filter_order_dir	= $this->getState($fname_order_dir);


		//$filter_order		= JFilterInput::clean($filter_order, 'var');
		//$filter_order_dir	= JFilterInput::clean($filter_order_dir, 'word');
		//echo $params->get('rate_smart');
		//echo $filter_order_dir; exit;
		switch($filter_order)
		{
			case 'random':
				$filter_order = "RAND()";
				break;

			case 'comment':
				$filter_order = "(SELECT count(id) from #__js_res_comments where record_id = r.id)";
				break;

			case 'favorite':
				//$filter_order = "(SELECT count(user_id) from #__js_res_favorite where record_id = r.id)";
				$filter_order = "r.favorite_num";
				break;

			case 'r.hits':
				//$filter_order = "(SELECT count(id) FROM #__js_res_hits WHERE record_id = r.id AND ctime > (NOW() - INTERVAL 1 MONTH))";
				$filter_order = "r.hits";
				break;

			case 'rate':

				$filter_order = "r.votes_result";
				break;


		}

		switch ($params->get('url_view_what'))
		{
			case "favorites":
			case "rated":
			case "commented":
			case "last-visited":
			case "expired":
				$filter_order = 'r.extime';
				break;
		}

		$where = $this->_buildWhere($catid, $total);

		$key = MECache::getKey('record');

		$query = 'SELECT '.($total == true ?
		"r.*, cu.name as user_category, IF((r.extime = '0000-00-00 00:00:00' OR r.extime > '".$now."'), 0, 1) AS expired ".
		($params->get('cache_enable', 0) ? ", ch.content " : NULL) : 'r.id').
		' FROM #__js_res_record AS r ' .
		' LEFT JOIN #__js_res_category_user AS cu ON cu.id = r.ucatid'. //;// .
		($params->get('cache_enable', 0) ? " LEFT JOIN #__js_res_cache AS ch ON ch.ref_id = r.id AND ch.`key` = '" .$key. "' " : NULL).
		' LEFT JOIN #__users AS u ON u.id = r.user_id';


		// sort by additional field
		$match = array();
		if(preg_match("/vo([0-9]+)\.field_value/iU", $filter_order, $match))
		{
			$filter_order = $filter_order. ' + 0 '. $filter_order_dir.', '.$filter_order;
			$query .= ' LEFT JOIN #__js_res_record_values AS vo'.($match[1]).' ON vo'.($match[1]).'.record_id = r.id AND  vo'.($match[1]).'.field_id = '.$match[1];
		}

		$joins = unserialize($params->get('url_join'));
		foreach ($joins as $join) {
			$query .= ' '.$join;
		}

		/*if($params->get('client') != 'module')
		{
			$query .= $this->leftJoinFilters($catid, $params);
		}*/

		if($params->get('featured_first')) $filter_order = "r.featured DESC, ". $filter_order;
		$query .=	$where .($total ? ' ORDER BY ' . $filter_order .' '. $filter_order_dir : NULL);
//var_dump($params->get('url_view_what'),$filter_order);exit;
		//echo  $filter_order .' '. $filter_order_dir;
//		echo str_replace( '#__', 'jos_', $query ).'<br /><br />';
//		exit;

		return $query;
	}
	function leftJoinFilters($catid, $params)
	{
		global $mainframe, $option;
		static $out = array();
		if(@$out[$catid]) return $out[$catid];

		$itemid = JRequest::getInt('Itemid');
		$query = '';

		switch($params->get('filters_mode', 1))
		{
			case 3:
			case 1:
				$fname_search = "{$option}.content.filter_search{$itemid}{$catid}" . $params->get('url_user_id');
				$fname_tag = "{$option}.content.filter_tag{$itemid}{$catid}" . $params->get('url_user_id');
				break;
			case 2:
				$fname_search = "{$option}.content.filter_search{$itemid}" . $params->get('url_user_id');
				$fname_tag = "{$option}.content.filter_tag{$itemid}" . $params->get('url_user_id');
				break;
		}

		$filter_search = $mainframe->getUserStateFromRequest($fname_search, 'filter_search', '', 'var');
		$filter_tag = $mainframe->getUserStateFromRequest($fname_tag, 'filter_tag', '', 'var');
		if(is_object($filter_search)) $filter_search = false;
		if(is_object($filter_tag)) $filter_tag = false;

		/*if($filter_search)
		{
			//$query .= ' LEFT JOIN #__js_res_fields AS fAll ON fAll.id = vAll.field_id ';
			//$query .= " LEFT JOIN #__users AS u ON u.id = r.user_id ";
			if(JComponentHelper::isEnabled('com_joomfish', true)){
				$query .= ' LEFT JOIN #__js_res_record_values AS vAll ON vAll.record_id = r.id ';
				$query .= " LEFT JOIN #__jf_content as jfc ON jfc.reference_id = r.id OR jfc.reference_id = vAll.id ";
			}
		}*/

		if($filter_tag)
		{
			$query .= ' LEFT JOIN #__js_res_tags_history AS th ON th.record_id = r.id ';
		}

		if(JRequest::getVar('content_client') != 'module')
		{
			$filters = $this->getFilters($catid, $params);

			if(is_array($filters))
			{
				foreach($filters as $k => $filter_array)
				{
					$filter = $filter_array['filter'];
					/*if(JRequest::getInt('filter_reset', 0) == 1)
					 {
						JRequest::setVar('filter_'.$filter->id, 1);
						}
						switch ($params->get('filters_mode', 1))
						{
						case 3:
						case 1:
						$fname = "{$option}.content.filter_{$filter->id}{$itemid}{$catid}".$params->get('url_user_id');
						break;
						case 2:
						$fname = "{$option}.content.filter_{$filter->id}{$itemid}".$params->get('url_user_id');
						break;
						}

						${'filter_'.$filter->id} = $this->getFilterState($fname, $filter->id);

						if(is_array(${'filter_'.$filter->id}) && ${'filter_'.$filter->id}[0])*/

					if(is_array($filter->default) && @$filter->default[0])
					{
						$query .= ' LEFT JOIN #__js_res_record_values AS v' . ($filter->id) . ' ON v' . ($filter->id) . '.record_id = r.id AND v' . ($filter->id) . '.field_id = ' . $filter->id;
					}
				}
			}

			if($params->get('filters_ext'))
			{

				$dispatcher = & JDispatcher::getInstance();
				$ext_filters = $this->getExtFilters($catid, $params);

				if(is_array($ext_filters))
				{
					foreach($ext_filters as $ext_filter)
					{
						$fname = '';
						switch($params->get('filters_mode', 1))
						{
							case 3:
							case 1:
								$fname = "{$option}.content.ext_filter_{$ext_filter->id}{$itemid}{$catid}" . $params->get('url_user_id');
								break;
							case 2:
								$fname = "{$option}.content.ext_filter_{$ext_filter->id}{$itemid}" . $params->get('url_user_id');
								break;
						}

						if(JRequest::getInt('filter_reset', 0) == 1)
						{
							JRequest::setVar('ext_filter_' . $ext_filter->id, 1);
						}

						//$extFilterState = $this->getFilterState($fname, $ext_filter->id, true);
						//$ext_filter->default = $extFilterState;


						if(is_array($ext_filter->default) && $ext_filter->default[0])
						{
							JPluginHelper::importPlugin('joomsuite_content', 'filter_' . $ext_filter->type);
							$dispatcher->trigger('onFilterLeftJoin', array(
								&$query, $ext_filter, $params, $catid
							));
						}
					}
				}
			}

		/*
			 //************ Felix code

			 $filters_model = &JModel::getInstance( 'Filters', 'ResModel' );
			 $section = $this->getCategory( ResHelper::getCategorySection( $catid ) );
			 $ext_filter_elements = $filters_model->getFiltersForFiltering( $catid, $section->id );
			 if($ext_filter_elements['left_joines']) $query .= implode( "\n", $ext_filter_elements['left_joines'] );
			 if($ext_filter_elements['wheres']) $where .= ( count( $ext_filter_elements['wheres'] ) ? " AND " : " " ).implode( " AND ", $ext_filter_elements['wheres'] );

			 //************ Felix code end
				*/
		}
		//echo '<br><br>'.$query;
		$out[$catid] = $query;
		return $out[$catid];
	}

	function whereFilters($catid, $params, $total)
	{
		global $mainframe, $option;


		static $out = array();

		if(isset($out[$catid][$total])) return $out[$catid][$total];

		$where = array();
		$db = JFactory::getDBO();
		$itemid = JRequest::getInt('Itemid');
		$section_id = ResHelper::getCategorySection($catid);
		$document = & JFactory::getDocument();

		$dispatcher = & JDispatcher::getInstance();
		JPluginHelper::importPlugin('joomsuite_content_fields');

		switch($params->get('filters_mode', 1))
		{
			case 3:
			case 1:
				$fname_search = "{$option}.content.filter_search{$itemid}{$catid}" . $params->get('url_user_id');
				$fname_alpha = "{$option}.content.filter_alpha{$itemid}{$catid}" . $params->get('url_user_id');
				$fname_tag = "{$option}.content.filter_tag{$itemid}{$catid}" . $params->get('url_user_id');
				$date_name = "{$option}.calendar.date_view{$itemid}{$catid}" . $params->get('tmpl_list') . $params->get('url_user_id');
				$view_name = "{$option}.calendar.cal_view{$itemid}{$catid}" . $params->get('tmpl_list') . $params->get('url_user_id');
				break;
			case 2:
				$fname_search = "{$option}.content.filter_search{$itemid}" . $params->get('url_user_id');
				$fname_alpha = "{$option}.content.filter_alpha{$itemid}" . $params->get('url_user_id');
				$fname_tag = "{$option}.content.filter_tag{$itemid}" . $params->get('url_user_id');
				$date_name = "{$option}.calendar.date_view{$itemid}" . $params->get('tmpl_list') . $params->get('url_user_id');
				$view_name = "{$option}.calendar.cal_view{$itemid}" . $params->get('tmpl_list') . $params->get('url_user_id');
				break;

		}

		if(JRequest::getInt('filter_reset', 0) == 1)
		{
			JRequest::setVar('filter_alpha', JText::_('All'));
			JRequest::setVar('filter_search', '');
			JRequest::setVar('filter_tag', '');
		}
		//echo $date_name;


		if(JRequest::getVar('content_client') != 'module')
		{
			//$filter_alpha = ResHelper::MyState($fname_alpha, JRequest::getVar('filter_alpha'), FALSE);
			$filter_alpha = $mainframe->getUserStateFromRequest($fname_alpha, 'filter_alpha', JText::_('All'), 'var');
			$filter_search = $mainframe->getUserStateFromRequest($fname_search, 'filter_search', '', 'var');
			$filter_tag = $mainframe->getUserStateFromRequest($fname_tag, 'filter_tag', 0, 'int');
			$filter_cal = $mainframe->getUserStateFromRequest($date_name, 'cal_date', 0, 'int');
			//var_dump($filter_cal);
			if(is_object($filter_cal)) $filter_cal = false;
			if(is_object($filter_alpha)) $filter_alpha = false;
			if(is_object($filter_search)) $filter_search = false;
			if(is_object($filter_tag)) $filter_tag = false;
			if($filter_alpha == 1)
			{
				$filter_alpha = false;
				$mainframe->setUserState($fname_alpha, null);
			}
			if($filter_search == 1)
			{
				$filter_search = false;
				$mainframe->setUserState($fname_search, null);
			}
			if($filter_tag == 1)
			{
				$filter_tag = false;
				$mainframe->setUserState($fname_tag, null);
			}
			if($filter_cal == 1)
			{
				$filter_cal = false;
				$mainframe->setUserState($date_name, null);
			}

			//echo $params->get('tmpl_list');
			if(($filter_cal || (substr($params->get('tmpl_list'), 0, 8) == 'calendar')) && $total)
			{
				if(! $filter_cal) $filter_cal = time();
				$cur_view = $mainframe->getUserStateFromRequest($view_name, 'cal_view', $params->get('tpl_cal_view', 3), 'int');
				switch($cur_view)
				{
					case 1:
						$start = mktime(0, 0, 0, date('n', $filter_cal), date('d', $filter_cal), date('Y', $filter_cal));
						$end = mktime(23, 59, 59, date('n', $filter_cal), date('d', $filter_cal), date('Y', $filter_cal));
						break;
					case 2:
						$day_of_week = strftime('%w', $filter_cal);
						if($params->get('tpl_cal_first_day') == 1) $day_of_week --;

						$start = mktime(0, 0, 0, date('n', $filter_cal), (date('d', $filter_cal) - $day_of_week), date('Y', $filter_cal));
						$end = mktime(23, 59, 59, date('n', $filter_cal), (date('d', $filter_cal) - $day_of_week) + 6, date('Y', $filter_cal));
						break;
					case 3:
						$start = mktime(0, 0, 0, date('n', $filter_cal), 1, date('Y', $filter_cal));
						$end = mktime(23, 59, 59, date('n', $filter_cal) + 1, 0, date('Y', $filter_cal));
						break;
					case 4:
						$start = mktime(0, 0, 0, date('n', $filter_cal), 1, date('Y', $filter_cal));
						$end = mktime(23, 59, 59, date('n', $filter_cal) + 2, 0, date('Y', $filter_cal));
						break;
					case 5:
						$start = mktime(0, 0, 0, date('n', $filter_cal), 1, date('Y', $filter_cal));
						$end = mktime(23, 59, 59, date('n', $filter_cal) + 4, 0, date('Y', $filter_cal));
						break;
					case 6:
						$start = mktime(0, 0, 0, date('n', $filter_cal), 1, date('Y', $filter_cal));
						$end = mktime(23, 59, 59, date('n', $filter_cal) + 6, 0, date('Y', $filter_cal));
						break;
					case 7:
						$start = mktime(0, 0, 0, date('n', $filter_cal), 1, date('Y', $filter_cal));
						$end = mktime(23, 59, 59, date('n', $filter_cal) + 3, 0, date('Y', $filter_cal));
						break;
				}
				if($start && $end)
				{
					$start_date = new JDate((int) $start);
					$end_date = new JDate((int) $end);
					$where[] = sprintf("(r.ctime >= '%s' AND r.ctime <= '%s')", $start_date->toMySQL(), $end_date->toMySQL());
				}
			}
			if($filter_alpha && $filter_alpha != JText::_('All'))
			{
				$this->_rss['&filter_alpha'] = urlencode($filter_alpha);
				$this->_fworn['filter_alpha']['name'] = JText::_('Alpha');
				$this->_fworn['filter_alpha']['value'] = JString::strtoupper($filter_alpha);
				$where[] = "r.title LIKE '{$filter_alpha}%'";
			}

			$filter_search = preg_replace("/[\+\=\;\`\~\?\>\<\!\#\$\%\^\*\/\\\]+/i", '', $filter_search);
			if($filter_search != '')
			{
				$swords = explode(' ', $filter_search);
				$wk = 1;
				$sw = array();
				$set = array();

				$joomfish = array();
				$isJoomfishEnabled = JComponentHelper::isEnabled('com_joomfish', true);

				//$fsw[] = "fAll.searchable = 1";
				foreach($swords as $word)
				{
					$word = trim($word);
					if(JString::strlen($word) < $params->get('search_length_limit', 3)) continue;
					$word = $db->getEscaped($word);

					$sw[] = "r.title LIKE '%{$word}%'";
					$fsw[] = "r.fieldsdata LIKE '%{$word}%'";
					$set[] = $word;
					$nw[] = "u.name LIKE '%{$word}%'";
					$unw[] = "u.username LIKE '%{$word}%'";
					$ew[] = "u.email LIKE '%{$word}%'";

					//if($isJoomfishEnabled){
					//	$joomfish[] = "LOWER(jfc.value) LIKE '%{$word}%'";
					//}

					if($wk >= $params->get('search_limit', 3)) break;
					$wk ++;
				}
				$mainframe->setUserState($fname_search, implode(' ', $set));

				$this->_fworn['filter_search']['name'] = JText::_('Keyword');
				$this->_fworn['filter_search']['value'] = $filter_search;
				$this->_rss['&filter_search'] = urlencode($filter_search);

				if(@$set) $mainframe->setUserState($fname_search, implode(" ", $set));
				if(@$sw) $w[] = "(" . implode(" AND ", $sw) . ")";
				if(@$fsw) $w[] = "(" . implode(" AND ", $fsw) . ")";
				if(@$nw) $w[] = "(" . implode(" AND ", $nw) . ")";
				if(@$unw) $w[] = "(" . implode(" AND ", $unw) . ")";
				if(@$ew) $w[] = "(" . implode(" AND ", $ew) . ")";
				if(@$joomfish) $w[] = "(" . implode(" AND ", $joomfish) . ")";
				if(@$w) $where[] = "(" . implode(" OR ", $w) . ")";
			}
			if($filter_tag)
			{
				$tagname = $this->tagName($filter_tag);
				$this->_fworn['filter_tag']['name'] = JText::_('Tags');
				$this->_fworn['filter_tag']['value'] = $tagname;
				$this->_rss['&filter_tag'] = urlencode($filter_tag);

				$document->setMetadata('keywords', $tagname . ', ' . $document->getMetadata('keywords'));

				$where[] = "r.id IN (SELECT record_id FROM #__js_res_tags_history WHERE tag_id = {$filter_tag} AND section_id = {$section_id})";
			}


			$filters = $this->getFilters($catid, $params);


			if(is_array($filters))
			{
				foreach($filters as $filter_array)
				{
					$filter = $filter_array['filter'];

					if(is_array($filter->default) && @$filter->default[0]) //((count(${'filter_'.$filter->id}) > 0) && is_array(${'filter_'.$filter->id}))
					{

						$filter_where = array();
						$fvalues = array();
						$w = 0;
						foreach($filter->default as $key => $fval)
						{
							if(! trim($fval))
							{
								unset($filter->default[$key]);
								continue;
							}
							$sql = NULL;
							$dispatcher->trigger('onFilterWhere', array(
								&$sql, $filter, $filter, $db->getEscaped(stripslashes(base64_decode($fval)))
							));
							if($sql)
							{
								if(substr($sql, 0, 11) == 'field_value')
								{
									$filter_where[] = $sql;
								}
								else
								{
									$where[] = $sql;
								}
							}
							else
							{
								$filter_where[] = "field_value LIKE '%" . $db->getEscaped(stripslashes(base64_decode($fval))) . "%'";
							}

							$w = 1;

							$label = null;
							$dispatcher->trigger('onFilterWornLabel', array(
								&$label, &$filter, stripslashes(base64_decode($fval)), &$params, $catid
							));
							if($label)
							{
								if(is_array($label)) $fvalues = $label;
								else $fvalues[] = $label;
							}
							else
							{
								$exploded = explode("^", base64_decode($fval));
								$fvalues[] = JText::_($exploded[0]);
							}

							$this->_rss["&filter{$filter->id}[]"] = urlencode($fval);
						}

						if($w)
						{
							$this->_fworn['filter_' . $filter->id]['name'] = $filter->title;
							$this->_fworn['filter_' . $filter->id]['value'] = $fvalues;

							if(count($filter_where))
							{
								$where[] = "r.id IN (SELECT record_id FROM #__js_res_record_values WHERE field_id = {$filter->id} AND (" . implode(" OR ", $filter_where) . "))";
							}
						}
					}
				}
			}

			if($params->get('filters_ext'))
			{
				$dispatcher = & JDispatcher::getInstance();
				$ext_filters = $this->getExtFilters($catid, $params);

				if(is_array($ext_filters))
				{
					foreach($ext_filters as $ext_filter)
					{
						if(JRequest::getInt('filter_reset') == 1)
						{
							JRequest::setVar('ext_filter_' . $ext_filter->id, 1);
						}

						switch($params->get('filters_mode', 1))
						{
							case 3:
							case 1:
								$fname = "{$option}.content.ext_filter_{$ext_filter->id}{$itemid}{$catid}" . $params->get('url_user_id');
								break;
							case 2:
								$fname = "{$option}.content.ext_filter_{$ext_filter->id}{$itemid}" . $params->get('url_user_id');
								break;
						}

						//$extFilterState = $this->getFilterState($fname, $ext_filter->id, true);
						//$ext_filter->default = $extFilterState;


						if(is_array($ext_filter->default) && $ext_filter->default[0])
						{
							JPluginHelper::importPlugin('joomsuite_content', 'filter_' . $ext_filter->type);
							$exwhere = array();
							$dispatcher->trigger('onFilterWhere', array(
								&$exwhere, $ext_filter, $params, $catid
							));
							//echo $ext_filter->type;
							if($exwhere)
							{
								$dispatcher->trigger('onFilterWorn', array(
									&$worn, $ext_filter, $params, $catid
								));
								$this->_fworn['ext_filter_' . $ext_filter->id]['name'] = $ext_filter->title;
								$this->_fworn['ext_filter_' . $ext_filter->id]['value'] = $worn;
								foreach($ext_filter->default as $key => $dvalue)
								{
									$this->_rss["&ext_filter{$ext_filter->id}[{$key}]"] = urlencode($dvalue);
								}
								$where = array_merge($where, $exwhere);
							}
						}
					}
				}
			}
		}

		//print($where[0]);
		$out[$catid][$total] = $where;
		return $where;
	}

	function _buildWhere($catid = false, $total)
	{
		global $option, $mainframe;

		static $out = array();
		static $cache = array();

		$params = $this->_params;
		$now = ResHelper::getDate();

		$okey = md5($catid . '-' . $params->get('url_view_what') . '-' . $params->get('url_user_id') . '-' . $params->get('url_where'));
		if(@$out[$okey][(int) $total]) return $out[$okey][(int) $total];

		$where = array();

		//$isAdmin = ($user->get('gid') == 21 || $user->get('gid') == 20 || $user->get('gid') == 23 || $user->get('gid') == 24 || $user->get('gid') == 25);


		$itemid = JRequest::getInt('true_itemid', JRequest::getInt('Itemid'));
		$url_params = &$mainframe->getParams();
		$section = $this->getCategory(ResHelper::getCategorySection($catid));
		$session = & JFactory::getSession();

		$user = & JFactory::getUser();

		if($params->get('lang_mode'))
		{
			jimport('joomla.language.helper');
			$lang = & JFactory::getLanguage();
			$where[] = " r.langs = '" . $lang->getTag() . "' ";
		}

		//		if($option != 'com_resource') 	$params->set('list_clients', 0);
		if($params->get('url_group_id')) $params->set('list_clients', 0);
		if($compare = JRequest::getInt('compare'))
		{
			//$params->set('list_clients', 0);
			$params->set('client', 'module');
			$params->set('url_all', 1);
			$compare_ids = $session->get('compare');
			settype($compare_ids, 'array');
			if(is_array(@$compare_ids[$compare]))
			{
				$ids = implode(',', $compare_ids[$compare]);
				$where[] = "r.id IN ($ids)";
			}
		}

		$viewWhat = $params->get('url_view_what');
		// Handle 'view_what' = related.
		$cmd = JRequest::getInt('child') . JRequest::getInt('parent') . JRequest::getInt('field');
		if($viewWhat == 'related' && JRequest::getInt('field'))
		{
			$params->set('client', 'module');
			$params->set('url_all', 1);

			if(JRequest::getInt('child'))
			{
				$articleId = JRequest::getInt('child');
				$q = 'SELECT rv.field_value, f.type ' . 'FROM #__js_res_record_values rv ' . 'LEFT JOIN #__js_res_fields f ON rv.field_id = f.id ' . 'WHERE record_id = ' . $articleId .
				 ' AND field_id = ' . JRequest::getInt('field');
				$this->_db->setQuery($q, 0, 1);

				$fieldValue = $this->_db->loadObject();

				if($fieldValue->type != 'relate_child3')
				{
					JError::raiseError(404, JText::_('URL is not complete. Related field not found'));
					return;
				}

				if($fieldValue)
				{
					$relatedIds = explode(',', $fieldValue->field_value);
					JArrayHelper::toInteger($relatedIds);
					$cache['relation'][$cmd] = ' r.`id` IN (' . implode(', ', $relatedIds) . ') ';
				}
				else
				{
					// No records exist
					$cache['relation'][$cmd] = ' FALSE ';
				}
			}
			elseif(JRequest::getInt('parent') && JRequest::getInt('field'))
			{
				$articleId = JRequest::getInt('parent');
				$relatedField = & JTable::getInstance('Field', 'Table');

				if($relatedField->load(JRequest::getInt('field')))
				{
					if($relatedField->type != 'relate_parent3')
					{
						JError::raiseError(404, JText::_('URL is not complete. Related field not found'));
						return;
					}

					$relatedField->params = new JParameter($relatedField->params);
					$q = 'SELECT rv.record_id, f.type ' . 'FROM #__js_res_record_values rv ' . 'LEFT JOIN #__js_res_fields f ON rv.field_id = f.id ' . 'WHERE rv.field_value LIKE \'%,' . $articleId .
					 ',%\' AND field_id = ' . $relatedField->params->get('relate_field');

					$this->_db->setQuery($q);
					$relatedIds = $this->_db->loadResultArray(0);

					$relatedIds = array_unique($relatedIds);
					JArrayHelper::toInteger($relatedIds);
					if($relatedIds)
					{
						@$cache['relation'][$cmd] = ' r.`id` IN (' . implode(', ', $relatedIds) . ') ';
					}
					else
					{
						// No records exist
						@$cache['relation'][$cmd] = ' FALSE ';
					}
				}
			}
			// Get where clause from cache
			if(@$cache['relation'][$cmd]) $where[] = $cache['relation'][$cmd];
		}


		if($params->get('list_clients') == 0)
		{
			//if($params->get('url_group_id'))
			$where[] = " r.client_id = '" . $params->get('url_group_id', 0) . "'";


		//$where[] = " r.client = '".addslashes(stripslashes($params->get('url_group_name', 'resource')))."'";
		}
		//else
		//{
		//	if (JRequest::getVar('client_id'))
		///	$where[] = " r.client_id = ".$this->_db->Quote(JRequest::getVar('client_id'));
		//	if (JRequest::getVar('client'))
		//	$where[] = " r.client = ".$this->_db->Quote(JRequest::getVar('client'));
		//}


		//if(JRequest::getInt('user_id') && (JRequest::getVar('option') == 'com_resource'))
		if($params->get('url_user_id'))
		{
			$skip_view_what = array(
				'last-visited', 'favorites', 'rated', 'commented'
			);
			if(! in_array($params->get('url_view_what'), $skip_view_what)) $where['user_id'] = 'r.user_id = ' . $params->get('url_user_id');
		}
		if(! $params->get('show_restrict'))
		{
			$where[] = '(r.access <= ' . $user->get('aid') . ' OR r.user_id = ' . $user->get('id') . ')';
		}

		if(JRequest::getInt('ucid') && $params->get('category_mode') > 1 && ($params->get('url_view_what') == 'created'))
		{
			$where[] = 'r.ucatid = ' . JRequest::getInt('ucid');
		}

		if($params->get('client') != 'module')
		{
			$add = $this->whereFilters($catid, $params, $total);
			if(is_array($add)) $where = array_merge($where, $add);
		}

		if($params->get('url_view_what') == 'hidden')
		{
			$where[] = 'r.hidden = 1';
		}
		else
		{
			$where[] = 'r.hidden = 0';
		}

		if($params->get('url_view_what') == 'expired')
		{
			$where['ex'] = " (r.extime != '0000-00-00 00:00:00' AND r.extime < '{$now}')";
			if(MEAccess::isModerator($user->get('id'), 'moder_extend_record', $params) || MEAccess::isAdmin() || MEAccess::isPublisher() || MEAccess::isEditor())
			{
				unset($where['user_id']);
			}
		}
		else
		{
			if($params->get('show_past_records') == 0) $where['ex'] = " (r.extime = '0000-00-00 00:00:00' OR r.extime > '{$now}') ";
		}
		if($params->get('show_future_records') == 0)
		{
			$where[] = "r.ctime < '{$now}'";
		}

		if($params->get('url_view_what') == 'unpublished')
		{
			$where[] = " r.published = 0 ";
			if(MEAccess::isModerator($user->get('id'), 'moder_publish_record', $params) || MEAccess::isAdmin() || MEAccess::isPublisher() || MEAccess::isEditor())
			{
				$params->set('url_all', 1);
				unset($where['user_id']);
				unset($where['ex']);
			}
		}
		else
		{
			$params->get('menu_archive') ? $where[] = ' r.published = -1 ' : $where[] = ' r.published = 1 ';
		}

		if($params->get('url_user_id'))
		{
			switch($params->get('url_view_what'))
			{
				case "favorites":
					$where[] = 'r.id IN (SELECT record_id FROM #__js_res_favorite WHERE user_id = '.$params->get('url_user_id').' ORDER BY ctime DESC)';
					break;
				case "rated":
					$where[] = 'r.id IN (SELECT record_id FROM #__js_res_vote WHERE user_id = '.$params->get('url_user_id').' ORDER BY ctime DESC)';
					break;
				case "commented":
					$where[] = 'r.id IN (SELECT record_id FROM #__js_res_comments WHERE user_id = '.$params->get('url_user_id').' ORDER BY ctime DESC)';
					break;
				case "last-visited":
					$where[] = 'r.id IN (SELECT record_id FROM #__js_res_hits WHERE user_id = '.$params->get('url_user_id').' ORDER BY ctime DESC)';
					break;
				case 'related':
					// Check the required param:
					if(JRequest::getInt('child_field'))
					{
						if(JRequest::getInt('child_record'))
						{
							$where[] = ' r.id IN (SELECT record_id FROM #__js_res_field_extra WHERE field_value_id = ' . JRequest::getInt('child_record') . ' AND field_id = ' . JRequest::getInt('child_field').')';
						}
						else if(JRequest::getInt('parent_record'))
						{
							$where[] = ' r.id IN (SELECT field_value_id FROM #__js_res_field_extra WHERE record_id = ' . JRequest::getInt('parent_record') . ' AND field_id = ' . JRequest::getInt('child_field').')';
						}
					}
					break;
			}
		}
		$wheres = unserialize($params->get('url_where'));
		foreach($wheres as $aw)
		{
			$where[] = $aw;
		}


		if($catid > 0)
		{
			$use_catid = true;

			if($params->get('url_all') == 1) $use_catid = false;
			if(JRequest::getInt('ucid')) $use_catid = false;
			if($params->get('filters_mode') == 2 && (count($this->_fworn) > 0)) $use_catid = false;
			if($params->get('filters_mode') == 3 && (count($this->_fworn) > 0)) $use_catid = false;
			if($params->get('url_user_id')) $use_catid = false;
			if($params->get('category_mode') == 2) $use_catid = false;

			// DOIT change filter mode
			if($use_catid)
			{
				if($params->get('records_mode') && ! ($params->get('filters_mode') == 1 && (count($this->_fworn) > 0)))
				{
					$ids = ResHelper::getCategoryChildrenIds($catid);
					$where[] = "r.id IN(SELECT record_id FROM #__js_res_record_category WHERE catid  IN ({$ids})) ";
				}
				else
				{
					$where[] = "r.id IN(SELECT record_id FROM #__js_res_record_category WHERE catid = {$catid})";
				}
			}
			else
			{
				if($params->get('filters_mode', 1) == 3 && ($params->get('url_all') != 1))
				{
					$ids = ResHelper::getCategoryChildrenIds($catid);
					$where[] = "r.id IN(SELECT record_id FROM #__js_res_record_category WHERE catid IN ({$ids}))";
					//$where[] = "c.catid IN ({$ids}) ";
				}
				else
				{
					$this->_isCategoey = true;
					$where[] = "r.id IN(SELECT record_id FROM #__js_res_record_category WHERE catid IN (SELECT id FROM #__js_res_category WHERE id = {$section->id} OR section_id = {$section->id}))";
					//$where[] = "(rc.id = {$section->id} OR rc.section_id = {$section->id})";
				}
			}
		}
		//else
		//{
		//	$where[] = 'r.user_id = '.$user->get('id');
		//}



		$where = (count($where) ? ' WHERE ' . implode(' AND ', $where) : '');
		//echo '<br><br>'.$where; exit;
		$out[$okey][(int) $total] = $where;
		return $where;
	}

	function getFilters($category_id, $params = null)
	{
		global $option, $mainframe;

		$okey = $category_id;

		static $filters = array();

		if(array_key_exists($okey, $filters)) return $filters[$okey];

		if(! $params) $params = $this->_params;

		$itemid = JRequest::getInt('Itemid');

		$filters[$okey] = array();

		$user = & JFactory::getUser();
		$section_id = ResHelper::getCategorySection($category_id);
		$ckey = MECache::getKey('filter' . JRequest::getInt('user_id') . JRequest::getInt('client_id') . ($params->get('filters_mode', 1) == 1 ? $category_id : null));


		Switch($params->get('filters_mode', 1))
		{
			case 1:
				$add = " SELECT field_id FROM #__js_res_category_filters WHERE category_id = {$category_id} ";
				break;
			case 2:
				$add = "  SELECT field_id FROM #__js_res_category_filters WHERE category_id IN (SELECT id FROM #__js_res_category WHERE section_id = {$section_id} OR id  = {$section_id}) ";
				break;
			case 3:
				$ids = ResHelper::getCategoryChildrenIds($category_id);
				$add = "  SELECT field_id FROM #__js_res_category_filters WHERE category_id IN ({$ids}) ";
				break;
		}

		$query = "SELECT f.params, f.id, f.title, f.type, f.type_id ".
		($params->get('cache_enable', 0) ? ", ch.content" : NULL)
		." FROM #__js_res_fields AS f
		LEFT JOIN #__js_res_types AS t ON t.id = f.type_id".
		($params->get('cache_enable', 0) ? " LEFT JOIN #__js_res_cache AS ch ON ch.ref_id = f.id AND ch.`key` = '{$ckey}' " : NULL)
		." WHERE t.published = 1
		AND f.published = 1
		AND f.access <= " . (int) $user->get('aid') . "
		AND f.id IN({$add})
		GROUP BY f.id
		ORDER BY f.ordering";

		//echo $query;
		//exit;
		$filter_list = $this->_getList($query);

		$out = array();

		$dispatcher = & JDispatcher::getInstance();
		foreach($filter_list as $key => $filter)
		{
			$get = false;
			$cache = false;

			if(!empty($filter->content))
			{
				$get = unserialize($filter->content);

				$out[$filter->id]['values'] = $get['values'];
				$out[$filter->id]['filter'] = $get['filter'];
				$filter = $get['filter'];
				$filter->content = '';
				$cache = true;
			}

			$filter->title = JText::_($filter->title);

			switch($params->get('filters_mode', 1))
			{
				case 3:
				case 1:
					$fname = "{$option}.content.filter_{$filter->id}{$itemid}{$category_id}" . $params->get('url_user_id');
					break;
				case 2:
					$fname = "{$option}.content.filter_{$filter->id}{$itemid}" . $params->get('url_user_id');
					break;
			}
			if(JRequest::getInt('filter_reset', 0) == 1)
			{
				JRequest::setVar('filter_' . $filter->id, 1);
			}


			$def = $this->getFilterState($fname, $filter->id);
			$filter->default = $def;

			//print_r($def);


			if($cache)
			{
				$out[$filter->id]['filter']->default = $def;
				continue;
			}

			//$get = array();
			$fparams = new JParameter($filter->params);
			if($fparams->get('filter_hide') == 0)
			{
				JPluginHelper::importPlugin('joomsuite_content_fields', $filter->type);
				$dispatcher->trigger('onRenderFilter', array(
					&$get, &$filter, &$params, $category_id
				));
			}
			$out[$filter->id]['values'] = $get;
			$out[$filter->id]['filter'] = $filter;

			if($params->get('cache_enable', 0)) MECache::set($out[$filter->id], $filter->id, $ckey, 'filter', $section_id);
		}
		$filters[$okey] = $out;
		return $out;
	}

	function getFilters_backup($category_id, $params = null)
	{
		global $option, $mainframe;

		$okey = $category_id;

		static $filters = array();

		if(array_key_exists($okey, $filters)) return $filters[$okey];

		if(! $params) $params = $this->_params;

		$itemid = JRequest::getInt('Itemid');

		$ckey = MECache::getKey('filter' . JRequest::getInt('user_id') . JRequest::getInt('client_id') . ($params->get('filters_mode', 1) == 1 ? $category_id : null));
		//$ckey = MECache::getKey('filter'.($params->get('filters_mode',1) == 1 ? $category_id : null));//echo $key;



		//if(empty($filters[$category_id]))
		//{
		$filters[$okey] = array();

		$user = & JFactory::getUser();
		$section_id = ResHelper::getCategorySection($category_id);

		Switch($params->get('filters_mode', 1))
		{
			case 1:
				$add = " AND c.catid = {$category_id}";
				break;
			case 2:
				$add = " AND (c2.id = {$section_id} OR c2.section_id = {$section_id})";
				break;
			case 3:
				$ids = ResHelper::getCategoryChildrenIds($category_id);
				$add = " AND c.catid IN ({$ids}) ";
				break;
		}

		$query = "SELECT f.params, f.id, f.title, f.type, f.type_id, ch.content
		FROM #__js_res_fields as f
		LEFT JOIN #__js_res_types AS t ON t.id = f.type_id
		LEFT JOIN #__js_res_record AS r ON r.type_id = t.id
		LEFT JOIN #__js_res_record_category AS c ON c.record_id = r.id
		LEFT JOIN #__js_res_category AS c2 ON c2.id = c.catid
		LEFT JOIN #__js_res_cache AS ch ON ch.ref_id = f.id AND ch.`key` = '{$ckey}'
		WHERE f.filter = 1
		AND r.published = 1
		AND t.published = 1
		AND f.published = 1
		AND f.access <= " . (int) $user->get('aid') . $add . "
				GROUP BY f.id
				ORDER BY f.ordering";

		$filter_list = $this->_getList($query);

		$out = array();

		$dispatcher = & JDispatcher::getInstance();
		foreach($filter_list as $key => $filter)
		{
			$get = false;
			$cache = false;

			if($filter->content)
			{
				$get = unserialize($filter->content);

				$out[$filter->id]['values'] = $get['values'];
				$out[$filter->id]['filter'] = $get['filter'];
				$filter = $get['filter'];
				$filter->content = '';
				$cache = true;
			}

			$filter->title = JText::_($filter->title);

			switch($params->get('filters_mode', 1))
			{
				case 3:
				case 1:
					$fname = "{$option}.content.filter_{$filter->id}{$itemid}{$category_id}" . $params->get('url_user_id');
					break;
				case 2:
					$fname = "{$option}.content.filter_{$filter->id}{$itemid}" . $params->get('url_user_id');
					break;
			}
			if(JRequest::getInt('filter_reset', 0) == 1)
			{
				JRequest::setVar('filter_' . $filter->id, 1);
			}


			$def = $this->getFilterState($fname, $filter->id);
			$filter->default = $def;

			//print_r($def);


			if($cache)
			{
				$out[$filter->id]['filter']->default = $def;
				continue;
			}

			//$get = array();
			$fparams = new JParameter($filter->params);
			if($fparams->get('filter_hide') == 0)
			{
				JPluginHelper::importPlugin('joomsuite_content_fields', $filter->type);
				$dispatcher->trigger('onRenderFilter', array(
					&$get, &$filter, &$params, $category_id
				));
			}
			$out[$filter->id]['values'] = $get;
			$out[$filter->id]['filter'] = $filter;

			if($params->get('cache_enable', 0)) MECache::set($out[$filter->id], $filter->id, $ckey, 'filter', $section_id);
		}
		$filters[$okey] = $out;
		return $out;
	}

	/**
	 * Renders extended filters.
	 *
	 * @param int $cat_id Category ID
	 * @param JParameter $prm Parameters
	 * @param boolean $noCache ignore cache
	 * @return unknown_type
	 */
	function getExtFilters($cat_id, $prm = null, $cache = false)
	{

		static $flist = array();

		global $option, $mainframe;
		if(! $prm) $prm = $this->_params;
		if($prm->get('cache_enable', 0)) $cache = false;
		$section_id = ResHelper::getCategorySection($cat_id);

		$ckey = MECache::getKey('ext_filter' . ($prm->get('filters_mode', 1) == 1 ? $cat_id : null));

		if(isset($flist[$cat_id]))
		{
			return $flist[$cat_id];
		}

		$itemid = JRequest::getInt('Itemid');

		$query = "SELECT f.* " . ($cache ? ', ch.content' : null) . " FROM  #__js_res_filters AS f " .
		 ($cache ? " LEFT JOIN #__js_res_cache AS ch ON ch.ref_id = f.id AND ch.`key` = '{$ckey}' " : null) . " WHERE f.published = 1 ORDER By f.ordering ASC";

		if(empty($this->_ext_filters))
		{
			//$this->_ext_filters = $this->_getList($query);
		}

		$filters = $this->_getList($query);
		//$this->_ext_filters;

		if(! $filters)
		{
			$flist[$cat_id] = array();
			return;
		}

		$result = array();
		$out = '';

		$dispatcher = & JDispatcher::getInstance();

		foreach($filters as $filter)
		{

			if(@$filter->content)
			{

				$get = unserialize($filter->content);
				$result[$filter->id] = $get;
				$filter->content = '';
				$cache = true;
			}

			switch($prm->get('filters_mode', 1))
			{
				case 3:
				case 1:
					$fname = "{$option}.content.ext_filter_{$filter->id}{$itemid}{$cat_id}" . $prm->get('url_user_id');
					break;
				case 2:
					$fname = "{$option}.content.ext_filter_{$filter->id}{$itemid}" . $prm->get('url_user_id');
					break;
			}

			if(JRequest::getInt('filter_reset', 0) == 1)
			{
				JRequest::setVar('ext_filter_' . $filter->id, 1);
			}

			$def = $this->getFilterState($fname, $filter->id, true);
			$filter->default = $def;

			if($cache)
			{
				$result[$filter->title]->default = $def;
				continue;
			}

			$params = new JParameter($filter->params);

			$filter_cats = $params->get('ext_filter_category', array());
			$filter_cats = (is_array($filter_cats) ? $filter_cats : array(
				$filter_cats
			));

			if(! in_array($cat_id, $filter_cats)) continue;

			$filter->exec_params = $params;

			JPluginHelper::importPlugin('joomsuite_content', 'filter_' . $filter->type);
			$dispatcher->trigger('onFilterRender', array(
				&$out, $filter, $cat_id, $prm
			));

			if($out)
			{
				$filter->result = $out;
				$result[$filter->id] = $filter;
			}
			if($cache) MECache::set($result[$filter->id], $filter->id, $ckey, 'ext_filter', $section_id);
		}
		$flist[$cat_id] = $result;

		return $result;
	}

	function getFilterState($fname, $filter_id, $ext = false)
	{
		global $mainframe;

		if($ext) $ext = 'ext_';

		if(JRequest::getVar($ext . 'filter_' . $filter_id) == 1)
		{
			$mainframe->setUserState($fname, NULL);
			return NULL;
		}

		$new_data = JRequest::getVar($ext . 'filter' . $filter_id, array(), 'REQUEST', 'array');
		//print_r($new_data);
		//print_r( JRequest::getVar('filter16'));


		if(JRequest::getVar('mrfmsb'))
		{
			$mainframe->setUserState($fname, serialize($new_data));
		}
		else
		{
			if(count($new_data) > 0 && $new_data[0])
			{
				$mainframe->setUserState($fname, serialize($new_data));
			}
		}
		$out = $mainframe->getUserState($fname);

		if($out) $out = unserialize($out);

		return $out;
	}

	function getCategoriesList($parent = 0, $params = null, $level = 0)
	{
		static $data = array();
		static $counter = 0;
		$where = '';
		$having = '';
		//if($params->get('subcat_level') > 0 && ($level > $params->get('subcat_level'))) return array();


		if(@$data[$parent]) return $data[$parent];

		if(! $params) $params = $this->_params;

		if($params->get('cat_nums', 0))
		{

			$now = ResHelper::getDate();

			if($params->get('lang_mode'))
			{
				jimport('joomla.language.helper');
				$lang = & JFactory::getLanguage();
				$where = " AND r.langs = '" . $lang->getTag() . "' ";
			}
			if($params->get('show_future_records') == 0)
			{
				$where .= " AND r.ctime < '{$now}' ";
			}
			if($params->get('show_past_records') == 0)
			{
				$where .= " AND (r.extime = '0000-00-00 00:00:00' OR r.extime > '{$now}') ";
			}
			$params->get('menu_archive') ? $where .= ' AND r.published = -1 ' : $where .= ' AND r.published = 1 ';

			if(is_object($params) && $params->get('list_clients') == 0) //JRequest::getVar('client_id'))
			{
				$where .= " AND r.client = '" . addslashes(stripslashes(JRequest::getVar('client', 'resource'))) . "'";
				if(JRequest::getVar('client_id'))
				{
					$where .= " AND r.client_id = '" . JRequest::getVar('client_id') . "'";
				}
			}
			if($level == 0 && $params->get('cat_empty') == 0){
				 $having = " HAVING nums > 0";
			}elseif($level > 0 && $params->get('subcat_empty') == 0){
				 $having = " HAVING nums > 0";
			}

			$query = "SELECT c.*, count(r.id) AS nums, sum(r.hits) as views FROM #__js_res_category AS c
			LEFT JOIN #__js_res_record_category AS n ON n.catid = c.id
			LEFT JOIN #__js_res_record AS r ON r.id = n.record_id
			$where
			WHERE c.parent = {$parent}
			AND c.published = 1
			GROUP BY c.id
			{$having}
			ORDER BY " .
			$params->get('cat_ordering', 'c.ordering ASC');
		}
		else
		{
			$query = "SELECT c.* FROM #__js_res_category AS c WHERE c.parent = {$parent} AND c.published = 1 ORDER BY " . $params->get('cat_ordering', 'c.ordering ASC');
		}
		$list = $this->_getList($query);


		foreach($list as $i => $item)
		{
			if(!$item->id)
			{
				unset($list[$i]);
				continue;
			}

			if($level > 0) $counter ++;
			if($params->get('subcat') == 0) // && $params->get('records_mode') == 0)
			{
				$list[$i]->children = array();
			}
			else
			{
				$list[$i]->children = $this->getCategoriesList($item->id, $params, $level + 1);
			}

			if($params->get('records_mode') == 1)
			{
				$total = @$list[$i]->nums;
				foreach($list[$i]->children as $sc => $child)
				{
					$total += $child->nums;

//					if(($params->get('subcat_empty') == 0 && $child->nums == 0))
//					{
//						unset($list[$i]->children[$sc]);
//					}
				}
				if($params->get('subcat_limit') > 0)
					array_splice($list[$i]->children, $params->get('subcat_limit'));
				$list[$i]->nums = $total;
			}
			if(JRequest::getVar('view') == 'list')
			{
				$tagPos = JString::strpos($list[$i]->description, '<hr id="system-readmore" />');
				$chars = 27;

				if(! $tagPos)
				{
					$chars = 25;
					$tagPos = JString::strpos($list[$i]->description, '<hr id="system-readmore">');
				}

				if($tagPos != false)
				{
					$list[$i]->description = JString::substr($list[$i]->description, 0, $tagPos);
				}
			}

//			if(($params->get('cat_empty') == 0 /*&& $params->get('records_mode') > 1*/ && $list[$i]->nums == 0 && $level == 0))
//			{//var_dump($list[$i]);
//				unset($list[$i]);
//			}
			if($params->get('subcat_level') < ($level + 1))

			{
				$list[$i]->children = array();
			}
		}
		if(! $list) $list = array();
		$data[$parent] = $list;

		return $data[$parent];
	}


	function getPCategories($user_id, $section_id, $params = null, $client_id = 0)
	{
		if(! $user_id && ! $client_id) return array();

		$user = &JFactory::getUser();
		$where = ' AND c.access <=  ' . (int) $user->get('aid');
		$having = '';
		$now = ResHelper::getDate();
		if(is_object($params))
		{
			if($params->get('pcat_empty') == 0)
			{
				//$where .= ' AND n.id IS NOT null ';
				$having = " HAVING nums > 0 ";
			}
		}
		$on = '';
		$on .= " AND r.ctime < '{$now}' ";
		$on .= " AND r.hidden = 0 AND r.user_id = c.user_id";
		$client_id = JRequest::getVar('client_id');
		//$on .= " AND r.client = '".JRequest::getVar('client', 'resource')."'";
		if(JRequest::getVar('client_id'))
		{
			//$on .= " AND r.client_id = '".JRequest::getVar('client_id')."'";
			$where .= " AND c.client_id = '" . $client_id . "'";
			$where .= " AND c.client = '" . addslashes(stripslashes(JRequest::getVar('client', 'resource'))) . "'";
		}
		else
		{
			$where .= " AND c.client_id = 0 AND c.user_id = " . $user_id;
		}
		if(! @$this->_pcategories[$user_id])
		{
			$query = "SELECT c.id as value, c.name as text, c.*, count(r.ucatid) AS nums, sum(r.hits) as views, c.params" .
			' FROM #__js_res_category_user AS c' .
			 ' LEFT JOIN #__js_res_record AS r ON r.ucatid = c.id AND r.published = 1 AND (r.extime = "0000-00-00 00:00:00" OR r.extime > \'' . $now . '\') '
			. $on .(!$client_id ? '' : ' AND r.client_id = '.$client_id )
			. ' WHERE c.section_id =  ' .
			 $section_id . ' AND c.published = 1 ' . $where . ' GROUP BY c.id ' . $having . ' ORDER BY c.ordering';
			$this->_pcategories[$user_id] = $this->_getList($query);
		}
		if(! $this->_pcategories[$user_id]) $this->_pcategories[$user_id] = array();
		//echo count($this->_pcategories[$user_id]);
//		echo $query;
		return $this->_pcategories[$user_id];
	}


	function getFields($record_id = 0, $show_anywhere = 0)
	{
		static $data = array();
		if(! $record_id) return array();

		if(is_array($record_id)){

			global $mainframe;
			$db = &JFactory::getDBO();

			$user = & JFactory::getUser();
			$params = &$mainframe->getParams();

			if(JRequest::getInt('article', $params->get('item')))
			{
				$show = ' AND f.show_detail = 1 ';
			}
			else
			{
				$show = ' AND f.show_intro = 1 ';
			}
			if(JRequest::getInt('compare'))
			{
				$show = ' AND f.show_compare = 1 ';
			}

			$query = "SELECT v.id, v.record_id, f.id as fid, v.field_value, v.params as vparams, f.filter,
			f.params, f.title, f.type, f.ordering, f.type_id
			FROM #__js_res_record_values as v " . ' LEFT JOIN #__js_res_fields AS f ON f.id = v.field_id' . ' WHERE v.record_id IN (' . implode(',',$record_id) . ') AND f.access <= ' . $user->get('aid', 0) .
			 ($show_anywhere == 0 ? $show : '') . ' AND f.published = 1 ' . ' ORDER BY f.ordering ASC';
			 $db->setQuery($query);
			$result = $db->loadObjectList();
			$temp = array();
			foreach ($result as $key => $value) {
				$temp[$value->record_id][] = $value;
			}
			return $temp;
		}
		elseif(! isset($data[$record_id]))
		{
			global $mainframe;

			$user = & JFactory::getUser();
			$params = &$mainframe->getParams();

			if(JRequest::getInt('article', $params->get('item')))
			{
				$show = ' AND f.show_detail = 1 ';
			}
			else
			{
				$show = ' AND f.show_intro = 1 ';
			}
			if(JRequest::getInt('compare'))
			{
				$show = ' AND f.show_compare = 1 ';
			}

			$query = "SELECT v.id, v.record_id, f.id as fid, v.field_value, v.params as vparams, f.filter,
			f.params, f.title, f.type, f.ordering, f.type_id
			FROM #__js_res_record_values as v " . ' LEFT JOIN #__js_res_fields AS f ON f.id = v.field_id' . ' WHERE v.record_id = '.$record_id.' AND f.access <= ' . $user->get('aid', 0) .
			 ($show_anywhere == 0 ? $show : '') . ' AND f.published = 1 ' . ' ORDER BY f.ordering ASC';
			$result = $this->_getList($query);
			//echo $query;
			//print'<pre>';print_r($this->_fields[$record_id]);print'</pre>'; exit;
			//echo $query;
			If(! $result) $result = array();
			$data[$record_id] = $result;
		}
		return $data[$record_id];
	}

	function getFieldValue($field, $user, $table = true)
	{

		if(! $field->field_value) return;
		$params = new JParameter($field->params);

		if(! $table)
		{
			$params->set('show_lable', 0);
			$params->set('show_icon', 0);
			$params->set('tabled', 0);
		}

		$dispatcher = & JDispatcher::getInstance();
		JPluginHelper::importPlugin('joomsuite_content');
		$results = $dispatcher->trigger('onBeforeFieldRender', array(
			& $field, & $user
		));


		if($params->get('break_before') && ! $params->get('tabled') && $table) $out[] = "<br />";
		if($params->get('lable_nowrap')) $wrap = '';
		else $wrap = ' nowrap="nowrap" ';
		$field_title = JText::_($field->title);
		if(($params->get('show_lable') || ($params->get('show_icon') && $params->get('icon'))) && ! $params->get('lable_line'))
		{
			if($params->get('tabled')) $out[] = '<tr valign="top"><td class="js_key" ' . $wrap . '>';
			if($params->get('show_icon') && $params->get('icon')) $out[] = JHTML::image(JURI::root() . 'components/com_resource/images/icons/' . $params->get('icon'), $field_title . 'Icon',
			array(
				'border' => 0, 'align' => 'absmiddle'
			));
			if($params->get('show_lable'))
			{
				if($params->get('lable_tag'))
				{
					$tag = $params->get('lable_tag');
					$class = '';
					if($params->get('lable_class')) $class = ' class="' . $params->get('lable_class') . '"';
					$out[] = "<{$tag}{$class}>{$field_title}</$tag> ";


				}
				else
				{
					$out[] = $field_title;
				}
			}
			if($params->get('tabled')) $out[] = '</td><td>';
		}
		else
		{
			if($params->get('tabled')) $out[] = '<tr><td colspan="2">';
			if($params->get('show_lable'))
			{
				if($params->get('show_icon') && ($params->get('icon') != - 1)) $out[] = JHTML::image(JURI::root() . 'components/com_resource/images/icons/' . $params->get('icon'),
				$field_title . 'Icon', array(
					'border' => 0, 'align' => 'absmiddle'
				));
				if($params->get('lable_tag'))
				{
					$tag = $params->get('lable_tag');
					$class = '';
					if($params->get('lable_class')) $class = ' class="' . $params->get('lable_class') . '"';
					$out[] = "<{$tag}{$class}>{$field_title}</$tag> ";
				}
				else
				{
					$out[] = $field_title;
				}
				if($table) $out[] = '<br>';
			}
		}

		$get = @$field->result;

		if($get)
		{
			if($params->get('field_class'))
			{
				$get = sprintf('<span class="%s">%s</span>', $params->get('field_class'), $get);
			}
			if($get) $out[] = $get;
			else return;
		}
		else
			return;

		if($params->get('break_after') && ! $params->get('tabled') && $table) $out[] = "<br />";
		if($params->get('tabled')) $out[] = '</td></tr>';

		return implode("\n", $out);
	}

	function _fieldKarmaAccess(&$get, $params, $gparams, $author)
	{
		$user = & JFactory::getUser();
		if($params->get('karma_view') == 0) return;
		if($params->get('karma_skip_admin') && MEAccess::isAdmin()) return;
		if($params->get('karma_skip_author') && MEAccess::isAuthor($author)) return;
		if($params->get('karma_skip_moder') && MEAccess::isModerator($user->get('id'), 'moder_edit_record', $gparams)) return;


		if(MECommunityHelper::isEnabled() && $params->get('karma_view'))
		{
			if(! $user->get('id'))
			{
				$get = JHTML::_('message.box', JText::sprintf($params->get('karma_msg_login'), $params->get('karma_view')));
				return;
			}
			MECommunityHelper::loadApi();
			$karma = JSCommunityApi::getUserCarma($user->get('id'));

			if($karma->points < $params->get('karma_view'))
			{
				$get = JHTML::_('message.box', JText::sprintf($params->get('karma_view_msg'), $params->get('karma_view')));
				return;
			}
		}
	}

	function _fieldSubscriptionAccess(&$get, $params, $gparams, $author)
	{
		$user = & JFactory::getUser();

		if($params->get('subscr_skip_admin') && MEAccess::isAdmin()) return;
		if($params->get('subscr_skip_author') && MEAccess::isAuthor($author)) return;
		if($params->get('subscr_skip_moder') && MEAccess::isModerator($user->get('id'), 'moder_edit_record', $gparams)) return;

		$plans = $params->get('view_sp');
		if(is_array($plans)) $plans = implode(",", $plans);

		if($params->get('view_sp') && jscCheckSubscription($params->get('view_sp'), JText::_($params->get('subscr_message_view', 'You can view this field if you have following subscription(s).')),
		$params->get('subscr_iid', JRequest::getInt('Itemid')), false, $params->get('field_view_subscription_count')))
		{
			if($params->get('show_field_if_view_denied_sp'))
			{
				$ids = $params->get('view_sp');
				settype($ids, 'array');
				$get = JHTML::_('message.box',
				JText::_(
				$params->get('subscr_message_view', 'You can view this field if you have following subscription(s).') . ' ' .
				 JHTML::link(JRoute::_('index.php?option=com_jcs&view=jcs&layout=form&id=' . implode(',', $ids) . '&Itemid=' . $params->get('subscr_iid', JRequest::getInt('Itemid'))),
				JText::_('View Subscriptions'))));
			}
			else
			{
				$get = false;
			}

			return 1;
		}
		else
		{
			if($params->get('view_sp')) jscCountLimit($params->get('view_sp'), $params->get('field_view_subscription_count'));
		}

		if($params->get('field_display_sp') && jscCheckSubscription($params->get('field_display_sp'),
		JText::_($params->get('field_display_message', 'You cannot view this field. Subscriptions of author of this record expired.')), $params->get('subscr_iid', JRequest::getInt('Itemid')), false,
		$params->get('field_display_subscription_count'), $author))
		{
			if($params->get('field_display_show_value'))
			{
				$get = JHTML::_('message.box', JText::_($params->get('field_display_message', 'You cannot view this field. Subscriptions of author of this record expired.')));
			}
			else
			{
				$get = false;
			}
			return 1;
		}
		else
		{
			if($params->get('field_display_sp')) jscCountLimit($params->get('field_display_sp'), $params->get('field_display_subscription_count'), $author);
		}
		return FALSE;
	}

	Function _fieldGroupAccess(&$get, $params)
	{

		$user_obj = & JFactory::getUser();
		$denied_groups = $params->get('denied_view', - 1);

		settype($denied_groups, 'array');

		if(in_array($user_obj->gid, $denied_groups))
		{
			//print_r($denied_groups);
			if($params->get('show_label_if_view_denied'))
			{
				$get = JHTML::_('message.box', JText::_($params->get('denied_view_description', 'You are no in appopriate group to view this field')));
				$get = $params->get('denied_view_description');
			}
			else
			{
				$get = false;
				return;
			}
		}
	}

	function getFieldValue2($jsparentrelatefield, $record, $user, $category)
	{
		$db = & JFactory::getDBO();

		static $field_value = array();

		$record_id = $record->id;


		if(! array_key_exists($jsparentrelatefield . '-' . $record_id, $field_value))
		{
			$sql = "SELECT v.`id`, f.id as fid,
				f.access,
				f.filter,
				v.record_id,
				f.`type_id`,
				f.`type`,
				f.`params`,
				f.`title`,
				r.user_id AS author_id,
				v.`field_value`,
				v.`params` AS fparams" . "\n      FROM #__js_res_fields AS f " . "\n LEFT JOIN #__js_res_record_values AS v ON v.field_id = f.id" . "\n LEFT JOIN #__js_res_record        AS r ON r.id = " .
			 $record_id . "\n     WHERE f.id = " . $jsparentrelatefield . " AND f.published > 0 AND v.record_id = " . $record_id . "\n  GROUP BY f.id " . "\n  ORDER BY f.ordering ASC ";
			$db->setQuery($sql);
			$field_for_show = $db->loadObject();
			if(! is_object($field_for_show)) return '';
			$field_value[$jsparentrelatefield . '-' . $record_id] = $field_for_show;
		}
		$field_for_show = $field_value[$jsparentrelatefield . '-' . $record_id];
		$get = '';
		//$field_for_show_params = new JParameter( $field_for_show->params."\n".$field_for_show->fparams);
		//$field_for_show_params->set('show_lable', 0);
		//$field_for_show_params->set('tabled', 0);


		$dispatcher = & JDispatcher::getInstance();
		JPluginHelper::importPlugin('joomsuite_content_fields', $field_for_show->type);
		$dispatcher->trigger('onRenderFieldValue', array(
			&$get, &$field_for_show, &$record, $category
		));

		return $get;
	}

	function countComments($item, $params)
	{
		global $mainframe;

		if($params->get('comments') == 0) return 0;
		if($params->get('comments') == 3)
		{
			$comments = $mainframe->getCfg('absolute_path') . '/components/com_jcomments/jcomments.php';
			if(file_exists($comments))
			{
				require_once ($comments);
				$count = JComments::getCommentsCount($item->id, 'com_resource');
				return $count;
			}
		}

		//global $mainframe;
		$db = & JFactory::getDBO();
		$user = &JFactory::getUser();
		//$params = ResHelper::initArticleParams($item->type_id);


		$sql = "SELECT COUNT(*) FROM #__js_res_comments WHERE record_id = {$item->id} AND published = 1 AND `access` <= " . (int) $user->get('aid');
		$db->setQuery($sql);
		$article = $db->loadResult();
		return $article;
	}

	function countFavorite($id)
	{
		$db = & JFactory::getDBO();
		$user = &JFactory::getUser();

		$sql = "SELECT COUNT(*) FROM #__js_res_favorite WHERE record_id = $id";
		$db->setQuery($sql);
		$article = $db->loadResult();
		//echo $article;
		return $article;
	}

	function _getCategoryRoutePath($id, $limit = 8, $separator = '/')
	{
		static $out = array();
		static $check = 0;

		if(@$out[$id . $limit . $separator]) return $out[$id . $limit . $separator];

		/*if($check == 0)
		 {
			$iid1 = JRequest::getInt('Itemid');
			$iid2 = MEUrl::itemid(null, $id);

			if($iid1 != $iid2)
			{
			return;
			}
			$check = 1;
			}*/

		$ctable = '#__js_res_category';
		$parent = 'parent';
		$type = 'name';
		if(RES_SEF_ALIASES == 1) $type = 'alias';

		if(! $id) return array();

		$leftJoines = array();
		if($limit > 1)
		{
			$ifs = "CONCAT(";
			$ife = ", CONCAT( c0.id, '-', REPLACE( c0.{$type}, '/', '-' )))";

			for($i = 1; $i < $limit; $i ++)
			{

				$leftJoines[] = "\n LEFT JOIN `" . $ctable . "` as `c" . $i . "` ON c" . $i . ".id = c" . ($i - 1) . "." . $parent;

				if($i <= $limit - 2)
				{
					$ifs .= "\n if( c" . $i . ".id, CONCAT(";
					$ife = "\n , CONCAT(  REPLACE( c{$i}.{$type}, '/', '-' ), '{$separator}' ) ), '' )" . $ife;
				}
				else
				{
					$ifs .= "\n if( c" . $i . ".id, ";
					$ife = "\n CONCAT( REPLACE( c{$i}.{$type}, '/', '-' ), '{$separator}' ),'')" . $ife;
				}

			}
			$if = $ifs . $ife;
		}
		else
		{
			$if = "CONCAT( c0.id, '-', REPLACE( c0.{$type}, '/', '-' ))";
		}

		$query = "SELECT " . $if . " AS path" . "\n  FROM " . $ctable . " as c0" . implode($leftJoines) . "\n WHERE c0.id = " . (int) $id;

		$this->_db->setQuery($query);
		$out[$id . $limit . $separator] = $this->_db->loadResult();
		return $out[$id . $limit . $separator];
	}

	function _getFieldTitle($fid)
	{
		static $out = array();
		if($out[$fid]) return $out[$fid];

		$query = ' SELECT title FROM #__js_res_fields WHERE id = ' . $fid;
		$this->_db->setQuery($query);
		$out[$fid] = $this->_db->loadResult();

		return $out[$fid];
	}

	function getFieldIdByValueId($id)
	{
		static $out = array();
		if(@$out[$id]) return $out[$id];

		$db = & Jfactory::getDBO();
		$query = ' SELECT field_id as id FROM #__js_res_record_values WHERE id = ' . $id;
		$db->setQuery($query);
		$out[$id] = $db->loadResult();

		return $out[$id];
	}

	function tagName($id)
	{
		static $tags = array();

		if(@$tags[$id]) return $tags[$id];

		$db = & JFactory::getDBO();
		$sql = "SELECT t.id, t.tag  FROM #__js_res_tags AS t WHERE t.id = {$id}";
		$db->setQuery($sql);
		$res = $db->loadObject();
		$tags[$id] = $res->tag;
		return $tags[$id];
	}

	function getTemplateName($tpl)
	{
		$xmlFile = new JSimpleXML();

		$file = JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'views' . DS . 'list' . DS . 'tmpl' . DS . 'default_subtmpl_' . $tpl . '.xml';

		if(! $xmlFile->loadFile($file))
		{
			return;
		}

		//$this->_option = $xmlFile->document->_attributes['option'];
		foreach($xmlFile->document->_children as $child)
		{
			if($child->_name == 'name') return $child->_data;
		}
	}
}

?>