<?php
/**
 * $Id: resource.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.utilities.mail');
jimport('joomla.utilities.date');
jimport('joomla.utilities.utility');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
jimport('joomla.html.pane');
jimport('joomla.mail.helper');
jimport('joomla.filter.output');
jimport('joomla.language.helper');
jimport('joomla.database.table');

//echo JRequest::getVar('task'); exit();
JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models');
JModel::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'models');
JModel::addIncludePath(JPATH_COMPONENT_SITE.DS.'models');
JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables');
JHTML::addIncludePath(JPATH_COMPONENT.DS.'library'.DS.'php'.DS.'html');

require_once (JPATH_ROOT.DS.'administrator'.DS.'includes'.DS.'toolbar.php');
require_once (JPATH_COMPONENT_SITE.DS.'helpers'.DS.'helper.php');
if ( !class_exists( 'ResHelper' ) ) {
	require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');
	//require_once (JPATH_COMPONENT_ADMINISTRATOR.DS.'library'.DS.'helper.php');
}
require_once(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'helpers'.DS.'record.php');
require_once (JPATH_ADMINISTRATOR.DS.'includes'.DS.'toolbar.php');
require_once (JPATH_COMPONENT.DS.'api.php');
require_once (JPATH_COMPONENT.DS.'controller.php');
require_once (JPATH_COMPONENT_SITE.DS.'library'.DS.'php'.DS.'jsfilemanager.php');
require_once (JPATH_COMPONENT_ADMINISTRATOR.DS.'controllers'.DS.'config.php');
ResControllerConfig::initialyze();

cleanURI();

$document = &JFactory::getDocument();
$document->addStyleSheet( JURI::root().'components/com_resource/library/css/style.css' );
$document->addScript( JURI::root().'components/com_resource/library/js/script.js' );
$document->addScript( JURI::root().'components/com_resource/library/js/felixrating.js' );

if($controller = JRequest::getWord('controller')) {
	$path = JPATH_COMPONENT.DS.'controllers'.DS.$controller.'.php';
	if (file_exists($path)) {
		require_once $path;
	} else {
		$controller = '';
	}
}

$classname	= 'ResController'.ucfirst($controller);
$controller = new $classname( );

include_once('resource.xajax.php');

$controller->execute(JRequest::getCmd('task'));

$controller->redirect();
?>
<?php if (RES_GENERAL_COPYRIGHT) :?>
<br />
<center><span class="small">Powered by <a
	href="http://www.mightyextensions.com/joomla-components/resources-cck-custom-content-types"
	target="_blank">Resources</a></span></center>
<br />
<?php endif; ?>