<?php
/**
 * $Id: resource.xajax.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );
switch (JRequest::getVar('task')) {
	case 'download':
	case 'show_picture':
	case 'show_video':
	case 'download_attachment':
	case 'mp3':
		return;
		break;
}
if(JRequest::getWord('view') == 'captcha') return;
if(JRequest::getInt('gavick_template') > 0) return;
if(JRequest::getInt('download') == 1) return;
if(JRequest::getString('type') == 'xml') return;
if(JRequest::getString('option') != 'com_resource'){
	if(JRequest::getString('option') != 'com_jcs') return;
}

if( !class_exists( 'JS_SAFE_xajaxresponse' ) ) {
	require_once( JPATH_ROOT.DS.'media'.DS.'mightyextensions'.DS.'xajax'.DS.'xajaxAIO.inc.php'  );
}
function jsrLoadComment($id) {
	global $mainframe;

	$objResponse = new JS_SAFE_xajaxResponse();

	$session = & JFactory::getSession();
	$user	 = & JFactory::getUser();
	$category->id = JRequest::getInt('category_id');

	$comment = & JTable::getInstance('Comments', 'Res');
	$comment->load($id);

	$session->set('unforld_comment_'.$comment->id, 1);
	setcookie("unforld_comment_{$comment->id}", 1, 86400 * 365);

	$article = & JTable::getInstance('Record', 'Res');
	$article->load($comment->record_id);

	$params = ResHelper::initArticleParams($article->type_id, $article->params);
	$url_params = &$mainframe->getParams();
	$params->merge($url_params);

	JRequest::setVar('article', $comment->record_id);

	$model = & JModel::getInstance('Article', 'ResModel');
	$comment = $model->getComments($params, $category, 0, $comment->id);
	$comment = @$comment[0];

	$that = new stdClass();
	
	$that->params = $params;
	$that->user   = $user;

	ob_start();
	$GLOBALS['comment'] = $comment;
	include_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'article'.DS.'tmpl'.DS.'default_comments_'.$params->get('tmpl_comment').'.php';
	$content = trim(ob_get_contents());
	ob_end_clean();

	eregi('<script language=\"javascript\">(.*)<\/script>', $content, $matches);
	eregi_replace('<script language=\"javascript\">(.*)<\/script>', '', $content);

	//preg_match('<div id="63_child">(.*)</div>');
	$script = trim($matches[1]);
	//if($script)	$objResponse->alert($script);
	//preg_match("/<script language=\"javascript\">(.*)<\/script>/iU", $content, $matches);
	//return $objResponse;

	$objResponse->assign("load_comment_{$id}", 'innerHTML', $content);

	if($script)
	{
		//$objResponse->script("alert('123');");
		$objResponse->script("{$script}");
		//$objResponse->script("alert('123');");
	}
	return $objResponse;
}

function jsHit($article_id)
{
	$objResponse = new JS_SAFE_xajaxResponse();
	$model = JModel::getInstance('article', 'ResModel');
	JRequest::setVar('article', $article_id);
	$model->hit();
	return $objResponse;
}
function jsCompare($article)
{
	$objResponse = new JS_SAFE_xajaxResponse();

	$session = &JFactory::getSession();
	$db = & JFactory::getDBO();

	$compares = $session->get('compare');
	settype($compares, 'array');

	JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models');
	$model = & JModel::getInstance('Article', 'ResModel');
	$model->_id = $article;
	$article = $model->getRecord();
	
	$section_id = ResHelper::getArticleSection($article->id);
	$params = ResHelper::initArticleParams($article->type_id);

	if(!is_array(@$compares[$article->type_id])) $compares[$article->type_id] = array();
	
	$query = "SELECT template FROM #__templates_menu WHERE client_id='0' AND menuid='0'";
	$db->setQuery( $query );
	$template = $db->loadResult();
	
	if(in_array($article->id, $compares[$article->type_id]))
	{
		$icon = MRRecordHelper::button($template, 'compare0.png', JText::_('Add to compare'), array('id' => 'compare'.$article->id), true);
		unset($compares[$article->type_id][$article->id]);
	}
	else
	{
		$icon = MRRecordHelper::button($template, 'compare1.png', JText::_('Delete from compare'), array('id' => 'compare'.$article->id), true);
		$compares[$article->type_id][$article->id] = $article->id;
	}
	if(!is_array($compares[$article->type_id])) $compares[$article->type_id] = array();
	
	$number = count($compares[$article->type_id]);
	
	if($number > $params->get('item_compare'))
	{
		$objResponse->alert(JText::_('You reached maximum number of records you can compare. Please delete other records before add new one.'));
		return $objResponse;
	}
	
	$objResponse->assign("type_compare_{$article->type_id}", 'innerHTML', $number);
	$objResponse->assign("compare{$article->id}", 'src', $icon);

	$session->set('compare', $compares);

	return $objResponse;
}
function jsFavorite($article, $user)
{
	$objResponse = new JS_SAFE_xajaxResponse();

	JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models');
	$model = & JModel::getInstance('Article', 'ResModel');
	$model->_id = $article;
	$article = $model->getRecord();
	$db = & JFactory::getDBO();

	$query = "SELECT template FROM #__templates_menu WHERE client_id='0' AND menuid='0'";
	$db->setQuery( $query );
	$template = $db->loadResult();

	$section_id = ResHelper::getArticleSection($article->id);
	$params = ResHelper::initListParams($section_id);
	$iparams = ResHelper::initArticleParams($article->type_id, '');
	$params->merge($iparams);

	$sql = "SELECT COUNT(*) AS total FROM #__js_res_favorite WHERE record_id = {$article->id} AND user_id = $user";
	$db->setQuery($sql);
	$res = $db->loadResult();

	$k1 = 0; $k2 = 0;
	if($res)
	{
		$icon = MRRecordHelper::button($template, 'favorite0.png', JText::_('Add to favorites'), array('id' => 'favorite'.$article->id), true);

		$sql = "UPDATE #__js_res_record SET favorite_num = favorite_num - 1 WHERE id = {$article->id}";
		$db->setQuery($sql);
		$db->query();

		$sql = "DELETE FROM #__js_res_favorite WHERE record_id = {$article->id} AND user_id = $user";
		$objResponse->assign("favorite{$article->id}", 'src', $icon);
		$text = JText::_('Article have been deleted from your favorites');
		$k1 -= $params->get('karma_add_fav');
		$k2 -= $params->get('karma_added_fav');
	}
	else
	{
		$icon = MRRecordHelper::button($template, 'favorite1.png', JText::_('Delete from favorites'), array('id' => 'favorite'.$article->id), true);
		
		$sql = "UPDATE #__js_res_record SET favorite_num = favorite_num + 1 WHERE id = {$article->id}";
		$db->setQuery($sql);
		$db->query();
		$now = ResHelper::getDate();

		$sql = "INSERT INTO #__js_res_favorite VALUES ({$user}, {$article->id}, '{$now}')";
		$objResponse->assign("favorite{$article->id}", 'src', $icon);
		$text = JText::_('Article have been added to your favorites');
		if($params->get('activity_add_favorite'))
		{
			$link = MEUrl::link_record($article, JRequest::getInt('category_id'));
			$link = JURI::root().MERoute::_($link, FALSE);
	
			$param['icon'] = $params->get('activity_icon_favorite');
			$param['user_id'] = $user;
			$param['type'] = JText::_('Favorited').' '. $model->getTypeName($article->type_id);
			$param['text'] = JText::_($params->get('activity_text_favorite'));
			$param['text'] .= sprintf(' <a href="%s">%s</a>', $link, $article->title);
	
			//ResHelper::regActivity($param);
			MECommunityHelper::registerActivity($param, JRequest::getInt('client_id'));
		}
		MEAlerts::favorite($article, $params);
		$k1 += $params->get('karma_add_fav');
		$k2 += $params->get('karma_added_fav');
	}
	$db->setQuery($sql);
	$db->query();

	
	MECommunityHelper::increasKarma($user, $k1);
	MECommunityHelper::increasKarma($article->user_id, $k2);

	$link = MEUrl::link_record($article, JRequest::getInt('category_id'));
	$link = MERoute::_($link);

	
	//$objResponse->alert($text);

	//$objResponse->script("listAdmin();");
	return $objResponse;
}
function jsrRateComment($mode, $comment)
{
	global $mainframe;

	$objResponse = new JS_SAFE_xajaxResponse();
	$db = JFactory::getDBO();
	$session = & JFactory::getSession();
	$user = & JFactory::getUser();

	if($session->get('user_rate_comment_'.$comment) || isset($_COOKIE["user_rate_comment_{$comment}"]) )
	{
		$objResponse->alert(JText::_('You already Voted'));
		$objResponse->assign("comment_rate_{$comment}", 'InnerHTML', '');
		return $objResponse;
	}

	$comment_o = & JTable::getInstance('Comments', 'Res');
	$comment_o->load($comment);

	if($comment_o->user_id && ($comment_o->user_id == $user->get('id')))
	{
		$objResponse->alert(JText::_('You cannot vote your own comment'));
		$objResponse->assign("comment_rate_{$comment}", 'InnerHTML', '');
		return $objResponse;
	}

	$article = & JTable::getInstance('Record', 'Res');
	$article->load($comment_o->record_id);

	$params = ResHelper::initArticleParams($article->type_id, $article->params);

	$url_params = &$mainframe->getParams();
	$params->merge($url_params);

	$session->set('user_rate_comment_'.$comment, 1);
	setcookie("user_rate_comment_{$comment}", 1, 86400 * 365);

	$sql = "UPDATE #__js_res_comments SET rate = rate {$mode} 1 WHERE id = $comment";
	$db->setQuery($sql);
	$db->query();

	$objResponse->assign("comment_rate_{$comment}", 'innerHTML', JText::_('Voted'));

	$sql = "SELECT user_id, rate FROM #__js_res_comments WHERE id = {$comment}";
	$db->setQuery($sql);
	$res = $db->loadObject();

	MECommunityHelper::increasKarma($user->get('id'), $params->get('karma_add_rate_com'), $params->get('karma_add_rate_com'));
	$k = 0;
	if($mode == '+') $k += $params->get('karma_added_rate_com'); else $k -= $params->get('karma_added_rate_com');
	MECommunityHelper::increasKarma($comment_o->user_id, $k);

	//$objResponse->alert(JText::_('You Voted'));
	//return $objResponse;
	// automatically unpublish comment if it gets to low rating
	if($params->get('comments_rate_delete') && (($params->get('comments_rate_delete') + $res->rate) <= 0))
	{
		$sql = "UPDATE #__js_res_comments SET published = 0 WHERE id = $comment";
		$db->setQuery($sql);
		$db->query();
	}

	MEAlerts::comment_rate($comment_o, $article, $params, $user, $mode);
	MEAlerts::comment_vote_admin($comment_o, $article, $params, $mode);

	$objResponse->assign("comment_rate_num_{$comment}", 'innerHTML', $res->rate);

	return $objResponse;
}
function jsRate($vote, $article)
{
	$objResponse = new JS_SAFE_xajaxResponse();

	if(!(int)$vote || !$article)
	{
		$objResponse->alert(JText::_('Please, select the vote'));
		return $objResponse;
	}

	JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models');
	$lmodel = & JModel::getInstance('List', 'ResModel');
	$model = & JModel::getInstance('Article', 'ResModel');
	$model->_id = $article;
	$article = $model->getRecord();
	$section_id = ResHelper::getArticleSection($article->id);
	$params = ResHelper::initListParams($section_id);
	$iparams = ResHelper::initArticleParams($article->type_id);
	$params->merge($iparams);
	$now = ResHelper::getDate();

	$user = JFactory::getUser();
	$user = @$user->get('id');

	$db = JFactory::getDBO();

	$sql = "INSERT INTO #__js_res_vote VALUES (NULL, '{$user}', '{$article->id}', '$vote', '{$now}', '{$_SERVER['REMOTE_ADDR']}')";
	$db->setQuery($sql);
	$db->query();

	$insertid = $db->insertid();

	switch ($params->get('rate_smart'))
	{
		case 2:
			$votes = $lmodel->getAverage($section_id, $params);
			$sql = "SELECT COUNT(*) AS total, ((".$votes['avg_num_vote']." * ".$votes['avg_vote'].") + (COUNT(vote) * AVG(vote))) / (".$votes['avg_num_vote']." + COUNT(vote)) AS rating FROM #__js_res_vote WHERE  record_id = {$article->id} GROUP BY record_id";
			break;
		case 3:
			$sql = 	"SELECT COUNT(*) AS total, if(count(id) >= ".$params->get('rate_smart_minimum').", sum(vote) / count(id), 0) AS rating FROM ".
								"#__js_res_vote WHERE record_id = {$article->id} AND ctime > '{$now}' - INTERVAL ".$params->get('rate_smart_before')." DAY GROUP BY record_id";
			break;
		default:
			$sql = 	"SELECT COUNT(*) AS total, SUM(vote) / COUNT(*) AS rating FROM ".
								"#__js_res_vote WHERE record_id = {$article->id} GROUP BY record_id";
			break;
	}
	$db->setQuery($sql);
	$rating = $db->loadObject();

	$sql = "UPDATE #__js_res_record SET votes_result = ".(int)$rating->rating.",  votes = ".(int)$rating->total."  WHERE id = {$article->id}";
	$db->setQuery($sql);
	$db->query();

	$text = JText::_('Accepted')." {$vote}%";

	$objResponse->assign("rtr_{$article->id}", 'innerHTML', $text);

	$session = & JFactory::getSession();
	$session->set('user_rate_'.$article->id, 1);

	setcookie("user_rate_{$article->id}_{$user}", 1, 86400 * 365);
	
	if(MECommunityHelper::isEnabled()){

		MECommunityHelper::increasKarma($user, $params->get('karma_add_rate'));
		if($params->get('karma_added_rate'))
		{
			$rates = explode("\n", $params->get('karma_added_rate'));
			foreach($rates AS $rate)
			{
				$values = explode("::", $rate);
				$rate_vals[$values[0]] = (int)$values[1];
			}
			$value = 0;
			for($i = 1; $i <= 10; $i++)
			{
				if(@$rate_vals[$i * 10]) $value = @$rate_vals[$i * 10];
				$result[$i * 10] = $value;
			}
			$karma = round($vote / 10) * 10;
			$karma = @$result[$karma];
			MECommunityHelper::increasKarma($article->user_id, $karma, $params->get('karma_added_rate'));
		}
	}
	$link = MEUrl::link_record($article, JRequest::getInt('category_id'));
	$link = JURI::root().MERoute::_($link, FALSE);

	if(MECommunityHelper::isEnabled() && $params->get('activity_add_rate') && $user)
	{
		$param['icon'] = $params->get('activity_icon_rate');
		$param['user_id'] = $user;
		$param['type'] = JText::_('Rated').' '. $model->getTypeName($article->type_id);
		$param['text'] = JText::_($params->get('activity_text_rate'));
		$param['text'] .= sprintf(' (%s of 100) <a href="%s">%s</a>', $vote, $link, $article->title);

		MECommunityHelper::registerActivity($param, JRequest::getInt('client_id'));
	}

	MEAlerts::rating($article, $link, $vote, $params);
	MEAlerts::rating_admin($article, $link, $vote, $params, $insertid);

	return $objResponse;
}


/**
 * Removes media file from the RES_GENERAL_UPLOAD directory.
 * The path is chosen according to the file extension, and the
 * id of current user.
 * @deprecated
 */
function jcRemoveMediaFile($filename, $recordId, $prefix) {
	require_once JPATH_ADMINISTRATOR.'/components/com_resource/tables/record_values.php';
	require_once JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php';

	$enDebug = false;

	$user = & JFactory::getUser();
	$userId = $user->get('id');

	ResControllerConfig::initialyze ();
	JTable::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_resource/tables/');

	$objResponse = new JS_SAFE_xajaxResponse();
	$objResponse->setReturnValue(false);
	$enDebug && $objResponse->alert($filename.' - '. $prefix);

	$record = & JTable::getInstance('Record', 'Res');
	$record->set('id', $recordId);

	if ($record->load()) {
		$userId = $record->get('user_id');
	}
	$enDebug && $objResponse->alert('userid - '. $userId);

	// Now, check, if we have our file
	// Delete the file, if it is already uploaded.
	$ext = JString::strtolower(JFile::getExt($filename));
	if ($ext == 'jpeg')
	$ext = 'jpg';

	$fileToDelete = RES_GENERAL_UPLOAD.DS.$userId.DS.$ext.DS.$filename;
	$enDebug && $objResponse->alert('File to delete: '.$fileToDelete);

	// entodo: remove debug stuff;
	if (JFile::exists($fileToDelete)) {
		$enDebug && $objResponse->alert('File to delete exists');
		JFile::delete($fileToDelete);
	}

	// Good.. now, delete that '<tr>' on the page!
	$guid = substr($prefix, 0, strlen($prefix) - 1);
	$trId = $prefix.$filename;
	$command = 'MediaHelper'.$guid.'.onSuccess("'.$trId.'");';
	$enDebug && $objResponse->alert($command);
	$objResponse->script($command);

	$objResponse->setReturnValue(true);
	return $objResponse;
}

function jsCallPlugin( $plugin_group, $plugin_name, $plugin_function, $params )
{
	if (JString::strpos(JString::strtolower($plugin_function), 'xajax') === false)
	return;

	$dispatcher =& JDispatcher::getInstance();

	JPluginHelper::importPlugin( $plugin_group, $plugin_name );

	$objResponse = new JS_SAFE_xajaxResponse();

	array_unshift( $params, 1 );

	$params[0] = & $objResponse;

	$dispatcher->trigger( $plugin_function, $params );

	return $objResponse;
}

function jsSearchTags($search)
{
	$db = & Jfactory::getDBO();

	$search = JFilterOutput::cleanText($search);

	$objResponse = new JS_SAFE_xajaxResponse();

	if(!$search || JString::strlen($search) < 3)
	{
		$objResponse->script("var now = new Date(); ajaxCalled = false;	lastCall = now.getTime();");
		$objResponse->assign("tag_image", 'src', JURI::root()."components/com_resource/images/tag-icon.png");
		$objResponse->assign("search_tags_result", 'innerHTML', '<i>'.JText::_('No tags found').'</i>');
		return $objResponse;
	}

	$search = $db->getEscaped($search);
	$sql = "SELECT tag FROM #__js_res_tags WHERE tag LIKE '%{$search}%' LIMIT 20";
	$db->setQuery($sql);
	$list = $db->loadObjectList();

	$tag_list = array(); $i = 3000;
	JHTML::addIncludePath(JPATH_COMPONENT.DS.'library'.DS.'php'.DS.'html');
	foreach ($list as $tag) {
		$tag_list[] = JHTML::_('tags.tag2', $tag->tag, $i++);
	}
	if(!$tag_list) $tag_list[] = '<i>'.JText::_('No tags found').'</i>';

	$objResponse->assign("search_tags_result", 'innerHTML', implode(" ", $tag_list));
	$objResponse->assign("tag_image", 'src', JURI::root()."components/com_resource/images/tag-icon.png");
	$objResponse->script("ajaxCalled = false;	lastCall = now.getTime();");
	//$objResponse->alert($sql);
	return $objResponse;
}

function jsAddTag($id, $tags)
{
	$db = & Jfactory::getDBO();
	$user = & JFactory::getUser();
	$now = ResHelper::getDate();
	
	$objResponse = new JS_SAFE_xajaxResponse();

	$tags = explode(",", $tags);
	$insert = array();
	$section_id = ResHelper::getArticleSection($id);
	
	$model = & JModel::getInstance('Article', 'ResModel');
	$article = $model->getArticle($id);
	$params = ResHelper::initArticleParams($article->type_id);
	
	foreach ($tags AS $tag)
	{
		$tag = trim($tag);
		$tag = JFilterOutput::cleanText($tag);

		if(JString::strlen($tag) < 1) continue;
		

		$sql = "SELECT id FROM #__js_res_tags WHERE LOWER(`tag`) = '".JString::strtolower($tag)."'";
		$db->setQuery($sql);
		$tid = $db->loadResult();

		if(!$tid)
		{
			$slug = aliasConverter(JString::strtolower($tag));
			$slug = JString::strtolower(JString::str_ireplace(Array(" ", "--"), "-", $slug));
			$sql = "INSERT INTO #__js_res_tags VALUES(NULL, '$tag', '{$now}', '$slug')";
			$db->setQuery($sql);
			$db->query($sql);
			$tid = $db->insertid();
		}

		$sql = "SELECT id FROM #__js_res_tags_history WHERE tag_id = {$tid} AND record_id = {$id}";
		$db->setQuery($sql);
		$rtid = $db->loadResult();

		if(!$rtid)
		{
			$sql = "INSERT INTO #__js_res_tags_history VALUES (NULL, {$id}, {$tid}, ".(int)$user->get('id').", '{$now}', {$section_id}, 0)";
			$db->setQuery($sql);
			$db->query($sql);

			$link = MEUrl::link_list($section_id, array());
			$link .= '&filter_tag='.$tid;
			$link = MERoute::_($link);

			$tag .= ' (1)';
			$insert[] = JHTML::link($link, $tag);
			
			if(!MEAccess::isAuthor($article->user_id, $params->get('alert_tags')))
			{
				$body = JText::_('User [USER] added tags ([TAGS]) for your [TYPE]');
				$body = str_replace('[USER]', $user->get('username', JText::_('Anonymous')), $body);
				$body = str_replace('[TAGS]', implode(", ", @$insert), $body);
				
				MEAlerts::custom($id, 'Tag(s) Added', $body, null, array('email_field' => 1));
			}
		}
	}
	
	MECache::delete($id, 'record');


	$objResponse->append("new_tags".$id, 'innerHTML', ', '.implode(", ", @$insert));
	$objResponse->assign("load_image".$id, 'style.display', "none");
	//$objResponse->alert($tags);
	return $objResponse;
}
/*
function jsrEditField($field, $element, $record, $category)
{
	$objResponse = new JS_SAFE_xajaxResponse();
	$db = & JFactory::getDBO();

	$params = ResHelper::initListParams($category);

	//$objResponse->alert($params);
	//return $objResponse;

	$sql = " SELECT f.access, f.`id`, ".$record." AS record_id, v.id AS vid, f.`type_id`, f.`type`, f.`params`, f.`title`, v.`field_value`, v.`params` AS fparams
			 FROM #__js_res_fields AS f
		LEFT JOIN #__js_res_record_values AS v ON v.field_id = f.id AND v.record_id = " . $record .
		  " WHERE f.id = " . $field;
			" AND v.record_id = ".$record;
	$db->setQuery($sql);
	$object = $db->loadObject();

	include_once (JPATH_COMPONENT_ADMINISTRATOR . DS . 'views' . DS . 'record' . DS . 'view.html.php');
	ResViewRecord::renderField2($object, $out, $params);

	if($out)
	{
		$objResponse->assign("jip_image_".$element, 'style.display', "none");
		//$html  = '<form action="#" id="form_'.$element.'" name="form_'.$element.'">';
		$html .= $out;
		$html .= '<br><input type="button" class="button" value="'.JText::_('Save').'" onclick="mrEditFieldSave('.$field.', '.$element.', '.$record.')" />';
		//$html .= '</form>';
	}
	else
	{
		$article = & JTable::getInstance('Record', 'Res');
		$article->load($record);
		$html = MightyResourcesApi::getFieldValue($object, $article, $category, 1);
		$html = JHTML::_('message.box', JText::_('Could not load form')).'<br />'.$html;
	}
	//	$script = "
	//var insert = document.getElementById('jip_{$element}');
	//insert.innerHTML = '{$html}';
	//	";

	//$objResponse->alert($script);
	//$objResponse->script($script);
	$objResponse->assign("jip_".$element, 'innerHTML', $html);
	return $objResponse;
}
function jsrEditFieldSave($data, $field, $element, $record)
{
	$objResponse = new JS_SAFE_xajaxResponse();


	$db = & JFactory::getDBO();
	$sql = " SELECT f.access, f.`id`, ".$record." AS record_id, v.id AS vid, f.`type_id`, f.`type`, f.`params`, f.`title`, v.`field_value`, v.`params` AS fparams
			 FROM #__js_res_fields AS f
		LEFT JOIN #__js_res_record_values AS v ON v.field_id = f.id AND v.record_id = " . $record .
		  " WHERE f.id = " . $field;
			" AND v.record_id = ".$record;
	$db->setQuery($sql);
	$object = $db->loadObject();

	$article = & JTable::getInstance('Record', 'Res');
	$article->load($record);

	$html = MightyResourcesApi::getFieldValue($object, $article, $category, 1);
	$objResponse->alert(print_r($data, TRUE));
	//return $objResponse;


	//$objResponse->alert(print_r($data, TRUE));
	$objResponse->assign("jip_".$element, 'innerHTML', $html);
	$objResponse->assign("jip_image_".$element, 'style.display', "inline");
	//$objResponse->alert(print_r($data, TRUE));
	return $objResponse;
}*/


function jsrGetRelatedRecords($search, $fieldId, $articleId, $categoryId, $options = false, $callback = false) 
{
	$responce = new JS_SAFE_xajaxResponse();
	
	$listModel = &JModel::getInstance('List','ResModel');
	$section = null;
	$category = null;
	$catParams = null;

	if ($categoryId)
	{
		$section  = $listModel->getCategory(ResHelper::getCategorySection($categoryId));
		$category = $listModel->getCategory($categoryId);
		$catParams = ResHelper::initListParams($categoryId);
	}
	
	
	$field = & JTable::getInstance('Field', 'Table');
	if ( ! $field->load($fieldId)) {
		$responce->alert(JText::_('Cannot find field. Please check menu link parameters'));
		return $responce;
	}
	
	$field->params = new JParameter($field->params);
	
	$filterCategories = JRequest::getVar('filter_categories', array(), 'default', 'array');
	
	$lists = array();
	$lists['limitstart'] = isset($options['limitstart']) ? $options['limitstart'] : 0;
	$lists['limit'] 	= isset($options['limit']) ? $options['limit'] : 20;
	$lists['category'] 	= isset($options['category']) ? $options['category'] : $categoryId;
	
	$db = &JFactory::getDBO();
	if($field->type == 'relate_parent3'){
		$sql = "SELECT record_id FROM #__js_res_record_values WHERE field_value LIKE '%,{$articleId},%' AND field_id = ".$field->params->get('relate_field');
		$db->setQuery($sql);
		$selected = $db->loadResultArray();
	}else{
		$sql = "SELECT field_value FROM #__js_res_record_values WHERE record_id = {$articleId} AND field_id = ".$field->id;
		$db->setQuery($sql);
		$selected = explode(',', $db->loadResult());
	}
	
	
	$model = & JModel::getInstance('Utility', 'ResModel');
	$model->setState('what', 		'related');
	$model->setState('id', 			$fieldId);
	$model->setState('record_id', 	$articleId);
	$model->setState('search', 		$search);
	$model->setState('category', 	$lists['category']);
	$model->setState('limit', 		$lists['limit']);
	$model->setState('limitstart', 	$lists['limitstart']);
	
	
	$records = $model->getData();
	$pagination = $model->getPagination();
	
	if (empty($records))
		$records = array();
	
	$canSelectMultipleArticles = false;
	if ($field->params->get('multi_parented', 1) && $field->type == 'relate_child3'
		||
		$field->type == 'relate_parent3'
	) {
		$canSelectMultipleArticles = true;
	}
	
	$k = 0;
	$i = 0;
	ob_start();
	?>
	<?php if ( ! count($records)) : ?>
		<?php echo JText::_('No items'); ?>
	<?php endif; ?>
	<table class="joomlatable">
		<tbody id="maintable">
			<?php foreach ($records as $rec) : ?>
			<tr class="row<?php echo $k; $k = 1 - $k; $i++; ?>">
				<td>
					<?php if ($canSelectMultipleArticles) : ?>
					<input type="checkbox" name="toAdd[]" class="inputbox" id="ctrl_<?php echo $i; ?>" <?php echo (in_array($rec->id, $selected) ? 'checked="checked"' : '');?> value="<?php echo $rec->id; ?>" title="<?php echo htmlspecialchars($rec->title, ENT_QUOTES, 'UTF-8'); ?>" />
					<?php else: ?>
					<input type="radio" name="toAdd[]" class="inputbox" id="ctrl_<?php echo $i; ?>" <?php echo (in_array($rec->id, $selected) ? 'checked="checked"' : '');?> value="<?php echo $rec->id; ?>" title="<?php echo htmlspecialchars($rec->title, ENT_QUOTES, 'UTF-8'); ?>" />
					<?php endif; ?>
				</td>
				<td>
					<label for="ctrl_<?php echo $i; ?>">
					<?php echo htmlspecialchars($rec->title, ENT_QUOTES, 'UTF-8'); ?>
					</label>
				</td>
			</tr>
			<?php endforeach; ?>
		</tbody>
	</table>
	<?php
	$html = ob_get_clean();
	
	$responce->assign('maintable_outer', 'innerHTML', $html);
	$responce->assign('pagination_outer', 'innerHTML', $pagination->getListFooter());
	
	if ($callback)
		$responce->script($callback.'();');
	
	return $responce;
}

function jsGetCategoryList($catid = 0, $multiple, $disabled, $name){
	$responce = new JS_SAFE_xajaxResponse();
	
	if(!is_integer($catid)){
		$parts = explode('_', $catid);
		$id = $parts[1];
	}else{
		$id = $catid;
	}
	$db = JFactory::getDBO();
	
	$sql = "select c.id AS value, c.name as text, count(c1.id)  as leaf 
				FROM #__js_res_category as c
				LEFT JOIN #__js_res_category as c1 on c1.parent = c.id WHERE c.parent = $id AND c.published = 1 GROUP BY c.id";
	$db->setQuery($sql);
	$res = $db->loadObjectList();
	
	$node = array();
	$amount = count($res);
	$i = 0;
	foreach ($res as $key => $r) {
		$i++;
		$node[] = '<li id="catid_'.$r->value.'" class="Node '.($i == $amount ? ' IsLast ' : ''). (!$r->leaf ? ' ExpandLeaf ' : ' ExpandClosed ').' ">
					    <div id="catid_'.$r->value.'_control" class="Expand" '.(!$r->leaf ? '' : 'onclick="my_load($(\'catid_'.$r->value.'\'));"').'></div>
					    <div class="Content">'.
						(empty($disabled) || in_array($r->value, $disabled) ? '<input id="input'.$r->value.'" type="'.($multiple ? 'checkbox' : 'radio').'" name="'.$name.'" value="'.$r->value.'" ' : '').
						(empty($disabled) || in_array($r->value, $disabled) ? '<label for="input'.$r->value.'" ':'<span ').(!$r->leaf ? '' : 'ondblclick="my_load($(\'catid_'.$r->value.'\'));"').'>'.$r->text.
						(empty($disabled) || in_array($r->value, $disabled) ? '</label> ' : '</span>').
						'</div><ul id="catid_'.$r->value.'_container" class="Container">
					    </ul>
				    </li>';
	}
	if($amount){
		$responce->assign($catid.'_container', 'innerHTML', implode($node));
	}else{
		$responce->append($catid, 'className', ' ExpandLeaf');
	}
	$responce->replace($catid, 'className', 'ExpandClosed', 'ExpandOpen');
	$responce->replace($catid.'_control', 'className', 'ExpandLoading', 'Expand');
	
	return $responce;
}

$link = JURI::root().
	'/index2.php?option=com_resource&controller='.
JRequest::getVar('controller').'&Itemid='.JRequest::getInt('Itemid');
if(JRequest::getInt('category_id')) $link .= "&category_id=".JRequest::getInt('category_id');
if(JRequest::getInt('article')) $link .= "&article=".JRequest::getInt('article');
$link = MEUrl::linkAdditions($link);

$xajax = new JS_SAFE_xajax($link);

//$xajax->debugOn(); // Uncomment this line to turn debugging on

$xajax->registerFunction( "jsrLoadComment" );
$xajax->registerFunction( "jsAddTag" );
//$xajax->registerFunction( "jsrEditField" );
//$xajax->registerFunction( "jsrEditFieldSave" );
$xajax->registerFunction( "jsrRateComment" );
$xajax->registerFunction( "jsFavorite" );
$xajax->registerFunction( "jsCompare" );
$xajax->registerFunction( "jsSearchTags" );
$xajax->registerFunction( "jsHit" );
$xajax->registerFunction( "jsRate" );
$xajax->registerFunction( "jcRemoveMediaFile" );
$xajax->registerFunction( "jsrLoadComment" );
$xajax->registerFunction( "jsCallPlugin" );
$xajax->registerFunction( "jsrGetRelatedRecords" );
$xajax->registerFunction( "jsGetCategoryList" );

$xajax->processRequest();
$xajax->printJavascript(JURI::root().'media/mightyextensions/xajax/');

?>