<?php
/**
 * $Id: view.pdf.php 7763 2012-01-26 07:47:42Z kostya $
 * $LastChangedDate: 2012-01-26 13:47:42 +0600 (Thu, 26 Jan 2012) $
 * $LastChangedBy: kostya $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class ResViewArticle extends JView
{

	function display($tpl = null)
	{
		global $mainframe, $option;

		$category_id = JRequest::getInt('category_id', ResHelper::getArticleSection(JRequest::getInt('article')));

		//echo "ddd"; exit;

		if(!$category_id || !JRequest::getInt('article'))
		{
			JError::raiseError(403, JText::_('URL is not complete'));
			return;
		}

		$document	= &JFactory::getDocument();
		$uri 		= &JFactory::getURI();
		$pathway	= &$mainframe->getPathway();
		$params = ResHelper::initListParams($category_id);
		$model = $this->getModel();
		$user  = &JFactory::getUser();

//		$menus = &JSite::getMenu();
//		$menu  = $menus->getActive();

		$article = $this->get('article');
		$iparams = ResHelper::initArticleParams($article->type_id, $article->params);
		$params->merge($iparams);

		//echo $article->text;  exit;
		if($params->get('access_section') == 'none')
		{
			JError::raiseWarning(404, JText::_('Section Offline'));
			echo '<div class="componentheading">'.$params->get('access_msg').'</div>';
			return;
		}
		if($params->get('access_section') > $user->get('aid'))
		{
			JError::raiseWarning(404, JText::_('Access Denied'));
			echo '<div class="componentheading">'.JText::_('You do not have enough rights').'</div>';
			if($params->get('access_section') == 1)
			{
				JError::raiseWarning(404, JText::_('This section accessible only for Registered users'));
				 
				$return		= $uri->toString();

				$url  = 'index.php?option=com_user&view=login&Itemid='.JRequest::getInt('Itemid');
				$url .= '&return='.base64_encode($return);
				 
				$mainframe->redirect( JRoute::_($url, FALSE) );
			}
			if($params->get('access_section') == 2)
			{
				echo '<p>'.JText::_('This section accessible only for users with administrator rights').'</p>';
			}
			return;
		}

		$list = JModel::getInstance('list', 'ResModel');
		$fields = $list->getFields($article->id);

		//print_r($article);

		$category1 = $list->getCategory($params->get('category_id'));

		require_once(JPATH_COMPONENT_SITE.DS.'views'.DS.'list'.DS.'view.html.php');
		$items[0] = $article;
		//$items = ResViewList::prepareItems($items, $params, $category1);
		MRRecordHelper::prepareItems($items, $params, $category1);
		$article = $items[0];

		$document->setTitle( $article->title);

		echo $this->_prepare($article, $iparams);
		?>
<br>
<br>

		<?php $tab_close = false;
		foreach($fields AS $field):
		if($field->type == 'mail') continue;
		$fparam = new JParameter($field->params);
		$fparam->set('tabled',0);
		$field->params = $fparam->toString();
		echo $list->getFieldValue($field, $article->user_id);
		endforeach;
	}

	function _prepare(& $article, & $params)
	{
		// Initialize some variables
		$text = '';
		$user = JFactory::getUser($article->user_id);

		jimport('joomla.utilities.date');

		if ($params->get('item_author')) {
			// Display Author name
			if ($user->get('usertype') == 'administrator' ||
			$user->get('usertype') == 'superadministrator') {
				$text .= "\n<br>";
				$text .= JText::_('Written by').' '. $user->get($params->get('item_author_mode', 'username'));
			} else {
				$text .= "\n<br>";
				$text .= JText::_('Contributed by').' '. $user->get($params->get('item_author_mode', 'username'));
			}
		}

		if ($params->get('item_ctime') && $article->ctime) {
			// Display Created Date
			//$date = new JDate($article->ctime);
			$text .= "\n<br>".JText::_('Created').': '.$article->ctime->toFormat($params->get('item_time_format'));// $article->ctime;
		}

		if ($params->get('item_ctime') && $article->mtime) {
			// Display Modified Date
			$text .= "\n<br>".JText::_('Modified').': '.$article->mtime->toFormat($params->get('item_time_format'));// $article->ctime;
				
		}
		return $text;
	}
}
?>
