<?php
/**
 * $Id: form.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyResources by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access'); ?>

<div class="componentheading">  
	<?php echo $this->isNew ? JText::_('Add') : JText::_('Edit')  ?> <?php echo JText::_($this->params->get('pcat_mean'));?>: <?php echo htmlspecialchars(JRequest::getVar('name', $this->category->name), ENT_QUOTES, 'UTF-8');?>
</div>
<script language="javascript" type="text/javascript">
function submitbutton(pressbutton) {
	var form = document.adminForm;
	if (pressbutton == 'cancel') {
		submitform( pressbutton );
		return;
	}

	// do field validation
	if (form.name.value == ""){
		alert( "<?php echo JText::_( 'Name not set', true ); ?>" );
	} else {
		submitform( pressbutton );
	}
}
</script>
<div class="contentpaneopen">
<form id="adminForm" name="adminForm" method="POST" enctype="multipart/form-data" action="<?php echo $this->action ?>">
<table width="100%" cellpadding="2" cellspacing="0" border="0">
	<?php if($this->params->get('pcat_icon')):?>
		<tr valign="top">
			<td><?php echo JText::_('Icon');?></td>
			<td>
			<?php if($this->category->icon):?>
				<?php echo JHTML::image('images/icons/'.$this->user->get('id').'/'.$this->category->icon, JText::_('Icon'));?>
				<input type="hidden" name="icon" value="<?php echo $this->category->icon ?>" />
				<input type="checkbox" name="remove_icon" value="1" /> <?php echo JText::_('Remove current') ?>
				<br><br>
			<?php endif; ?>
			<input type="file" name="icon" style="width:100%" /><br>
			<?php echo JText::_('You may apload any image format: jpg, gif, png') ?><br>
			<?php echo JText::printf('Image will be automatically resized to width %dpx / height %dpx', $this->params->get('pcat_icon_w'),  $this->params->get('pcat_icon_h')) ?>
			
			</td>
		</tr>
	<?php endif; ?>
	<tr>
		<td><?php echo JText::_('Title');?></td>
		<td><input class="inputbox" type="text" name="name" value="<?php echo htmlspecialchars(JRequest::getVar('name', $this->category->name), ENT_QUOTES, 'UTF-8');?>" style="width:100%" /></td>
	</tr>
	<tr valign="top">
		<td><?php echo JText::_('Description');?></td>
		<td><textarea name="description" style="width:100%" rows="10"><?php echo htmlspecialchars(JRequest::getVar('description', $this->category->description), ENT_QUOTES, 'UTF-8');?></textarea></td>
	</tr>
	<tr>
		<td><?php echo JText::_('Publish');?></td>
		<td><?php echo $this->lists['publish'];?></td>
	</tr>
	<tr>
		<td><?php echo JText::_('Access');?></td>
		<td><?php echo $this->lists['access'];?></td>
	</tr>
	<tr>
		<td><?php echo JText::_('Ordering');?></td>
		<td><?php echo $this->lists['ordering'];?></td>
	</tr>
	
</table>
<?php if($this->params->get('pcat_meta')): ?>
<?php $cparams = new JParameter($this->category->params); ?>
<table width="100%" cellpadding="2" cellspacing="0" border="0">
	<tr>
		<td width="50%">
		<?php echo JText::_('Meta Keywords'); ?>:<br>
		<textarea style="width:98%" rows="5" name="params[meta_key]"><?php echo @$_POST['params']['meta_key'] ? @$_POST['params']['meta_key'] : $cparams->get('meta_key')?></textarea>
		</td>
		<td width="50%">
		<?php echo JText::_('Meta Description'); ?>:<br>
		<textarea style="width:98%" rows="5" name="params[meta_descr]"><?php echo @$_POST['params']['meta_descr'] ? @$_POST['params']['meta_descr'] : $cparams->get('meta_descr')?></textarea>
		</td>
	</tr>
</table>
<?php endif; ?>

<input type="hidden" name="return" value="<?php echo JRequest::getVar('return'); ?>" />
<input type="hidden" name="id" value="<?php echo $this->category->id?>" />
<input type="hidden" name="client" value="<?php echo stripslashes(JRequest::getVar('client', $this->category->client ? $this->category->client : 'resource')) ?>" />
<input type="hidden" name="client_id" value="<?php echo JRequest::getInt('client_id', $this->category->client_id) ?>" />
<input type="hidden" name="alias" value="<?php echo $this->category->alias?>" />
<input type="hidden" name="user_id" value="<?php echo $this->user->get('id')?>" />
<input type="hidden" name="section_id" value="<?php echo $this->section->id; ?>" />
<input type="hidden" name="mtime" value="<?php echo $this->category->mtime; ?>" />
<input type="hidden" name="ctime" value="<?php echo $this->category->ctime; ?>" />
<input type="hidden" name="hits" value="<?php echo $this->category->hits; ?>" />
<input type="hidden" name="rate" value="<?php echo $this->category->rate; ?>" />
<input type="hidden" name="rate_count" value="<?php echo $this->category->rate_count; ?>" />
<input type="hidden" name="task" value="" />
<input type="button" onclick="submitbutton('add_user_category')" value="<?php echo JText::_('Save'); ?>" />
<input type="button" onclick="submitbutton('apply')" value="<?php echo JText::_('Apply');  ?>" />
<input type="button" onclick="submitbutton('cancel')" value="<?php echo JText::_('Cancel');  ?>" />
</form>
</div>